/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern0 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!gpc_reg_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode
          || !gpc_reg_operand (operands[1], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!gpc_reg_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode
          || !gpc_reg_operand (operands[1], E_DImode))
        return -1;
      return 1;

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x3) != E_V4SImode
          || !register_operand (operands[1], E_V4SImode))
        return -1;
      return 2;

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || GET_MODE (x3) != E_V8HImode
          || !register_operand (operands[1], E_V8HImode))
        return -1;
      return 3;

    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode)
          || GET_MODE (x3) != E_V16QImode
          || !register_operand (operands[1], E_V16QImode))
        return -1;
      return 4;

    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || GET_MODE (x3) != E_V2DImode
          || !register_operand (operands[1], E_V2DImode))
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern28 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x2, 1);
  if (GET_CODE (x5) != LABEL_REF)
    return -1;
  x6 = XEXP (x2, 2);
  if (GET_CODE (x6) != PC)
    return -1;
  x7 = XEXP (x1, 0);
  if (GET_CODE (x7) != PC)
    return -1;
  x8 = XEXP (x3, 0);
  operands[2] = x8;
  if (!cc_reg_operand (operands[2], E_VOIDmode))
    return -1;
  x9 = XEXP (x5, 0);
  operands[0] = x9;
  return 0;
}

int
pattern35 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != AND)
    return -1;
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + -16])
    return -1;
  x5 = XEXP (x1, 0);
  operands[0] = x5;
  if (!register_operand (operands[0], i1))
    return -1;
  return pattern34 (x3); /* [-1, 3] */
}

int
pattern41 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !gpc_reg_operand (operands[0], i1)
      || !gpc_reg_operand (operands[1], i1)
      || !gpc_reg_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern50 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !gpc_reg_operand (operands[0], i1))
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != i1
      || !gpc_reg_operand (operands[1], i1))
    return -1;
  x5 = XEXP (x1, 1);
  if (GET_MODE (x5) != i1
      || !gpc_reg_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern59 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!altivec_register_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !altivec_register_operand (operands[0], i1)
      || !altivec_register_operand (operands[1], i1)
      || !altivec_register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern66 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_DImode)
    return -1;
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (!indexed_or_indirect_operand (operands[1], E_SImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      if (!gpc_reg_operand (operands[0], E_SFmode)
          || GET_MODE (x1) != E_SFmode)
        return -1;
      return 0;

    case E_DFmode:
      if (!gpc_reg_operand (operands[0], E_DFmode)
          || GET_MODE (x1) != E_DFmode)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern72 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != E_DImode)
    return -1;
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  if (!indexed_or_indirect_operand (operands[1], E_SImode))
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 0);
  operands[2] = x7;
  if (!scratch_operand (operands[2], E_DImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      if (!gpc_reg_operand (operands[0], E_SFmode)
          || GET_MODE (x3) != E_SFmode)
        return -1;
      return 0;

    case E_DFmode:
      if (!gpc_reg_operand (operands[0], E_DFmode)
          || GET_MODE (x3) != E_DFmode)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern81 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XVECEXP (x1, 0, 0);
  x4 = XEXP (x3, 0);
  operands[0] = x4;
  x5 = XEXP (x3, 1);
  x6 = XEXP (x5, 0);
  operands[1] = x6;
  x7 = XEXP (x2, 0);
  operands[2] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      if (GET_MODE (x5) != E_QImode)
        return -1;
      return 0;

    case E_HImode:
      if (GET_MODE (x5) != E_HImode)
        return -1;
      return 1;

    case E_SImode:
      if (GET_MODE (x5) != E_SImode)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern89 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[1], i1)
      || !short_cint_operand (operands[2], i1)
      || !scratch_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  return 0;
}

int
pattern92 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[1], i1)
      || !exact_log2_cint_operand (operands[2], i1)
      || !scratch_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  return 0;
}

int
pattern99 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 0);
  operands[2] = x7;
  if (!scratch_operand (operands[2], E_DImode))
    return -1;
  x8 = XVECEXP (x1, 0, 2);
  x9 = XEXP (x8, 0);
  operands[3] = x9;
  if (!scratch_operand (operands[3], E_DImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      if (!gpc_reg_operand (operands[0], E_SFmode)
          || GET_MODE (x3) != E_SFmode
          || !gpc_reg_operand (operands[1], E_SFmode))
        return -1;
      return 0;

    case E_DFmode:
      if (!gpc_reg_operand (operands[0], E_DFmode)
          || GET_MODE (x3) != E_DFmode
          || !gpc_reg_operand (operands[1], E_DFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern109 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[1]))
    {
    case E_SImode:
      if (!gpc_reg_operand (operands[1], E_SImode)
          || !reg_or_short_operand (operands[2], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!gpc_reg_operand (operands[1], E_DImode)
          || !reg_or_short_operand (operands[2], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern114 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  x6 = XEXP (x4, 1);
  operands[2] = x6;
  x7 = XVECEXP (x1, 0, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XVECEXP (x1, 0, 2);
  x10 = XEXP (x9, 0);
  operands[4] = x10;
  x11 = XVECEXP (x1, 0, 3);
  x12 = XEXP (x11, 0);
  operands[5] = x12;
  if (!scratch_operand (operands[5], E_CCUNSmode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern113 (x4, 
E_SImode); /* [-1, 1] */

    case E_DImode:
      res = pattern113 (x4, 
E_DImode);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    default:
      return -1;
    }
}

int
pattern124 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !vector_shift_constant (operands[2], i1))
    return -1;
  return 0;
}

int
pattern131 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_DImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], E_DImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!gpc_reg_operand (operands[1], E_DImode))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!gpc_reg_operand (operands[2], E_DImode))
    return -1;
  return 0;
}

int
pattern140 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], i1))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], i1))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern148 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], i1))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], i1))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!register_operand (operands[2], E_V16QImode))
    return -1;
  return 0;
}

int
pattern156 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      if (!gpc_reg_operand (operands[0], E_SFmode)
          || GET_MODE (x3) != E_SFmode
          || !gpc_reg_operand (operands[1], E_SFmode))
        return -1;
      return 0;

    case E_DFmode:
      if (!gpc_reg_operand (operands[0], E_DFmode)
          || GET_MODE (x3) != E_DFmode
          || !gpc_reg_operand (operands[1], E_DFmode))
        return -1;
      return 1;

    case E_KFmode:
      if (!altivec_register_operand (operands[0], E_KFmode)
          || GET_MODE (x3) != E_KFmode
          || !altivec_register_operand (operands[1], E_KFmode))
        return -1;
      return 2;

    case E_TFmode:
      if (!altivec_register_operand (operands[0], E_TFmode)
          || GET_MODE (x3) != E_TFmode
          || !altivec_register_operand (operands[1], E_TFmode))
        return -1;
      return 3;

    case E_V4SFmode:
      if (GET_MODE (x3) != E_V4SFmode)
        return -1;
      return 4;

    case E_V2DFmode:
      if (!vsx_register_operand (operands[0], E_V2DFmode)
          || GET_MODE (x3) != E_V2DFmode
          || !vsx_register_operand (operands[1], E_V2DFmode))
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern171 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], i1))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], i2))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!register_operand (operands[2], i1))
    return -1;
  x6 = XVECEXP (x2, 0, 2);
  operands[3] = x6;
  if (!register_operand (operands[3], E_V16QImode))
    return -1;
  return 0;
}

int
pattern177 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[1]))
    {
    case E_QImode:
      if (!gpc_reg_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!gpc_reg_operand (operands[1], E_HImode))
        return -1;
      return 1;

    case E_SImode:
      if (!gpc_reg_operand (operands[1], E_SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern183 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 0);
  if (!rtx_equal_p (x5, operands[1]))
    return -1;
  x6 = XEXP (x4, 1);
  if (!rtx_equal_p (x6, operands[2]))
    return -1;
  return pattern180 (x1); /* [-1, 1] */
}

int
pattern186 (rtx x1, rtx_code i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 106
      || GET_MODE (x3) != i2)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != i1)
    return -1;
  return 0;
}

int
pattern191 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !gpc_reg_operand (operands[0], i1)
      || !gpc_reg_operand (operands[1], i1)
      || !gpc_reg_operand (operands[2], i1)
      || !scratch_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern196 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XVECEXP (x1, 0, 0);
  x4 = XEXP (x3, 0);
  operands[3] = x4;
  x5 = XEXP (x3, 1);
  x6 = XEXP (x5, 1);
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  operands[4] = x7;
  x8 = XEXP (x5, 0);
  x9 = XEXP (x8, 0);
  switch (GET_CODE (x9))
    {
    case NOT:
      return pattern194 (x5); /* [-1, 1] */

    case REG:
    case SUBREG:
      res = pattern192 (x5);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    default:
      return -1;
    }
}

int
pattern205 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], E_IFmode)
      || GET_MODE (x1) != E_IFmode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_DFmode:
      if (!nonimmediate_operand (operands[1], E_DFmode))
        return -1;
      return 0;

    case E_TFmode:
      if (!gpc_reg_operand (operands[1], E_TFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern213 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !gpc_reg_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern219 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[3] = x3;
  x4 = XEXP (x2, 1);
  operands[4] = x4;
  return pattern218 (x1); /* [-1, 1] */
}

int
pattern223 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_SImode
      || !register_operand (operands[0], E_SImode))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  operands[1] = x2;
  switch (GET_MODE (operands[1]))
    {
    case E_V16QImode:
      if (!altivec_register_operand (operands[1], E_V16QImode))
        return -1;
      return 0;

    case E_V8HImode:
      if (!altivec_register_operand (operands[1], E_V8HImode))
        return -1;
      return 1;

    case E_V4SImode:
      if (!altivec_register_operand (operands[1], E_V4SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern233 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !gpc_reg_operand (operands[0], i1))
    return -1;
  x3 = XEXP (x1, 1);
  return pattern232 (x3, 
i1); /* [-1, 0] */
}

int
pattern238 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !gpc_reg_operand (operands[0], i1)
      || !gpc_reg_operand (operands[1], i1)
      || !gpc_reg_operand (operands[2], i1)
      || !scratch_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern246 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x1, 1);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
      operands[2] = x5;
      switch (GET_MODE (operands[3]))
        {
        case E_SImode:
          return pattern193 (x1, 
E_SImode); /* [-1, 0] */

        case E_DImode:
          if (pattern193 (x1, 
E_DImode) != 0)
            return -1;
          return 1;

        case E_V4SImode:
          if (pattern243 (x1, 
E_V4SImode) != 0)
            return -1;
          return 2;

        case E_V8HImode:
          if (pattern243 (x1, 
E_V8HImode) != 0)
            return -1;
          return 3;

        case E_V16QImode:
          if (pattern243 (x1, 
E_V16QImode) != 0)
            return -1;
          return 4;

        case E_V4SFmode:
          if (pattern243 (x1, 
E_V4SFmode) != 0)
            return -1;
          return 5;

        case E_V2DFmode:
          if (pattern243 (x1, 
E_V2DFmode) != 0)
            return -1;
          return 6;

        case E_V2DImode:
          if (pattern243 (x1, 
E_V2DImode) != 0)
            return -1;
          return 7;

        case E_V1TImode:
          if (pattern243 (x1, 
E_V1TImode) != 0)
            return -1;
          return 8;

        case E_TImode:
          if (pattern243 (x1, 
E_TImode) != 0)
            return -1;
          return 9;

        case E_KFmode:
          if (pattern243 (x1, 
E_KFmode) != 0)
            return -1;
          return 10;

        case E_TFmode:
          if (pattern243 (x1, 
E_TFmode) != 0)
            return -1;
          return 11;

        default:
          return -1;
        }

    case NOT:
      x6 = XEXP (x5, 0);
      operands[2] = x6;
      switch (GET_MODE (operands[3]))
        {
        case E_SImode:
          if (pattern244 (x1, 
E_SImode) != 0)
            return -1;
          return 12;

        case E_DImode:
          if (pattern244 (x1, 
E_DImode) != 0)
            return -1;
          return 13;

        case E_V4SImode:
          if (pattern245 (x1, 
E_V4SImode) != 0)
            return -1;
          return 14;

        case E_V8HImode:
          if (pattern245 (x1, 
E_V8HImode) != 0)
            return -1;
          return 15;

        case E_V16QImode:
          if (pattern245 (x1, 
E_V16QImode) != 0)
            return -1;
          return 16;

        case E_V4SFmode:
          if (pattern245 (x1, 
E_V4SFmode) != 0)
            return -1;
          return 17;

        case E_V2DFmode:
          if (pattern245 (x1, 
E_V2DFmode) != 0)
            return -1;
          return 18;

        case E_V2DImode:
          if (pattern245 (x1, 
E_V2DImode) != 0)
            return -1;
          return 19;

        case E_V1TImode:
          if (pattern245 (x1, 
E_V1TImode) != 0)
            return -1;
          return 20;

        case E_TImode:
          if (pattern245 (x1, 
E_TImode) != 0)
            return -1;
          return 21;

        case E_KFmode:
          if (pattern245 (x1, 
E_KFmode) != 0)
            return -1;
          return 22;

        case E_TFmode:
          if (pattern245 (x1, 
E_TFmode) != 0)
            return -1;
          return 23;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern282 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !gpc_reg_operand (operands[0], i1)
      || !gpc_reg_operand (operands[1], i1))
    return -1;
  x5 = XEXP (x1, 1);
  if (GET_MODE (x5) != i1
      || !gpc_reg_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern288 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !gpc_reg_operand (operands[1], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1
      || !gpc_reg_operand (operands[3], i1)
      || !rs6000_tls_symbol_ref (operands[2], i1))
    return -1;
  return 0;
}

int
pattern295 (rtx x1, machine_mode i1, int i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != SET)
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != UNSPEC
      || XVECLEN (x2, 0) != 1
      || XINT (x2, 1) != i2
      || GET_MODE (x2) != i1)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  return 0;
}

int
pattern302 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  if (!scratch_operand (operands[2], E_V16QImode))
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  return pattern301 (x5); /* [-1, 1] */
}

int
pattern309 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !gpc_reg_operand (operands[1], i1)
      || !scc_eq_operand (operands[2], i1)
      || !gpc_reg_operand (operands[3], i1)
      || !scratch_operand (operands[4], i1)
      || !scratch_operand (operands[5], i1))
    return -1;
  x5 = XVECEXP (x1, 0, 3);
  x6 = XEXP (x5, 0);
  if (GET_MODE (x6) != i1)
    return -1;
  return 0;
}

int
pattern319 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_SImode:
      if (!gpc_reg_operand (operands[1], E_SImode)
          || !reg_or_short_operand (operands[2], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!gpc_reg_operand (operands[1], E_DImode)
          || !reg_or_short_operand (operands[2], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern329 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || !boolean_operator (operands[3], i1)
      || !gpc_reg_operand (operands[1], i1)
      || !gpc_reg_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern336 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!memory_operand (operands[0], i1))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_KFmode:
      if (!altivec_register_operand (operands[1], E_KFmode))
        return -1;
      return 0;

    case E_TFmode:
      if (!altivec_register_operand (operands[1], E_TFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern344 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !gpc_reg_operand (operands[1], i1)
      || !gpc_reg_operand (operands[2], i1))
    return -1;
  x2 = XEXP (x1, 2);
  if (GET_MODE (x2) != i1
      || !gpc_reg_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern353 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x2, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 98)
    return -1;
  x6 = XEXP (x3, 0);
  if (!rtx_equal_p (x6, operands[1]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern352 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern352 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern362 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!base_reg_operand (operands[0], i1))
    return -1;
  x2 = XEXP (x1, 0);
  operands[2] = x2;
  x3 = XEXP (x1, 1);
  operands[3] = x3;
  switch (GET_MODE (operands[2]))
    {
    case E_QImode:
      if (!base_reg_operand (operands[2], E_QImode)
          || !fusion_gpr_mem_load (operands[3], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!base_reg_operand (operands[2], E_HImode)
          || !fusion_gpr_mem_load (operands[3], E_HImode))
        return -1;
      return 1;

    case E_SImode:
      if (!base_reg_operand (operands[2], E_SImode)
          || !fusion_gpr_mem_load (operands[3], E_SImode))
        return -1;
      return 2;

    case E_DImode:
      if (!base_reg_operand (operands[2], E_DImode)
          || !fusion_gpr_mem_load (operands[3], E_DImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern381 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !gpc_reg_operand (operands[1], i1)
      || !gpc_reg_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern390 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!boolean_operator (operands[3], i1))
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !gpc_reg_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !gpc_reg_operand (operands[2], i1)
      || !gpc_reg_operand (operands[0], i1))
    return -1;
  return 0;
}

int
pattern399 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  operands[1] = x4;
  switch (GET_MODE (operands[3]))
    {
    case E_SImode:
      return pattern397 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern397 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern398 (x1, 
E_V4SImode) != 0)
        return -1;
      return 2;

    case E_V8HImode:
      if (pattern398 (x1, 
E_V8HImode) != 0)
        return -1;
      return 3;

    case E_V16QImode:
      if (pattern398 (x1, 
E_V16QImode) != 0)
        return -1;
      return 4;

    case E_V4SFmode:
      if (pattern398 (x1, 
E_V4SFmode) != 0)
        return -1;
      return 5;

    case E_V2DFmode:
      if (pattern398 (x1, 
E_V2DFmode) != 0)
        return -1;
      return 6;

    case E_V2DImode:
      if (pattern398 (x1, 
E_V2DImode) != 0)
        return -1;
      return 7;

    case E_V1TImode:
      if (pattern398 (x1, 
E_V1TImode) != 0)
        return -1;
      return 8;

    case E_TImode:
      if (pattern398 (x1, 
E_TImode) != 0)
        return -1;
      return 9;

    case E_KFmode:
      if (pattern398 (x1, 
E_KFmode) != 0)
        return -1;
      return 10;

    case E_TFmode:
      if (pattern398 (x1, 
E_TFmode) != 0)
        return -1;
      return 11;

    default:
      return -1;
    }
}

int
pattern413 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  if (!vfloat_operand (operands[0], E_DFmode))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_DFmode)
    return -1;
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  x7 = XEXP (x6, 0);
  operands[1] = x7;
  if (!vfloat_operand (operands[1], E_V2DFmode))
    return -1;
  x8 = XVECEXP (x1, 0, 1);
  x9 = XEXP (x8, 0);
  operands[2] = x9;
  if (!scratch_operand (operands[2], E_DFmode))
    return -1;
  x10 = XEXP (x5, 1);
  x11 = XEXP (x10, 0);
  if (!rtx_equal_p (x11, operands[1]))
    return -1;
  x12 = XEXP (x4, 1);
  if (!rtx_equal_p (x12, operands[1]))
    return -1;
  return 0;
}

int
pattern423 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !gpc_reg_operand (operands[0], i1))
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_MODE (x5) != i1
      || !gpc_reg_operand (operands[1], i1)
      || !gpc_reg_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern431 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !gpc_reg_operand (operands[1], i1)
      || !gpc_reg_operand (operands[2], i1)
      || !gpc_reg_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern437 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_XOmode
      || !fpr_reg_operand (operands[0], E_XOmode)
      || !vsx_register_operand (operands[1], i1)
      || !vsx_register_operand (operands[2], E_V16QImode)
      || !const_0_to_15_operand (operands[3], E_SImode))
    return -1;
  return 0;
}

int
pattern443 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1
      || !gpc_reg_operand (operands[1], i1)
      || !short_cint_operand (operands[2], i1))
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XEXP (x4, 1);
  if (GET_MODE (x6) != i1
      || !const_int_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern450 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || !memory_operand (operands[1], E_V4SImode))
        return -1;
      return 0;

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || !memory_operand (operands[1], E_V8HImode))
        return -1;
      return 1;

    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode)
          || !memory_operand (operands[1], E_V16QImode))
        return -1;
      return 2;

    case E_V4SFmode:
      if (!register_operand (operands[0], E_V4SFmode)
          || !memory_operand (operands[1], E_V4SFmode))
        return -1;
      return 3;

    case E_V2DFmode:
      if (!register_operand (operands[0], E_V2DFmode)
          || !memory_operand (operands[1], E_V2DFmode))
        return -1;
      return 4;

    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || !memory_operand (operands[1], E_V2DImode))
        return -1;
      return 5;

    case E_V1TImode:
      if (!register_operand (operands[0], E_V1TImode)
          || !memory_operand (operands[1], E_V1TImode))
        return -1;
      return 6;

    case E_KFmode:
      if (!register_operand (operands[0], E_KFmode)
          || !memory_operand (operands[1], E_KFmode))
        return -1;
      return 7;

    case E_TFmode:
      if (!register_operand (operands[0], E_TFmode)
          || !memory_operand (operands[1], E_TFmode))
        return -1;
      return 8;

    default:
      return -1;
    }
}

int
pattern478 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!scratch_operand (operands[2], E_SImode))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_SFmode:
      if (!gpc_reg_operand (operands[1], E_SFmode))
        return -1;
      return 0;

    case E_DFmode:
      if (!gpc_reg_operand (operands[1], E_DFmode))
        return -1;
      return 1;

    case E_KFmode:
      if (!altivec_register_operand (operands[1], E_KFmode))
        return -1;
      return 2;

    case E_TFmode:
      if (!altivec_register_operand (operands[1], E_TFmode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern490 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !gpc_reg_operand (operands[1], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1
      || !immediate_operand (operands[2], i1)
      || !immediate_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern494 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!vsx_register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !gpc_reg_operand (operands[1], i2)
      || !gpc_reg_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern503 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!altivec_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !altivec_register_operand (operands[1], E_V2DImode)
      || !altivec_register_operand (operands[3], i1)
      || !altivec_register_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern508 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !gpc_reg_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  return 0;
}

int
pattern517 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  x6 = XEXP (x5, 0);
  if (GET_MODE (x6) != i1)
    return -1;
  return 0;
}

int
pattern521 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!altivec_register_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !altivec_register_operand (operands[0], i1)
      || !altivec_register_operand (operands[1], i1)
      || !altivec_register_operand (operands[2], i1)
      || !scratch_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern530 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1
      || !gpc_reg_operand (operands[1], i1)
      || !scc_eq_operand (operands[2], i1)
      || !scratch_operand (operands[3], i1)
      || !scratch_operand (operands[4], i1))
    return -1;
  x4 = XVECEXP (x1, 0, 3);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1)
    return -1;
  return 0;
}

int
pattern538 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern548 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_TImode)
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != E_TImode)
    return -1;
  x5 = XEXP (x1, 1);
  if (GET_MODE (x5) != E_TImode)
    return -1;
  switch (GET_CODE (x3))
    {
    case SIGN_EXTEND:
      return pattern547 (x1, 
SIGN_EXTEND); /* [-1, 0] */

    case ZERO_EXTEND:
      if (pattern547 (x1, 
ZERO_EXTEND) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern558 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!boolean_operator (operands[3], i1)
      || GET_MODE (x1) != i1
      || !gpc_reg_operand (operands[2], i1)
      || !gpc_reg_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern563 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !gpc_reg_operand (operands[1], i1))
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 0);
  if (GET_MODE (x7) != i1)
    return -1;
  return 0;
}

int
pattern571 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[1], i1)
      || !reg_or_short_operand (operands[2], i1)
      || !gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  return 0;
}

int
pattern578 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x6 = XEXP (x4, 0);
  operands[1] = x6;
  x7 = XVECEXP (x1, 0, 1);
  x8 = XEXP (x7, 1);
  x9 = XEXP (x8, 0);
  if (!rtx_equal_p (x9, operands[1]))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_SImode:
      return pattern577 (x8, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern577 (x8, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern590 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!indirect_call_operand (operands[1], i1)
      || !unspec_tls (operands[2], i1))
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !const_int_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern600 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!indirect_call_operand (operands[1], i1)
      || !unspec_tls (operands[2], i1)
      || !memory_operand (operands[4], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 3);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != i1
      || !const_int_operand (operands[5], i1))
    return -1;
  x5 = XVECEXP (x1, 0, 4);
  x6 = XEXP (x5, 0);
  if (GET_MODE (x6) != i1)
    return -1;
  return 0;
}

 int
recog_2 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_CCFPmode)
    return -1;
  x3 = XEXP (x2, 0);
  switch (XVECLEN (x3, 0))
    {
    case 2:
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      x5 = XVECEXP (x3, 0, 0);
      operands[1] = x5;
      x6 = XVECEXP (x3, 0, 1);
      operands[2] = x6;
      switch (XINT (x3, 1))
        {
        case 150:
          if (GET_MODE (x3) != E_DFmode
              || !cc_reg_operand (operands[0], E_CCFPmode)
              || !vsx_register_operand (operands[1], E_DFmode)
              || !vsx_register_operand (operands[2], E_DFmode))
            return -1;
          x7 = XEXP (x2, 1);
          operands[3] = x7;
          if (!zero_constant (operands[3], E_SImode)
              || !
#line 5305 "../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
            return -1;
          return 1680; /* *xscmpexpdp */

        case 151:
          if (!cc_reg_operand (operands[0], E_CCFPmode))
            return -1;
          x7 = XEXP (x2, 1);
          operands[3] = x7;
          if (!zero_constant (operands[3], E_SImode))
            return -1;
          switch (GET_MODE (x3))
            {
            case E_KFmode:
              if (!altivec_register_operand (operands[1], E_KFmode)
                  || !altivec_register_operand (operands[2], E_KFmode)
                  || !(
#line 5339 "../../gcc/config/rs6000/vsx.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
                return -1;
              return 1681; /* *xscmpexpqp */

            case E_TFmode:
              if (!altivec_register_operand (operands[1], E_TFmode)
                  || !altivec_register_operand (operands[2], E_TFmode)
                  || !(
#line 5339 "../../gcc/config/rs6000/vsx.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
                return -1;
              return 1682; /* *xscmpexpqp */

            default:
              return -1;
            }

        case 152:
          x7 = XEXP (x2, 1);
          if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
              || !u7bit_cint_operand (operands[2], E_SImode))
            return -1;
          switch (GET_MODE (x3))
            {
            case E_SFmode:
              if (!vsx_register_operand (operands[1], E_SFmode)
                  || !
#line 5452 "../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR
   && (!FLOAT128_IEEE_P (SFmode) || TARGET_FLOAT128_HW)))
                return -1;
              return 1683; /* *xststdc_sf */

            case E_DFmode:
              if (!vsx_register_operand (operands[1], E_DFmode)
                  || !
#line 5452 "../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR
   && (!FLOAT128_IEEE_P (DFmode) || TARGET_FLOAT128_HW)))
                return -1;
              return 1684; /* *xststdc_df */

            case E_KFmode:
              if (!altivec_register_operand (operands[1], E_KFmode)
                  || !(
#line 5452 "../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR
   && (!FLOAT128_IEEE_P (KFmode) || TARGET_FLOAT128_HW)) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
                return -1;
              return 1685; /* *xststdc_kf */

            case E_TFmode:
              if (!altivec_register_operand (operands[1], E_TFmode)
                  || !(
#line 5452 "../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR
   && (!FLOAT128_IEEE_P (TFmode) || TARGET_FLOAT128_HW)) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
                return -1;
              return 1686; /* *xststdc_tf */

            default:
              return -1;
            }

        case 430:
          if (!const_int_operand (operands[1], E_SImode))
            return -1;
          x7 = XEXP (x2, 1);
          operands[3] = x7;
          if (!zero_constant (operands[3], E_SImode))
            return -1;
          switch (GET_MODE (x3))
            {
            case E_DDmode:
              if (!gpc_reg_operand (operands[2], E_DDmode)
                  || !
#line 368 "../../gcc/config/rs6000/dfp.md"
(TARGET_P9_MISC))
                return -1;
              return 2463; /* *dfp_sgnfcnc_dd */

            case E_TDmode:
              if (!gpc_reg_operand (operands[2], E_TDmode)
                  || !
#line 368 "../../gcc/config/rs6000/dfp.md"
(TARGET_P9_MISC))
                return -1;
              return 2464; /* *dfp_sgnfcnc_td */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 3:
      if (pnum_clobbers == NULL)
        return -1;
      x4 = XEXP (x1, 0);
      if (GET_CODE (x4) != REG
          || REGNO (x4) != 106
          || GET_MODE (x4) != E_CCFPmode
          || GET_MODE (x3) != E_V2DFmode)
        return -1;
      x5 = XVECEXP (x3, 0, 0);
      operands[1] = x5;
      x6 = XVECEXP (x3, 0, 1);
      operands[2] = x6;
      x8 = XVECEXP (x3, 0, 2);
      operands[3] = x8;
      if (!const_0_to_1_operand (operands[3], E_QImode))
        return -1;
      x7 = XEXP (x2, 1);
      operands[4] = x7;
      if (!zero_constant (operands[4], E_V2DFmode))
        return -1;
      switch (XINT (x3, 1))
        {
        case 342:
          switch (pattern569 ())
            {
            case 0:
              if (!
#line 4610 "../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
                return -1;
              *pnum_clobbers = 1;
              return 2337; /* *bcdadd_test_v1ti */

            case 1:
              if (!
#line 4610 "../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
                return -1;
              *pnum_clobbers = 1;
              return 2339; /* *bcdadd_test_v16qi */

            default:
              return -1;
            }

        case 343:
          switch (pattern569 ())
            {
            case 0:
              if (!
#line 4610 "../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
                return -1;
              *pnum_clobbers = 1;
              return 2338; /* *bcdsub_test_v1ti */

            case 1:
              if (!
#line 4610 "../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
                return -1;
              *pnum_clobbers = 1;
              return 2340; /* *bcdsub_test_v16qi */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 1:
      if (pnum_clobbers == NULL
          || XINT (x3, 1) != 343
          || GET_MODE (x3) != E_V2DFmode)
        return -1;
      x4 = XEXP (x1, 0);
      if (GET_CODE (x4) != REG
          || REGNO (x4) != 106
          || GET_MODE (x4) != E_CCFPmode)
        return -1;
      x5 = XVECEXP (x3, 0, 0);
      operands[1] = x5;
      x7 = XEXP (x2, 1);
      operands[2] = x7;
      if (!zero_constant (operands[2], E_V2DFmode))
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V1TImode:
          if (!register_operand (operands[1], E_V1TImode)
              || !
#line 4737 "../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
            return -1;
          *pnum_clobbers = 1;
          return 2353; /* *bcdinvalid_v1ti */

        case E_V16QImode:
          if (!register_operand (operands[1], E_V16QImode)
              || !
#line 4737 "../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
            return -1;
          *pnum_clobbers = 1;
          return 2354; /* *bcdinvalid_v16qi */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_24 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case LT:
      x3 = XEXP (x2, 1);
      switch (GET_CODE (x3))
        {
        case CONST_INT:
          if (XWINT (x3, 0) != 0L)
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              switch (pattern330 (x2, 
E_SImode))
                {
                case 0:
                  if (!
#line 4257 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
                    return -1;
                  return 252; /* *lt0_sidi */

                case 1:
                  return 254; /* *lt0_sisi */

                default:
                  return -1;
                }

            case E_DImode:
              switch (pattern330 (x2, 
E_DImode))
                {
                case 0:
                  if (!
#line 4257 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
                    return -1;
                  return 253; /* *lt0_didi */

                case 1:
                  if (!
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
                    return -1;
                  return 255; /* *lt0_disi */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case REG:
        case SUBREG:
          switch (pattern11 (x2))
            {
            case 0:
              if (!
#line 606 "../../gcc/config/rs6000/vector.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V4SFmode) && can_create_pseudo_p ()))
                return -1;
              return 1236; /* vector_ltv4sf */

            case 1:
              if (!
#line 606 "../../gcc/config/rs6000/vector.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V2DFmode) && can_create_pseudo_p ()))
                return -1;
              return 1243; /* vector_ltv2df */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case UNORDERED:
      switch (pattern11 (x2))
        {
        case 0:
          if (!
#line 653 "../../gcc/config/rs6000/vector.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V4SFmode) && can_create_pseudo_p ()))
            return -1;
          return 1252; /* vector_unorderedv4sf */

        case 1:
          if (!
#line 653 "../../gcc/config/rs6000/vector.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V2DFmode) && can_create_pseudo_p ()))
            return -1;
          return 1256; /* vector_unorderedv2df */

        default:
          return -1;
        }

    case EQ:
      x3 = XEXP (x2, 1);
      operands[2] = x3;
      switch (GET_MODE (operands[0]))
        {
        case E_V4SFmode:
          if (GET_MODE (x2) != E_V4SFmode)
            return -1;
          if (vsx_register_operand (operands[0], E_V4SFmode)
              && vsx_register_operand (operands[1], E_V4SFmode)
              && vsx_register_operand (operands[2], E_V4SFmode)
              && 
#line 2159 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V4SFmode)))
            return 1381; /* vsx_eqv4sf */
          if (!altivec_register_operand (operands[0], E_V4SFmode)
              || !altivec_register_operand (operands[1], E_V4SFmode)
              || !altivec_register_operand (operands[2], E_V4SFmode)
              || !
#line 674 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V4SFmode)))
            return -1;
          return 1865; /* *altivec_eqv4sf */

        case E_V2DFmode:
          if (pattern2 (x2, 
E_V2DFmode) != 0
              || !
#line 2159 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode)))
            return -1;
          return 1382; /* vsx_eqv2df */

        case E_V1TImode:
          if (pattern1 (x2, 
E_V1TImode) != 0
              || !
#line 626 "../../gcc/config/rs6000/altivec.md"
(TARGET_POWER10))
            return -1;
          return 1850; /* altivec_eqv1ti */

        case E_V4SImode:
          if (pattern1 (x2, 
E_V4SImode) != 0
              || !
#line 634 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V4SImode)))
            return -1;
          return 1851; /* altivec_eqv4si */

        case E_V8HImode:
          if (pattern1 (x2, 
E_V8HImode) != 0
              || !
#line 634 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V8HImode)))
            return -1;
          return 1852; /* altivec_eqv8hi */

        case E_V16QImode:
          if (pattern1 (x2, 
E_V16QImode) != 0
              || !
#line 634 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V16QImode)))
            return -1;
          return 1853; /* altivec_eqv16qi */

        case E_V2DImode:
          if (pattern1 (x2, 
E_V2DImode) != 0
              || !
#line 634 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_P8_VECTOR_P (V2DImode)))
            return -1;
          return 1854; /* altivec_eqv2di */

        default:
          return -1;
        }

    case GT:
      x3 = XEXP (x2, 1);
      operands[2] = x3;
      switch (GET_MODE (operands[0]))
        {
        case E_V4SFmode:
          if (GET_MODE (x2) != E_V4SFmode)
            return -1;
          if (vsx_register_operand (operands[0], E_V4SFmode)
              && vsx_register_operand (operands[1], E_V4SFmode)
              && vsx_register_operand (operands[2], E_V4SFmode)
              && 
#line 2167 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V4SFmode)))
            return 1383; /* vsx_gtv4sf */
          if (!altivec_register_operand (operands[0], E_V4SFmode)
              || !altivec_register_operand (operands[1], E_V4SFmode)
              || !altivec_register_operand (operands[2], E_V4SFmode)
              || !
#line 682 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V4SFmode)))
            return -1;
          return 1866; /* *altivec_gtv4sf */

        case E_V2DFmode:
          if (pattern2 (x2, 
E_V2DFmode) != 0
              || !
#line 2167 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode)))
            return -1;
          return 1384; /* vsx_gtv2df */

        case E_V4SImode:
          if (pattern1 (x2, 
E_V4SImode) != 0
              || !
#line 642 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V4SImode)))
            return -1;
          return 1855; /* *altivec_gtv4si */

        case E_V8HImode:
          if (pattern1 (x2, 
E_V8HImode) != 0
              || !
#line 642 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V8HImode)))
            return -1;
          return 1856; /* *altivec_gtv8hi */

        case E_V16QImode:
          if (pattern1 (x2, 
E_V16QImode) != 0
              || !
#line 642 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V16QImode)))
            return -1;
          return 1857; /* *altivec_gtv16qi */

        case E_V2DImode:
          if (pattern1 (x2, 
E_V2DImode) != 0
              || !
#line 642 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_P8_VECTOR_P (V2DImode)))
            return -1;
          return 1858; /* *altivec_gtv2di */

        case E_V1TImode:
          if (pattern1 (x2, 
E_V1TImode) != 0
              || !
#line 650 "../../gcc/config/rs6000/altivec.md"
(TARGET_POWER10))
            return -1;
          return 1859; /* *altivec_gtv1ti */

        default:
          return -1;
        }

    case GTU:
      x3 = XEXP (x2, 1);
      operands[2] = x3;
      switch (GET_MODE (operands[0]))
        {
        case E_V4SImode:
          if (pattern1 (x2, 
E_V4SImode) != 0
              || !
#line 658 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V4SImode)))
            return -1;
          return 1860; /* *altivec_gtuv4si */

        case E_V8HImode:
          if (pattern1 (x2, 
E_V8HImode) != 0
              || !
#line 658 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V8HImode)))
            return -1;
          return 1861; /* *altivec_gtuv8hi */

        case E_V16QImode:
          if (pattern1 (x2, 
E_V16QImode) != 0
              || !
#line 658 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V16QImode)))
            return -1;
          return 1862; /* *altivec_gtuv16qi */

        case E_V2DImode:
          if (pattern1 (x2, 
E_V2DImode) != 0
              || !
#line 658 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_P8_VECTOR_P (V2DImode)))
            return -1;
          return 1863; /* *altivec_gtuv2di */

        case E_V1TImode:
          if (pattern1 (x2, 
E_V1TImode) != 0
              || !
#line 666 "../../gcc/config/rs6000/altivec.md"
(TARGET_POWER10))
            return -1;
          return 1864; /* *altivec_gtuv1ti */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_25 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  operands[1] = x2;
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!gpc_reg_operand (operands[0], E_SImode)
          || !scc_comparison_operator (operands[1], E_SImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_CCmode:
          if (cc_reg_operand (operands[2], E_CCmode)
              && 
#line 5599 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWER10))
            return 361; /* setbc_cc_si */
          break;

        case E_CCUNSmode:
          if (cc_reg_operand (operands[2], E_CCUNSmode)
              && 
#line 5599 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWER10))
            return 363; /* setbc_ccuns_si */
          break;

        default:
          break;
        }
      if (!cc_reg_operand (operands[2], E_VOIDmode))
        return -1;
      return 886; /* setsi_cc */

    case E_DImode:
      if (!gpc_reg_operand (operands[0], E_DImode)
          || !scc_comparison_operator (operands[1], E_DImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_CCmode:
          if (cc_reg_operand (operands[2], E_CCmode)
              && (
#line 5599 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWER10) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return 362; /* setbc_cc_di */
          break;

        case E_CCUNSmode:
          if (cc_reg_operand (operands[2], E_CCUNSmode)
              && (
#line 5599 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWER10) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return 364; /* setbc_ccuns_di */
          break;

        default:
          break;
        }
      if (!cc_reg_operand (operands[2], E_VOIDmode)
          || !
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
        return -1;
      return 887; /* setdi_cc */

    default:
      return -1;
    }
}

 int
recog_26 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  x5 = XEXP (x2, 0);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      switch (pattern287 (
E_SImode))
        {
        case 0:
          if (!
#line 5608 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWER10))
            return -1;
          return 365; /* *setbcr_cc_si */

        case 1:
          if (!
#line 5608 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWER10))
            return -1;
          return 367; /* *setbcr_ccuns_si */

        default:
          return -1;
        }

    case E_DImode:
      switch (pattern287 (
E_DImode))
        {
        case 0:
          if (!(
#line 5608 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWER10) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 366; /* *setbcr_cc_di */

        case 1:
          if (!(
#line 5608 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWER10) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 368; /* *setbcr_ccuns_di */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_27 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (pnum_clobbers == NULL
          || !gpc_reg_operand (operands[0], E_SImode))
        return -1;
      x2 = XEXP (x1, 1);
      switch (pattern319 (x2, 
E_SImode))
        {
        case 0:
          if (!
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(LE == EQ && operands[2] == const0_rtx)
   && !(LE == NE && operands[2] == const0_rtx
	&& SImode == Pmode && SImode == Pmode)))
            return -1;
          *pnum_clobbers = 3;
          return 894; /* lesisi2_isel */

        case 1:
          if (!(
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(LE == EQ && operands[2] == const0_rtx)
   && !(LE == NE && operands[2] == const0_rtx
	&& SImode == Pmode && DImode == Pmode)) && 
#line 478 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 3;
          return 914; /* lesidi2_isel */

        default:
          return -1;
        }

    case E_DImode:
      if (pnum_clobbers == NULL
          || !gpc_reg_operand (operands[0], E_DImode))
        return -1;
      x2 = XEXP (x1, 1);
      switch (pattern319 (x2, 
E_DImode))
        {
        case 0:
          if (!(
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(LE == EQ && operands[2] == const0_rtx)
   && !(LE == NE && operands[2] == const0_rtx
	&& DImode == Pmode && SImode == Pmode)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 3;
          return 904; /* ledisi2_isel */

        case 1:
          if (!(
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(LE == EQ && operands[2] == const0_rtx)
   && !(LE == NE && operands[2] == const0_rtx
	&& DImode == Pmode && DImode == Pmode)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 3;
          return 924; /* ledidi2_isel */

        default:
          return -1;
        }

    case E_V4SFmode:
      x2 = XEXP (x1, 1);
      if (pattern10 (x2, 
E_V4SFmode) != 0
          || !
#line 606 "../../gcc/config/rs6000/vector.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V4SFmode) && can_create_pseudo_p ()))
        return -1;
      return 1237; /* vector_lev4sf */

    case E_V2DFmode:
      x2 = XEXP (x1, 1);
      if (pattern10 (x2, 
E_V2DFmode) != 0
          || !
#line 606 "../../gcc/config/rs6000/vector.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (V2DFmode) && can_create_pseudo_p ()))
        return -1;
      return 1244; /* vector_lev2df */

    default:
      return -1;
    }
}

 int
recog_29 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  switch (XVECLEN (x3, 0))
    {
    case 2:
      switch (XINT (x3, 1))
        {
        case 14:
          x4 = XVECEXP (x3, 0, 0);
          operands[2] = x4;
          x5 = XVECEXP (x3, 0, 1);
          operands[3] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern430 (x2, 
E_SImode) != 0
                  || !(
#line 10607 "../../gcc/config/rs6000/rs6000.md"
(HAVE_AS_TLS && TARGET_ELF && TARGET_CMODEL != CMODEL_SMALL) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                return -1;
              return 752; /* *tls_gd_low32 */

            case E_DImode:
              if (pattern430 (x2, 
E_DImode) != 0
                  || !(
#line 10607 "../../gcc/config/rs6000/rs6000.md"
(HAVE_AS_TLS && TARGET_ELF && TARGET_CMODEL != CMODEL_SMALL) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                return -1;
              return 753; /* *tls_gd_low64 */

            default:
              return -1;
            }

        case 23:
          switch (pattern289 (x2))
            {
            case 0:
              if (!(
#line 10720 "../../gcc/config/rs6000/rs6000.md"
(HAVE_AS_TLS && TARGET_CMODEL != CMODEL_SMALL) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                return -1;
              return 772; /* *tls_got_dtprel_low32 */

            case 1:
              if (!(
#line 10720 "../../gcc/config/rs6000/rs6000.md"
(HAVE_AS_TLS && TARGET_CMODEL != CMODEL_SMALL) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                return -1;
              return 773; /* *tls_got_dtprel_low64 */

            default:
              return -1;
            }

        case 27:
          switch (pattern289 (x2))
            {
            case 0:
              if (!(
#line 10800 "../../gcc/config/rs6000/rs6000.md"
(HAVE_AS_TLS && TARGET_CMODEL != CMODEL_SMALL) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                return -1;
              return 786; /* *tls_got_tprel_low32 */

            case 1:
              if (!(
#line 10800 "../../gcc/config/rs6000/rs6000.md"
(HAVE_AS_TLS && TARGET_CMODEL != CMODEL_SMALL) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                return -1;
              return 787; /* *tls_got_tprel_low64 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 1:
      if (XINT (x3, 1) != 15)
        return -1;
      x4 = XVECEXP (x3, 0, 0);
      operands[2] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern379 (x2, 
E_SImode) != 0
              || !(
#line 10652 "../../gcc/config/rs6000/rs6000.md"
(HAVE_AS_TLS && TARGET_ELF && TARGET_CMODEL != CMODEL_SMALL) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
            return -1;
          return 760; /* *tls_ld_low32 */

        case E_DImode:
          if (pattern379 (x2, 
E_DImode) != 0
              || !(
#line 10652 "../../gcc/config/rs6000/rs6000.md"
(HAVE_AS_TLS && TARGET_ELF && TARGET_CMODEL != CMODEL_SMALL) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
            return -1;
          return 761; /* *tls_ld_low64 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_31 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
      operands[1] = x3;
      res = recog_30 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      if (pnum_clobbers == NULL
          || GET_CODE (x3) != REG
          || REGNO (x3) != 98)
        return -1;
      x4 = XEXP (x2, 1);
      if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + -1])
        return -1;
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!gpc_reg_operand (operands[0], E_SImode)
              || GET_MODE (x2) != E_SImode
              || GET_MODE (x3) != E_SImode)
            return -1;
          *pnum_clobbers = 1;
          return 124; /* subfsi3_carry_in_xx */

        case E_DImode:
          if (!gpc_reg_operand (operands[0], E_DImode)
              || GET_MODE (x2) != E_DImode
              || GET_MODE (x3) != E_DImode
              || !
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
            return -1;
          *pnum_clobbers = 1;
          return 125; /* subfdi3_carry_in_xx */

        default:
          return -1;
        }

    case MULT:
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      x4 = XEXP (x2, 1);
      operands[3] = x4;
      x6 = XEXP (x3, 0);
      switch (GET_CODE (x6))
        {
        case ASHIFTRT:
          if (pattern290 (x2) != 0)
            return -1;
          x7 = XEXP (x3, 1);
          switch (GET_CODE (x7))
            {
            case SIGN_EXTEND:
              x8 = XEXP (x6, 0);
              operands[2] = x8;
              x9 = XEXP (x7, 0);
              operands[1] = x9;
              if (!gpc_reg_operand (operands[1], E_HImode)
                  || !
#line 1286 "../../gcc/config/rs6000/rs6000.md"
(TARGET_MULHW))
                return -1;
              return 38; /* *macchw */

            case ASHIFTRT:
              x10 = XEXP (x7, 1);
              if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 16])
                return -1;
              x8 = XEXP (x6, 0);
              operands[1] = x8;
              x9 = XEXP (x7, 0);
              operands[2] = x9;
              if (!gpc_reg_operand (operands[2], E_SImode)
                  || !
#line 1353 "../../gcc/config/rs6000/rs6000.md"
(TARGET_MULHW))
                return -1;
              return 42; /* *machhw */

            default:
              return -1;
            }

        case LSHIFTRT:
          if (pattern290 (x2) != 0)
            return -1;
          x7 = XEXP (x3, 1);
          switch (GET_CODE (x7))
            {
            case ZERO_EXTEND:
              x8 = XEXP (x6, 0);
              operands[2] = x8;
              x9 = XEXP (x7, 0);
              operands[1] = x9;
              if (!gpc_reg_operand (operands[1], E_HImode)
                  || !
#line 1318 "../../gcc/config/rs6000/rs6000.md"
(TARGET_MULHW))
                return -1;
              return 40; /* *macchwu */

            case LSHIFTRT:
              x10 = XEXP (x7, 1);
              if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 16])
                return -1;
              x8 = XEXP (x6, 0);
              operands[1] = x8;
              x9 = XEXP (x7, 0);
              operands[2] = x9;
              if (!gpc_reg_operand (operands[2], E_SImode)
                  || !
#line 1388 "../../gcc/config/rs6000/rs6000.md"
(TARGET_MULHW))
                return -1;
              return 44; /* *machhwu */

            default:
              return -1;
            }

        case SIGN_EXTEND:
          if (pattern291 (x2, 
SIGN_EXTEND) != 0
              || !
#line 1417 "../../gcc/config/rs6000/rs6000.md"
(TARGET_MULHW))
            return -1;
          return 46; /* *maclhw */

        case ZERO_EXTEND:
          if (pattern291 (x2, 
ZERO_EXTEND) != 0
              || !
#line 1446 "../../gcc/config/rs6000/rs6000.md"
(TARGET_MULHW))
            return -1;
          return 48; /* *maclhwu */

        case REG:
        case SUBREG:
          operands[1] = x6;
          x7 = XEXP (x3, 1);
          operands[2] = x7;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern431 (x2, 
E_SImode) != 0
                  || !
#line 3265 "../../gcc/config/rs6000/rs6000.md"
(TARGET_MADDLD))
                return -1;
              return 181; /* maddldsi4 */

            case E_DImode:
              if (pattern431 (x2, 
E_DImode) != 0
                  || !(
#line 3265 "../../gcc/config/rs6000/rs6000.md"
(TARGET_MADDLD) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 182; /* maddlddi4 */

            case E_V8HImode:
              if (!register_operand (operands[0], E_V8HImode)
                  || GET_MODE (x2) != E_V8HImode
                  || GET_MODE (x3) != E_V8HImode
                  || !register_operand (operands[1], E_V8HImode)
                  || !register_operand (operands[2], E_V8HImode)
                  || !register_operand (operands[3], E_V8HImode)
                  || !
#line 1144 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
                return -1;
              return 1957; /* fmav8hi4 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case PLUS:
      if (pnum_clobbers == NULL)
        return -1;
      x6 = XEXP (x3, 0);
      switch (GET_CODE (x6))
        {
        case REG:
        case SUBREG:
          operands[1] = x6;
          x4 = XEXP (x2, 1);
          if (GET_CODE (x4) == REG
              && REGNO (x4) == 98)
            {
              x5 = XEXP (x1, 0);
              operands[0] = x5;
              x7 = XEXP (x3, 1);
              operands[2] = x7;
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  if (pattern491 (x2, 
E_SImode) == 0)
                    {
                      *pnum_clobbers = 1;
                      return 88; /* *addsi3_carry_in_internal */
                    }
                  break;

                case E_DImode:
                  if (pattern491 (x2, 
E_DImode) == 0
                      && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
                    {
                      *pnum_clobbers = 1;
                      return 89; /* *adddi3_carry_in_internal */
                    }
                  break;

                default:
                  break;
                }
            }
          operands[0] = x6;
          if (altivec_register_operand (operands[0], E_V2DImode))
            {
              x5 = XEXP (x1, 0);
              operands[3] = x5;
              if (altivec_register_operand (operands[3], E_V2DImode)
                  && GET_MODE (x2) == E_V2DImode
                  && GET_MODE (x3) == E_V2DImode)
                {
                  x7 = XEXP (x3, 1);
                  operands[1] = x7;
                  if (altivec_register_operand (operands[1], E_V2DImode))
                    {
                      operands[2] = x4;
                      if (altivec_register_operand (operands[2], E_V2DImode)
                          && 
#line 3049 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                        {
                          *pnum_clobbers = 1;
                          return 3341; /* *fuse_vaddudm_vaddudm */
                        }
                    }
                }
            }
          operands[1] = x6;
          x7 = XEXP (x3, 1);
          if (GET_CODE (x7) != REG
              || REGNO (x7) != 98)
            return -1;
          x5 = XEXP (x1, 0);
          operands[0] = x5;
          switch (GET_CODE (x4))
            {
            case REG:
            case SUBREG:
              operands[2] = x4;
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  if (pattern507 (x2, 
E_SImode) != 0)
                    return -1;
                  *pnum_clobbers = 1;
                  return 90; /* *addsi3_carry_in_internal2 */

                case E_DImode:
                  if (pattern507 (x2, 
E_DImode) != 0
                      || !
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
                    return -1;
                  *pnum_clobbers = 1;
                  return 91; /* *adddi3_carry_in_internal2 */

                default:
                  return -1;
                }

            case CONST_INT:
              if (XWINT (x4, 0) != -1L)
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  if (pattern508 (x2, 
E_SImode) != 0)
                    return -1;
                  *pnum_clobbers = 1;
                  return 94; /* addsi3_carry_in_m1 */

                case E_DImode:
                  if (pattern508 (x2, 
E_DImode) != 0
                      || !
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
                    return -1;
                  *pnum_clobbers = 1;
                  return 95; /* adddi3_carry_in_m1 */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case NOT:
          x7 = XEXP (x3, 1);
          if (GET_CODE (x7) != REG
              || REGNO (x7) != 98)
            return -1;
          x5 = XEXP (x1, 0);
          operands[0] = x5;
          x8 = XEXP (x6, 0);
          operands[1] = x8;
          x4 = XEXP (x2, 1);
          operands[2] = x4;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern492 (x2, 
E_SImode) != 0)
                return -1;
              *pnum_clobbers = 1;
              return 118; /* *subfsi3_carry_in_internal */

            case E_DImode:
              if (pattern492 (x2, 
E_DImode) != 0
                  || !
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
                return -1;
              *pnum_clobbers = 1;
              return 119; /* *subfdi3_carry_in_internal */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case NOT:
      if (pnum_clobbers == NULL)
        return -1;
      x4 = XEXP (x2, 1);
      if (GET_CODE (x4) != REG
          || REGNO (x4) != 98)
        return -1;
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      x6 = XEXP (x3, 0);
      operands[1] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern432 (x2, 
E_SImode) != 0)
            return -1;
          *pnum_clobbers = 1;
          return 120; /* subfsi3_carry_in_0 */

        case E_DImode:
          if (pattern432 (x2, 
E_DImode) != 0
              || !
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
            return -1;
          *pnum_clobbers = 1;
          return 121; /* subfdi3_carry_in_0 */

        default:
          return -1;
        }

    case MINUS:
      if (pnum_clobbers == NULL)
        return -1;
      x6 = XEXP (x3, 0);
      if (GET_CODE (x6) != REG
          || REGNO (x6) != 98)
        return -1;
      x4 = XEXP (x2, 1);
      if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + -2])
        return -1;
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      x7 = XEXP (x3, 1);
      operands[1] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern459 (x2, 
E_SImode) != 0)
            return -1;
          *pnum_clobbers = 1;
          return 122; /* subfsi3_carry_in_m1 */

        case E_DImode:
          if (pattern459 (x2, 
E_DImode) != 0
              || !
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
            return -1;
          *pnum_clobbers = 1;
          return 123; /* subfdi3_carry_in_m1 */

        default:
          return -1;
        }

    case AND:
      x4 = XEXP (x2, 1);
      if (GET_CODE (x4) != ASHIFT)
        return -1;
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      switch (pattern219 (x2))
        {
        case 0:
          if (!
#line 4333 "../../gcc/config/rs6000/rs6000.md"
(INTVAL (operands[2]) > 0
   && INTVAL (operands[2]) == exact_log2 (UINTVAL (operands[4]) + 1)))
            return -1;
          return 262; /* *rotlsi3_insert_3_plus */

        case 1:
          if (!(
#line 4333 "../../gcc/config/rs6000/rs6000.md"
(INTVAL (operands[2]) > 0
   && INTVAL (operands[2]) == exact_log2 (UINTVAL (operands[4]) + 1)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 264; /* *rotldi3_insert_3_plus */

        default:
          return -1;
        }

    case VEC_CONCAT:
      if (pnum_clobbers == NULL
          || GET_MODE (x3) != E_V2DFmode)
        return -1;
      x6 = XEXP (x3, 0);
      if (GET_CODE (x6) != VEC_SELECT
          || GET_MODE (x6) != E_DFmode)
        return -1;
      x11 = XEXP (x6, 1);
      if (GET_CODE (x11) != PARALLEL
          || XVECLEN (x11, 0) != 1)
        return -1;
      x12 = XVECEXP (x11, 0, 0);
      if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x7 = XEXP (x3, 1);
      if (GET_CODE (x7) != VEC_SELECT
          || GET_MODE (x7) != E_DFmode)
        return -1;
      x10 = XEXP (x7, 1);
      if (GET_CODE (x10) != PARALLEL
          || XVECLEN (x10, 0) != 1)
        return -1;
      x13 = XVECEXP (x10, 0, 0);
      if (x13 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      if (pattern4 (x2) != 0
          || !
#line 4927 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode)))
        return -1;
      *pnum_clobbers = 1;
      return 1635; /* vsx_reduc_plus_v2df */

    case UNSPEC:
      if (pnum_clobbers == NULL
          || XVECLEN (x3, 0) != 1
          || XINT (x3, 1) != 102
          || GET_MODE (x3) != E_V4SFmode)
        return -1;
      x14 = XVECEXP (x3, 0, 0);
      if (x14 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      if (!vfloat_operand (operands[0], E_V4SFmode)
          || GET_MODE (x2) != E_V4SFmode)
        return -1;
      x4 = XEXP (x2, 1);
      operands[1] = x4;
      if (!vfloat_operand (operands[1], E_V4SFmode)
          || !
#line 4949 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V4SFmode)))
        return -1;
      *pnum_clobbers = 2;
      return 1638; /* vsx_reduc_plus_v4sf */

    default:
      return -1;
    }
}

 int
recog_87 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  switch (GET_CODE (x4))
    {
    case CONST_INT:
      if (XWINT (x4, 0) != 0L)
        return -1;
      switch (pattern9 (x3))
        {
        case 0:
          if (!(
#line 10614 "../../gcc/config/rs6000/rs6000.md"
(HAVE_AS_TLS && TARGET_ELF) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
            return -1;
          return 754; /* *tls_ld_pcrel32 */

        case 1:
          if (!(
#line 10614 "../../gcc/config/rs6000/rs6000.md"
(HAVE_AS_TLS && TARGET_ELF) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
            return -1;
          return 755; /* *tls_ld_pcrel64 */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      operands[1] = x4;
      switch (pattern292 (x3))
        {
        case 0:
          if (!(
#line 10622 "../../gcc/config/rs6000/rs6000.md"
(HAVE_AS_TLS && TARGET_ELF) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
            return -1;
          return 756; /* *tls_ld32 */

        case 1:
          if (!(
#line 10622 "../../gcc/config/rs6000/rs6000.md"
(HAVE_AS_TLS && TARGET_ELF) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
            return -1;
          return 757; /* *tls_ld64 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_100 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_V4SImode:
      if (pattern378 (x3, 
E_V4SImode) != 0
          || !
#line 6700 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
        return -1;
      return 1780; /* xxblend_v4si */

    case E_V8HImode:
      if (pattern378 (x3, 
E_V8HImode) != 0
          || !
#line 6700 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
        return -1;
      return 1781; /* xxblend_v8hi */

    case E_V16QImode:
      if (pattern378 (x3, 
E_V16QImode) != 0
          || !
#line 6700 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
        return -1;
      return 1782; /* xxblend_v16qi */

    case E_V4SFmode:
      if (pattern378 (x3, 
E_V4SFmode) != 0
          || !
#line 6700 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
        return -1;
      return 1783; /* xxblend_v4sf */

    case E_V2DFmode:
      if (pattern378 (x3, 
E_V2DFmode) != 0
          || !
#line 6700 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
        return -1;
      return 1784; /* xxblend_v2df */

    case E_V2DImode:
      if (pattern435 (x3) != 0
          || !
#line 6700 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
        return -1;
      return 1785; /* xxblend_v2di */

    default:
      return -1;
    }
}

 int
recog_107 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (XINT (x2, 1))
    {
    case 82:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      x6 = XVECEXP (x2, 0, 2);
      switch (GET_CODE (x6))
        {
        case REG:
        case SUBREG:
          operands[3] = x6;
          switch (GET_MODE (operands[0]))
            {
            case E_KFmode:
              if (pattern461 (x2, 
E_KFmode) != 0
                  || !(
#line 15544 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
                return -1;
              return 1193; /* fmakf4_odd */

            case E_TFmode:
              if (pattern461 (x2, 
E_TFmode) != 0
                  || !(
#line 15544 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
                return -1;
              return 1194; /* fmatf4_odd */

            default:
              return -1;
            }

        case NEG:
          x7 = XEXP (x6, 0);
          operands[3] = x7;
          switch (GET_MODE (operands[0]))
            {
            case E_KFmode:
              if (pattern462 (x2, 
E_KFmode) != 0
                  || !(
#line 15557 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
                return -1;
              return 1195; /* *fmskf4_odd */

            case E_TFmode:
              if (pattern462 (x2, 
E_TFmode) != 0
                  || !(
#line 15557 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
                return -1;
              return 1196; /* *fmstf4_odd */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 194:
      switch (pattern163 (x1))
        {
        case 0:
          if (!
#line 4241 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1537; /* vextractlv16qi_internal */

        case 1:
          if (!
#line 4241 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1538; /* vextractlv8hi_internal */

        case 2:
          if (!
#line 4241 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1539; /* vextractlv4si_internal */

        case 3:
          if (!
#line 4241 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1540; /* vextractlv2di_internal */

        default:
          return -1;
        }

    case 195:
      switch (pattern163 (x1))
        {
        case 0:
          if (!
#line 4271 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1541; /* vextractrv16qi_internal */

        case 1:
          if (!
#line 4271 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1542; /* vextractrv8hi_internal */

        case 2:
          if (!
#line 4271 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1543; /* vextractrv4si_internal */

        case 3:
          if (!
#line 4271 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1544; /* vextractrv2di_internal */

        default:
          return -1;
        }

    case 196:
      switch (pattern164 (x1))
        {
        case 0:
          if (!
#line 4298 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1545; /* vinsertvl_internal_v16qi */

        case 1:
          if (!
#line 4352 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1553; /* vinsertgl_internal_v16qi */

        case 2:
          if (!
#line 4298 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1546; /* vinsertvl_internal_v8hi */

        case 3:
          if (!
#line 4352 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1554; /* vinsertgl_internal_v8hi */

        case 4:
          if (!
#line 4298 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1547; /* vinsertvl_internal_v4si */

        case 5:
          if (!
#line 4352 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1555; /* vinsertgl_internal_v4si */

        case 6:
          if (!
#line 4298 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1548; /* vinsertvl_internal_v2di */

        case 7:
          if (!
#line 4352 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1556; /* vinsertgl_internal_v2di */

        default:
          return -1;
        }

    case 197:
      switch (pattern164 (x1))
        {
        case 0:
          if (!
#line 4325 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1549; /* vinsertvr_internal_v16qi */

        case 1:
          if (!
#line 4379 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1557; /* vinsertgr_internal_v16qi */

        case 2:
          if (!
#line 4325 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1550; /* vinsertvr_internal_v8hi */

        case 3:
          if (!
#line 4379 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1558; /* vinsertgr_internal_v8hi */

        case 4:
          if (!
#line 4325 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1551; /* vinsertvr_internal_v4si */

        case 5:
          if (!
#line 4379 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1559; /* vinsertgr_internal_v4si */

        case 6:
          if (!
#line 4325 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1552; /* vinsertvr_internal_v2di */

        case 7:
          if (!
#line 4379 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1560; /* vinsertgr_internal_v2di */

        default:
          return -1;
        }

    case 198:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      x6 = XVECEXP (x2, 0, 2);
      operands[3] = x6;
      if (!const_0_to_12_operand (operands[3], E_QImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V4SImode:
          if (pattern463 (x2, 
E_SImode, 
E_V4SImode) != 0
              || !
#line 4413 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1561; /* vreplace_elt_v4si_inst */

        case E_V4SFmode:
          if (pattern463 (x2, 
E_SFmode, 
E_V4SFmode) != 0
              || !
#line 4413 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1562; /* vreplace_elt_v4sf_inst */

        case E_V2DImode:
          if (pattern463 (x2, 
E_DImode, 
E_V2DImode) != 0
              || !
#line 4413 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1563; /* vreplace_elt_v2di_inst */

        case E_V2DFmode:
          if (pattern463 (x2, 
E_DFmode, 
E_V2DFmode) != 0
              || !
#line 4413 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1564; /* vreplace_elt_v2df_inst */

        default:
          return -1;
        }

    case 199:
      return recog_101 (x1, insn, pnum_clobbers);

    case 123:
      return recog_96 (x1, insn, pnum_clobbers);

    case 126:
      return recog_98 (x1, insn, pnum_clobbers);

    case 160:
      if (pattern165 (x1) != 0
          || !
#line 5738 "../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR && TARGET_64BIT))
        return -1;
      return 1701; /* *lxvl */

    case 161:
      if (pattern165 (x1) != 0
          || !
#line 5748 "../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
        return -1;
      return 1702; /* lxvll */

    case 165:
      if (pattern166 (x1) != 0
          || !
#line 5777 "../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
        return -1;
      return 1703; /* stxvll */

    case 164:
      if (pattern166 (x1) != 0
          || !
#line 5834 "../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR && TARGET_64BIT))
        return -1;
      return 1704; /* *stxvl */

    case 183:
      if (GET_MODE (x2) != E_V16QImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!vsx_register_operand (operands[0], E_V16QImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!vsx_register_operand (operands[1], E_V4SImode))
        return -1;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      if (!vsx_register_operand (operands[2], E_V16QImode))
        return -1;
      x6 = XVECEXP (x2, 0, 2);
      operands[3] = x6;
      if (!const_0_to_12_operand (operands[3], E_QImode)
          || !
#line 6073 "../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
        return -1;
      return 1731; /* *insert4b_internal */

    case 206:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      if (!u1bit_cint_operand (operands[2], E_QImode))
        return -1;
      x6 = XVECEXP (x2, 0, 2);
      operands[3] = x6;
      if (!s32bit_cint_operand (operands[3], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V4SImode:
          if (!register_operand (operands[0], E_V4SImode)
              || GET_MODE (x2) != E_V4SImode
              || !register_operand (operands[1], E_V4SImode)
              || !
#line 6659 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1778; /* xxsplti32dx_v4si_inst */

        case E_V4SFmode:
          if (!register_operand (operands[0], E_V4SFmode)
              || GET_MODE (x2) != E_V4SFmode
              || !register_operand (operands[1], E_V4SFmode)
              || !
#line 6688 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1779; /* xxsplti32dx_v4sf_inst */

        default:
          return -1;
        }

    case 207:
      return recog_100 (x1, insn, pnum_clobbers);

    case 202:
      if (pattern167 (x1, 
E_V2DImode) != 0
          || !
#line 6788 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
        return -1;
      return 1788; /* vmsumcud */

    case 263:
      return recog_95 (x1, insn, pnum_clobbers);

    case 358:
      switch (pattern168 (x1))
        {
        case 0:
          if (!
#line 885 "../../gcc/config/rs6000/altivec.md"
(TARGET_POWER10))
            return -1;
          return 1910; /* vsldb_v16qi */

        case 1:
          if (!
#line 885 "../../gcc/config/rs6000/altivec.md"
(TARGET_POWER10))
            return -1;
          return 1912; /* vsldb_v8hi */

        case 2:
          if (!
#line 885 "../../gcc/config/rs6000/altivec.md"
(TARGET_POWER10))
            return -1;
          return 1914; /* vsldb_v4si */

        case 3:
          if (!
#line 885 "../../gcc/config/rs6000/altivec.md"
(TARGET_POWER10))
            return -1;
          return 1916; /* vsldb_v2di */

        case 4:
          if (!
#line 885 "../../gcc/config/rs6000/altivec.md"
(TARGET_POWER10))
            return -1;
          return 1918; /* vsldb_v1ti */

        default:
          return -1;
        }

    case 359:
      switch (pattern168 (x1))
        {
        case 0:
          if (!
#line 885 "../../gcc/config/rs6000/altivec.md"
(TARGET_POWER10))
            return -1;
          return 1911; /* vsrdb_v16qi */

        case 1:
          if (!
#line 885 "../../gcc/config/rs6000/altivec.md"
(TARGET_POWER10))
            return -1;
          return 1913; /* vsrdb_v8hi */

        case 2:
          if (!
#line 885 "../../gcc/config/rs6000/altivec.md"
(TARGET_POWER10))
            return -1;
          return 1915; /* vsrdb_v4si */

        case 3:
          if (!
#line 885 "../../gcc/config/rs6000/altivec.md"
(TARGET_POWER10))
            return -1;
          return 1917; /* vsrdb_v2di */

        case 4:
          if (!
#line 885 "../../gcc/config/rs6000/altivec.md"
(TARGET_POWER10))
            return -1;
          return 1919; /* vsrdb_v1ti */

        default:
          return -1;
        }

    case 210:
      switch (pattern169 (x1))
        {
        case 0:
          if (!
#line 1011 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
            return -1;
          return 1929; /* altivec_vmsumuhm */

        case 1:
          if (!
#line 1011 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
            return -1;
          return 1930; /* altivec_vmsumubm */

        default:
          return -1;
        }

    case 211:
      if (pattern167 (x1, 
E_V2DImode) != 0
          || !
#line 1021 "../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
        return -1;
      return 1931; /* altivec_vmsumudm */

    case 212:
      switch (pattern169 (x1))
        {
        case 0:
          if (!
#line 1031 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
            return -1;
          return 1932; /* altivec_vmsummhm */

        case 1:
          if (!
#line 1031 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
            return -1;
          return 1933; /* altivec_vmsummbm */

        default:
          return -1;
        }

    case 213:
      if (GET_MODE (x2) != E_V4SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_V4SImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_V8HImode))
        return -1;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      if (!register_operand (operands[2], E_V8HImode))
        return -1;
      x6 = XVECEXP (x2, 0, 2);
      operands[3] = x6;
      if (!register_operand (operands[3], E_V4SImode)
          || !
#line 1041 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
        return -1;
      return 1934; /* altivec_vmsumshm */

    case 346:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      x6 = XVECEXP (x2, 0, 2);
      operands[3] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_V2DImode:
          if (pattern435 (x2) != 0
              || !
#line 2008 "../../gcc/config/rs6000/altivec.md"
(TARGET_P9_VECTOR))
            return -1;
          return 2021; /* altivec_vrldmi */

        case E_V4SImode:
          if (pattern378 (x2, 
E_V4SImode) != 0
              || !
#line 2008 "../../gcc/config/rs6000/altivec.md"
(TARGET_P9_VECTOR))
            return -1;
          return 2022; /* altivec_vrlwmi */

        case E_V1TImode:
          if (pattern132 (x2, 
E_V1TImode) != 0
              || !vsx_register_operand (operands[3], E_V1TImode)
              || !
#line 2036 "../../gcc/config/rs6000/altivec.md"
(TARGET_POWER10))
            return -1;
          return 2023; /* altivec_vrlqmi_inst */

        default:
          return -1;
        }

    case 253:
      return recog_97 (x1, insn, pnum_clobbers);

    case 255:
      switch (pattern170 (x1))
        {
        case 0:
          if (!
#line 2535 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
            return -1;
          return 2085; /* *altivec_vperm_v4si_uns_internal */

        case 1:
          if (!
#line 2535 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
            return -1;
          return 2086; /* *altivec_vperm_v8hi_uns_internal */

        case 2:
          if (!
#line 2535 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
            return -1;
          return 2087; /* *altivec_vperm_v16qi_uns_internal */

        case 3:
          if (!
#line 2535 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
            return -1;
          return 2088; /* *altivec_vperm_v4sf_uns_internal */

        case 4:
          if (!
#line 2535 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
            return -1;
          return 2089; /* *altivec_vperm_v2df_uns_internal */

        case 5:
          if (!
#line 2535 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
            return -1;
          return 2090; /* *altivec_vperm_v2di_uns_internal */

        case 6:
          if (!
#line 2535 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
            return -1;
          return 2091; /* *altivec_vperm_v1ti_uns_internal */

        case 7:
          if (!
#line 2535 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
            return -1;
          return 2092; /* *altivec_vperm_ti_uns_internal */

        case 8:
          if (!(
#line 2535 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          return 2093; /* *altivec_vperm_kf_uns_internal */

        case 9:
          if (!(
#line 2535 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          return 2094; /* *altivec_vperm_tf_uns_internal */

        default:
          return -1;
        }

    case 254:
      return recog_104 (x1, insn, pnum_clobbers);

    case 321:
      if (pattern171 (x1, 
E_V4SImode, 
E_V8HImode) != 0
          || !
#line 3837 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
        return -1;
      return 2291; /* vperm_v8hiv4si */

    case 322:
      if (pattern171 (x1, 
E_V8HImode, 
E_V16QImode) != 0
          || !
#line 3850 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
        return -1;
      return 2292; /* vperm_v16qiv8hi */

    case 335:
      if (pattern167 (x1, 
E_V1TImode) != 0
          || !
#line 4469 "../../gcc/config/rs6000/altivec.md"
(TARGET_VADDUQM))
        return -1;
      return 2326; /* altivec_vaddeuqm */

    case 336:
      if (pattern167 (x1, 
E_V1TImode) != 0
          || !
#line 4479 "../../gcc/config/rs6000/altivec.md"
(TARGET_VADDUQM))
        return -1;
      return 2327; /* altivec_vaddecuq */

    case 338:
      if (pattern167 (x1, 
E_V1TImode) != 0
          || !
#line 4489 "../../gcc/config/rs6000/altivec.md"
(TARGET_VADDUQM))
        return -1;
      return 2328; /* altivec_vsubeuqm */

    case 339:
      if (pattern167 (x1, 
E_V1TImode) != 0
          || !
#line 4499 "../../gcc/config/rs6000/altivec.md"
(TARGET_VADDUQM))
        return -1;
      return 2329; /* altivec_vsubecuq */

    case 342:
      switch (pattern172 (x1, pnum_clobbers))
        {
        case 0:
          if (!
#line 4592 "../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
            return -1;
          *pnum_clobbers = 1;
          return 2333; /* bcdadd_v1ti */

        case 1:
          if (!
#line 4592 "../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
            return -1;
          *pnum_clobbers = 1;
          return 2335; /* bcdadd_v16qi */

        default:
          return -1;
        }

    case 343:
      switch (pattern172 (x1, pnum_clobbers))
        {
        case 0:
          if (!
#line 4592 "../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
            return -1;
          *pnum_clobbers = 1;
          return 2334; /* bcdsub_v1ti */

        case 1:
          if (!
#line 4592 "../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
            return -1;
          *pnum_clobbers = 1;
          return 2336; /* bcdsub_v16qi */

        default:
          return -1;
        }

    case 345:
      if (pnum_clobbers == NULL
          || pattern148 (x1, 
E_V16QImode) != 0)
        return -1;
      x6 = XVECEXP (x2, 0, 2);
      operands[3] = x6;
      if (!const_0_to_1_operand (operands[3], E_QImode)
          || !
#line 4763 "../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
        return -1;
      *pnum_clobbers = 1;
      return 2355; /* bcdshift_v16qi */

    case 417:
      if (pattern173 (x1, 
E_V16QImode) != 0
          || !
#line 540 "../../gcc/config/rs6000/mma.md"
(TARGET_MMA))
        return -1;
      return 2372; /* mma_xvi4ger8pp */

    case 419:
      if (pattern173 (x1, 
E_V16QImode) != 0
          || !
#line 540 "../../gcc/config/rs6000/mma.md"
(TARGET_MMA))
        return -1;
      return 2373; /* mma_xvi8ger4pp */

    case 420:
      if (pattern173 (x1, 
E_V16QImode) != 0
          || !
#line 540 "../../gcc/config/rs6000/mma.md"
(TARGET_MMA))
        return -1;
      return 2374; /* mma_xvi8ger4spp */

    case 413:
      if (pattern173 (x1, 
E_V16QImode) != 0
          || !
#line 540 "../../gcc/config/rs6000/mma.md"
(TARGET_MMA))
        return -1;
      return 2375; /* mma_xvi16ger2pp */

    case 415:
      if (pattern173 (x1, 
E_V16QImode) != 0
          || !
#line 540 "../../gcc/config/rs6000/mma.md"
(TARGET_MMA))
        return -1;
      return 2376; /* mma_xvi16ger2spp */

    case 401:
      if (pattern173 (x1, 
E_V16QImode) != 0
          || !
#line 540 "../../gcc/config/rs6000/mma.md"
(TARGET_MMA))
        return -1;
      return 2377; /* mma_xvf16ger2pp */

    case 400:
      if (pattern173 (x1, 
E_V16QImode) != 0
          || !
#line 540 "../../gcc/config/rs6000/mma.md"
(TARGET_MMA))
        return -1;
      return 2378; /* mma_xvf16ger2pn */

    case 399:
      if (pattern173 (x1, 
E_V16QImode) != 0
          || !
#line 540 "../../gcc/config/rs6000/mma.md"
(TARGET_MMA))
        return -1;
      return 2379; /* mma_xvf16ger2np */

    case 398:
      if (pattern173 (x1, 
E_V16QImode) != 0
          || !
#line 540 "../../gcc/config/rs6000/mma.md"
(TARGET_MMA))
        return -1;
      return 2380; /* mma_xvf16ger2nn */

    case 396:
      if (pattern173 (x1, 
E_V16QImode) != 0
          || !
#line 540 "../../gcc/config/rs6000/mma.md"
(TARGET_MMA))
        return -1;
      return 2381; /* mma_xvbf16ger2pp */

    case 395:
      if (pattern173 (x1, 
E_V16QImode) != 0
          || !
#line 540 "../../gcc/config/rs6000/mma.md"
(TARGET_MMA))
        return -1;
      return 2382; /* mma_xvbf16ger2pn */

    case 394:
      if (pattern173 (x1, 
E_V16QImode) != 0
          || !
#line 540 "../../gcc/config/rs6000/mma.md"
(TARGET_MMA))
        return -1;
      return 2383; /* mma_xvbf16ger2np */

    case 393:
      if (pattern173 (x1, 
E_V16QImode) != 0
          || !
#line 540 "../../gcc/config/rs6000/mma.md"
(TARGET_MMA))
        return -1;
      return 2384; /* mma_xvbf16ger2nn */

    case 406:
      if (pattern173 (x1, 
E_V16QImode) != 0
          || !
#line 540 "../../gcc/config/rs6000/mma.md"
(TARGET_MMA))
        return -1;
      return 2385; /* mma_xvf32gerpp */

    case 405:
      if (pattern173 (x1, 
E_V16QImode) != 0
          || !
#line 540 "../../gcc/config/rs6000/mma.md"
(TARGET_MMA))
        return -1;
      return 2386; /* mma_xvf32gerpn */

    case 404:
      if (pattern173 (x1, 
E_V16QImode) != 0
          || !
#line 540 "../../gcc/config/rs6000/mma.md"
(TARGET_MMA))
        return -1;
      return 2387; /* mma_xvf32gernp */

    case 403:
      if (pattern173 (x1, 
E_V16QImode) != 0
          || !
#line 540 "../../gcc/config/rs6000/mma.md"
(TARGET_MMA))
        return -1;
      return 2388; /* mma_xvf32gernn */

    case 411:
      if (pattern173 (x1, 
E_OOmode) != 0
          || !
#line 559 "../../gcc/config/rs6000/mma.md"
(TARGET_MMA))
        return -1;
      return 2390; /* mma_xvf64gerpp */

    case 410:
      if (pattern173 (x1, 
E_OOmode) != 0
          || !
#line 559 "../../gcc/config/rs6000/mma.md"
(TARGET_MMA))
        return -1;
      return 2391; /* mma_xvf64gerpn */

    case 409:
      if (pattern173 (x1, 
E_OOmode) != 0
          || !
#line 559 "../../gcc/config/rs6000/mma.md"
(TARGET_MMA))
        return -1;
      return 2392; /* mma_xvf64gernp */

    case 408:
      if (pattern173 (x1, 
E_OOmode) != 0
          || !
#line 559 "../../gcc/config/rs6000/mma.md"
(TARGET_MMA))
        return -1;
      return 2393; /* mma_xvf64gernn */

    case 432:
      return recog_103 (x1, insn, pnum_clobbers);

    case 439:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      x6 = XVECEXP (x2, 0, 2);
      operands[3] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_V16QImode:
          if (pattern378 (x2, 
E_V16QImode) != 0
              || !
#line 91 "../../gcc/config/rs6000/crypto.md"
(TARGET_P8_VECTOR))
            return -1;
          return 2485; /* crypto_vpermxor_v16qi */

        case E_V8HImode:
          if (pattern378 (x2, 
E_V8HImode) != 0
              || !
#line 91 "../../gcc/config/rs6000/crypto.md"
(TARGET_P8_VECTOR))
            return -1;
          return 2486; /* crypto_vpermxor_v8hi */

        case E_V4SImode:
          if (pattern378 (x2, 
E_V4SImode) != 0
              || !
#line 91 "../../gcc/config/rs6000/crypto.md"
(TARGET_P8_VECTOR))
            return -1;
          return 2487; /* crypto_vpermxor_v4si */

        case E_V2DImode:
          if (pattern435 (x2) != 0
              || !
#line 91 "../../gcc/config/rs6000/crypto.md"
(TARGET_P8_VECTOR))
            return -1;
          return 2488; /* crypto_vpermxor_v2di */

        default:
          return -1;
        }

    case 438:
      return recog_102 (x1, insn, pnum_clobbers);

    case 445:
      return recog_99 (x1, insn, pnum_clobbers);

    default:
      return -1;
    }
}

 int
recog_130 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != PARALLEL)
    return -1;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  x5 = XEXP (x2, 0);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
    case MEM:
      return recog_123 (x1, insn, pnum_clobbers);

    case VEC_CONCAT:
      switch (XVECLEN (x3, 0))
        {
        case 2:
          x6 = XEXP (x5, 0);
          operands[1] = x6;
          x7 = XEXP (x5, 1);
          operands[2] = x7;
          x8 = XVECEXP (x3, 0, 0);
          operands[3] = x8;
          if (!const_0_to_1_operand (operands[3], E_VOIDmode))
            return -1;
          x9 = XVECEXP (x3, 0, 1);
          operands[4] = x9;
          if (!const_2_to_3_operand (operands[4], E_VOIDmode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V2DFmode:
              if (pattern510 (x2, 
E_V2DFmode, 
E_V4DFmode) != 0
                  || !
#line 3855 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V2DFmode)))
                return -1;
              return 1512; /* vsx_xxpermdi2_v2df_1 */

            case E_V2DImode:
              if (pattern510 (x2, 
E_V2DImode, 
E_V4DImode) != 0
                  || !
#line 3855 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V2DImode)))
                return -1;
              return 1513; /* vsx_xxpermdi2_v2di_1 */

            default:
              return -1;
            }

        case 16:
          if (pattern224 (x3) != 0
              || pattern537 (x2, 
E_V16QImode, 
E_V32QImode) != 0)
            return -1;
          x8 = XVECEXP (x3, 0, 0);
          switch (XWINT (x8, 0))
            {
            case 0L:
              x9 = XVECEXP (x3, 0, 1);
              if (XWINT (x9, 0) != 16L)
                return -1;
              x10 = XVECEXP (x3, 0, 2);
              if (XWINT (x10, 0) != 1L)
                return -1;
              x11 = XVECEXP (x3, 0, 3);
              if (XWINT (x11, 0) != 17L)
                return -1;
              x12 = XVECEXP (x3, 0, 4);
              if (XWINT (x12, 0) != 2L)
                return -1;
              x13 = XVECEXP (x3, 0, 5);
              if (XWINT (x13, 0) != 18L)
                return -1;
              x14 = XVECEXP (x3, 0, 6);
              if (XWINT (x14, 0) != 3L)
                return -1;
              x15 = XVECEXP (x3, 0, 7);
              if (XWINT (x15, 0) != 19L)
                return -1;
              x16 = XVECEXP (x3, 0, 8);
              if (XWINT (x16, 0) != 4L)
                return -1;
              x17 = XVECEXP (x3, 0, 9);
              if (XWINT (x17, 0) != 20L)
                return -1;
              x18 = XVECEXP (x3, 0, 10);
              if (XWINT (x18, 0) != 5L)
                return -1;
              x19 = XVECEXP (x3, 0, 11);
              if (XWINT (x19, 0) != 21L)
                return -1;
              x20 = XVECEXP (x3, 0, 12);
              if (XWINT (x20, 0) != 6L)
                return -1;
              x21 = XVECEXP (x3, 0, 13);
              if (XWINT (x21, 0) != 22L)
                return -1;
              x22 = XVECEXP (x3, 0, 14);
              if (XWINT (x22, 0) != 7L)
                return -1;
              x23 = XVECEXP (x3, 0, 15);
              if (XWINT (x23, 0) != 23L)
                return -1;
              x6 = XEXP (x5, 0);
              operands[1] = x6;
              x7 = XEXP (x5, 1);
              operands[2] = x7;
              if (
#line 1177 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC && BYTES_BIG_ENDIAN))
                return 1958; /* altivec_vmrghb_direct_be */
              operands[2] = x6;
              operands[1] = x7;
              if (!
#line 1351 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC && !BYTES_BIG_ENDIAN))
                return -1;
              return 1968; /* altivec_vmrglb_direct_le */

            case 8L:
              x9 = XVECEXP (x3, 0, 1);
              if (XWINT (x9, 0) != 24L)
                return -1;
              x10 = XVECEXP (x3, 0, 2);
              if (XWINT (x10, 0) != 9L)
                return -1;
              x11 = XVECEXP (x3, 0, 3);
              if (XWINT (x11, 0) != 25L)
                return -1;
              x12 = XVECEXP (x3, 0, 4);
              if (XWINT (x12, 0) != 10L)
                return -1;
              x13 = XVECEXP (x3, 0, 5);
              if (XWINT (x13, 0) != 26L)
                return -1;
              x14 = XVECEXP (x3, 0, 6);
              if (XWINT (x14, 0) != 11L)
                return -1;
              x15 = XVECEXP (x3, 0, 7);
              if (XWINT (x15, 0) != 27L)
                return -1;
              x16 = XVECEXP (x3, 0, 8);
              if (XWINT (x16, 0) != 12L)
                return -1;
              x17 = XVECEXP (x3, 0, 9);
              if (XWINT (x17, 0) != 28L)
                return -1;
              x18 = XVECEXP (x3, 0, 10);
              if (XWINT (x18, 0) != 13L)
                return -1;
              x19 = XVECEXP (x3, 0, 11);
              if (XWINT (x19, 0) != 29L)
                return -1;
              x20 = XVECEXP (x3, 0, 12);
              if (XWINT (x20, 0) != 14L)
                return -1;
              x21 = XVECEXP (x3, 0, 13);
              if (XWINT (x21, 0) != 30L)
                return -1;
              x22 = XVECEXP (x3, 0, 14);
              if (XWINT (x22, 0) != 15L)
                return -1;
              x23 = XVECEXP (x3, 0, 15);
              if (XWINT (x23, 0) != 31L)
                return -1;
              x6 = XEXP (x5, 0);
              operands[2] = x6;
              x7 = XEXP (x5, 1);
              operands[1] = x7;
              if (
#line 1195 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC && !BYTES_BIG_ENDIAN))
                return 1959; /* altivec_vmrghb_direct_le */
              operands[1] = x6;
              operands[2] = x7;
              if (!
#line 1333 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC && BYTES_BIG_ENDIAN))
                return -1;
              return 1967; /* altivec_vmrglb_direct_be */

            default:
              return -1;
            }

        case 8:
          if (pattern225 (x3) != 0
              || pattern537 (x2, 
E_V8HImode, 
E_V16HImode) != 0)
            return -1;
          x8 = XVECEXP (x3, 0, 0);
          switch (XWINT (x8, 0))
            {
            case 0L:
              x9 = XVECEXP (x3, 0, 1);
              if (XWINT (x9, 0) != 8L)
                return -1;
              x10 = XVECEXP (x3, 0, 2);
              if (XWINT (x10, 0) != 1L)
                return -1;
              x11 = XVECEXP (x3, 0, 3);
              if (XWINT (x11, 0) != 9L)
                return -1;
              x12 = XVECEXP (x3, 0, 4);
              if (XWINT (x12, 0) != 2L)
                return -1;
              x13 = XVECEXP (x3, 0, 5);
              if (XWINT (x13, 0) != 10L)
                return -1;
              x14 = XVECEXP (x3, 0, 6);
              if (XWINT (x14, 0) != 3L)
                return -1;
              x15 = XVECEXP (x3, 0, 7);
              if (XWINT (x15, 0) != 11L)
                return -1;
              x6 = XEXP (x5, 0);
              operands[1] = x6;
              x7 = XEXP (x5, 1);
              operands[2] = x7;
              if (
#line 1224 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC && BYTES_BIG_ENDIAN))
                return 1960; /* altivec_vmrghh_direct_be */
              operands[2] = x6;
              operands[1] = x7;
              if (!
#line 1394 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC && !BYTES_BIG_ENDIAN))
                return -1;
              return 1970; /* altivec_vmrglh_direct_le */

            case 4L:
              x9 = XVECEXP (x3, 0, 1);
              if (XWINT (x9, 0) != 12L)
                return -1;
              x10 = XVECEXP (x3, 0, 2);
              if (XWINT (x10, 0) != 5L)
                return -1;
              x11 = XVECEXP (x3, 0, 3);
              if (XWINT (x11, 0) != 13L)
                return -1;
              x12 = XVECEXP (x3, 0, 4);
              if (XWINT (x12, 0) != 6L)
                return -1;
              x13 = XVECEXP (x3, 0, 5);
              if (XWINT (x13, 0) != 14L)
                return -1;
              x14 = XVECEXP (x3, 0, 6);
              if (XWINT (x14, 0) != 7L)
                return -1;
              x15 = XVECEXP (x3, 0, 7);
              if (XWINT (x15, 0) != 15L)
                return -1;
              x6 = XEXP (x5, 0);
              operands[2] = x6;
              x7 = XEXP (x5, 1);
              operands[1] = x7;
              if (
#line 1238 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC && !BYTES_BIG_ENDIAN))
                return 1961; /* altivec_vmrghh_direct_le */
              operands[1] = x6;
              operands[2] = x7;
              if (!
#line 1380 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC && BYTES_BIG_ENDIAN))
                return -1;
              return 1969; /* altivec_vmrglh_direct_be */

            default:
              return -1;
            }

        case 4:
          if (pattern226 (x3) != 0)
            return -1;
          x8 = XVECEXP (x3, 0, 0);
          switch (XWINT (x8, 0))
            {
            case 0L:
              x9 = XVECEXP (x3, 0, 1);
              if (XWINT (x9, 0) != 4L)
                return -1;
              x10 = XVECEXP (x3, 0, 2);
              switch (XWINT (x10, 0))
                {
                case 1L:
                  x11 = XVECEXP (x3, 0, 3);
                  if (XWINT (x11, 0) != 5L)
                    return -1;
                  switch (GET_MODE (operands[0]))
                    {
                    case E_V4SFmode:
                      if (pattern537 (x2, 
E_V4SFmode, 
E_V8SFmode) != 0)
                        return -1;
                      x7 = XEXP (x5, 1);
                      operands[2] = x7;
                      x6 = XEXP (x5, 0);
                      operands[1] = x6;
                      if (
#line 1267 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC && BYTES_BIG_ENDIAN))
                        return 1962; /* altivec_vmrghw_direct_v4sf_be */
                      if (
#line 1295 "../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_P (V4SFmode)))
                        return 1966; /* *altivec_vmrghsf */
                      operands[1] = x7;
                      operands[2] = x6;
                      if (!
#line 1437 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC && !BYTES_BIG_ENDIAN))
                        return -1;
                      return 1973; /* altivec_vmrglw_direct_v4sf_le */

                    case E_V4SImode:
                      if (pattern537 (x2, 
E_V4SImode, 
E_V8SImode) != 0)
                        return -1;
                      x7 = XEXP (x5, 1);
                      operands[2] = x7;
                      x6 = XEXP (x5, 0);
                      operands[1] = x6;
                      if (
#line 1267 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC && BYTES_BIG_ENDIAN))
                        return 1963; /* altivec_vmrghw_direct_v4si_be */
                      operands[1] = x7;
                      operands[2] = x6;
                      if (!
#line 1437 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC && !BYTES_BIG_ENDIAN))
                        return -1;
                      return 1974; /* altivec_vmrglw_direct_v4si_le */

                    default:
                      return -1;
                    }

                case 2L:
                  x11 = XVECEXP (x3, 0, 3);
                  if (XWINT (x11, 0) != 6L)
                    return -1;
                  switch (pattern539 (x2))
                    {
                    case 0:
                      if (!
#line 1487 "../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
                        return -1;
                      return 1976; /* p8_vmrgew_v4sf */

                    case 1:
                      if (!
#line 1487 "../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
                        return -1;
                      return 1977; /* p8_vmrgew_v4si */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            case 2L:
              x9 = XVECEXP (x3, 0, 1);
              if (XWINT (x9, 0) != 6L)
                return -1;
              x10 = XVECEXP (x3, 0, 2);
              if (XWINT (x10, 0) != 3L)
                return -1;
              x11 = XVECEXP (x3, 0, 3);
              if (XWINT (x11, 0) != 7L)
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_V4SFmode:
                  if (pattern537 (x2, 
E_V4SFmode, 
E_V8SFmode) != 0)
                    return -1;
                  x7 = XEXP (x5, 1);
                  operands[1] = x7;
                  x6 = XEXP (x5, 0);
                  operands[2] = x6;
                  if (
#line 1281 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC && !BYTES_BIG_ENDIAN))
                    return 1964; /* altivec_vmrghw_direct_v4sf_le */
                  operands[2] = x7;
                  operands[1] = x6;
                  if (
#line 1423 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC && BYTES_BIG_ENDIAN))
                    return 1971; /* altivec_vmrglw_direct_v4sf_be */
                  if (!
#line 1451 "../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_P (V4SFmode)))
                    return -1;
                  return 1975; /* *altivec_vmrglsf */

                case E_V4SImode:
                  if (pattern537 (x2, 
E_V4SImode, 
E_V8SImode) != 0)
                    return -1;
                  x7 = XEXP (x5, 1);
                  operands[1] = x7;
                  x6 = XEXP (x5, 0);
                  operands[2] = x6;
                  if (
#line 1281 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC && !BYTES_BIG_ENDIAN))
                    return 1965; /* altivec_vmrghw_direct_v4si_le */
                  operands[2] = x7;
                  operands[1] = x6;
                  if (!
#line 1423 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC && BYTES_BIG_ENDIAN))
                    return -1;
                  return 1972; /* altivec_vmrglw_direct_v4si_be */

                default:
                  return -1;
                }

            case 1L:
              x9 = XVECEXP (x3, 0, 1);
              if (XWINT (x9, 0) != 5L)
                return -1;
              x10 = XVECEXP (x3, 0, 2);
              if (XWINT (x10, 0) != 3L)
                return -1;
              x11 = XVECEXP (x3, 0, 3);
              if (XWINT (x11, 0) != 7L)
                return -1;
              switch (pattern539 (x2))
                {
                case 0:
                  if (!
#line 1504 "../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
                    return -1;
                  return 1978; /* p8_vmrgow_v4sf */

                case 1:
                  if (!
#line 1504 "../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
                    return -1;
                  return 1979; /* p8_vmrgow_v4si */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case PLUS:
      switch (pattern176 (x2, pnum_clobbers))
        {
        case 0:
          if (!
#line 4997 "../../gcc/config/rs6000/vsx.md"
(BYTES_BIG_ENDIAN && VECTOR_UNIT_VSX_P (V2DFmode)))
            return -1;
          *pnum_clobbers = 1;
          return 1641; /* *vsx_reduc_plus_v2df_scalar */

        case 1:
          if (!
#line 5024 "../../gcc/config/rs6000/vsx.md"
(BYTES_BIG_ENDIAN && VECTOR_UNIT_VSX_P (V4SFmode)))
            return -1;
          *pnum_clobbers = 3;
          return 1644; /* *vsx_reduc_plus_v4sf_scalar */

        default:
          return -1;
        }

    case SMIN:
      switch (pattern176 (x2, pnum_clobbers))
        {
        case 0:
          if (!
#line 4997 "../../gcc/config/rs6000/vsx.md"
(BYTES_BIG_ENDIAN && VECTOR_UNIT_VSX_P (V2DFmode)))
            return -1;
          *pnum_clobbers = 1;
          return 1642; /* *vsx_reduc_smin_v2df_scalar */

        case 1:
          if (!
#line 5024 "../../gcc/config/rs6000/vsx.md"
(BYTES_BIG_ENDIAN && VECTOR_UNIT_VSX_P (V4SFmode)))
            return -1;
          *pnum_clobbers = 3;
          return 1645; /* *vsx_reduc_smin_v4sf_scalar */

        default:
          return -1;
        }

    case SMAX:
      switch (pattern176 (x2, pnum_clobbers))
        {
        case 0:
          if (!
#line 4997 "../../gcc/config/rs6000/vsx.md"
(BYTES_BIG_ENDIAN && VECTOR_UNIT_VSX_P (V2DFmode)))
            return -1;
          *pnum_clobbers = 1;
          return 1643; /* *vsx_reduc_smax_v2df_scalar */

        case 1:
          if (!
#line 5024 "../../gcc/config/rs6000/vsx.md"
(BYTES_BIG_ENDIAN && VECTOR_UNIT_VSX_P (V4SFmode)))
            return -1;
          *pnum_clobbers = 3;
          return 1646; /* *vsx_reduc_smax_v4sf_scalar */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_140 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_DFmode:
          if (!gpc_reg_operand (operands[0], E_DFmode)
              || GET_MODE (x3) != E_DFmode)
            return -1;
          if (reg_or_mem_operand (operands[1], E_SFmode)
              && 
#line 5241 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && !HONOR_SNANS (SFmode)))
            return 328; /* *extendsfdf2_fpr */
          if (!gpc_reg_operand (operands[1], E_SFmode)
              || !
#line 5262 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && HONOR_SNANS (SFmode)))
            return -1;
          return 329; /* *extendsfdf2_snan */

        case E_IFmode:
          switch (pattern205 (x3))
            {
            case 0:
              if (!(
#line 8930 "../../gcc/config/rs6000/rs6000.md"
(TARGET_LONG_DOUBLE_128 && TARGET_VSX) && 
#line 630 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IBM_P (IFmode))))
                return -1;
              return 613; /* extenddfif2_vsx */

            case 1:
              if (!
#line 9461 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_TYPE
    && FLOAT128_IBM_P (TFmode) == FLOAT128_IBM_P (IFmode)))
                return -1;
              return 639; /* *extendtfif2_internal */

            default:
              return -1;
            }

        case E_TFmode:
          if (GET_MODE (x3) != E_TFmode)
            return -1;
          if (gpc_reg_operand (operands[0], E_TFmode))
            {
              switch (pattern316 ())
                {
                case 0:
                  if ((
#line 8930 "../../gcc/config/rs6000/rs6000.md"
(TARGET_LONG_DOUBLE_128 && TARGET_VSX) && 
#line 631 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IBM_P (TFmode))))
                    return 614; /* extenddftf2_vsx */
                  break;

                case 1:
                  if (
#line 9448 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_TYPE
    && FLOAT128_IBM_P (TFmode) == FLOAT128_IBM_P (IFmode)))
                    return 637; /* *extendiftf2_internal */
                  break;

                case 2:
                  if (
#line 9448 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_TYPE
    && FLOAT128_IBM_P (TFmode) == FLOAT128_IBM_P (KFmode)))
                    return 638; /* *extendkftf2_internal */
                  break;

                default:
                  break;
                }
            }
          if (altivec_register_operand (operands[0], E_TFmode))
            {
              switch (GET_MODE (operands[1]))
                {
                case E_SFmode:
                  if (altivec_register_operand (operands[1], E_SFmode)
                      && (
#line 15201 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
                    return 1122; /* extendsftf2_hw */
                  break;

                case E_DFmode:
                  if (altivec_register_operand (operands[1], E_DFmode)
                      && (
#line 15201 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
                    return 1124; /* extenddftf2_hw */
                  break;

                default:
                  break;
                }
            }
          if (!vsx_register_operand (operands[0], E_TFmode)
              || !vsx_register_operand (operands[1], E_KFmode)
              || !
#line 15211 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_TYPE && TARGET_IEEEQUAD))
            return -1;
          return 1125; /* *extendkftf2 */

        case E_KFmode:
          if (GET_MODE (x3) != E_KFmode)
            return -1;
          if (gpc_reg_operand (operands[0], E_KFmode)
              && gpc_reg_operand (operands[1], E_TFmode)
              && 
#line 9461 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_TYPE
    && FLOAT128_IBM_P (TFmode) == FLOAT128_IBM_P (KFmode)))
            return 640; /* *extendtfkf2_internal */
          if (altivec_register_operand (operands[0], E_KFmode))
            {
              switch (GET_MODE (operands[1]))
                {
                case E_SFmode:
                  if (altivec_register_operand (operands[1], E_SFmode)
                      && (
#line 15201 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
                    return 1121; /* extendsfkf2_hw */
                  break;

                case E_DFmode:
                  if (altivec_register_operand (operands[1], E_DFmode)
                      && (
#line 15201 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
                    return 1123; /* extenddfkf2_hw */
                  break;

                default:
                  break;
                }
            }
          if (!vsx_register_operand (operands[0], E_KFmode)
              || !vsx_register_operand (operands[1], E_TFmode)
              || !
#line 15227 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_TYPE && TARGET_IEEEQUAD))
            return -1;
          return 1126; /* *extendtfkf2 */

        case E_DDmode:
          if (!gpc_reg_operand (operands[0], E_DDmode)
              || GET_MODE (x3) != E_DDmode
              || !gpc_reg_operand (operands[1], E_SDmode)
              || !
#line 62 "../../gcc/config/rs6000/dfp.md"
(TARGET_DFP))
            return -1;
          return 2425; /* extendsddd2 */

        case E_TDmode:
          if (!gpc_reg_operand (operands[0], E_TDmode)
              || GET_MODE (x3) != E_TDmode
              || !gpc_reg_operand (operands[1], E_DDmode)
              || !
#line 140 "../../gcc/config/rs6000/dfp.md"
(TARGET_DFP))
            return -1;
          return 2433; /* extendddtd2 */

        default:
          return -1;
        }

    case VEC_SELECT:
      switch (pattern7 (x3, 
E_V2DFmode))
        {
        case 0:
          if (!
#line 2371 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V4SFmode) && BYTES_BIG_ENDIAN))
            return -1;
          return 1420; /* vsx_xvcvspdp_be */

        case 1:
          if (!
#line 2380 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V4SFmode) && !BYTES_BIG_ENDIAN))
            return -1;
          return 1421; /* vsx_xvcvspdp_le */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_151 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case SYMBOL_REF:
      operands[1] = x4;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern123 (x3, 
E_SImode) == 0)
            return 275; /* rotlsi3 */
          break;

        case E_DImode:
          if (pattern123 (x3, 
E_DImode) == 0
              && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
            return 276; /* rotldi3 */
          break;

        case E_V4SImode:
          if (pattern3 (x3, 
E_V4SImode) == 0
              && 
#line 1989 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V4SImode)))
            return 2016; /* altivec_vrlw */
          break;

        case E_V8HImode:
          if (pattern3 (x3, 
E_V8HImode) == 0
              && 
#line 1989 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V8HImode)))
            return 2017; /* altivec_vrlh */
          break;

        case E_V16QImode:
          if (pattern3 (x3, 
E_V16QImode) == 0
              && 
#line 1989 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V16QImode)))
            return 2018; /* altivec_vrlb */
          break;

        case E_V2DImode:
          if (pattern3 (x3, 
E_V2DImode) == 0
              && 
#line 1989 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_P8_VECTOR_P (V2DImode)))
            return 2019; /* altivec_vrld */
          break;

        case E_V1TImode:
          if (pattern2 (x3, 
E_V1TImode) == 0
              && 
#line 1997 "../../gcc/config/rs6000/altivec.md"
(TARGET_POWER10))
            return 2020; /* altivec_vrlq */
          break;

        default:
          break;
        }
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 64])
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V1TImode:
          if (!nonimmediate_operand (operands[0], E_V1TImode)
              || GET_MODE (x3) != E_V1TImode
              || !input_operand (operands[1], E_V1TImode)
              || !
#line 1003 "../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX && !TARGET_P9_VECTOR))
            return -1;
          return 1271; /* *vsx_le_permute_v1ti */

        case E_TImode:
          if (!nonimmediate_operand (operands[0], E_TImode)
              || GET_MODE (x3) != E_TImode
              || !input_operand (operands[1], E_TImode)
              || !
#line 1003 "../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX && !TARGET_P9_VECTOR))
            return -1;
          return 1272; /* *vsx_le_permute_ti */

        default:
          return -1;
        }

    case ROTATE:
      x6 = XEXP (x4, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 64])
        return -1;
      x5 = XEXP (x3, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 64])
        return -1;
      switch (pattern215 (x3))
        {
        case 0:
          if (!
#line 1021 "../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX))
            return -1;
          return 1273; /* *vsx_le_undo_permute_v1ti */

        case 1:
          if (!
#line 1021 "../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX))
            return -1;
          return 1274; /* *vsx_le_undo_permute_ti */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_161 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[3] = x3;
  if (!altivec_register_operand (operands[3], E_V2DImode))
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != E_V2DImode)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != E_V2DImode)
    return -1;
  x6 = XEXP (x5, 1);
  operands[1] = x6;
  if (!altivec_register_operand (operands[1], E_V2DImode))
    return -1;
  x7 = XEXP (x4, 1);
  operands[2] = x7;
  if (!altivec_register_operand (operands[2], E_V2DImode))
    return -1;
  x8 = XVECEXP (x1, 0, 1);
  x9 = XEXP (x8, 0);
  operands[4] = x9;
  if (!scratch_operand (operands[4], E_V2DImode)
      || !
#line 3049 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
    return -1;
  return 3341; /* *fuse_vaddudm_vaddudm */
}

 int
recog_165 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
      operands[0] = x3;
      x4 = XVECEXP (x1, 0, 1);
      x5 = XEXP (x4, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x6 = XEXP (x4, 0);
      if (GET_CODE (x6) != REG
          || REGNO (x6) != 98)
        return -1;
      x7 = XEXP (x2, 1);
      operands[1] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!gpc_reg_operand (operands[0], E_SImode)
              || !gpc_reg_operand (operands[1], E_SImode)
              || GET_MODE (x6) != E_SImode
              || !
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT))
            return -1;
          return 82; /* *addsi3_imm_carry_0 */

        case E_DImode:
          if (!gpc_reg_operand (operands[0], E_DImode)
              || !gpc_reg_operand (operands[1], E_DImode)
              || GET_MODE (x6) != E_DImode
              || !
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT))
            return -1;
          return 83; /* *adddi3_imm_carry_0 */

        default:
          return -1;
        }

    case MEM:
      x8 = XEXP (x3, 0);
      if (GET_CODE (x8) != PLUS)
        return -1;
      x4 = XVECEXP (x1, 0, 1);
      x5 = XEXP (x4, 1);
      if (GET_CODE (x5) != PLUS)
        return -1;
      x9 = XEXP (x8, 0);
      operands[1] = x9;
      x10 = XEXP (x8, 1);
      operands[2] = x10;
      x7 = XEXP (x2, 1);
      operands[3] = x7;
      x6 = XEXP (x4, 0);
      operands[0] = x6;
      x11 = XEXP (x5, 0);
      if (!rtx_equal_p (x11, operands[1]))
        return -1;
      x12 = XEXP (x5, 1);
      if (!rtx_equal_p (x12, operands[2]))
        return -1;
      switch (GET_MODE (x3))
        {
        case E_DImode:
          if (!gpc_reg_operand (operands[3], E_DImode))
            return -1;
          switch (GET_MODE (x8))
            {
            case E_SImode:
              if (pattern581 (x5, 
E_SImode) != 0
                  || !(
#line 10257 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64 && TARGET_UPDATE
   && (!avoiding_indexed_address_p (DImode)
       || !gpc_reg_operand (operands[2], Pmode)
       || (REG_P (operands[0])
	   && REGNO (operands[0]) == STACK_POINTER_REGNUM))) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                return -1;
              return 704; /* movdi_si_update */

            case E_DImode:
              if (pattern581 (x5, 
E_DImode) != 0)
                return -1;
              if ((
#line 10257 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64 && TARGET_UPDATE
   && (!avoiding_indexed_address_p (DImode)
       || !gpc_reg_operand (operands[2], Pmode)
       || (REG_P (operands[0])
	   && REGNO (operands[0]) == STACK_POINTER_REGNUM))) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                return 705; /* movdi_di_update */
              if (!
#line 10277 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT))
                return -1;
              return 706; /* movdi_update_stack */

            default:
              return -1;
            }

        case E_SImode:
          switch (pattern572 (x1, 
E_SImode))
            {
            case 0:
              if ((
#line 10321 "../../gcc/config/rs6000/rs6000.md"
(TARGET_UPDATE
   && (!avoiding_indexed_address_p (SImode)
       || !gpc_reg_operand (operands[2], Pmode)
       || (REG_P (operands[0])
	   && REGNO (operands[0]) == STACK_POINTER_REGNUM))) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                return 711; /* movsi_si_update */
              if (!
#line 10341 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT))
                return -1;
              return 713; /* movsi_update_stack */

            case 1:
              if (!(
#line 10321 "../../gcc/config/rs6000/rs6000.md"
(TARGET_UPDATE
   && (!avoiding_indexed_address_p (SImode)
       || !gpc_reg_operand (operands[2], Pmode)
       || (REG_P (operands[0])
	   && REGNO (operands[0]) == STACK_POINTER_REGNUM))) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                return -1;
              return 712; /* movsi_di_update */

            default:
              return -1;
            }

        case E_HImode:
          switch (pattern572 (x1, 
E_HImode))
            {
            case 0:
              if (!(
#line 10406 "../../gcc/config/rs6000/rs6000.md"
(TARGET_UPDATE
   && (!avoiding_indexed_address_p (HImode)
       || !gpc_reg_operand (operands[2], Pmode))) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                return -1;
              return 724; /* *movhi_update4 */

            case 1:
              if (!(
#line 10406 "../../gcc/config/rs6000/rs6000.md"
(TARGET_UPDATE
   && (!avoiding_indexed_address_p (HImode)
       || !gpc_reg_operand (operands[2], Pmode))) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                return -1;
              return 725; /* *movhi_update4 */

            default:
              return -1;
            }

        case E_QImode:
          switch (pattern572 (x1, 
E_QImode))
            {
            case 0:
              if (!(
#line 10455 "../../gcc/config/rs6000/rs6000.md"
(TARGET_UPDATE
   && (!avoiding_indexed_address_p (QImode)
       || !gpc_reg_operand (operands[2], Pmode))) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                return -1;
              return 732; /* *movqi_update3 */

            case 1:
              if (!(
#line 10455 "../../gcc/config/rs6000/rs6000.md"
(TARGET_UPDATE
   && (!avoiding_indexed_address_p (QImode)
       || !gpc_reg_operand (operands[2], Pmode))) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                return -1;
              return 733; /* *movqi_update3 */

            default:
              return -1;
            }

        case E_SFmode:
          switch (pattern572 (x1, 
E_SFmode))
            {
            case 0:
              if ((
#line 10488 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_UPDATE
   && (!avoiding_indexed_address_p (SFmode)
       || !gpc_reg_operand (operands[2], Pmode))) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                return 738; /* *movsf_update2 */
              if (!(
#line 10521 "../../gcc/config/rs6000/rs6000.md"
(TARGET_SOFT_FLOAT && TARGET_UPDATE
   && (!avoiding_indexed_address_p (SFmode)
       || !gpc_reg_operand (operands[2], Pmode))) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                return -1;
              return 744; /* *movsf_update4 */

            case 1:
              if ((
#line 10488 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_UPDATE
   && (!avoiding_indexed_address_p (SFmode)
       || !gpc_reg_operand (operands[2], Pmode))) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                return 739; /* *movsf_update2 */
              if (!(
#line 10521 "../../gcc/config/rs6000/rs6000.md"
(TARGET_SOFT_FLOAT && TARGET_UPDATE
   && (!avoiding_indexed_address_p (SFmode)
       || !gpc_reg_operand (operands[2], Pmode))) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                return -1;
              return 745; /* *movsf_update4 */

            default:
              return -1;
            }

        case E_DFmode:
          switch (pattern572 (x1, 
E_DFmode))
            {
            case 0:
              if (!(
#line 10488 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_UPDATE
   && (!avoiding_indexed_address_p (DFmode)
       || !gpc_reg_operand (operands[2], Pmode))) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                return -1;
              return 740; /* *movdf_update2 */

            case 1:
              if (!(
#line 10488 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_UPDATE
   && (!avoiding_indexed_address_p (DFmode)
       || !gpc_reg_operand (operands[2], Pmode))) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                return -1;
              return 741; /* *movdf_update2 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_173 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  switch (XVECLEN (x3, 0))
    {
    case 2:
      return recog_157 (x1, insn, pnum_clobbers);

    case 1:
      return recog_156 (x1, insn, pnum_clobbers);

    case 3:
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      x5 = XVECEXP (x3, 0, 0);
      operands[1] = x5;
      switch (XINT (x3, 1))
        {
        case 123:
          if (GET_MODE (x3) != E_V4SFmode)
            return -1;
          x6 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x6) != CLOBBER
              || !gpc_reg_operand (operands[0], E_V4SFmode))
            return -1;
          switch (pattern470 (x1))
            {
            case 0:
              if (!
#line 4616 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SFmode) && TARGET_P9_VECTOR && TARGET_POWERPC64))
                return -1;
              return 1606; /* vsx_set_v4sf_p9 */

            case 1:
              if (!
#line 4652 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SFmode) && TARGET_P9_VECTOR && TARGET_POWERPC64))
                return -1;
              return 1607; /* *vsx_set_v4sf_p9_zero */

            case 2:
              if (!
#line 4712 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SFmode) && VECTOR_MEM_VSX_P (V4SImode)
   && TARGET_P9_VECTOR && TARGET_POWERPC64
   && (INTVAL (operands[3]) != (BYTES_BIG_ENDIAN ? 1 : 2))))
                return -1;
              return 1609; /* *vsx_insert_extract_v4sf_p9_2 */

            default:
              return -1;
            }

        case 214:
          if (pattern349 (x1, 
E_V4SImode) != 0
              || !
#line 1052 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
            return -1;
          return 1935; /* altivec_vmsumuhs */

        case 215:
          if (pattern349 (x1, 
E_V4SImode) != 0
              || !
#line 1063 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
            return -1;
          return 1936; /* altivec_vmsumshs */

        case 216:
          if (pattern349 (x1, 
E_V8HImode) != 0
              || !
#line 1124 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
            return -1;
          return 1955; /* altivec_vmhaddshs */

        case 217:
          if (pattern349 (x1, 
E_V8HImode) != 0
              || !
#line 1135 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
            return -1;
          return 1956; /* altivec_vmhraddshs */

        case 342:
          switch (pattern351 (x1, 
342))
            {
            case 0:
              if (!
#line 4592 "../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
                return -1;
              return 2333; /* bcdadd_v1ti */

            case 1:
              if (!
#line 4592 "../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
                return -1;
              return 2335; /* bcdadd_v16qi */

            case 2:
              if (!
#line 4627 "../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
                return -1;
              return 2341; /* *bcdadd_test2_v1ti */

            case 3:
              if (!
#line 4627 "../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
                return -1;
              return 2343; /* *bcdadd_test2_v16qi */

            default:
              return -1;
            }

        case 343:
          switch (pattern351 (x1, 
343))
            {
            case 0:
              if (!
#line 4592 "../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
                return -1;
              return 2334; /* bcdsub_v1ti */

            case 1:
              if (!
#line 4592 "../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
                return -1;
              return 2336; /* bcdsub_v16qi */

            case 2:
              if (!
#line 4627 "../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
                return -1;
              return 2342; /* *bcdsub_test2_v1ti */

            case 3:
              if (!
#line 4627 "../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
                return -1;
              return 2344; /* *bcdsub_test2_v16qi */

            default:
              return -1;
            }

        case 345:
          if (GET_MODE (x3) != E_V16QImode)
            return -1;
          x6 = XVECEXP (x1, 0, 1);
          if (pattern253 (x6, 
E_CCFPmode, 
106) != 0
              || !register_operand (operands[0], E_V16QImode)
              || !register_operand (operands[1], E_V16QImode))
            return -1;
          x7 = XVECEXP (x3, 0, 1);
          operands[2] = x7;
          if (!register_operand (operands[2], E_V16QImode))
            return -1;
          x8 = XVECEXP (x3, 0, 2);
          operands[3] = x8;
          if (!const_0_to_1_operand (operands[3], E_QImode)
              || !
#line 4763 "../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
            return -1;
          return 2355; /* bcdshift_v16qi */

        case 445:
          x6 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x6) != CLOBBER)
            return -1;
          x7 = XVECEXP (x3, 0, 1);
          operands[2] = x7;
          x8 = XVECEXP (x3, 0, 2);
          operands[3] = x8;
          if (!const_int_operand (operands[3], E_VOIDmode))
            return -1;
          x9 = XEXP (x6, 0);
          operands[4] = x9;
          switch (GET_MODE (operands[0]))
            {
            case E_QImode:
              if (pattern540 (x3, 
E_QImode) != 0
                  || !
#line 152 "../../gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT
   && (GET_CODE (operands[4]) == SCRATCH
       || reg_mentioned_p (operands[4], operands[1]))))
                return -1;
              return 3344; /* *pcrel_opt_ldqi_gpr */

            case E_HImode:
              if (pattern540 (x3, 
E_HImode) != 0
                  || !
#line 152 "../../gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT
   && (GET_CODE (operands[4]) == SCRATCH
       || reg_mentioned_p (operands[4], operands[1]))))
                return -1;
              return 3345; /* *pcrel_opt_ldhi_gpr */

            case E_SImode:
              if (pattern540 (x3, 
E_SImode) != 0
                  || !
#line 152 "../../gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT
   && (GET_CODE (operands[4]) == SCRATCH
       || reg_mentioned_p (operands[4], operands[1]))))
                return -1;
              return 3346; /* *pcrel_opt_ldsi_gpr */

            case E_DImode:
              if (GET_MODE (x3) != E_DImode
                  || !d_form_memory (operands[1], E_DImode))
                return -1;
              if (int_reg_operand (operands[0], E_DImode)
                  && int_reg_operand (operands[2], E_DImode)
                  && scratch_operand (operands[4], E_DImode)
                  && 
#line 152 "../../gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT
   && (GET_CODE (operands[4]) == SCRATCH
       || reg_mentioned_p (operands[4], operands[1]))))
                return 3347; /* *pcrel_opt_lddi_gpr */
              if (!vsx_register_operand (operands[0], E_DImode)
                  || !vsx_register_operand (operands[2], E_DImode)
                  || !base_reg_operand (operands[4], E_DImode)
                  || !
#line 224 "../../gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT))
                return -1;
              return 3358; /* *pcrel_opt_lddi_vsx */

            case E_SFmode:
              if (GET_MODE (x3) != E_SFmode
                  || !d_form_memory (operands[1], E_SFmode))
                return -1;
              if (int_reg_operand (operands[0], E_SFmode)
                  && int_reg_operand (operands[2], E_DImode)
                  && scratch_operand (operands[4], E_DImode)
                  && 
#line 152 "../../gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT
   && (GET_CODE (operands[4]) == SCRATCH
       || reg_mentioned_p (operands[4], operands[1]))))
                return 3348; /* *pcrel_opt_ldsf_gpr */
              if (!vsx_register_operand (operands[0], E_SFmode)
                  || !vsx_register_operand (operands[2], E_DImode)
                  || !base_reg_operand (operands[4], E_DImode)
                  || !
#line 224 "../../gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT))
                return -1;
              return 3360; /* *pcrel_opt_ldsf_vsx */

            case E_DFmode:
              if (GET_MODE (x3) != E_DFmode
                  || !d_form_memory (operands[1], E_DFmode))
                return -1;
              if (int_reg_operand (operands[0], E_DFmode)
                  && int_reg_operand (operands[2], E_DImode)
                  && scratch_operand (operands[4], E_DImode)
                  && 
#line 152 "../../gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT
   && (GET_CODE (operands[4]) == SCRATCH
       || reg_mentioned_p (operands[4], operands[1]))))
                return 3349; /* *pcrel_opt_lddf_gpr */
              if (!vsx_register_operand (operands[0], E_DFmode)
                  || !vsx_register_operand (operands[2], E_DImode)
                  || !base_reg_operand (operands[4], E_DImode)
                  || !
#line 224 "../../gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT))
                return -1;
              return 3359; /* *pcrel_opt_lddf_vsx */

            case E_TImode:
              if (pattern541 (x3, 
E_TImode) != 0
                  || !
#line 256 "../../gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT))
                return -1;
              return 3362; /* *pcrel_opt_ldti */

            case E_KFmode:
              if (pattern541 (x3, 
E_KFmode) != 0
                  || !
#line 256 "../../gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT))
                return -1;
              return 3363; /* *pcrel_opt_ldkf */

            case E_V1TImode:
              if (pattern541 (x3, 
E_V1TImode) != 0
                  || !
#line 256 "../../gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT))
                return -1;
              return 3364; /* *pcrel_opt_ldv1ti */

            case E_V2DImode:
              if (pattern541 (x3, 
E_V2DImode) != 0
                  || !
#line 256 "../../gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT))
                return -1;
              return 3365; /* *pcrel_opt_ldv2di */

            case E_V4SImode:
              if (pattern541 (x3, 
E_V4SImode) != 0
                  || !
#line 256 "../../gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT))
                return -1;
              return 3366; /* *pcrel_opt_ldv4si */

            case E_V8HImode:
              if (pattern541 (x3, 
E_V8HImode) != 0
                  || !
#line 256 "../../gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT))
                return -1;
              return 3367; /* *pcrel_opt_ldv8hi */

            case E_V16QImode:
              if (pattern541 (x3, 
E_V16QImode) != 0
                  || !
#line 256 "../../gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT))
                return -1;
              return 3368; /* *pcrel_opt_ldv16qi */

            case E_V2DFmode:
              if (pattern541 (x3, 
E_V2DFmode) != 0
                  || !
#line 256 "../../gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT))
                return -1;
              return 3369; /* *pcrel_opt_ldv2df */

            case E_V4SFmode:
              if (pattern541 (x3, 
E_V4SFmode) != 0
                  || !
#line 256 "../../gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT))
                return -1;
              return 3370; /* *pcrel_opt_ldv4sf */

            case E_TFmode:
              if (pattern541 (x3, 
E_TFmode) != 0
                  || !(
#line 256 "../../gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT) && 
#line 99 "../../gcc/config/rs6000/pcrel-opt.md"
(TARGET_FLOAT128_TYPE && TARGET_IEEEQUAD)))
                return -1;
              return 3371; /* *pcrel_opt_ldtf */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_175 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[1] = x4;
      res = recog_159 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      if (GET_CODE (x4) != REG
          || REGNO (x4) != 98)
        return -1;
      x5 = XEXP (x3, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + -1])
        return -1;
      switch (pattern296 (x1, 
98, 
CLOBBER))
        {
        case 0:
          if (pattern517 (x1, 
E_SImode) != 0)
            return -1;
          return 124; /* subfsi3_carry_in_xx */

        case 1:
          if (pattern517 (x1, 
E_DImode) != 0
              || !
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
            return -1;
          return 125; /* subfdi3_carry_in_xx */

        default:
          return -1;
        }

    case PLUS:
      x6 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x6) != CLOBBER)
        return -1;
      x7 = XEXP (x4, 0);
      switch (GET_CODE (x7))
        {
        case REG:
        case SUBREG:
          operands[1] = x7;
          res = recog_160 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          operands[0] = x7;
          if (altivec_register_operand (operands[0], E_V2DImode))
            {
              res = recog_161 (x1, insn, pnum_clobbers);
              if (res >= 0)
                return res;
            }
          operands[1] = x7;
          if (pattern297 (x1) == 0)
            {
              x5 = XEXP (x3, 1);
              switch (GET_CODE (x5))
                {
                case REG:
                case SUBREG:
                  operands[2] = x5;
                  switch (GET_MODE (operands[0]))
                    {
                    case E_SImode:
                      if (pattern562 (x1, 
E_SImode) == 0)
                        return 90; /* *addsi3_carry_in_internal2 */
                      break;

                    case E_DImode:
                      if (pattern562 (x1, 
E_DImode) == 0
                          && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
                        return 91; /* *adddi3_carry_in_internal2 */
                      break;

                    default:
                      break;
                    }
                  break;

                case CONST_INT:
                  if (XWINT (x5, 0) == -1L)
                    {
                      switch (GET_MODE (operands[0]))
                        {
                        case E_SImode:
                          if (pattern563 (x1, 
E_SImode) == 0)
                            return 94; /* addsi3_carry_in_m1 */
                          break;

                        case E_DImode:
                          if (pattern563 (x1, 
E_DImode) == 0
                              && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
                            return 95; /* adddi3_carry_in_m1 */
                          break;

                        default:
                          break;
                        }
                    }
                  break;

                default:
                  break;
                }
            }
          operands[0] = x7;
          x8 = XEXP (x2, 0);
          operands[3] = x8;
          switch (pattern250 (x1))
            {
            case 0:
              if (!
#line 3031 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 3339; /* *fuse_add_add */

            case 1:
              if (!(
#line 3031 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 3340; /* *fuse_add_add */

            default:
              return -1;
            }

        case NOT:
          if (pattern297 (x1) != 0)
            return -1;
          x9 = XEXP (x7, 0);
          operands[1] = x9;
          x5 = XEXP (x3, 1);
          operands[2] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern550 (x1, 
E_SImode) != 0)
                return -1;
              return 118; /* *subfsi3_carry_in_internal */

            case E_DImode:
              if (pattern550 (x1, 
E_DImode) != 0
                  || !
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
                return -1;
              return 119; /* *subfdi3_carry_in_internal */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case NOT:
      x5 = XEXP (x3, 1);
      if (GET_CODE (x5) != REG
          || REGNO (x5) != 98)
        return -1;
      x6 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x6) != CLOBBER)
        return -1;
      x10 = XEXP (x6, 0);
      if (GET_CODE (x10) != REG
          || REGNO (x10) != 98)
        return -1;
      x8 = XEXP (x2, 0);
      operands[0] = x8;
      x7 = XEXP (x4, 0);
      operands[1] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern518 (x1, 
E_SImode) != 0)
            return -1;
          return 120; /* subfsi3_carry_in_0 */

        case E_DImode:
          if (pattern518 (x1, 
E_DImode) != 0
              || !
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
            return -1;
          return 121; /* subfdi3_carry_in_0 */

        default:
          return -1;
        }

    case MINUS:
      x7 = XEXP (x4, 0);
      if (GET_CODE (x7) != REG
          || REGNO (x7) != 98)
        return -1;
      x5 = XEXP (x3, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + -2])
        return -1;
      x6 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x6) != CLOBBER)
        return -1;
      x10 = XEXP (x6, 0);
      if (GET_CODE (x10) != REG
          || REGNO (x10) != 98)
        return -1;
      x8 = XEXP (x2, 0);
      operands[0] = x8;
      x11 = XEXP (x4, 1);
      operands[1] = x11;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern542 (x1, 
E_SImode) != 0)
            return -1;
          return 122; /* subfsi3_carry_in_m1 */

        case E_DImode:
          if (pattern542 (x1, 
E_DImode) != 0
              || !
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
            return -1;
          return 123; /* subfdi3_carry_in_m1 */

        default:
          return -1;
        }

    case VEC_CONCAT:
      if (GET_MODE (x4) != E_V2DFmode)
        return -1;
      x7 = XEXP (x4, 0);
      if (GET_CODE (x7) != VEC_SELECT
          || GET_MODE (x7) != E_DFmode)
        return -1;
      x12 = XEXP (x7, 1);
      if (GET_CODE (x12) != PARALLEL
          || XVECLEN (x12, 0) != 1)
        return -1;
      x13 = XVECEXP (x12, 0, 0);
      if (x13 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x11 = XEXP (x4, 1);
      if (GET_CODE (x11) != VEC_SELECT
          || GET_MODE (x11) != E_DFmode)
        return -1;
      x14 = XEXP (x11, 1);
      if (GET_CODE (x14) != PARALLEL
          || XVECLEN (x14, 0) != 1)
        return -1;
      x15 = XVECEXP (x14, 0, 0);
      if (x15 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x6 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x6) != CLOBBER)
        return -1;
      x8 = XEXP (x2, 0);
      operands[0] = x8;
      if (!vfloat_operand (operands[0], E_V2DFmode)
          || GET_MODE (x3) != E_V2DFmode
          || pattern82 (x1) != 0
          || !
#line 4927 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode)))
        return -1;
      return 1635; /* vsx_reduc_plus_v2df */

    case AND:
      switch (pattern195 (x1))
        {
        case 0:
          if (!
#line 1663 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2675; /* *fuse_and_add */

        case 1:
          if (!(
#line 1663 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2676; /* *fuse_and_add */

        case 2:
          if (!
#line 1699 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2679; /* *fuse_nor_add */

        case 3:
          if (!(
#line 1699 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2680; /* *fuse_nor_add */

        default:
          return -1;
        }

    case IOR:
      switch (pattern196 (x1))
        {
        case 0:
          if (!
#line 1681 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2677; /* *fuse_nand_add */

        case 1:
          if (!(
#line 1681 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2678; /* *fuse_nand_add */

        case 2:
          if (!
#line 1717 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2681; /* *fuse_or_add */

        case 3:
          if (!(
#line 1717 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2682; /* *fuse_or_add */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_180 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case EQ:
    case GE:
    case GT:
      operands[1] = x4;
      if (fpmask_comparison_operator (operands[1], E_CCFPmode))
        {
          switch (pattern300 (x1))
            {
            case 0:
              if (
#line 5665 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_MINMAX))
                return 381; /* *movsfsfcc_p9 */
              break;

            case 1:
              if (
#line 5665 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_MINMAX))
                return 383; /* *movsfdfcc_p9 */
              break;

            case 2:
              if (
#line 5665 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_MINMAX))
                return 382; /* *movdfsfcc_p9 */
              break;

            case 3:
              if (
#line 5665 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_MINMAX))
                return 384; /* *movdfdfcc_p9 */
              break;

            case 4:
              if ((
#line 5770 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWER10 && TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
                return 393; /* *movkfcc_p10 */
              break;

            case 5:
              if ((
#line 5770 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWER10 && TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
                return 394; /* *movtfcc_p10 */
              break;

            default:
              break;
            }
        }
      if (pnum_clobbers == NULL)
        return -1;
      switch (pattern254 (x1, 
EQ))
        {
        case 0:
          if (!
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT))
            return -1;
          *pnum_clobbers = 2;
          return 990; /* bdz_si */

        case 1:
          if (!
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT))
            return -1;
          *pnum_clobbers = 2;
          return 992; /* bdz_di */

        default:
          return -1;
        }

    case NE:
    case UNLE:
    case UNLT:
      operands[1] = x4;
      if (invert_fpmask_comparison_operator (operands[1], E_CCFPmode))
        {
          switch (pattern300 (x1))
            {
            case 0:
              if (
#line 5697 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_MINMAX))
                return 385; /* *movsfsfcc_invert_p9 */
              break;

            case 1:
              if (
#line 5697 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_MINMAX))
                return 387; /* *movsfdfcc_invert_p9 */
              break;

            case 2:
              if (
#line 5697 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_MINMAX))
                return 386; /* *movdfsfcc_invert_p9 */
              break;

            case 3:
              if (
#line 5697 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_MINMAX))
                return 388; /* *movdfdfcc_invert_p9 */
              break;

            case 4:
              if ((
#line 5802 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWER10 && TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
                return 395; /* *movkfcc_invert_p10 */
              break;

            case 5:
              if ((
#line 5802 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWER10 && TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
                return 396; /* *movtfcc_invert_p10 */
              break;

            default:
              break;
            }
        }
      if (pnum_clobbers == NULL)
        return -1;
      switch (pattern254 (x1, 
NE))
        {
        case 0:
          if (!
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT))
            return -1;
          *pnum_clobbers = 2;
          return 991; /* bdnz_si */

        case 1:
          if (!
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT))
            return -1;
          *pnum_clobbers = 2;
          return 993; /* bdnz_di */

        default:
          return -1;
        }

    case AND:
      if (pnum_clobbers == NULL)
        return -1;
      x5 = XEXP (x4, 1);
      if (!branch_comparison_operator (x5, E_VOIDmode))
        return -1;
      operands[3] = x5;
      x6 = XEXP (x5, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x7 = XEXP (x3, 1);
      if (GET_CODE (x7) != LABEL_REF)
        return -1;
      x8 = XEXP (x3, 2);
      if (GET_CODE (x8) != PC
          || pattern415 (x1) != 0)
        return -1;
      x9 = XEXP (x5, 0);
      operands[4] = x9;
      if (!cc_reg_operand (operands[4], E_VOIDmode))
        return -1;
      x10 = XEXP (x7, 0);
      operands[0] = x10;
      x11 = XVECEXP (x1, 0, 1);
      x12 = XEXP (x11, 0);
      operands[2] = x12;
      x13 = XEXP (x4, 0);
      switch (GET_CODE (x13))
        {
        case EQ:
          switch (pattern588 (x1))
            {
            case 0:
              if (!
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT))
                return -1;
              *pnum_clobbers = 3;
              return 994; /* bdztf_si */

            case 1:
              if (!
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT))
                return -1;
              *pnum_clobbers = 3;
              return 996; /* bdztf_di */

            default:
              return -1;
            }

        case NE:
          switch (pattern588 (x1))
            {
            case 0:
              if (!
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT))
                return -1;
              *pnum_clobbers = 3;
              return 995; /* bdnztf_si */

            case 1:
              if (!
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT))
                return -1;
              *pnum_clobbers = 3;
              return 997; /* bdnztf_di */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_189 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 4);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XVECEXP (x1, 0, 0);
  switch (GET_CODE (x3))
    {
    case SET:
      x4 = XEXP (x3, 1);
      switch (GET_CODE (x4))
        {
        case UNSIGNED_FLOAT:
          if (pattern200 (x1, 
USE, 
E_DFmode) != 0
              || pattern411 (x1) != 0
              || !
#line 6170 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_FCFIDU && TARGET_HARD_FLOAT
   && !(TARGET_FCFID && TARGET_POWERPC64)))
            return -1;
          return 416; /* *floatunssidf2_internal */

        case FIX:
          if (pattern200 (x1, 
CLOBBER, 
E_SImode) != 0)
            return -1;
          switch (pattern412 (x1))
            {
            case 0:
              if (!(
#line 9097 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_LONG_DOUBLE_128) && 
#line 630 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IBM_P (IFmode))))
                return -1;
              return 621; /* *fix_truncifsi2_internal */

            case 1:
              if (!(
#line 9097 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_LONG_DOUBLE_128) && 
#line 631 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IBM_P (TFmode))))
                return -1;
              return 622; /* *fix_trunctfsi2_internal */

            default:
              return -1;
            }

        case CALL:
          x5 = XEXP (x4, 0);
          if (GET_CODE (x5) != MEM
              || GET_MODE (x5) != E_SImode
              || pattern258 (x1) != 0)
            return -1;
          x6 = XEXP (x3, 0);
          operands[0] = x6;
          x7 = XEXP (x5, 0);
          operands[1] = x7;
          x8 = XEXP (x4, 1);
          operands[2] = x8;
          x9 = XVECEXP (x1, 0, 1);
          x10 = XEXP (x9, 0);
          operands[3] = x10;
          if (!immediate_operand (operands[3], E_SImode))
            return -1;
          x11 = XVECEXP (x1, 0, 2);
          x12 = XEXP (x11, 0);
          operands[4] = x12;
          x13 = XVECEXP (x1, 0, 3);
          x14 = XEXP (x13, 1);
          x15 = XVECEXP (x14, 0, 0);
          operands[5] = x15;
          switch (GET_MODE (operands[1]))
            {
            case E_SImode:
              if (pattern600 (x1, 
E_SImode) != 0
                  || !(
#line 11749 "../../gcc/config/rs6000/rs6000.md"
(DEFAULT_ABI == ABI_AIX) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                return -1;
              return 841; /* *call_value_indirect_aixsi */

            case E_DImode:
              if (pattern600 (x1, 
E_DImode) != 0
                  || !(
#line 11749 "../../gcc/config/rs6000/rs6000.md"
(DEFAULT_ABI == ABI_AIX) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                return -1;
              return 842; /* *call_value_indirect_aixdi */

            default:
              return -1;
            }

        case IF_THEN_ELSE:
          x5 = XEXP (x4, 0);
          if (GET_CODE (x5) != AND)
            return -1;
          x16 = XEXP (x5, 1);
          if (!branch_comparison_operator (x16, E_VOIDmode))
            return -1;
          operands[3] = x16;
          x17 = XEXP (x16, 1);
          if (x17 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
              || pattern116 (x1) != 0)
            return -1;
          x18 = XEXP (x16, 0);
          operands[4] = x18;
          if (!cc_reg_operand (operands[4], E_VOIDmode))
            return -1;
          x8 = XEXP (x4, 1);
          x19 = XEXP (x8, 0);
          operands[0] = x19;
          x9 = XVECEXP (x1, 0, 1);
          x10 = XEXP (x9, 0);
          operands[2] = x10;
          x11 = XVECEXP (x1, 0, 2);
          x12 = XEXP (x11, 0);
          operands[5] = x12;
          x13 = XVECEXP (x1, 0, 3);
          x20 = XEXP (x13, 0);
          operands[6] = x20;
          if (!scratch_operand (operands[6], E_CCmode))
            return -1;
          x21 = XEXP (x2, 0);
          operands[7] = x21;
          if (!scratch_operand (operands[7], E_CCEQmode))
            return -1;
          x7 = XEXP (x5, 0);
          switch (GET_CODE (x7))
            {
            case EQ:
              switch (pattern604 (x1))
                {
                case 0:
                  if (!
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT))
                    return -1;
                  return 994; /* bdztf_si */

                case 1:
                  if (!
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT))
                    return -1;
                  return 996; /* bdztf_di */

                default:
                  return -1;
                }

            case NE:
              switch (pattern604 (x1))
                {
                case 0:
                  if (!
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT))
                    return -1;
                  return 995; /* bdnztf_si */

                case 1:
                  if (!
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT))
                    return -1;
                  return 997; /* bdnztf_di */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case CALL:
      x6 = XEXP (x3, 0);
      if (GET_CODE (x6) != MEM
          || GET_MODE (x6) != E_SImode
          || pattern258 (x1) != 0)
        return -1;
      x22 = XEXP (x6, 0);
      operands[0] = x22;
      x4 = XEXP (x3, 1);
      operands[1] = x4;
      x9 = XVECEXP (x1, 0, 1);
      x10 = XEXP (x9, 0);
      operands[2] = x10;
      if (!immediate_operand (operands[2], E_SImode))
        return -1;
      x11 = XVECEXP (x1, 0, 2);
      x12 = XEXP (x11, 0);
      operands[3] = x12;
      x13 = XVECEXP (x1, 0, 3);
      x14 = XEXP (x13, 1);
      x15 = XVECEXP (x14, 0, 0);
      operands[4] = x15;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern595 (x1, 
E_SImode) != 0
              || !(
#line 11728 "../../gcc/config/rs6000/rs6000.md"
(DEFAULT_ABI == ABI_AIX) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
            return -1;
          return 839; /* *call_indirect_aixsi */

        case E_DImode:
          if (pattern595 (x1, 
E_DImode) != 0
              || !(
#line 11728 "../../gcc/config/rs6000/rs6000.md"
(DEFAULT_ABI == ABI_AIX) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
            return -1;
          return 840; /* *call_indirect_aixdi */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 rtx_insn *
split_3 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return NULL;
  x3 = XVECEXP (x1, 0, 0);
  x4 = XEXP (x3, 0);
  operands[0] = x4;
  x5 = XEXP (x3, 1);
  switch (XVECLEN (x5, 0))
    {
    case 1:
      x6 = XEXP (x2, 0);
      operands[2] = x6;
      switch (XINT (x5, 1))
        {
        case 87:
          if (GET_MODE (x5) != E_SImode
              || !nonimmediate_operand (operands[0], E_SImode))
            return NULL;
          x7 = XVECEXP (x5, 0, 0);
          operands[1] = x7;
          if (!input_operand (operands[1], E_SFmode)
              || !scratch_operand (operands[2], E_V4SFmode)
              || !(
#line 7832 "../../gcc/config/rs6000/rs6000.md"
(TARGET_NO_SF_SUBREG
   && (register_operand (operands[0], SImode)
       || register_operand (operands[1], SFmode))) && 
#line 7847 "../../gcc/config/rs6000/rs6000.md"
( reload_completed
   && int_reg_operand (operands[0], SImode)
   && vsx_reg_sfsubreg_ok (operands[1], SFmode))))
            return NULL;
          return gen_split_291 (insn, operands);

        case 86:
          if (GET_MODE (x5) != E_SFmode
              || !scratch_operand (operands[2], E_DImode))
            return NULL;
          if (nonimmediate_operand (operands[0], E_SFmode))
            {
              x7 = XVECEXP (x5, 0, 0);
              operands[1] = x7;
              if (input_operand (operands[1], E_SImode)
                  && (
#line 8385 "../../gcc/config/rs6000/rs6000.md"
(TARGET_NO_SF_SUBREG
   && (register_operand (operands[0], SFmode)
       || register_operand (operands[1], SImode))) && 
#line 8400 "../../gcc/config/rs6000/rs6000.md"
( reload_completed
   && vsx_reg_sfsubreg_ok (operands[0], SFmode)
   && int_reg_operand_not_pseudo (operands[1], SImode))))
                return gen_split_301 (insn, operands);
            }
          x7 = XVECEXP (x5, 0, 0);
          if (!lowpart_subreg_operator (x7, E_SImode))
            return NULL;
          switch (pattern495 (x7))
            {
            case 0:
              if (!(
#line 8452 "../../gcc/config/rs6000/rs6000.md"
(TARGET_NO_SF_SUBREG) && 
#line 8454 "../../gcc/config/rs6000/rs6000.md"
( 1)))
                return NULL;
              return gen_split_302 (insn, operands);

            case 1:
              if (!(
#line 8452 "../../gcc/config/rs6000/rs6000.md"
(TARGET_NO_SF_SUBREG) && 
#line 8454 "../../gcc/config/rs6000/rs6000.md"
( 1)))
                return NULL;
              return gen_split_303 (insn, operands);

            default:
              return NULL;
            }

        case 61:
          x7 = XVECEXP (x5, 0, 0);
          operands[1] = x7;
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              if (pattern468 (x5, 
E_DImode, 
E_IFmode) != 0
                  || !(
#line 9589 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWERPC64 && TARGET_DIRECT_MOVE) && 
#line 9591 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                return NULL;
              return gen_split_342 (insn, operands);

            case E_DFmode:
              if (pattern468 (x5, 
E_DFmode, 
E_IFmode) != 0
                  || !(
#line 9589 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWERPC64 && TARGET_DIRECT_MOVE) && 
#line 9591 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                return NULL;
              return gen_split_343 (insn, operands);

            case E_DDmode:
              if (pattern468 (x5, 
E_DDmode, 
E_IFmode) != 0
                  || !(
#line 9589 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWERPC64 && TARGET_DIRECT_MOVE) && 
#line 9591 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                return NULL;
              return gen_split_344 (insn, operands);

            case E_TImode:
              if (pattern468 (x5, 
E_TImode, 
E_IFmode) != 0
                  || !(
#line 9634 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT) && 
#line 9636 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                return NULL;
              return gen_split_345 (insn, operands);

            case E_V16QImode:
              if (pattern468 (x5, 
E_V16QImode, 
E_IFmode) != 0
                  || !(
#line 9634 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT) && 
#line 9636 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                return NULL;
              return gen_split_346 (insn, operands);

            case E_V8HImode:
              if (pattern468 (x5, 
E_V8HImode, 
E_IFmode) != 0
                  || !(
#line 9634 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT) && 
#line 9636 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                return NULL;
              return gen_split_347 (insn, operands);

            case E_V4SImode:
              if (pattern468 (x5, 
E_V4SImode, 
E_IFmode) != 0
                  || !(
#line 9634 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT) && 
#line 9636 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                return NULL;
              return gen_split_348 (insn, operands);

            case E_V4SFmode:
              if (pattern468 (x5, 
E_V4SFmode, 
E_IFmode) != 0
                  || !(
#line 9634 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT) && 
#line 9636 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                return NULL;
              return gen_split_349 (insn, operands);

            case E_V2DImode:
              if (pattern468 (x5, 
E_V2DImode, 
E_IFmode) != 0
                  || !(
#line 9634 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT) && 
#line 9636 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                return NULL;
              return gen_split_350 (insn, operands);

            case E_V2DFmode:
              if (pattern468 (x5, 
E_V2DFmode, 
E_IFmode) != 0
                  || !(
#line 9634 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT) && 
#line 9636 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                return NULL;
              return gen_split_351 (insn, operands);

            case E_V1TImode:
              if (pattern468 (x5, 
E_V1TImode, 
E_IFmode) != 0
                  || !(
#line 9634 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT) && 
#line 9636 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                return NULL;
              return gen_split_352 (insn, operands);

            case E_KFmode:
              if (pattern468 (x5, 
E_KFmode, 
E_IFmode) != 0
                  || !((
#line 9634 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT) && 
#line 560 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_VECTOR_P (KFmode))) && 
#line 9636 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                return NULL;
              return gen_split_353 (insn, operands);

            case E_TFmode:
              if (pattern468 (x5, 
E_TFmode, 
E_IFmode) != 0
                  || !((
#line 9634 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT) && 
#line 561 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_VECTOR_P (TFmode))) && 
#line 9636 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                return NULL;
              return gen_split_354 (insn, operands);

            case E_SFmode:
              if (pattern468 (x5, 
E_SFmode, 
E_DImode) != 0
                  || !(
#line 9688 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT) && 
#line 9690 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                return NULL;
              return gen_split_365 (insn, operands);

            default:
              return NULL;
            }

        case 64:
          x7 = XVECEXP (x5, 0, 0);
          operands[1] = x7;
          switch (GET_MODE (operands[0]))
            {
            case E_TImode:
              if (pattern469 (x5, 
E_TImode) != 0
                  || !(
#line 9724 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT) && 
#line 9726 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                return NULL;
              return gen_split_366 (insn, operands);

            case E_V16QImode:
              if (pattern469 (x5, 
E_V16QImode) != 0
                  || !(
#line 9724 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT) && 
#line 9726 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                return NULL;
              return gen_split_367 (insn, operands);

            case E_V8HImode:
              if (pattern469 (x5, 
E_V8HImode) != 0
                  || !(
#line 9724 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT) && 
#line 9726 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                return NULL;
              return gen_split_368 (insn, operands);

            case E_V4SImode:
              if (pattern469 (x5, 
E_V4SImode) != 0
                  || !(
#line 9724 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT) && 
#line 9726 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                return NULL;
              return gen_split_369 (insn, operands);

            case E_V4SFmode:
              if (pattern468 (x5, 
E_V4SFmode, 
E_V4SFmode) != 0
                  || !(
#line 9724 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT) && 
#line 9726 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                return NULL;
              return gen_split_370 (insn, operands);

            case E_V2DImode:
              if (pattern469 (x5, 
E_V2DImode) != 0
                  || !(
#line 9724 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT) && 
#line 9726 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                return NULL;
              return gen_split_371 (insn, operands);

            case E_V2DFmode:
              if (pattern469 (x5, 
E_V2DFmode) != 0
                  || !(
#line 9724 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT) && 
#line 9726 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                return NULL;
              return gen_split_372 (insn, operands);

            case E_V1TImode:
              if (pattern469 (x5, 
E_V1TImode) != 0
                  || !(
#line 9724 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT) && 
#line 9726 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                return NULL;
              return gen_split_373 (insn, operands);

            case E_KFmode:
              if (pattern469 (x5, 
E_KFmode) != 0
                  || !((
#line 9724 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT) && 
#line 560 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_VECTOR_P (KFmode))) && 
#line 9726 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                return NULL;
              return gen_split_374 (insn, operands);

            case E_TFmode:
              if (pattern469 (x5, 
E_TFmode) != 0
                  || !((
#line 9724 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT) && 
#line 561 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_VECTOR_P (TFmode))) && 
#line 9726 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                return NULL;
              return gen_split_375 (insn, operands);

            case E_SFmode:
              if (pattern468 (x5, 
E_SFmode, 
E_V4SFmode) != 0
                  || !(
#line 9752 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT) && 
#line 9754 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                return NULL;
              return gen_split_376 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case 2:
      if (XINT (x5, 1) != 145)
        return NULL;
      switch (pattern348 (x1))
        {
        case 0:
          if (!(
#line 3675 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V2DFmode) && TARGET_DIRECT_MOVE_64BIT) && 
#line 3677 "../../gcc/config/rs6000/vsx.md"
( reload_completed)))
            return NULL;
          return gen_split_611 (insn, operands);

        case 1:
          if (!(
#line 3675 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V2DImode) && TARGET_DIRECT_MOVE_64BIT) && 
#line 3677 "../../gcc/config/rs6000/vsx.md"
( reload_completed)))
            return NULL;
          return gen_split_612 (insn, operands);

        case 2:
          if (!(
#line 3762 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SFmode) && TARGET_DIRECT_MOVE_64BIT) && 
#line 3764 "../../gcc/config/rs6000/vsx.md"
( reload_completed)))
            return NULL;
          return gen_split_617 (insn, operands);

        case 3:
          if (!(
#line 4204 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V16QImode) && TARGET_DIRECT_MOVE_64BIT) && 
#line 4206 "../../gcc/config/rs6000/vsx.md"
( reload_completed)))
            return NULL;
          return gen_split_636 (insn, operands);

        case 4:
          if (!(
#line 4204 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V8HImode) && TARGET_DIRECT_MOVE_64BIT) && 
#line 4206 "../../gcc/config/rs6000/vsx.md"
( reload_completed)))
            return NULL;
          return gen_split_637 (insn, operands);

        case 5:
          if (!(
#line 4204 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT) && 
#line 4206 "../../gcc/config/rs6000/vsx.md"
( reload_completed)))
            return NULL;
          return gen_split_638 (insn, operands);

        default:
          return NULL;
        }

    case 3:
      if (XINT (x5, 1) != 123
          || GET_MODE (x5) != E_V4SFmode
          || !gpc_reg_operand (operands[0], E_V4SFmode))
        return NULL;
      x7 = XVECEXP (x5, 0, 0);
      operands[1] = x7;
      switch (pattern470 (x1))
        {
        case 0:
          if (!(
#line 4616 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SFmode) && TARGET_P9_VECTOR && TARGET_POWERPC64) && 
#line 4618 "../../gcc/config/rs6000/vsx.md"
( reload_completed)))
            return NULL;
          return gen_split_673 (insn, operands);

        case 1:
          if (!(
#line 4652 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SFmode) && TARGET_P9_VECTOR && TARGET_POWERPC64) && 
#line 4654 "../../gcc/config/rs6000/vsx.md"
( reload_completed)))
            return NULL;
          return gen_split_674 (insn, operands);

        case 2:
          if (!(
#line 4712 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SFmode) && VECTOR_MEM_VSX_P (V4SImode)
   && TARGET_P9_VECTOR && TARGET_POWERPC64
   && (INTVAL (operands[3]) != (BYTES_BIG_ENDIAN ? 1 : 2))) && 
#line 4716 "../../gcc/config/rs6000/vsx.md"
( 1)))
            return NULL;
          return gen_split_675 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_9 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
      operands[1] = x3;
      x4 = XEXP (x2, 1);
      operands[2] = x4;
      switch (GET_CODE (operands[2]))
        {
        case CONST_INT:
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern416 (x2, 
E_SImode) != 0
                  || !(
#line 3840 "../../gcc/config/rs6000/rs6000.md"
(rs6000_is_valid_2insn_and (operands[2], SImode)
   && !(rs6000_is_valid_and_mask (operands[2], SImode)
	|| logical_const_operand (operands[2], SImode))) && 
#line 3844 "../../gcc/config/rs6000/rs6000.md"
( 1)))
                return NULL;
              return gen_split_78 (insn, operands);

            case E_DImode:
              if (pattern416 (x2, 
E_DImode) != 0
                  || !((
#line 3840 "../../gcc/config/rs6000/rs6000.md"
(rs6000_is_valid_2insn_and (operands[2], DImode)
   && !(rs6000_is_valid_and_mask (operands[2], DImode)
	|| logical_const_operand (operands[2], DImode))) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 3844 "../../gcc/config/rs6000/rs6000.md"
( 1)))
                return NULL;
              return gen_split_79 (insn, operands);

            default:
              return NULL;
            }

        case REG:
        case SUBREG:
          switch (GET_MODE (operands[0]))
            {
            case E_TImode:
              if (pattern369 (x2, 
E_TImode) != 0
                  || !
#line 7388 "../../gcc/config/rs6000/rs6000.md"
(reload_completed && int_reg_operand (operands[0], TImode)))
                return NULL;
              return gen_split_230 (insn, operands);

            case E_PTImode:
              if (pattern369 (x2, 
E_PTImode) != 0
                  || !
#line 7388 "../../gcc/config/rs6000/rs6000.md"
(reload_completed && int_reg_operand (operands[0], PTImode)))
                return NULL;
              return gen_split_231 (insn, operands);

            case E_V16QImode:
              if (pattern369 (x2, 
E_V16QImode) != 0
                  || !(
#line 7388 "../../gcc/config/rs6000/rs6000.md"
(reload_completed && int_reg_operand (operands[0], V16QImode)) && 
#line 778 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
                return NULL;
              return gen_split_232 (insn, operands);

            case E_V8HImode:
              if (pattern369 (x2, 
E_V8HImode) != 0
                  || !(
#line 7388 "../../gcc/config/rs6000/rs6000.md"
(reload_completed && int_reg_operand (operands[0], V8HImode)) && 
#line 779 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
                return NULL;
              return gen_split_233 (insn, operands);

            case E_V4SImode:
              if (pattern369 (x2, 
E_V4SImode) != 0
                  || !(
#line 7388 "../../gcc/config/rs6000/rs6000.md"
(reload_completed && int_reg_operand (operands[0], V4SImode)) && 
#line 780 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
                return NULL;
              return gen_split_234 (insn, operands);

            case E_V4SFmode:
              if (pattern369 (x2, 
E_V4SFmode) != 0
                  || !(
#line 7388 "../../gcc/config/rs6000/rs6000.md"
(reload_completed && int_reg_operand (operands[0], V4SFmode)) && 
#line 781 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
                return NULL;
              return gen_split_235 (insn, operands);

            case E_V2DImode:
              if (pattern369 (x2, 
E_V2DImode) != 0
                  || !(
#line 7388 "../../gcc/config/rs6000/rs6000.md"
(reload_completed && int_reg_operand (operands[0], V2DImode)) && 
#line 782 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
                return NULL;
              return gen_split_236 (insn, operands);

            case E_V2DFmode:
              if (pattern369 (x2, 
E_V2DFmode) != 0
                  || !(
#line 7388 "../../gcc/config/rs6000/rs6000.md"
(reload_completed && int_reg_operand (operands[0], V2DFmode)) && 
#line 783 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
                return NULL;
              return gen_split_237 (insn, operands);

            case E_V1TImode:
              if (pattern369 (x2, 
E_V1TImode) != 0
                  || !(
#line 7388 "../../gcc/config/rs6000/rs6000.md"
(reload_completed && int_reg_operand (operands[0], V1TImode)) && 
#line 784 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
                return NULL;
              return gen_split_238 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case PLUS:
      x4 = XEXP (x2, 1);
      if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + -16])
        return NULL;
      switch (pattern261 (x2))
        {
        case 0:
          if (!((
#line 9532 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC && reload_completed) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)) && 
#line 9534 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
            return NULL;
          return gen_split_340 (insn, operands);

        case 1:
          if (!((
#line 9532 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC && reload_completed) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)) && 
#line 9534 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
            return NULL;
          return gen_split_341 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_12 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (nonimmediate_operand (operands[0], E_TImode)
      && input_operand (operands[1], E_TImode)
      && 
#line 9660 "../../gcc/config/rs6000/rs6000.md"
(reload_completed
   && (int_reg_operand (operands[0], TImode)
       || int_reg_operand (operands[1], TImode))
   && (!TARGET_DIRECT_MOVE_128
       || (!vsx_register_operand (operands[0], TImode)
           && !vsx_register_operand (operands[1], TImode)))))
    return gen_split_355 (insn, operands);
  if (int_reg_operand (operands[0], E_TImode)
      && const_scalar_int_operand (operands[1], E_TImode)
      && 
#line 10063 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64
   && (VECTOR_MEM_NONE_P (TImode)
       || (reload_completed && INT_REGNO_P (REGNO (operands[0]))))))
    return gen_split_388 (insn, operands);
  if (nonimmediate_operand (operands[0], E_TImode)
      && input_operand (operands[1], E_TImode))
    {
      if (
#line 10090 "../../gcc/config/rs6000/rs6000.md"
(reload_completed
   && gpr_or_gpr_p (operands[0], operands[1])
   && !direct_move_p (operands[0], operands[1])
   && !quad_load_store_p (operands[0], operands[1])))
        return gen_split_390 (insn, operands);
      if (
#line 171 "../../gcc/config/rs6000/vector.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (TImode)
   && reload_completed
   && gpr_or_gpr_p (operands[0], operands[1])
   && !direct_move_p (operands[0], operands[1])
   && !quad_load_store_p (operands[0], operands[1])))
        return gen_split_538 (insn, operands);
    }
  if (indexed_or_indirect_operand (operands[0], E_TImode)
      && indexed_or_indirect_operand (operands[1], E_TImode)
      && (
#line 427 "../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN
   && TARGET_VSX
   && !TARGET_P9_VECTOR
   && can_create_pseudo_p ()) && 
#line 432 "../../gcc/config/rs6000/vsx.md"
( 1)))
    return gen_split_563 (insn, operands);
  if (vsx_register_operand (operands[0], E_TImode)
      && memory_operand (operands[1], E_TImode)
      && 
#line 1045 "../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX && !TARGET_P9_VECTOR
   && !altivec_indexed_or_indirect_operand (operands[1], TImode)))
    return gen_split_586 (insn, operands);
  if (memory_operand (operands[0], E_TImode)
      && vsx_register_operand (operands[1], E_TImode))
    {
      if (
#line 1075 "../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX && !reload_completed && !TARGET_P9_VECTOR
   && !altivec_indexed_or_indirect_operand (operands[0], TImode)))
        return gen_split_590 (insn, operands);
      if (
#line 1131 "../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX && reload_completed && !TARGET_P9_VECTOR
   && !altivec_indexed_or_indirect_operand (operands[0], TImode)))
        return gen_split_594 (insn, operands);
    }
  if (!altivec_register_operand (operands[0], E_TImode))
    return NULL;
  if (easy_vector_constant_msb (operands[1], E_TImode)
      && 
#line 286 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (TImode) && reload_completed))
    return gen_split_699 (insn, operands);
  if (easy_vector_constant_add_self (operands[1], E_TImode)
      && 
#line 324 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (TImode) && reload_completed))
    return gen_split_709 (insn, operands);
  if (!easy_vector_constant_vsldoi (operands[1], E_TImode)
      || !
#line 353 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_OR_VSX_P (TImode) && can_create_pseudo_p ()))
    return NULL;
  return gen_split_719 (insn, operands);
}

 rtx_insn *
split_17 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case XOR:
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_TImode:
          if (GET_MODE (x3) != E_TImode
              || GET_MODE (x4) != E_TImode)
            return NULL;
          if (vlogical_operand (operands[0], E_TImode)
              && vlogical_operand (operands[1], E_TImode)
              && vlogical_operand (operands[2], E_TImode)
              && 
#line 7582 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR && reload_completed
   && int_reg_operand (operands[0], TImode)))
            return gen_split_270 (insn, operands);
          if (!int_reg_operand (operands[0], E_TImode)
              || !int_reg_operand (operands[1], E_TImode)
              || !int_reg_operand (operands[2], E_TImode)
              || !
#line 7611 "../../gcc/config/rs6000/rs6000.md"
(reload_completed && !TARGET_P8_VECTOR))
            return NULL;
          return gen_split_279 (insn, operands);

        case E_PTImode:
          if (GET_MODE (x3) != E_PTImode
              || GET_MODE (x4) != E_PTImode)
            return NULL;
          if (vlogical_operand (operands[0], E_PTImode)
              && vlogical_operand (operands[1], E_PTImode)
              && vlogical_operand (operands[2], E_PTImode)
              && 
#line 7582 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR && reload_completed
   && int_reg_operand (operands[0], PTImode)))
            return gen_split_271 (insn, operands);
          if (!int_reg_operand (operands[0], E_PTImode)
              || !int_reg_operand (operands[1], E_PTImode)
              || !int_reg_operand (operands[2], E_PTImode)
              || !
#line 7611 "../../gcc/config/rs6000/rs6000.md"
(reload_completed && !TARGET_P8_VECTOR))
            return NULL;
          return gen_split_280 (insn, operands);

        case E_V16QImode:
          if (pattern317 (x3, 
E_V16QImode) != 0
              || !(
#line 7582 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR && reload_completed
   && int_reg_operand (operands[0], V16QImode)) && 
#line 778 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
            return NULL;
          return gen_split_272 (insn, operands);

        case E_V8HImode:
          if (pattern317 (x3, 
E_V8HImode) != 0
              || !(
#line 7582 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR && reload_completed
   && int_reg_operand (operands[0], V8HImode)) && 
#line 779 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
            return NULL;
          return gen_split_273 (insn, operands);

        case E_V4SImode:
          if (pattern317 (x3, 
E_V4SImode) != 0
              || !(
#line 7582 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR && reload_completed
   && int_reg_operand (operands[0], V4SImode)) && 
#line 780 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
            return NULL;
          return gen_split_274 (insn, operands);

        case E_V4SFmode:
          if (pattern317 (x3, 
E_V4SFmode) != 0
              || !(
#line 7582 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR && reload_completed
   && int_reg_operand (operands[0], V4SFmode)) && 
#line 781 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
            return NULL;
          return gen_split_275 (insn, operands);

        case E_V2DImode:
          if (pattern317 (x3, 
E_V2DImode) != 0
              || !(
#line 7582 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR && reload_completed
   && int_reg_operand (operands[0], V2DImode)) && 
#line 782 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
            return NULL;
          return gen_split_276 (insn, operands);

        case E_V2DFmode:
          if (pattern317 (x3, 
E_V2DFmode) != 0
              || !(
#line 7582 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR && reload_completed
   && int_reg_operand (operands[0], V2DFmode)) && 
#line 783 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
            return NULL;
          return gen_split_277 (insn, operands);

        case E_V1TImode:
          if (pattern317 (x3, 
E_V1TImode) != 0
              || !(
#line 7582 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR && reload_completed
   && int_reg_operand (operands[0], V1TImode)) && 
#line 784 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
            return NULL;
          return gen_split_278 (insn, operands);

        default:
          return NULL;
        }

    case REG:
    case SUBREG:
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_TImode:
          if (!vlogical_operand (operands[0], E_TImode)
              || GET_MODE (x3) != E_TImode
              || !vlogical_operand (operands[1], E_TImode)
              || !
#line 7639 "../../gcc/config/rs6000/rs6000.md"
(reload_completed && int_reg_operand (operands[0], TImode)))
            return NULL;
          return gen_split_281 (insn, operands);

        case E_PTImode:
          if (!vlogical_operand (operands[0], E_PTImode)
              || GET_MODE (x3) != E_PTImode
              || !vlogical_operand (operands[1], E_PTImode)
              || !
#line 7639 "../../gcc/config/rs6000/rs6000.md"
(reload_completed && int_reg_operand (operands[0], PTImode)))
            return NULL;
          return gen_split_282 (insn, operands);

        case E_V16QImode:
          if (!vlogical_operand (operands[0], E_V16QImode)
              || GET_MODE (x3) != E_V16QImode
              || !vlogical_operand (operands[1], E_V16QImode)
              || !(
#line 7639 "../../gcc/config/rs6000/rs6000.md"
(reload_completed && int_reg_operand (operands[0], V16QImode)) && 
#line 778 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
            return NULL;
          return gen_split_283 (insn, operands);

        case E_V8HImode:
          if (!vlogical_operand (operands[0], E_V8HImode)
              || GET_MODE (x3) != E_V8HImode
              || !vlogical_operand (operands[1], E_V8HImode)
              || !(
#line 7639 "../../gcc/config/rs6000/rs6000.md"
(reload_completed && int_reg_operand (operands[0], V8HImode)) && 
#line 779 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
            return NULL;
          return gen_split_284 (insn, operands);

        case E_V4SImode:
          if (!vlogical_operand (operands[0], E_V4SImode)
              || GET_MODE (x3) != E_V4SImode
              || !vlogical_operand (operands[1], E_V4SImode)
              || !(
#line 7639 "../../gcc/config/rs6000/rs6000.md"
(reload_completed && int_reg_operand (operands[0], V4SImode)) && 
#line 780 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
            return NULL;
          return gen_split_285 (insn, operands);

        case E_V4SFmode:
          if (!vlogical_operand (operands[0], E_V4SFmode)
              || GET_MODE (x3) != E_V4SFmode
              || !vlogical_operand (operands[1], E_V4SFmode)
              || !(
#line 7639 "../../gcc/config/rs6000/rs6000.md"
(reload_completed && int_reg_operand (operands[0], V4SFmode)) && 
#line 781 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
            return NULL;
          return gen_split_286 (insn, operands);

        case E_V2DImode:
          if (!vlogical_operand (operands[0], E_V2DImode)
              || GET_MODE (x3) != E_V2DImode
              || !vlogical_operand (operands[1], E_V2DImode)
              || !(
#line 7639 "../../gcc/config/rs6000/rs6000.md"
(reload_completed && int_reg_operand (operands[0], V2DImode)) && 
#line 782 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
            return NULL;
          return gen_split_287 (insn, operands);

        case E_V2DFmode:
          if (!vlogical_operand (operands[0], E_V2DFmode)
              || GET_MODE (x3) != E_V2DFmode
              || !vlogical_operand (operands[1], E_V2DFmode)
              || !(
#line 7639 "../../gcc/config/rs6000/rs6000.md"
(reload_completed && int_reg_operand (operands[0], V2DFmode)) && 
#line 783 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
            return NULL;
          return gen_split_288 (insn, operands);

        case E_V1TImode:
          if (!vlogical_operand (operands[0], E_V1TImode)
              || GET_MODE (x3) != E_V1TImode
              || !vlogical_operand (operands[1], E_V1TImode)
              || !(
#line 7639 "../../gcc/config/rs6000/rs6000.md"
(reload_completed && int_reg_operand (operands[0], V1TImode)) && 
#line 784 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
            return NULL;
          return gen_split_289 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
peephole2_2 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = PATTERN (peep2_next_insn (1));
  if (GET_CODE (x2) != SET)
    return NULL;
  x3 = XEXP (x1, 1);
  switch (GET_CODE (x3))
    {
    case DIV:
      switch (pattern119 (x1, 
MOD))
        {
        case 0:
          if (!
#line 3539 "../../gcc/config/rs6000/rs6000.md"
(TARGET_MODULO
   && ! reg_mentioned_p (operands[0], operands[1])
   && ! reg_mentioned_p (operands[0], operands[2])
   && ! reg_mentioned_p (operands[3], operands[1])
   && ! reg_mentioned_p (operands[3], operands[2])))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_1 (insn, operands);

        case 1:
          if (!(
#line 3539 "../../gcc/config/rs6000/rs6000.md"
(TARGET_MODULO
   && ! reg_mentioned_p (operands[0], operands[1])
   && ! reg_mentioned_p (operands[0], operands[2])
   && ! reg_mentioned_p (operands[3], operands[1])
   && ! reg_mentioned_p (operands[3], operands[2])) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_2 (insn, operands);

        default:
          return NULL;
        }

    case UDIV:
      switch (pattern119 (x1, 
UMOD))
        {
        case 0:
          if (!
#line 3561 "../../gcc/config/rs6000/rs6000.md"
(TARGET_MODULO
   && ! reg_mentioned_p (operands[0], operands[1])
   && ! reg_mentioned_p (operands[0], operands[2])
   && ! reg_mentioned_p (operands[3], operands[1])
   && ! reg_mentioned_p (operands[3], operands[2])))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_3 (insn, operands);

        case 1:
          if (!(
#line 3561 "../../gcc/config/rs6000/rs6000.md"
(TARGET_MODULO
   && ! reg_mentioned_p (operands[0], operands[1])
   && ! reg_mentioned_p (operands[0], operands[2])
   && ! reg_mentioned_p (operands[3], operands[1])
   && ! reg_mentioned_p (operands[3], operands[2])) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_4 (insn, operands);

        default:
          return NULL;
        }

    case COMPARE:
      if (GET_MODE (x3) != E_CCmode)
        return NULL;
      x4 = XEXP (x3, 1);
      if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return NULL;
      x5 = XEXP (x1, 0);
      operands[2] = x5;
      if (!cc_reg_operand (operands[2], E_CCmode))
        return NULL;
      x6 = XEXP (x3, 0);
      operands[1] = x6;
      x7 = XEXP (x2, 0);
      operands[0] = x7;
      x8 = XEXP (x2, 1);
      if (!rtx_equal_p (x8, operands[1]))
        return NULL;
      switch (GET_MODE (operands[1]))
        {
        case E_SImode:
          if (!int_reg_operand (operands[1], E_SImode)
              || !int_reg_operand (operands[0], E_SImode)
              || !(
#line 8059 "../../gcc/config/rs6000/rs6000.md"
(!cc_reg_not_cr0_operand (operands[2], CCmode)) && 
#line 513 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWERPC64)))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_5 (insn, operands);

        case E_DImode:
          if (!int_reg_operand (operands[1], E_DImode)
              || !int_reg_operand (operands[0], E_DImode)
              || !(
#line 8059 "../../gcc/config/rs6000/rs6000.md"
(!cc_reg_not_cr0_operand (operands[2], CCmode)) && 
#line 513 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_6 (insn, operands);

        default:
          return NULL;
        }

    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case PLUS:
    case HIGH:
      x5 = XEXP (x1, 0);
      switch (GET_MODE (x5))
        {
        case E_SImode:
          operands[0] = x5;
          operands[1] = x3;
          if (int_reg_operand (operands[1], E_SImode)
              && pattern361 (x2, 
E_SImode) == 0)
            {
              if ((
#line 8074 "../../gcc/config/rs6000/rs6000.md"
(!cc_reg_not_cr0_operand (operands[2], CCmode)) && 
#line 513 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWERPC64)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_7 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              if ((
#line 8074 "../../gcc/config/rs6000/rs6000.md"
(!cc_reg_not_cr0_operand (operands[2], CCmode)) && ((
#line 513 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWERPC64) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 513 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWERPC64))))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_8 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
            }
          if (peep2_current_count >= 3)
            {
              res = peephole2_1 (x1, insn, pmatch_len_);
              if (res != NULL_RTX)
                return res;
            }
          if (!fusion_gpr_addis (operands[1], E_SImode))
            return NULL;
          switch (pattern362 (x2, 
E_SImode))
            {
            case 0:
              if (!(
#line 14717 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_FUSION
   && fusion_gpr_load_p (operands[0], operands[1], operands[2],
			 operands[3])) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                return NULL;
              *pmatch_len_ = 1;
              return gen_peephole2_14 (insn, operands);

            case 1:
              if (!(
#line 14717 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_FUSION
   && fusion_gpr_load_p (operands[0], operands[1], operands[2],
			 operands[3])) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                return NULL;
              *pmatch_len_ = 1;
              return gen_peephole2_15 (insn, operands);

            case 2:
              if (!(
#line 14717 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_FUSION
   && fusion_gpr_load_p (operands[0], operands[1], operands[2],
			 operands[3])) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                return NULL;
              *pmatch_len_ = 1;
              return gen_peephole2_16 (insn, operands);

            case 3:
              if (!(
#line 14717 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_FUSION
   && fusion_gpr_load_p (operands[0], operands[1], operands[2],
			 operands[3])) && ((
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT) && 
#line 484 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 484 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))))
                return NULL;
              *pmatch_len_ = 1;
              return gen_peephole2_17 (insn, operands);

            default:
              return NULL;
            }

        case E_DImode:
          operands[0] = x5;
          operands[1] = x3;
          if (int_reg_operand (operands[1], E_DImode)
              && pattern361 (x2, 
E_DImode) == 0
              && (
#line 8074 "../../gcc/config/rs6000/rs6000.md"
(!cc_reg_not_cr0_operand (operands[2], CCmode)) && 
#line 513 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_9 (insn, operands);
              if (res != NULL_RTX)
                return res;
              *pmatch_len_ = 1;
              res = gen_peephole2_10 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          if (fusion_gpr_addis (operands[1], E_DImode))
            {
              switch (pattern362 (x2, 
E_DImode))
                {
                case 0:
                  if ((
#line 14717 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_FUSION
   && fusion_gpr_load_p (operands[0], operands[1], operands[2],
			 operands[3])) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                    {
                      *pmatch_len_ = 1;
                      res = gen_peephole2_18 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                  break;

                case 1:
                  if ((
#line 14717 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_FUSION
   && fusion_gpr_load_p (operands[0], operands[1], operands[2],
			 operands[3])) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                    {
                      *pmatch_len_ = 1;
                      res = gen_peephole2_19 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                  break;

                case 2:
                  if ((
#line 14717 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_FUSION
   && fusion_gpr_load_p (operands[0], operands[1], operands[2],
			 operands[3])) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                    {
                      *pmatch_len_ = 1;
                      res = gen_peephole2_20 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                  break;

                case 3:
                  if ((
#line 14717 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_FUSION
   && fusion_gpr_load_p (operands[0], operands[1], operands[2],
			 operands[3])) && ((
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT) && 
#line 484 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 484 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))))
                    {
                      *pmatch_len_ = 1;
                      res = gen_peephole2_21 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                  break;

                default:
                  break;
                }
            }
          operands[1] = x5;
          if (!fpr_reg_operand (operands[1], E_DImode))
            return NULL;
          operands[2] = x3;
          x7 = XEXP (x2, 0);
          operands[3] = x7;
          if (altivec_register_operand (operands[3], E_DImode)
              && simple_offsettable_mem_operand (operands[2], E_DImode))
            {
              x8 = XEXP (x2, 1);
              if (rtx_equal_p (x8, operands[1]))
                {
                  if ((
#line 14757 "../../gcc/config/rs6000/rs6000.md"
(TARGET_VSX && !TARGET_P9_VECTOR && peep2_reg_dead_p (2, operands[1])) && (((
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT) && 
#line 858 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 858 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 858 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))))
                    {
                      *pmatch_len_ = 1;
                      res = gen_peephole2_26 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                  if ((
#line 14757 "../../gcc/config/rs6000/rs6000.md"
(TARGET_VSX && !TARGET_P9_VECTOR && peep2_reg_dead_p (2, operands[1])) && (((
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT) && 
#line 858 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 858 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 858 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))))
                    {
                      *pmatch_len_ = 1;
                      res = gen_peephole2_27 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                }
            }
          if (!simple_offsettable_mem_operand (operands[3], E_DImode)
              || !altivec_register_operand (operands[2], E_DImode))
            return NULL;
          x8 = XEXP (x2, 1);
          if (!rtx_equal_p (x8, operands[1]))
            return NULL;
          if ((
#line 14793 "../../gcc/config/rs6000/rs6000.md"
(TARGET_VSX && !TARGET_P9_VECTOR && peep2_reg_dead_p (2, operands[1])) && (((
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT) && 
#line 858 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 858 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 858 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_32 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          if (!(
#line 14793 "../../gcc/config/rs6000/rs6000.md"
(TARGET_VSX && !TARGET_P9_VECTOR && peep2_reg_dead_p (2, operands[1])) && (((
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT) && 
#line 858 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 858 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 858 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_33 (insn, operands);

        case E_DFmode:
          operands[0] = x5;
          if (pattern264 (x3, 
E_DFmode) == 0
              && 
#line 10545 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_VSX
   && peep2_reg_dead_p (2, operands[0])))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_11 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          operands[1] = x5;
          if (!fpr_reg_operand (operands[1], E_DFmode))
            return NULL;
          operands[2] = x3;
          x7 = XEXP (x2, 0);
          operands[3] = x7;
          if (altivec_register_operand (operands[3], E_DFmode)
              && simple_offsettable_mem_operand (operands[2], E_DFmode))
            {
              x8 = XEXP (x2, 1);
              if (rtx_equal_p (x8, operands[1]))
                {
                  if ((
#line 14757 "../../gcc/config/rs6000/rs6000.md"
(TARGET_VSX && !TARGET_P9_VECTOR && peep2_reg_dead_p (2, operands[1])) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                    {
                      *pmatch_len_ = 1;
                      res = gen_peephole2_22 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                  if ((
#line 14757 "../../gcc/config/rs6000/rs6000.md"
(TARGET_VSX && !TARGET_P9_VECTOR && peep2_reg_dead_p (2, operands[1])) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                    {
                      *pmatch_len_ = 1;
                      res = gen_peephole2_23 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                }
            }
          if (!simple_offsettable_mem_operand (operands[3], E_DFmode)
              || !altivec_register_operand (operands[2], E_DFmode))
            return NULL;
          x8 = XEXP (x2, 1);
          if (!rtx_equal_p (x8, operands[1]))
            return NULL;
          if ((
#line 14793 "../../gcc/config/rs6000/rs6000.md"
(TARGET_VSX && !TARGET_P9_VECTOR && peep2_reg_dead_p (2, operands[1])) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_28 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          if (!(
#line 14793 "../../gcc/config/rs6000/rs6000.md"
(TARGET_VSX && !TARGET_P9_VECTOR && peep2_reg_dead_p (2, operands[1])) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_29 (insn, operands);

        case E_SFmode:
          operands[0] = x5;
          if (pattern264 (x3, 
E_SFmode) == 0
              && 
#line 10554 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_P8_VECTOR
   && peep2_reg_dead_p (2, operands[0])))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_12 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          operands[1] = x5;
          if (!fpr_reg_operand (operands[1], E_SFmode))
            return NULL;
          operands[2] = x3;
          x7 = XEXP (x2, 0);
          operands[3] = x7;
          if (altivec_register_operand (operands[3], E_SFmode)
              && simple_offsettable_mem_operand (operands[2], E_SFmode))
            {
              x8 = XEXP (x2, 1);
              if (rtx_equal_p (x8, operands[1]))
                {
                  if ((
#line 14757 "../../gcc/config/rs6000/rs6000.md"
(TARGET_VSX && !TARGET_P9_VECTOR && peep2_reg_dead_p (2, operands[1])) && (((
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT) && 
#line 857 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR)) && 
#line 857 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR)) && 
#line 857 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR))))
                    {
                      *pmatch_len_ = 1;
                      res = gen_peephole2_24 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                  if ((
#line 14757 "../../gcc/config/rs6000/rs6000.md"
(TARGET_VSX && !TARGET_P9_VECTOR && peep2_reg_dead_p (2, operands[1])) && (((
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT) && 
#line 857 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR)) && 
#line 857 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR)) && 
#line 857 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR))))
                    {
                      *pmatch_len_ = 1;
                      res = gen_peephole2_25 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                }
            }
          if (!simple_offsettable_mem_operand (operands[3], E_SFmode)
              || !altivec_register_operand (operands[2], E_SFmode))
            return NULL;
          x8 = XEXP (x2, 1);
          if (!rtx_equal_p (x8, operands[1]))
            return NULL;
          if ((
#line 14793 "../../gcc/config/rs6000/rs6000.md"
(TARGET_VSX && !TARGET_P9_VECTOR && peep2_reg_dead_p (2, operands[1])) && (((
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT) && 
#line 857 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR)) && 
#line 857 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR)) && 
#line 857 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR))))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_30 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          if (!(
#line 14793 "../../gcc/config/rs6000/rs6000.md"
(TARGET_VSX && !TARGET_P9_VECTOR && peep2_reg_dead_p (2, operands[1])) && (((
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT) && 
#line 857 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR)) && 
#line 857 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR)) && 
#line 857 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR))))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_31 (insn, operands);

        default:
          return NULL;
        }

    case ROTATE:
      x4 = XEXP (x3, 1);
      if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 64])
        return NULL;
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      x6 = XEXP (x3, 0);
      operands[1] = x6;
      x8 = XEXP (x2, 1);
      if (GET_CODE (x8) != ROTATE)
        return NULL;
      x9 = XEXP (x8, 1);
      if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 64])
        return NULL;
      x7 = XEXP (x2, 0);
      operands[2] = x7;
      x10 = XEXP (x8, 0);
      if (!rtx_equal_p (x10, operands[0]))
        return NULL;
      switch (GET_MODE (operands[0]))
        {
        case E_V1TImode:
          if (!int_reg_operand (operands[0], E_V1TImode)
              || GET_MODE (x3) != E_V1TImode
              || GET_MODE (x8) != E_V1TImode)
            return NULL;
          if (memory_operand (operands[1], E_V1TImode)
              && int_reg_operand (operands[2], E_V1TImode)
              && 
#line 1095 "../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX && !TARGET_P9_VECTOR
   && (rtx_equal_p (operands[0], operands[2])
       || peep2_reg_dead_p (2, operands[0]))))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_34 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          if (!int_reg_operand (operands[1], E_V1TImode)
              || !memory_operand (operands[2], E_V1TImode)
              || !
#line 1107 "../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX && !TARGET_P9_VECTOR
   && peep2_reg_dead_p (2, operands[0])))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_36 (insn, operands);

        case E_TImode:
          if (GET_MODE (x3) != E_TImode
              || GET_MODE (x8) != E_TImode)
            return NULL;
          if (int_reg_operand (operands[0], E_TImode))
            {
              if (memory_operand (operands[1], E_TImode)
                  && int_reg_operand (operands[2], E_TImode)
                  && 
#line 1095 "../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX && !TARGET_P9_VECTOR
   && (rtx_equal_p (operands[0], operands[2])
       || peep2_reg_dead_p (2, operands[0]))))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_35 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              if (int_reg_operand (operands[1], E_TImode)
                  && memory_operand (operands[2], E_TImode)
                  && 
#line 1107 "../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX && !TARGET_P9_VECTOR
   && peep2_reg_dead_p (2, operands[0])))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_37 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
            }
          if (!vsx_register_operand (operands[0], E_TImode)
              || !vsx_register_operand (operands[1], E_TImode)
              || !vsx_register_operand (operands[2], E_TImode)
              || !
#line 1121 "../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX && !TARGET_P9_VECTOR
   && (rtx_equal_p (operands[0], operands[2])
       || peep2_reg_dead_p (2, operands[0]))))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_38 (insn, operands);

        default:
          return NULL;
        }

    case ZERO_EXTEND:
      if (peep2_current_count < 3
          || peep2_current_count < 4
          || GET_MODE (x3) != E_DImode)
        return NULL;
      x5 = XEXP (x1, 0);
      operands[2] = x5;
      if (!int_reg_operand (operands[2], E_DImode))
        return NULL;
      x6 = XEXP (x3, 0);
      operands[3] = x6;
      if (!vsx_register_operand (operands[3], E_SImode))
        return NULL;
      x7 = XEXP (x2, 0);
      operands[4] = x7;
      if (!int_reg_operand (operands[4], E_SImode))
        return NULL;
      x8 = XEXP (x2, 1);
      if (GET_MODE (x8) != E_SImode)
        return NULL;
      x11 = PATTERN (peep2_next_insn (2));
      if (GET_CODE (x11) != SET)
        return NULL;
      x12 = XEXP (x11, 1);
      if (GET_CODE (x12) != ASHIFT
          || GET_MODE (x12) != E_DImode)
        return NULL;
      x13 = XEXP (x12, 1);
      if (x13 != const_int_rtx[MAX_SAVED_CONST_INT + 32])
        return NULL;
      x14 = XEXP (x11, 0);
      operands[7] = x14;
      if (!int_reg_operand (operands[7], E_DImode))
        return NULL;
      x15 = XEXP (x12, 0);
      operands[8] = x15;
      if (!int_reg_operand (operands[8], E_DImode))
        return NULL;
      x16 = PATTERN (peep2_next_insn (3));
      if (GET_CODE (x16) != SET)
        return NULL;
      x17 = XEXP (x16, 1);
      if (GET_CODE (x17) != UNSPEC
          || XVECLEN (x17, 0) != 1
          || XINT (x17, 1) != 62
          || GET_MODE (x17) != E_SFmode)
        return NULL;
      x18 = XEXP (x16, 0);
      operands[9] = x18;
      if (!vsx_register_operand (operands[9], E_SFmode))
        return NULL;
      x19 = XVECEXP (x17, 0, 0);
      if (!rtx_equal_p (x19, operands[7]))
        return NULL;
      switch (GET_CODE (x8))
        {
        case AND:
          x10 = XEXP (x8, 0);
          operands[5] = x10;
          if (!int_reg_operand (operands[5], E_SImode))
            return NULL;
          x9 = XEXP (x8, 1);
          operands[6] = x9;
          if (!reg_or_cint_operand (operands[6], E_SImode)
              || !
#line 6343 "../../gcc/config/rs6000/vsx.md"
(TARGET_DIRECT_MOVE_64BIT
   /* The REG_P (xxx) tests prevents SUBREG's, which allows us to use REGNO
      to compare registers, when the mode is different.  */
   && REG_P (operands[SFBOOL_MFVSR_D]) && REG_P (operands[SFBOOL_BOOL_D])
   && REG_P (operands[SFBOOL_BOOL_A1]) && REG_P (operands[SFBOOL_SHL_D])
   && REG_P (operands[SFBOOL_SHL_A])   && REG_P (operands[SFBOOL_MTVSR_D])
   && (REG_P (operands[SFBOOL_BOOL_A2])
       || CONST_INT_P (operands[SFBOOL_BOOL_A2]))
   && (REGNO (operands[SFBOOL_BOOL_D]) == REGNO (operands[SFBOOL_MFVSR_D])
       || peep2_reg_dead_p (2, operands[SFBOOL_MFVSR_D]))
   && (REGNO (operands[SFBOOL_MFVSR_D]) == REGNO (operands[SFBOOL_BOOL_A1])
       || (REG_P (operands[SFBOOL_BOOL_A2])
	   && REGNO (operands[SFBOOL_MFVSR_D])
		== REGNO (operands[SFBOOL_BOOL_A2])))
   && REGNO (operands[SFBOOL_BOOL_D]) == REGNO (operands[SFBOOL_SHL_A])
   && (REGNO (operands[SFBOOL_SHL_D]) == REGNO (operands[SFBOOL_BOOL_D])
       || peep2_reg_dead_p (3, operands[SFBOOL_BOOL_D]))
   && peep2_reg_dead_p (4, operands[SFBOOL_SHL_D])))
            return NULL;
          *pmatch_len_ = 3;
          return gen_peephole2_39 (insn, operands);

        case IOR:
          x10 = XEXP (x8, 0);
          operands[5] = x10;
          if (!int_reg_operand (operands[5], E_SImode))
            return NULL;
          x9 = XEXP (x8, 1);
          operands[6] = x9;
          if (!reg_or_cint_operand (operands[6], E_SImode)
              || !
#line 6343 "../../gcc/config/rs6000/vsx.md"
(TARGET_DIRECT_MOVE_64BIT
   /* The REG_P (xxx) tests prevents SUBREG's, which allows us to use REGNO
      to compare registers, when the mode is different.  */
   && REG_P (operands[SFBOOL_MFVSR_D]) && REG_P (operands[SFBOOL_BOOL_D])
   && REG_P (operands[SFBOOL_BOOL_A1]) && REG_P (operands[SFBOOL_SHL_D])
   && REG_P (operands[SFBOOL_SHL_A])   && REG_P (operands[SFBOOL_MTVSR_D])
   && (REG_P (operands[SFBOOL_BOOL_A2])
       || CONST_INT_P (operands[SFBOOL_BOOL_A2]))
   && (REGNO (operands[SFBOOL_BOOL_D]) == REGNO (operands[SFBOOL_MFVSR_D])
       || peep2_reg_dead_p (2, operands[SFBOOL_MFVSR_D]))
   && (REGNO (operands[SFBOOL_MFVSR_D]) == REGNO (operands[SFBOOL_BOOL_A1])
       || (REG_P (operands[SFBOOL_BOOL_A2])
	   && REGNO (operands[SFBOOL_MFVSR_D])
		== REGNO (operands[SFBOOL_BOOL_A2])))
   && REGNO (operands[SFBOOL_BOOL_D]) == REGNO (operands[SFBOOL_SHL_A])
   && (REGNO (operands[SFBOOL_SHL_D]) == REGNO (operands[SFBOOL_BOOL_D])
       || peep2_reg_dead_p (3, operands[SFBOOL_BOOL_D]))
   && peep2_reg_dead_p (4, operands[SFBOOL_SHL_D])))
            return NULL;
          *pmatch_len_ = 3;
          return gen_peephole2_40 (insn, operands);

        case XOR:
          x10 = XEXP (x8, 0);
          operands[5] = x10;
          if (!int_reg_operand (operands[5], E_SImode))
            return NULL;
          x9 = XEXP (x8, 1);
          operands[6] = x9;
          if (!reg_or_cint_operand (operands[6], E_SImode)
              || !
#line 6343 "../../gcc/config/rs6000/vsx.md"
(TARGET_DIRECT_MOVE_64BIT
   /* The REG_P (xxx) tests prevents SUBREG's, which allows us to use REGNO
      to compare registers, when the mode is different.  */
   && REG_P (operands[SFBOOL_MFVSR_D]) && REG_P (operands[SFBOOL_BOOL_D])
   && REG_P (operands[SFBOOL_BOOL_A1]) && REG_P (operands[SFBOOL_SHL_D])
   && REG_P (operands[SFBOOL_SHL_A])   && REG_P (operands[SFBOOL_MTVSR_D])
   && (REG_P (operands[SFBOOL_BOOL_A2])
       || CONST_INT_P (operands[SFBOOL_BOOL_A2]))
   && (REGNO (operands[SFBOOL_BOOL_D]) == REGNO (operands[SFBOOL_MFVSR_D])
       || peep2_reg_dead_p (2, operands[SFBOOL_MFVSR_D]))
   && (REGNO (operands[SFBOOL_MFVSR_D]) == REGNO (operands[SFBOOL_BOOL_A1])
       || (REG_P (operands[SFBOOL_BOOL_A2])
	   && REGNO (operands[SFBOOL_MFVSR_D])
		== REGNO (operands[SFBOOL_BOOL_A2])))
   && REGNO (operands[SFBOOL_BOOL_D]) == REGNO (operands[SFBOOL_SHL_A])
   && (REGNO (operands[SFBOOL_SHL_D]) == REGNO (operands[SFBOOL_BOOL_D])
       || peep2_reg_dead_p (3, operands[SFBOOL_BOOL_D]))
   && peep2_reg_dead_p (4, operands[SFBOOL_SHL_D])))
            return NULL;
          *pmatch_len_ = 3;
          return gen_peephole2_41 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}
