/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern5 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[1] = x4;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          if (GET_MODE (x3) != E_SFmode)
            return -1;
          return 0;

        case E_DFmode:
          if (GET_MODE (x3) != E_DFmode)
            return -1;
          return 1;

        case E_KFmode:
          if (pattern1 (x3, 
E_KFmode) != 0)
            return -1;
          return 2;

        case E_TFmode:
          if (pattern1 (x3, 
E_TFmode) != 0)
            return -1;
          return 3;

        case E_V4SFmode:
          if (GET_MODE (x3) != E_V4SFmode)
            return -1;
          return 4;

        case E_V2DFmode:
          if (pattern2 (x3, 
E_V2DFmode) != 0)
            return -1;
          return 5;

        case E_V4SImode:
          if (pattern3 (x3, 
E_V4SImode) != 0)
            return -1;
          return 6;

        case E_V8HImode:
          if (pattern3 (x3, 
E_V8HImode) != 0)
            return -1;
          return 7;

        case E_V16QImode:
          if (pattern3 (x3, 
E_V16QImode) != 0)
            return -1;
          return 8;

        case E_V2DImode:
          if (pattern3 (x3, 
E_V2DImode) != 0)
            return -1;
          return 9;

        default:
          return -1;
        }

    case VEC_CONCAT:
      if (pnum_clobbers == NULL
          || GET_MODE (x4) != E_V2DFmode)
        return -1;
      x6 = XEXP (x4, 0);
      if (GET_CODE (x6) != VEC_SELECT
          || GET_MODE (x6) != E_DFmode)
        return -1;
      x7 = XEXP (x6, 1);
      if (GET_CODE (x7) != PARALLEL
          || XVECLEN (x7, 0) != 1)
        return -1;
      x8 = XVECEXP (x7, 0, 0);
      if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x9 = XEXP (x4, 1);
      if (GET_CODE (x9) != VEC_SELECT
          || GET_MODE (x9) != E_DFmode)
        return -1;
      x10 = XEXP (x9, 1);
      if (GET_CODE (x10) != PARALLEL
          || XVECLEN (x10, 0) != 1)
        return -1;
      x11 = XVECEXP (x10, 0, 0);
      if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || pattern4 (x3) != 0)
        return -1;
      return 10;

    case UNSPEC:
      if (pnum_clobbers == NULL
          || XVECLEN (x4, 0) != 1
          || XINT (x4, 1) != 102
          || GET_MODE (x4) != E_V4SFmode)
        return -1;
      x12 = XVECEXP (x4, 0, 0);
      if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || !vfloat_operand (operands[0], E_V4SFmode)
          || GET_MODE (x3) != E_V4SFmode)
        return -1;
      x5 = XEXP (x3, 1);
      operands[1] = x5;
      if (!vfloat_operand (operands[1], E_V4SFmode))
        return -1;
      return 11;

    default:
      return -1;
    }
}

int
pattern48 (rtx x1, machine_mode i1, rtx_code i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x2, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + -1])
    return -1;
  x6 = XEXP (x2, 2);
  if (GET_CODE (x6) != IF_THEN_ELSE)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != i2)
    return -1;
  x8 = XEXP (x7, 1);
  if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x9 = XEXP (x6, 1);
  if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x10 = XEXP (x6, 2);
  if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x11 = XEXP (x1, 0);
  operands[0] = x11;
  if (!gpc_reg_operand (operands[0], E_SImode)
      || GET_MODE (x2) != E_SImode)
    return -1;
  x12 = XEXP (x3, 0);
  operands[1] = x12;
  if (!cc_reg_operand (operands[1], i1))
    return -1;
  x13 = XEXP (x7, 0);
  if (!rtx_equal_p (x13, operands[1]))
    return -1;
  return 0;
}

int
pattern65 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 0);
  operands[3] = x2;
  x3 = XEXP (x1, 1);
  return pattern63 (x3); /* [-1, 23] */
}

int
pattern69 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!gpc_reg_operand (operands[0], E_SImode)
          || !small_toc_ref (operands[1], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!gpc_reg_operand (operands[0], E_DImode)
          || !small_toc_ref (operands[1], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern71 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!altivec_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !scratch_operand (operands[2], E_DImode))
    return -1;
  return pattern70 (); /* [-1, 2] */
}

int
pattern75 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != PARALLEL
      || XVECLEN (x5, 0) != 1)
    return -1;
  x6 = XEXP (x4, 0);
  operands[1] = x6;
  x7 = XVECEXP (x5, 0, 0);
  operands[2] = x7;
  x8 = XVECEXP (x1, 0, 1);
  x9 = XEXP (x8, 0);
  operands[3] = x9;
  switch (GET_MODE (operands[0]))
    {
    case E_DFmode:
      if (!gpc_reg_operand (operands[0], E_DFmode)
          || GET_MODE (x3) != E_DFmode)
        return -1;
      switch (GET_MODE (x4))
        {
        case E_SImode:
          if (!gpc_reg_operand (operands[1], E_V4SImode))
            return -1;
          return 0;

        case E_QImode:
          if (!gpc_reg_operand (operands[1], E_V16QImode)
              || !const_int_operand (operands[2], E_QImode)
              || !scratch_operand (operands[3], E_QImode))
            return -1;
          return 1;

        case E_HImode:
          if (!gpc_reg_operand (operands[1], E_V8HImode)
              || !const_int_operand (operands[2], E_QImode)
              || !scratch_operand (operands[3], E_HImode))
            return -1;
          return 2;

        default:
          return -1;
        }

    case E_SFmode:
      res = pattern74 (x3, 
E_SFmode);
      if (res >= 0)
        return res + 3; /* [3, 5] */
      return -1;

    case E_KFmode:
      res = pattern74 (x3, 
E_KFmode);
      if (res >= 0)
        return res + 6; /* [6, 8] */
      return -1;

    case E_TFmode:
      res = pattern74 (x3, 
E_TFmode);
      if (res >= 0)
        return res + 9; /* [9, 11] */
      return -1;

    default:
      return -1;
    }
}

int
pattern95 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[1], i1)
      || !gpc_reg_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1)
    return -1;
  return 0;
}

int
pattern104 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[1], i1)
      || !scc_eq_operand (operands[2], i1)
      || !scratch_operand (operands[3], i1)
      || !scratch_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern106 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!memory_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !gpc_reg_operand (operands[1], i2)
      || !scratch_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern107 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != PARALLEL
      || XVECLEN (x4, 0) != 1)
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x5) != CLOBBER)
    return -1;
  x6 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x6) != CLOBBER)
    return -1;
  x7 = XEXP (x2, 0);
  operands[0] = x7;
  x8 = XEXP (x3, 0);
  operands[1] = x8;
  x9 = XVECEXP (x4, 0, 0);
  operands[2] = x9;
  if (!const_int_operand (operands[2], E_QImode))
    return -1;
  x10 = XEXP (x5, 0);
  operands[3] = x10;
  x11 = XEXP (x6, 0);
  operands[4] = x11;
  if (!scratch_operand (operands[4], E_SImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      return pattern106 (x3, 
E_QImode, 
E_V16QImode); /* [-1, 0] */

    case E_HImode:
      if (pattern106 (x3, 
E_HImode, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_SImode:
      if (pattern106 (x3, 
E_SImode, 
E_V4SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern120 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !gpc_reg_operand (operands[1], i1)
      || !scc_eq_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern127 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_SImode:
      if (!gpc_reg_operand (operands[1], E_SImode)
          || !reg_or_u_short_operand (operands[2], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!gpc_reg_operand (operands[1], E_DImode)
          || !reg_or_u_short_operand (operands[2], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern135 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_KFmode:
      return pattern134 (x3, 
E_KFmode); /* [-1, 0] */

    case E_TFmode:
      if (pattern134 (x3, 
E_TFmode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern143 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], i2))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], i1))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern153 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      return pattern141 (x3, 
E_V16QImode); /* [-1, 0] */

    case E_V2DImode:
      if (pattern141 (x3, 
E_V2DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern161 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || GET_MODE (x3) != E_V2DImode
          || !register_operand (operands[1], E_V4SImode))
        return -1;
      return 0;

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x3) != E_V4SImode
          || !register_operand (operands[1], E_V8HImode))
        return -1;
      return 1;

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || GET_MODE (x3) != E_V8HImode
          || !register_operand (operands[1], E_V16QImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern170 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  if (!register_operand (operands[3], E_V16QImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V4SImode:
      return pattern141 (x3, 
E_V4SImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern141 (x3, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V16QImode:
      if (pattern141 (x3, 
E_V16QImode) != 0)
        return -1;
      return 2;

    case E_V4SFmode:
      if (pattern141 (x3, 
E_V4SFmode) != 0)
        return -1;
      return 3;

    case E_V2DFmode:
      if (pattern141 (x3, 
E_V2DFmode) != 0)
        return -1;
      return 4;

    case E_V2DImode:
      if (pattern141 (x3, 
E_V2DImode) != 0)
        return -1;
      return 5;

    case E_V1TImode:
      if (pattern141 (x3, 
E_V1TImode) != 0)
        return -1;
      return 6;

    case E_TImode:
      if (pattern141 (x3, 
E_TImode) != 0)
        return -1;
      return 7;

    case E_KFmode:
      if (pattern141 (x3, 
E_KFmode) != 0)
        return -1;
      return 8;

    case E_TFmode:
      if (pattern141 (x3, 
E_TFmode) != 0)
        return -1;
      return 9;

    default:
      return -1;
    }
}

int
pattern184 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x2, 0);
  operands[3] = x5;
  if (!cc_reg_operand (operands[3], E_CCmode)
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x6 = XEXP (x3, 0);
  x7 = XEXP (x6, 0);
  operands[1] = x7;
  x8 = XEXP (x6, 1);
  operands[2] = x8;
  if (!reg_or_cint_operand (operands[2], E_SImode))
    return -1;
  x9 = XVECEXP (x1, 0, 1);
  switch (GET_CODE (x9))
    {
    case CLOBBER:
      return pattern179 (x1); /* [-1, 1] */

    case SET:
      x10 = XEXP (x9, 1);
      if (GET_CODE (x10) != i1)
        return -1;
      res = pattern183 (x1);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    default:
      return -1;
    }
}

int
pattern195 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XVECEXP (x1, 0, 0);
  x4 = XEXP (x3, 0);
  operands[3] = x4;
  x5 = XEXP (x3, 1);
  x6 = XEXP (x5, 1);
  operands[2] = x6;
  x7 = XEXP (x2, 0);
  operands[4] = x7;
  x8 = XEXP (x5, 0);
  x9 = XEXP (x8, 0);
  switch (GET_CODE (x9))
    {
    case REG:
    case SUBREG:
      return pattern192 (x5); /* [-1, 1] */

    case NOT:
      res = pattern194 (x5);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    default:
      return -1;
    }
}

int
pattern202 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  switch (GET_CODE (x2))
    {
    case CLOBBER:
      x3 = XEXP (x2, 0);
      operands[0] = x3;
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      x6 = XEXP (x5, 0);
      switch (GET_MODE (x6))
        {
        case E_SImode:
          if (!gpc_reg_operand (operands[1], E_SImode)
              || !gpc_reg_operand (operands[2], E_SImode)
              || !scratch_operand (operands[0], E_SImode))
            return -1;
          return 0;

        case E_DImode:
          if (!gpc_reg_operand (operands[1], E_DImode)
              || !gpc_reg_operand (operands[2], E_DImode)
              || !scratch_operand (operands[0], E_DImode))
            return -1;
          return 1;

        default:
          return -1;
        }

    case SET:
      x7 = XEXP (x2, 1);
      if (GET_CODE (x7) != i1)
        return -1;
      x3 = XEXP (x2, 0);
      operands[0] = x3;
      x8 = XEXP (x7, 0);
      if (!rtx_equal_p (x8, operands[1]))
        return -1;
      x9 = XEXP (x7, 1);
      if (!rtx_equal_p (x9, operands[2]))
        return -1;
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      x6 = XEXP (x5, 0);
      switch (GET_MODE (x6))
        {
        case E_SImode:
          if (pattern201 (x7, 
E_SImode) != 0)
            return -1;
          return 2;

        case E_DImode:
          if (pattern201 (x7, 
E_DImode) != 0)
            return -1;
          return 3;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern231 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!altivec_register_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !altivec_register_operand (operands[0], i1)
      || !altivec_register_operand (operands[1], i1)
      || !altivec_register_operand (operands[2], i1)
      || !scratch_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern235 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!altivec_register_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !altivec_register_operand (operands[0], i1))
    return -1;
  x3 = XEXP (x1, 1);
  return pattern234 (x3, 
i1); /* [-1, 0] */
}

int
pattern242 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  operands[1] = x3;
  x4 = XEXP (x1, 1);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[2] = x4;
      switch (GET_MODE (operands[3]))
        {
        case E_SImode:
          return pattern238 (x1, 
E_SImode); /* [-1, 0] */

        case E_DImode:
          if (pattern238 (x1, 
E_DImode) != 0)
            return -1;
          return 1;

        case E_V4SImode:
          if (pattern239 (x1, 
E_V4SImode) != 0)
            return -1;
          return 2;

        case E_V8HImode:
          if (pattern239 (x1, 
E_V8HImode) != 0)
            return -1;
          return 3;

        case E_V16QImode:
          if (pattern239 (x1, 
E_V16QImode) != 0)
            return -1;
          return 4;

        case E_V4SFmode:
          if (pattern239 (x1, 
E_V4SFmode) != 0)
            return -1;
          return 5;

        case E_V2DFmode:
          if (pattern239 (x1, 
E_V2DFmode) != 0)
            return -1;
          return 6;

        case E_V2DImode:
          if (pattern239 (x1, 
E_V2DImode) != 0)
            return -1;
          return 7;

        case E_V1TImode:
          if (pattern239 (x1, 
E_V1TImode) != 0)
            return -1;
          return 8;

        case E_TImode:
          if (pattern239 (x1, 
E_TImode) != 0)
            return -1;
          return 9;

        case E_KFmode:
          if (pattern239 (x1, 
E_KFmode) != 0)
            return -1;
          return 10;

        case E_TFmode:
          if (pattern239 (x1, 
E_TFmode) != 0)
            return -1;
          return 11;

        default:
          return -1;
        }

    case NOT:
      x5 = XEXP (x4, 0);
      operands[2] = x5;
      switch (GET_MODE (operands[3]))
        {
        case E_SImode:
          if (pattern240 (x1, 
E_SImode) != 0)
            return -1;
          return 12;

        case E_DImode:
          if (pattern240 (x1, 
E_DImode) != 0)
            return -1;
          return 13;

        case E_V4SImode:
          if (pattern241 (x1, 
E_V4SImode) != 0)
            return -1;
          return 14;

        case E_V8HImode:
          if (pattern241 (x1, 
E_V8HImode) != 0)
            return -1;
          return 15;

        case E_V16QImode:
          if (pattern241 (x1, 
E_V16QImode) != 0)
            return -1;
          return 16;

        case E_V4SFmode:
          if (pattern241 (x1, 
E_V4SFmode) != 0)
            return -1;
          return 17;

        case E_V2DFmode:
          if (pattern241 (x1, 
E_V2DFmode) != 0)
            return -1;
          return 18;

        case E_V2DImode:
          if (pattern241 (x1, 
E_V2DImode) != 0)
            return -1;
          return 19;

        case E_V1TImode:
          if (pattern241 (x1, 
E_V1TImode) != 0)
            return -1;
          return 20;

        case E_TImode:
          if (pattern241 (x1, 
E_TImode) != 0)
            return -1;
          return 21;

        case E_KFmode:
          if (pattern241 (x1, 
E_KFmode) != 0)
            return -1;
          return 22;

        case E_TFmode:
          if (pattern241 (x1, 
E_TFmode) != 0)
            return -1;
          return 23;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern278 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !gpc_reg_operand (operands[0], i1))
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_MODE (x5) != i1
      || !gpc_reg_operand (operands[1], i1))
    return -1;
  x6 = XEXP (x1, 1);
  if (GET_MODE (x6) != i1
      || !gpc_reg_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern285 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != NOT)
    return -1;
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  x4 = XEXP (x1, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  switch (GET_CODE (x6))
    {
    case NOT:
      x7 = XEXP (x6, 0);
      operands[0] = x7;
      x8 = XEXP (x5, 1);
      switch (GET_CODE (x8))
        {
        case NOT:
          return pattern280 (x1); /* [-1, 11] */

        case REG:
        case SUBREG:
          res = pattern277 (x1);
          if (res >= 0)
            return res + 12; /* [12, 23] */
          return -1;

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      res = pattern274 (x1);
      if (res >= 0)
        return res + 24; /* [24, 35] */
      return -1;

    default:
      return -1;
    }
}

int
pattern297 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 98)
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != REG
      || REGNO (x7) != 98)
    return -1;
  x8 = XEXP (x2, 0);
  operands[0] = x8;
  return 0;
}

int
pattern305 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 0);
  operands[2] = x7;
  if (!scratch_operand (operands[2], E_DImode))
    return -1;
  x8 = XVECEXP (x1, 0, 2);
  x9 = XEXP (x8, 0);
  operands[3] = x9;
  if (!scratch_operand (operands[3], E_DImode))
    return -1;
  x10 = XVECEXP (x1, 0, 3);
  x11 = XEXP (x10, 0);
  operands[4] = x11;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      return pattern304 (x4, 
E_SFmode); /* [-1, 1] */

    case E_DFmode:
      res = pattern304 (x4, 
E_DFmode);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    default:
      return -1;
    }
}

int
pattern320 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[3], i1)
      || GET_MODE (x1) != i1
      || !gpc_reg_operand (operands[2], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1
      || !gpc_reg_operand (operands[0], i1)
      || !gpc_reg_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern327 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !scc_rev_comparison_operator (operands[1], i1))
    return -1;
  switch (GET_MODE (operands[2]))
    {
    case E_CCmode:
      if (!cc_reg_operand (operands[2], E_CCmode))
        return -1;
      return 0;

    case E_CCUNSmode:
      if (!cc_reg_operand (operands[2], E_CCUNSmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern338 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_SFmode:
      if (!gpc_reg_operand (operands[1], E_SFmode))
        return -1;
      return 0;

    case E_DFmode:
      if (!gpc_reg_operand (operands[1], E_DFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern345 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!altivec_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !altivec_register_operand (operands[1], i1)
      || !altivec_register_operand (operands[2], i1))
    return -1;
  x2 = XEXP (x1, 2);
  if (GET_MODE (x2) != i1
      || !altivec_register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern357 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  if (!nonimmediate_operand (operands[2], E_DFmode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_IFmode:
      if (!gpc_reg_operand (operands[0], E_IFmode))
        return -1;
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (GET_MODE (x5) != E_IFmode)
        return -1;
      return 0;

    case E_TFmode:
      if (!gpc_reg_operand (operands[0], E_TFmode))
        return -1;
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (GET_MODE (x5) != E_TFmode)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern367 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !gpc_reg_operand (operands[1], i1)
      || !gpc_reg_operand (operands[2], i1))
    return -1;
  x3 = XEXP (x2, 2);
  if (GET_MODE (x3) != i1
      || !gpc_reg_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern374 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !gpc_reg_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !gpc_reg_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern383 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1))
    return -1;
  switch (GET_MODE (x1))
    {
    case E_SImode:
      if (!register_operand (operands[1], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[1], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern391 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[3] = x4;
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
      operands[1] = x5;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      x7 = XVECEXP (x1, 0, 1);
      switch (GET_CODE (x7))
        {
        case CLOBBER:
          x8 = XEXP (x7, 0);
          operands[0] = x8;
          switch (GET_MODE (operands[3]))
            {
            case E_SImode:
              return pattern385 (
E_SImode); /* [-1, 0] */

            case E_DImode:
              if (pattern385 (
E_DImode) != 0)
                return -1;
              return 1;

            default:
              return -1;
            }

        case SET:
          x8 = XEXP (x7, 0);
          operands[0] = x8;
          x9 = XEXP (x7, 1);
          if (!rtx_equal_p (x9, operands[3]))
            return -1;
          switch (GET_MODE (operands[3]))
            {
            case E_SImode:
              if (pattern386 (
E_SImode) != 0)
                return -1;
              return 2;

            case E_DImode:
              if (pattern386 (
E_DImode) != 0)
                return -1;
              return 3;

            default:
              return -1;
            }

        default:
          return -1;
        }

    case NOT:
      x6 = XEXP (x4, 1);
      switch (GET_CODE (x6))
        {
        case REG:
        case SUBREG:
          operands[1] = x6;
          x10 = XEXP (x5, 0);
          operands[2] = x10;
          x7 = XVECEXP (x1, 0, 1);
          switch (GET_CODE (x7))
            {
            case CLOBBER:
              x8 = XEXP (x7, 0);
              operands[0] = x8;
              switch (GET_MODE (operands[3]))
                {
                case E_SImode:
                  if (pattern387 (x5, 
E_SImode) != 0)
                    return -1;
                  return 4;

                case E_DImode:
                  if (pattern387 (x5, 
E_DImode) != 0)
                    return -1;
                  return 5;

                default:
                  return -1;
                }

            case SET:
              x8 = XEXP (x7, 0);
              operands[0] = x8;
              x9 = XEXP (x7, 1);
              if (!rtx_equal_p (x9, operands[3]))
                return -1;
              switch (GET_MODE (operands[3]))
                {
                case E_SImode:
                  if (pattern388 (x5, 
E_SImode) != 0)
                    return -1;
                  return 6;

                case E_DImode:
                  if (pattern388 (x5, 
E_DImode) != 0)
                    return -1;
                  return 7;

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case NOT:
          x10 = XEXP (x5, 0);
          operands[1] = x10;
          x11 = XEXP (x6, 0);
          operands[2] = x11;
          x7 = XVECEXP (x1, 0, 1);
          switch (GET_CODE (x7))
            {
            case CLOBBER:
              x8 = XEXP (x7, 0);
              operands[0] = x8;
              switch (GET_MODE (operands[3]))
                {
                case E_SImode:
                  if (pattern389 (operands[3], 
E_SImode) != 0)
                    return -1;
                  return 8;

                case E_DImode:
                  if (pattern389 (operands[3], 
E_DImode) != 0)
                    return -1;
                  return 9;

                default:
                  return -1;
                }

            case SET:
              x8 = XEXP (x7, 0);
              operands[0] = x8;
              x9 = XEXP (x7, 1);
              if (!rtx_equal_p (x9, operands[3]))
                return -1;
              switch (GET_MODE (operands[3]))
                {
                case E_SImode:
                  if (pattern390 (operands[3], 
E_SImode) != 0)
                    return -1;
                  return 10;

                case E_DImode:
                  if (pattern390 (operands[3], 
E_DImode) != 0)
                    return -1;
                  return 11;

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern449 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != E_V2DFmode)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != VEC_CONCAT
      || GET_MODE (x5) != E_V2DFmode)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != VEC_SELECT
      || GET_MODE (x6) != E_DFmode)
    return -1;
  x7 = XEXP (x6, 1);
  if (GET_CODE (x7) != PARALLEL
      || XVECLEN (x7, 0) != 1)
    return -1;
  x8 = XVECEXP (x7, 0, 0);
  if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x9 = XEXP (x5, 1);
  if (GET_CODE (x9) != VEC_SELECT
      || GET_MODE (x9) != E_DFmode)
    return -1;
  x10 = XEXP (x9, 1);
  if (GET_CODE (x10) != PARALLEL
      || XVECLEN (x10, 0) != 1)
    return -1;
  x11 = XVECEXP (x10, 0, 0);
  if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x12 = XEXP (x3, 1);
  x13 = XVECEXP (x12, 0, 0);
  if (XWINT (x13, 0) != 1L
      || pattern413 (x1) != 0)
    return -1;
  return 0;
}

int
pattern465 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !gpc_reg_operand (operands[1], i2)
      || !gpc_reg_operand (operands[2], i1)
      || !const_0_to_3_operand (operands[3], E_QImode))
    return -1;
  return 0;
}

int
pattern474 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != NOT)
    return -1;
  x4 = XEXP (x2, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  x6 = XEXP (x3, 0);
  operands[1] = x6;
  switch (GET_MODE (operands[3]))
    {
    case E_SImode:
      return pattern473 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern473 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern484 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 2);
  switch (GET_CODE (x2))
    {
    case USE:
      if (pnum_clobbers == NULL)
        return -1;
      x3 = XVECEXP (x1, 0, 3);
      if (GET_CODE (x3) != SET)
        return -1;
      x4 = XEXP (x3, 1);
      if (GET_CODE (x4) != UNSPEC
          || XVECLEN (x4, 0) != 1
          || XINT (x4, 1) != 3)
        return -1;
      x5 = XEXP (x3, 0);
      if (GET_CODE (x5) != REG
          || REGNO (x5) != 2)
        return -1;
      return 0;

    case SET:
      x6 = XEXP (x2, 1);
      if (GET_CODE (x6) != UNSPEC
          || XVECLEN (x6, 0) != 1
          || XINT (x6, 1) != 3)
        return -1;
      x7 = XEXP (x2, 0);
      if (GET_CODE (x7) != REG
          || REGNO (x7) != 2)
        return -1;
      x3 = XVECEXP (x1, 0, 3);
      if (GET_CODE (x3) != CLOBBER)
        return -1;
      x5 = XEXP (x3, 0);
      if (GET_CODE (x5) != REG
          || REGNO (x5) != 96)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern499 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 1);
  x6 = XVECEXP (x5, 0, 0);
  operands[2] = x6;
  if (!const_int_operand (operands[2], E_QImode))
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  if (!scratch_operand (operands[3], E_SImode))
    return -1;
  switch (GET_MODE (x4))
    {
    case E_QImode:
      if (!gpc_reg_operand (operands[1], E_V16QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!gpc_reg_operand (operands[1], E_V8HImode))
        return -1;
      return 1;

    case E_SImode:
      if (!gpc_reg_operand (operands[1], E_V4SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern514 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 0);
  if (GET_MODE (x4) != E_CCmode)
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  x6 = XEXP (x5, 1);
  if (GET_CODE (x6) != i1)
    return -1;
  x7 = XEXP (x4, 0);
  operands[1] = x7;
  x8 = XEXP (x4, 1);
  operands[2] = x8;
  x9 = XEXP (x6, 0);
  if (!rtx_equal_p (x9, operands[1]))
    return -1;
  x10 = XEXP (x6, 1);
  if (!rtx_equal_p (x10, operands[2]))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V4SFmode:
      return 0;

    case E_V2DFmode:
      return 1;

    case E_V4SImode:
      return 2;

    case E_V8HImode:
      return 3;

    case E_V16QImode:
      return 4;

    case E_V2DImode:
      return 5;

    case E_V1TImode:
      return 6;

    default:
      return -1;
    }
}

int
pattern529 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!gpc_reg_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode
          || !scratch_operand (operands[3], E_SImode)
          || !scratch_operand (operands[4], E_SImode)
          || !scratch_operand (operands[5], E_CCmode))
        return -1;
      return pattern109 (); /* [-1, 1] */

    case E_DImode:
      if (!gpc_reg_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_SImode:
          if (!gpc_reg_operand (operands[1], E_SImode))
            return -1;
          return 2;

        case E_DImode:
          if (!gpc_reg_operand (operands[1], E_DImode)
              || !reg_or_short_operand (operands[2], E_DImode)
              || !scratch_operand (operands[3], E_DImode)
              || !scratch_operand (operands[4], E_DImode)
              || !scratch_operand (operands[5], E_CCmode))
            return -1;
          return 3;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern547 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != i1)
    return -1;
  x4 = XEXP (x1, 1);
  if (GET_CODE (x4) != i1)
    return -1;
  x5 = XEXP (x2, 0);
  x6 = XEXP (x5, 0);
  operands[1] = x6;
  if (!gpc_reg_operand (operands[1], E_DImode))
    return -1;
  x7 = XEXP (x3, 0);
  operands[2] = x7;
  if (!gpc_reg_operand (operands[2], E_DImode))
    return -1;
  x8 = XEXP (x4, 0);
  operands[3] = x8;
  if (!gpc_reg_operand (operands[3], E_DImode))
    return -1;
  return 0;
}

int
pattern559 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!boolean_operator (operands[3], i1))
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !gpc_reg_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !gpc_reg_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern565 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  switch (GET_MODE (x3))
    {
    case E_SImode:
      if (!symbol_ref_operand (operands[1], E_SImode))
        return -1;
      x4 = XVECEXP (x1, 0, 3);
      x5 = XEXP (x4, 0);
      if (GET_MODE (x5) != E_SImode)
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_SImode:
          if (!gpc_reg_operand (operands[2], E_SImode)
              || !memory_operand (operands[3], E_SImode))
            return -1;
          return 0;

        case E_DFmode:
          if (!gpc_reg_operand (operands[2], E_DFmode)
              || !memory_operand (operands[3], E_DFmode))
            return -1;
          return 1;

        default:
          return -1;
        }

    case E_DImode:
      if (!symbol_ref_operand (operands[1], E_DImode))
        return -1;
      x4 = XVECEXP (x1, 0, 3);
      x5 = XEXP (x4, 0);
      if (GET_MODE (x5) != E_DImode)
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_DImode:
          if (!gpc_reg_operand (operands[2], E_DImode)
              || !memory_operand (operands[3], E_DImode))
            return -1;
          return 2;

        case E_DFmode:
          if (!gpc_reg_operand (operands[2], E_DFmode)
              || !memory_operand (operands[3], E_DFmode))
            return -1;
          return 3;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern594 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[1], i1)
      || !gpc_reg_operand (operands[2], i1)
      || !gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  return 0;
}

int
pattern599 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 1);
  x6 = XEXP (x5, 1);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 16])
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  x8 = XEXP (x7, 1);
  x9 = XEXP (x8, 1);
  if (GET_CODE (x9) != i1)
    return -1;
  x10 = XEXP (x9, 1);
  if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 16])
    return -1;
  x11 = XEXP (x4, 0);
  x12 = XEXP (x11, 0);
  operands[1] = x12;
  x13 = XEXP (x5, 0);
  operands[2] = x13;
  if (!gpc_reg_operand (operands[2], E_SImode))
    return -1;
  x14 = XEXP (x8, 0);
  x15 = XEXP (x14, 0);
  if (!rtx_equal_p (x15, operands[1]))
    return -1;
  x16 = XEXP (x9, 0);
  if (!rtx_equal_p (x16, operands[2]))
    return -1;
  return 0;
}

 int
recog_6 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x3, 0);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      switch (pattern327 (x2, 
E_SImode))
        {
        case 0:
          if (!
#line 5627 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWER10))
            return -1;
          return 373; /* *setnbcr_cc_si */

        case 1:
          if (!
#line 5627 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWER10))
            return -1;
          return 375; /* *setnbcr_ccuns_si */

        default:
          return -1;
        }

    case E_DImode:
      switch (pattern327 (x2, 
E_DImode))
        {
        case 0:
          if (!(
#line 5627 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWER10) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 374; /* *setnbcr_cc_di */

        case 1:
          if (!(
#line 5627 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWER10) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 376; /* *setnbcr_ccuns_di */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_12 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x2, 2);
  if (GET_CODE (x5) != PC)
    return -1;
  x6 = XEXP (x1, 0);
  if (GET_CODE (x6) != PC)
    return -1;
  x7 = XEXP (x3, 0);
  operands[1] = x7;
  if (!cc_reg_operand (operands[1], E_VOIDmode))
    return -1;
  x8 = XEXP (x2, 1);
  switch (GET_CODE (x8))
    {
    case RETURN:
      if (!
#line 13383 "../../gcc/config/rs6000/rs6000.md"
(direct_return ()))
        return -1;
      return 968; /* *creturn */

    case SIMPLE_RETURN:
      return 969; /* *creturn */

    default:
      return -1;
    }
}

 int
recog_16 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 0);
  operands[3] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
      switch (pattern63 (x3))
        {
        case 0:
          if (!
#line 367 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2531; /* *fuse_and_and */

        case 1:
          if (!(
#line 367 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 1;
          return 2532; /* *fuse_and_and */

        case 2:
          if (!
#line 1879 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2699; /* *fuse_vand_vand */

        case 3:
          if (!
#line 1879 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2700; /* *fuse_vand_vand */

        case 4:
          if (!
#line 1879 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2701; /* *fuse_vand_vand */

        case 5:
          if (!
#line 1879 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2702; /* *fuse_vand_vand */

        case 6:
          if (!
#line 1879 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2703; /* *fuse_vand_vand */

        case 7:
          if (!
#line 1879 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2704; /* *fuse_vand_vand */

        case 8:
          if (!
#line 1879 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2705; /* *fuse_vand_vand */

        case 9:
          if (!
#line 1879 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2706; /* *fuse_vand_vand */

        case 10:
          if (!(
#line 1879 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 2707; /* *fuse_vand_vand */

        case 11:
          if (!(
#line 1879 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 2708; /* *fuse_vand_vand */

        case 12:
          if (!
#line 547 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2551; /* *fuse_and_andc */

        case 13:
          if (!(
#line 547 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 1;
          return 2552; /* *fuse_and_andc */

        case 14:
          if (!
#line 2023 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2779; /* *fuse_vand_vandc */

        case 15:
          if (!
#line 2023 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2780; /* *fuse_vand_vandc */

        case 16:
          if (!
#line 2023 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2781; /* *fuse_vand_vandc */

        case 17:
          if (!
#line 2023 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2782; /* *fuse_vand_vandc */

        case 18:
          if (!
#line 2023 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2783; /* *fuse_vand_vandc */

        case 19:
          if (!
#line 2023 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2784; /* *fuse_vand_vandc */

        case 20:
          if (!
#line 2023 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2785; /* *fuse_vand_vandc */

        case 21:
          if (!
#line 2023 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2786; /* *fuse_vand_vandc */

        case 22:
          if (!(
#line 2023 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 2787; /* *fuse_vand_vandc */

        case 23:
          if (!(
#line 2023 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 2788; /* *fuse_vand_vandc */

        default:
          return -1;
        }

    case NOT:
      x6 = XEXP (x5, 0);
      operands[0] = x6;
      x7 = XEXP (x4, 1);
      switch (GET_CODE (x7))
        {
        case REG:
        case SUBREG:
          switch (pattern58 (x3))
            {
            case 0:
              if (!
#line 385 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2533; /* *fuse_andc_and */

            case 1:
              if (!(
#line 385 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              *pnum_clobbers = 1;
              return 2534; /* *fuse_andc_and */

            case 2:
              if (!
#line 1897 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2709; /* *fuse_vandc_vand */

            case 3:
              if (!
#line 1897 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2710; /* *fuse_vandc_vand */

            case 4:
              if (!
#line 1897 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2711; /* *fuse_vandc_vand */

            case 5:
              if (!
#line 1897 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2712; /* *fuse_vandc_vand */

            case 6:
              if (!
#line 1897 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2713; /* *fuse_vandc_vand */

            case 7:
              if (!
#line 1897 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2714; /* *fuse_vandc_vand */

            case 8:
              if (!
#line 1897 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2715; /* *fuse_vandc_vand */

            case 9:
              if (!
#line 1897 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2716; /* *fuse_vandc_vand */

            case 10:
              if (!(
#line 1897 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 2717; /* *fuse_vandc_vand */

            case 11:
              if (!(
#line 1897 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 2718; /* *fuse_vandc_vand */

            case 12:
              if (!
#line 565 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2553; /* *fuse_andc_andc */

            case 13:
              if (!(
#line 565 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              *pnum_clobbers = 1;
              return 2554; /* *fuse_andc_andc */

            case 14:
              if (!
#line 2041 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2789; /* *fuse_vandc_vandc */

            case 15:
              if (!
#line 2041 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2790; /* *fuse_vandc_vandc */

            case 16:
              if (!
#line 2041 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2791; /* *fuse_vandc_vandc */

            case 17:
              if (!
#line 2041 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2792; /* *fuse_vandc_vandc */

            case 18:
              if (!
#line 2041 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2793; /* *fuse_vandc_vandc */

            case 19:
              if (!
#line 2041 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2794; /* *fuse_vandc_vandc */

            case 20:
              if (!
#line 2041 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2795; /* *fuse_vandc_vandc */

            case 21:
              if (!
#line 2041 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2796; /* *fuse_vandc_vandc */

            case 22:
              if (!(
#line 2041 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 2797; /* *fuse_vandc_vandc */

            case 23:
              if (!(
#line 2041 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 2798; /* *fuse_vandc_vandc */

            default:
              return -1;
            }

        case NOT:
          switch (pattern52 (x3))
            {
            case 0:
              if (!
#line 439 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2539; /* *fuse_nor_and */

            case 1:
              if (!(
#line 439 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              *pnum_clobbers = 1;
              return 2540; /* *fuse_nor_and */

            case 2:
              if (!
#line 1951 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2739; /* *fuse_vnor_vand */

            case 3:
              if (!
#line 1951 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2740; /* *fuse_vnor_vand */

            case 4:
              if (!
#line 1951 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2741; /* *fuse_vnor_vand */

            case 5:
              if (!
#line 1951 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2742; /* *fuse_vnor_vand */

            case 6:
              if (!
#line 1951 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2743; /* *fuse_vnor_vand */

            case 7:
              if (!
#line 1951 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2744; /* *fuse_vnor_vand */

            case 8:
              if (!
#line 1951 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2745; /* *fuse_vnor_vand */

            case 9:
              if (!
#line 1951 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2746; /* *fuse_vnor_vand */

            case 10:
              if (!(
#line 1951 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 2747; /* *fuse_vnor_vand */

            case 11:
              if (!(
#line 1951 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 2748; /* *fuse_vnor_vand */

            case 12:
              if (!
#line 619 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2559; /* *fuse_nor_andc */

            case 13:
              if (!(
#line 619 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              *pnum_clobbers = 1;
              return 2560; /* *fuse_nor_andc */

            case 14:
              if (!
#line 2095 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2819; /* *fuse_vnor_vandc */

            case 15:
              if (!
#line 2095 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2820; /* *fuse_vnor_vandc */

            case 16:
              if (!
#line 2095 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2821; /* *fuse_vnor_vandc */

            case 17:
              if (!
#line 2095 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2822; /* *fuse_vnor_vandc */

            case 18:
              if (!
#line 2095 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2823; /* *fuse_vnor_vandc */

            case 19:
              if (!
#line 2095 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2824; /* *fuse_vnor_vandc */

            case 20:
              if (!
#line 2095 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2825; /* *fuse_vnor_vandc */

            case 21:
              if (!
#line 2095 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2826; /* *fuse_vnor_vandc */

            case 22:
              if (!(
#line 2095 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 2827; /* *fuse_vnor_vandc */

            case 23:
              if (!(
#line 2095 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 2828; /* *fuse_vnor_vandc */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_28 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (pnum_clobbers == NULL
          || !gpc_reg_operand (operands[0], E_SImode))
        return -1;
      x2 = XEXP (x1, 1);
      switch (pattern319 (x2, 
E_SImode))
        {
        case 0:
          if (!
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(GE == EQ && operands[2] == const0_rtx)
   && !(GE == NE && operands[2] == const0_rtx
	&& SImode == Pmode && SImode == Pmode)))
            return -1;
          *pnum_clobbers = 3;
          return 896; /* gesisi2_isel */

        case 1:
          if (!(
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(GE == EQ && operands[2] == const0_rtx)
   && !(GE == NE && operands[2] == const0_rtx
	&& SImode == Pmode && DImode == Pmode)) && 
#line 478 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 3;
          return 916; /* gesidi2_isel */

        default:
          return -1;
        }

    case E_DImode:
      if (pnum_clobbers == NULL
          || !gpc_reg_operand (operands[0], E_DImode))
        return -1;
      x2 = XEXP (x1, 1);
      switch (pattern319 (x2, 
E_DImode))
        {
        case 0:
          if (!(
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(GE == EQ && operands[2] == const0_rtx)
   && !(GE == NE && operands[2] == const0_rtx
	&& DImode == Pmode && SImode == Pmode)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 3;
          return 906; /* gedisi2_isel */

        case 1:
          if (!(
#line 12824 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWER10 && TARGET_ISEL
   && !(GE == EQ && operands[2] == const0_rtx)
   && !(GE == NE && operands[2] == const0_rtx
	&& DImode == Pmode && DImode == Pmode)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 3;
          return 926; /* gedidi2_isel */

        default:
          return -1;
        }

    case E_V4SFmode:
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4SFmode)
        return -1;
      if (vsx_register_operand (operands[0], E_V4SFmode)
          && vsx_register_operand (operands[1], E_V4SFmode)
          && vsx_register_operand (operands[2], E_V4SFmode)
          && 
#line 2175 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V4SFmode)))
        return 1385; /* *vsx_gev4sf */
      if (!altivec_register_operand (operands[0], E_V4SFmode)
          || !altivec_register_operand (operands[1], E_V4SFmode)
          || !altivec_register_operand (operands[2], E_V4SFmode)
          || !
#line 690 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V4SFmode)))
        return -1;
      return 1867; /* *altivec_gev4sf */

    case E_V2DFmode:
      x2 = XEXP (x1, 1);
      if (pattern2 (x2, 
E_V2DFmode) != 0
          || !
#line 2175 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode)))
        return -1;
      return 1386; /* *vsx_gev2df */

    default:
      return -1;
    }
}

 int
recog_30 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 1);
  switch (GET_CODE (x4))
    {
    case UNSPEC:
      if (XVECLEN (x4, 0) != 2
          || XINT (x4, 1) != 13)
        return -1;
      x5 = XVECEXP (x4, 0, 0);
      operands[2] = x5;
      x6 = XVECEXP (x4, 0, 1);
      operands[3] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern490 (x3, 
E_SImode) != 0
              || !(
#line 169 "../../gcc/config/rs6000/darwin.md"
(DEFAULT_ABI == ABI_DARWIN) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
            return -1;
          return 1; /* macho_correct_pic_si */

        case E_DImode:
          if (pattern490 (x3, 
E_DImode) != 0
              || !(
#line 169 "../../gcc/config/rs6000/darwin.md"
(DEFAULT_ABI == ABI_DARWIN) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
            return -1;
          return 2; /* macho_correct_pic_di */

        default:
          return -1;
        }

    case CONST_INT:
    case REG:
    case SUBREG:
      operands[2] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern380 (x3, 
E_SImode) == 0)
            return 68; /* *addsi3 */
          break;

        case E_DImode:
          if (pattern380 (x3, 
E_DImode) == 0
              && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
            return 69; /* *adddi3 */
          break;

        case E_SFmode:
          if (pattern19 (x3, 
E_SFmode) == 0
              && 
#line 5061 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT))
            return 312; /* *addsf3_fpr */
          break;

        case E_DFmode:
          if (pattern19 (x3, 
E_DFmode) == 0
              && 
#line 5061 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT))
            return 313; /* *adddf3_fpr */
          break;

        case E_KFmode:
          if (pattern1 (x3, 
E_KFmode) == 0
              && (
#line 15020 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
            return 1093; /* addkf3 */
          break;

        case E_TFmode:
          if (pattern1 (x3, 
E_TFmode) == 0
              && (
#line 15020 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
            return 1094; /* addtf3 */
          break;

        case E_V4SFmode:
          if (GET_MODE (x3) == E_V4SFmode)
            {
              if (vsx_register_operand (operands[0], E_V4SFmode)
                  && vsx_register_operand (operands[1], E_V4SFmode)
                  && vsx_register_operand (operands[2], E_V4SFmode)
                  && 
#line 1702 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V4SFmode)))
                return 1334; /* *vsx_addv4sf3 */
              if (register_operand (operands[0], E_V4SFmode)
                  && register_operand (operands[1], E_V4SFmode)
                  && register_operand (operands[2], E_V4SFmode)
                  && 
#line 519 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V4SFmode)))
                return 1823; /* *altivec_addv4sf3 */
            }
          break;

        case E_V2DFmode:
          if (pattern2 (x3, 
E_V2DFmode) == 0
              && 
#line 1702 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode)))
            return 1335; /* *vsx_addv2df3 */
          break;

        case E_V4SImode:
          if (pattern3 (x3, 
E_V4SImode) == 0
              && 
#line 511 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V4SImode)))
            return 1819; /* addv4si3 */
          break;

        case E_V8HImode:
          if (pattern3 (x3, 
E_V8HImode) == 0
              && 
#line 511 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V8HImode)))
            return 1820; /* addv8hi3 */
          break;

        case E_V16QImode:
          if (pattern3 (x3, 
E_V16QImode) == 0
              && 
#line 511 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V16QImode)))
            return 1821; /* addv16qi3 */
          break;

        case E_V2DImode:
          if (pattern3 (x3, 
E_V2DImode) == 0
              && 
#line 511 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_P8_VECTOR_P (V2DImode)))
            return 1822; /* addv2di3 */
          break;

        case E_V1TImode:
          if (pattern3 (x3, 
E_V1TImode) == 0
              && 
#line 4433 "../../gcc/config/rs6000/altivec.md"
(TARGET_VADDUQM))
            return 2322; /* addv1ti3 */
          break;

        case E_DDmode:
          if (pattern19 (x3, 
E_DDmode) == 0
              && 
#line 177 "../../gcc/config/rs6000/dfp.md"
(TARGET_DFP))
            return 2436; /* adddd3 */
          break;

        case E_TDmode:
          if (pattern19 (x3, 
E_TDmode) == 0
              && 
#line 177 "../../gcc/config/rs6000/dfp.md"
(TARGET_DFP))
            return 2437; /* addtd3 */
          break;

        default:
          break;
        }
      if (pnum_clobbers == NULL
          || GET_CODE (x4) != REG
          || REGNO (x4) != 98)
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern458 (x3, 
E_SImode) != 0)
            return -1;
          *pnum_clobbers = 1;
          return 92; /* addsi3_carry_in_0 */

        case E_DImode:
          if (pattern458 (x3, 
E_DImode) != 0
              || !
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
            return -1;
          *pnum_clobbers = 1;
          return 93; /* adddi3_carry_in_0 */

        default:
          return -1;
        }

    case HIGH:
      if (GET_MODE (x4) != E_SImode)
        return -1;
      x7 = XEXP (x4, 0);
      if (GET_CODE (x7) != CONST)
        return -1;
      x8 = XEXP (x7, 0);
      if (GET_CODE (x8) != MINUS
          || GET_MODE (x8) != E_SImode
          || !gpc_reg_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode
          || !gpc_reg_operand (operands[1], E_SImode))
        return -1;
      x9 = XEXP (x8, 0);
      operands[2] = x9;
      if (!symbol_ref_operand (operands[2], E_SImode))
        return -1;
      x10 = XEXP (x8, 1);
      operands[3] = x10;
      if (!symbol_ref_operand (operands[3], E_SImode)
          || !
#line 11231 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ELF && TARGET_SECURE_PLT && DEFAULT_ABI == ABI_V4 && flag_pic))
        return -1;
      return 800; /* load_toc_v4_PIC_3b */

    default:
      return -1;
    }
}

 int
recog_34 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_KFmode:
      if (!altivec_register_operand (operands[0], E_KFmode)
          || GET_MODE (x3) != E_KFmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_KFmode:
          if (!altivec_register_operand (operands[1], E_KFmode)
              || !altivec_register_operand (operands[2], E_DImode)
              || !(
#line 5239 "../../gcc/config/rs6000/vsx.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
            return -1;
          return 1670; /* xsiexpqpf_kf */

        case E_V1TImode:
          if (!altivec_register_operand (operands[1], E_V1TImode)
              || !altivec_register_operand (operands[2], E_V2DImode)
              || !(
#line 5251 "../../gcc/config/rs6000/vsx.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
            return -1;
          return 1672; /* xsiexpqp_kf_v2di */

        case E_TImode:
          if (!altivec_register_operand (operands[1], E_TImode)
              || !altivec_register_operand (operands[2], E_DImode)
              || !(
#line 5251 "../../gcc/config/rs6000/vsx.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
            return -1;
          return 1673; /* xsiexpqp_kf_di */

        default:
          return -1;
        }

    case E_TFmode:
      if (!altivec_register_operand (operands[0], E_TFmode)
          || GET_MODE (x3) != E_TFmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_TFmode:
          if (!altivec_register_operand (operands[1], E_TFmode)
              || !altivec_register_operand (operands[2], E_DImode)
              || !(
#line 5239 "../../gcc/config/rs6000/vsx.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
            return -1;
          return 1671; /* xsiexpqpf_tf */

        case E_V1TImode:
          if (!altivec_register_operand (operands[1], E_V1TImode)
              || !altivec_register_operand (operands[2], E_V2DImode)
              || !(
#line 5251 "../../gcc/config/rs6000/vsx.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
            return -1;
          return 1674; /* xsiexpqp_tf_v2di */

        case E_TImode:
          if (!altivec_register_operand (operands[1], E_TImode)
              || !altivec_register_operand (operands[2], E_DImode)
              || !(
#line 5251 "../../gcc/config/rs6000/vsx.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
            return -1;
          return 1675; /* xsiexpqp_tf_di */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_43 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  if (!u7bit_cint_operand (operands[2], E_SImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V4SImode:
      if (!vsx_register_operand (operands[0], E_V4SImode)
          || GET_MODE (x3) != E_V4SImode
          || !vsx_register_operand (operands[1], E_V4SFmode)
          || !
#line 5497 "../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
        return -1;
      return 1693; /* xvtstdcsp */

    case E_V2DImode:
      if (!vsx_register_operand (operands[0], E_V2DImode)
          || GET_MODE (x3) != E_V2DImode
          || !vsx_register_operand (operands[1], E_V2DFmode)
          || !
#line 5497 "../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
        return -1;
      return 1694; /* xvtstdcdp */

    default:
      return -1;
    }
}

 int
recog_48 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_DFmode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!vsx_register_operand (operands[0], E_DFmode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[1]))
    {
    case E_DImode:
      switch (pattern460 (
E_DImode))
        {
        case 0:
          if (!
#line 5261 "../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR && TARGET_POWERPC64))
            return -1;
          return 1676; /* xsiexpdp_si */

        case 1:
          if (!(
#line 5261 "../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR && TARGET_POWERPC64) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 1677; /* xsiexpdp_di */

        default:
          return -1;
        }

    case E_DFmode:
      switch (pattern460 (
E_DFmode))
        {
        case 0:
          if (!
#line 5271 "../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR && TARGET_POWERPC64))
            return -1;
          return 1678; /* xsiexpdpf_si */

        case 1:
          if (!(
#line 5271 "../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR && TARGET_POWERPC64) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 1679; /* xsiexpdpf_di */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_61 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!gpc_reg_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode
          || !gpc_reg_operand (operands[1], E_SImode)
          || !
#line 2547 "../../gcc/config/rs6000/rs6000.md"
(TARGET_CMPB && TARGET_POPCNTB))
        return -1;
      return 141; /* paritysi2_cmpb */

    case E_DImode:
      if (!gpc_reg_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode
          || !gpc_reg_operand (operands[1], E_DImode)
          || !(
#line 2547 "../../gcc/config/rs6000/rs6000.md"
(TARGET_CMPB && TARGET_POPCNTB) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
        return -1;
      return 142; /* paritydi2_cmpb */

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || GET_MODE (x3) != E_V8HImode
          || !register_operand (operands[1], E_V8HImode)
          || !
#line 4410 "../../gcc/config/rs6000/altivec.md"
(TARGET_P9_VECTOR))
        return -1;
      return 2316; /* rs6000_vprtybv8hi2 */

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x3) != E_V4SImode
          || !register_operand (operands[1], E_V4SImode)
          || !
#line 4410 "../../gcc/config/rs6000/altivec.md"
(TARGET_P9_VECTOR))
        return -1;
      return 2317; /* rs6000_vprtybv4si2 */

    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || GET_MODE (x3) != E_V2DImode
          || !register_operand (operands[1], E_V2DImode)
          || !
#line 4410 "../../gcc/config/rs6000/altivec.md"
(TARGET_P9_VECTOR))
        return -1;
      return 2318; /* rs6000_vprtybv2di2 */

    case E_V1TImode:
      if (!register_operand (operands[0], E_V1TImode)
          || GET_MODE (x3) != E_V1TImode
          || !register_operand (operands[1], E_V1TImode)
          || !
#line 4410 "../../gcc/config/rs6000/altivec.md"
(TARGET_P9_VECTOR))
        return -1;
      return 2319; /* rs6000_vprtybv1ti2 */

    case E_TImode:
      if (!register_operand (operands[0], E_TImode)
          || GET_MODE (x3) != E_TImode
          || !register_operand (operands[1], E_TImode)
          || !
#line 4410 "../../gcc/config/rs6000/altivec.md"
(TARGET_P9_VECTOR))
        return -1;
      return 2320; /* rs6000_vprtybti2 */

    default:
      return -1;
    }
}

 int
recog_71 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern156 (x1))
    {
    case 0:
      if (!
#line 6840 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_FPRND))
        return -1;
      return 483; /* floorsf2 */

    case 1:
      if (!
#line 6840 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_FPRND))
        return -1;
      return 484; /* floordf2 */

    case 2:
      if (!(
#line 15447 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
        return -1;
      return 1175; /* floorkf2 */

    case 3:
      if (!(
#line 15447 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
        return -1;
      return 1176; /* floortf2 */

    case 4:
      if (vsx_register_operand (operands[0], E_V4SFmode)
          && vsx_register_operand (operands[1], E_V4SFmode)
          && 
#line 2339 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V4SFmode)))
        return 1415; /* vsx_floorv4sf2 */
      if (!register_operand (operands[0], E_V4SFmode)
          || !register_operand (operands[1], E_V4SFmode)
          || !
#line 2589 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
        return -1;
      return 2107; /* *altivec_vrfim */

    case 5:
      if (!
#line 2339 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode)))
        return -1;
      return 1416; /* vsx_floorv2df2 */

    default:
      return -1;
    }
}

 int
recog_83 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      if (!base_reg_operand (operands[0], E_QImode)
          || GET_MODE (x3) != E_QImode
          || !fusion_addis_mem_combo_load (operands[1], E_QImode)
          || !
#line 14733 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_FUSION))
        return -1;
      return 1068; /* *fusion_gpr_load_qi */

    case E_HImode:
      if (!base_reg_operand (operands[0], E_HImode)
          || GET_MODE (x3) != E_HImode
          || !fusion_addis_mem_combo_load (operands[1], E_HImode)
          || !
#line 14733 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P8_FUSION))
        return -1;
      return 1069; /* *fusion_gpr_load_hi */

    default:
      return -1;
    }
}

 int
recog_91 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_V4SFmode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!vsx_register_operand (operands[0], E_V4SFmode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[1]))
    {
    case E_DFmode:
      if (!vsx_register_operand (operands[1], E_DFmode)
          || !
#line 2455 "../../gcc/config/rs6000/vsx.md"
(TARGET_XSCVDPSPN))
        return -1;
      return 1428; /* vsx_xscvdpspn */

    case E_SFmode:
      if (!vsx_register_operand (operands[1], E_SFmode)
          || !
#line 2471 "../../gcc/config/rs6000/vsx.md"
(TARGET_XSCVDPSPN))
        return -1;
      return 1430; /* vsx_xscvdpspn_scalar */

    default:
      return -1;
    }
}

 int
recog_98 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  if (!u5bit_cint_operand (operands[3], E_QImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      if (pattern132 (x3, 
E_V16QImode) != 0
          || !
#line 4907 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V16QImode)))
        return -1;
      return 1625; /* vsx_xxsldwi_v16qi */

    case E_V8HImode:
      if (pattern132 (x3, 
E_V8HImode) != 0
          || !
#line 4907 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V8HImode)))
        return -1;
      return 1626; /* vsx_xxsldwi_v8hi */

    case E_V4SImode:
      if (pattern132 (x3, 
E_V4SImode) != 0
          || !
#line 4907 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode)))
        return -1;
      return 1627; /* vsx_xxsldwi_v4si */

    case E_V2DImode:
      if (pattern132 (x3, 
E_V2DImode) != 0
          || !
#line 4907 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V2DImode)))
        return -1;
      return 1628; /* vsx_xxsldwi_v2di */

    case E_V4SFmode:
      if (pattern132 (x3, 
E_V4SFmode) != 0
          || !
#line 4907 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SFmode)))
        return -1;
      return 1629; /* vsx_xxsldwi_v4sf */

    case E_V2DFmode:
      if (pattern132 (x3, 
E_V2DFmode) != 0
          || !
#line 4907 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V2DFmode)))
        return -1;
      return 1630; /* vsx_xxsldwi_v2df */

    case E_V1TImode:
      if (pattern132 (x3, 
E_V1TImode) != 0
          || !
#line 4907 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V1TImode)))
        return -1;
      return 1631; /* vsx_xxsldwi_v1ti */

    case E_TImode:
      if (pattern132 (x3, 
E_TImode) != 0
          || !
#line 4907 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (TImode)))
        return -1;
      return 1632; /* vsx_xxsldwi_ti */

    case E_KFmode:
      if (pattern132 (x3, 
E_KFmode) != 0
          || !(
#line 4907 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (KFmode)) && 
#line 58 "../../gcc/config/rs6000/vsx.md"
(FLOAT128_VECTOR_P (KFmode))))
        return -1;
      return 1633; /* vsx_xxsldwi_kf */

    case E_TFmode:
      if (pattern132 (x3, 
E_TFmode) != 0
          || !(
#line 4907 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (TFmode)) && 
#line 59 "../../gcc/config/rs6000/vsx.md"
(FLOAT128_VECTOR_P (TFmode))))
        return -1;
      return 1634; /* vsx_xxsldwi_tf */

    default:
      return -1;
    }
}

 int
recog_111 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  switch (pattern30 (x2))
    {
    case 0:
      switch (GET_MODE (x2))
        {
        case E_V16QImode:
          if (!register_operand (operands[0], E_V16QImode))
            return -1;
          x3 = XEXP (x2, 0);
          switch (pattern31 (x3))
            {
            case 0:
              if (!(
#line 3218 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                return -1;
              return 2244; /* altivec_stvx_v16qi_2op_si */

            case 1:
              if (!(
#line 3218 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                return -1;
              return 2245; /* altivec_stvx_v16qi_2op_di */

            default:
              return -1;
            }

        case E_V2DFmode:
          if (!register_operand (operands[0], E_V2DFmode))
            return -1;
          x3 = XEXP (x2, 0);
          switch (pattern31 (x3))
            {
            case 0:
              if (!(
#line 3218 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                return -1;
              return 2248; /* altivec_stvx_v2df_2op_si */

            case 1:
              if (!(
#line 3218 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                return -1;
              return 2249; /* altivec_stvx_v2df_2op_di */

            default:
              return -1;
            }

        case E_KFmode:
          if (!register_operand (operands[0], E_KFmode))
            return -1;
          x3 = XEXP (x2, 0);
          switch (pattern31 (x3))
            {
            case 0:
              if (!(
#line 3218 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && (((((
#line 211 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode)) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)) && 
#line 211 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode)))))
                return -1;
              return 2254; /* altivec_stvx_kf_2op_si */

            case 1:
              if (!(
#line 3218 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && (((((
#line 211 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode)) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)) && 
#line 211 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode)))))
                return -1;
              return 2255; /* altivec_stvx_kf_2op_di */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 1:
      switch (GET_MODE (x2))
        {
        case E_V16QImode:
          x3 = XEXP (x2, 0);
          switch (pattern383 (x3, 
E_V16QImode))
            {
            case 0:
              if (!(
#line 3226 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                return -1;
              return 2262; /* altivec_stvx_v16qi_1op_si */

            case 1:
              if (!(
#line 3226 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                return -1;
              return 2263; /* altivec_stvx_v16qi_1op_di */

            default:
              return -1;
            }

        case E_V2DFmode:
          x3 = XEXP (x2, 0);
          switch (pattern383 (x3, 
E_V2DFmode))
            {
            case 0:
              if (!(
#line 3226 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                return -1;
              return 2266; /* altivec_stvx_v2df_1op_si */

            case 1:
              if (!(
#line 3226 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                return -1;
              return 2267; /* altivec_stvx_v2df_1op_di */

            default:
              return -1;
            }

        case E_KFmode:
          x3 = XEXP (x2, 0);
          switch (pattern383 (x3, 
E_KFmode))
            {
            case 0:
              if (!(
#line 3226 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && (((
#line 211 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode)) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)) && 
#line 211 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode)))))
                return -1;
              return 2272; /* altivec_stvx_kf_1op_si */

            case 1:
              if (!(
#line 3226 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && (((
#line 211 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode)) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)) && 
#line 211 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode)))))
                return -1;
              return 2273; /* altivec_stvx_kf_1op_di */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_117 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
      res = recog_115 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case HIGH:
      res = recog_116 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    default:
      break;
    }
  operands[1] = x2;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (nonimmediate_operand (operands[0], E_SImode)
          && input_operand (operands[1], E_SImode)
          && 
#line 7743 "../../gcc/config/rs6000/rs6000.md"
(gpc_reg_operand (operands[0], SImode)
   || gpc_reg_operand (operands[1], SImode)))
        return 568; /* *movsi_internal1 */
      break;

    case E_QImode:
      if (nonimmediate_operand (operands[0], E_QImode)
          && input_operand (operands[1], E_QImode)
          && 
#line 8116 "../../gcc/config/rs6000/rs6000.md"
(gpc_reg_operand (operands[0], QImode)
   || gpc_reg_operand (operands[1], QImode)))
        return 576; /* *movqi_internal */
      break;

    case E_HImode:
      if (nonimmediate_operand (operands[0], E_HImode)
          && input_operand (operands[1], E_HImode)
          && 
#line 8116 "../../gcc/config/rs6000/rs6000.md"
(gpc_reg_operand (operands[0], HImode)
   || gpc_reg_operand (operands[1], HImode)))
        return 577; /* *movhi_internal */
      break;

    case E_CCmode:
      if (nonimmediate_operand (operands[0], E_CCmode)
          && general_operand (operands[1], E_CCmode)
          && 
#line 8165 "../../gcc/config/rs6000/rs6000.md"
(register_operand (operands[0], CCmode)
   || register_operand (operands[1], CCmode)))
        return 578; /* *movcc_cc */
      break;

    case E_CCUNSmode:
      if (nonimmediate_operand (operands[0], E_CCUNSmode)
          && general_operand (operands[1], E_CCUNSmode)
          && 
#line 8165 "../../gcc/config/rs6000/rs6000.md"
(register_operand (operands[0], CCUNSmode)
   || register_operand (operands[1], CCUNSmode)))
        return 579; /* *movcc_ccuns */
      break;

    case E_CCEQmode:
      if (nonimmediate_operand (operands[0], E_CCEQmode)
          && general_operand (operands[1], E_CCEQmode)
          && 
#line 8165 "../../gcc/config/rs6000/rs6000.md"
(register_operand (operands[0], CCEQmode)
   || register_operand (operands[1], CCEQmode)))
        return 580; /* *movcc_cceq */
      break;

    case E_CCFPmode:
      if (nonimmediate_operand (operands[0], E_CCFPmode)
          && general_operand (operands[1], E_CCFPmode)
          && 
#line 8165 "../../gcc/config/rs6000/rs6000.md"
(register_operand (operands[0], CCFPmode)
   || register_operand (operands[1], CCFPmode)))
        return 581; /* *movcc_ccfp */
      break;

    case E_V4SFmode:
      if (pnum_clobbers != NULL
          && memory_operand (operands[0], E_V4SFmode)
          && immediate_operand (operands[1], E_V4SFmode)
          && 
#line 3458 "../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN
   && VECTOR_MEM_VSX_P (V4SFmode)
   && !TARGET_P9_VECTOR
   && !altivec_indexed_or_indirect_operand (operands[0], V4SFmode)
   && const_vec_duplicate_p (operands[1])))
        {
          *pnum_clobbers = 1;
          return 1487; /* vsx_stxvd2x4_le_const_v4sf */
        }
      if (nonimmediate_operand (operands[0], E_V4SFmode)
          && input_operand (operands[1], E_V4SFmode)
          && 
#line 245 "../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_P (V4SFmode)
   && (register_operand (operands[0], V4SFmode) 
       || register_operand (operands[1], V4SFmode))))
        return 1792; /* *altivec_movv4sf */
      break;

    default:
      break;
    }
  operands[0] = x2;
  switch (pattern32 (x3, 
E_V4SFmode))
    {
    case 0:
      if ((
#line 3218 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
        return 2246; /* altivec_stvx_v4sf_2op_si */
      break;

    case 1:
      if ((
#line 3218 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
        return 2247; /* altivec_stvx_v4sf_2op_di */
      break;

    case 2:
      if ((
#line 3226 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
        return 2264; /* altivec_stvx_v4sf_1op_si */
      break;

    case 3:
      if ((
#line 3226 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
        return 2265; /* altivec_stvx_v4sf_1op_di */
      break;

    default:
      break;
    }
  operands[0] = x3;
  switch (GET_CODE (x2))
    {
    case HIGH:
      if (GET_MODE (x2) != E_SImode
          || !gpc_reg_operand (operands[0], E_SImode))
        return -1;
      x4 = XEXP (x2, 0);
      if (GET_CODE (x4) == UNSPEC
          && GET_MODE (x4) == E_SImode)
        {
          switch (XVECLEN (x4, 0))
            {
            case 2:
              x5 = XVECEXP (x4, 0, 0);
              operands[1] = x5;
              x6 = XVECEXP (x4, 0, 1);
              operands[2] = x6;
              switch (XINT (x4, 1))
                {
                case 14:
                  if (rs6000_tls_symbol_ref (operands[1], E_SImode)
                      && gpc_reg_operand (operands[2], E_SImode)
                      && (
#line 10598 "../../gcc/config/rs6000/rs6000.md"
(HAVE_AS_TLS && TARGET_ELF && TARGET_CMODEL != CMODEL_SMALL) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                    return 750; /* *tls_gd_high32 */
                  break;

                case 23:
                  if (gpc_reg_operand (operands[1], E_SImode)
                      && rs6000_tls_symbol_ref (operands[2], E_SImode)
                      && (
#line 10711 "../../gcc/config/rs6000/rs6000.md"
(HAVE_AS_TLS && TARGET_CMODEL != CMODEL_SMALL) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                    return 770; /* *tls_got_dtprel_high32 */
                  break;

                case 27:
                  if (gpc_reg_operand (operands[1], E_SImode)
                      && rs6000_tls_symbol_ref (operands[2], E_SImode)
                      && (
#line 10791 "../../gcc/config/rs6000/rs6000.md"
(HAVE_AS_TLS && TARGET_CMODEL != CMODEL_SMALL) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                    return 784; /* *tls_got_tprel_high32 */
                  break;

                default:
                  break;
                }
              break;

            case 1:
              if (XINT (x4, 1) == 15)
                {
                  x5 = XVECEXP (x4, 0, 0);
                  operands[1] = x5;
                  if (gpc_reg_operand (operands[1], E_SImode)
                      && (
#line 10644 "../../gcc/config/rs6000/rs6000.md"
(HAVE_AS_TLS && TARGET_ELF && TARGET_CMODEL != CMODEL_SMALL) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                    return 758; /* *tls_ld_high32 */
                }
              break;

            default:
              break;
            }
        }
      operands[1] = x4;
      if (!
#line 11351 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ELF && !TARGET_64BIT && !flag_pic))
        return -1;
      return 807; /* elf_high */

    case MEM:
      x4 = XEXP (x2, 0);
      switch (GET_CODE (x4))
        {
        case PLUS:
          if (GET_MODE (x4) != E_SImode)
            return -1;
          x7 = XEXP (x4, 1);
          if (GET_CODE (x7) != CONST)
            return -1;
          x8 = XEXP (x7, 0);
          if (GET_CODE (x8) != MINUS
              || GET_MODE (x8) != E_SImode
              || !gpc_reg_operand (operands[0], E_SImode)
              || GET_MODE (x2) != E_SImode)
            return -1;
          x9 = XEXP (x4, 0);
          operands[1] = x9;
          if (!gpc_reg_operand (operands[1], E_SImode))
            return -1;
          x10 = XEXP (x8, 0);
          operands[2] = x10;
          if (!immediate_operand (operands[2], E_SImode))
            return -1;
          x11 = XEXP (x8, 1);
          operands[3] = x11;
          if (!immediate_operand (operands[3], E_SImode)
              || !
#line 11219 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ELF && DEFAULT_ABI == ABI_V4 && flag_pic == 2))
            return -1;
          return 799; /* load_toc_v4_PIC_2 */

        case AND:
          x7 = XEXP (x4, 1);
          if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + -16]
              || !register_operand (operands[0], E_V4SFmode)
              || GET_MODE (x2) != E_V4SFmode)
            return -1;
          switch (pattern34 (x4))
            {
            case 0:
              if (!(
#line 3162 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                return -1;
              return 2201; /* altivec_lvx_v4sf_2op_si */

            case 1:
              if (!(
#line 3162 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                return -1;
              return 2202; /* altivec_lvx_v4sf_2op_di */

            case 2:
              if (!(
#line 3170 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                return -1;
              return 2219; /* altivec_lvx_v4sf_1op_si */

            case 3:
              if (!(
#line 3170 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                return -1;
              return 2220; /* altivec_lvx_v4sf_1op_di */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_126 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case PLUS:
      res = recog_31 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case UNSPEC:
      res = recog_108 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    default:
      break;
    }
  operands[1] = x2;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  switch (pattern69 ())
    {
    case 0:
      if ((
#line 11337 "../../gcc/config/rs6000/rs6000.md"
(TARGET_TOC
    && legitimate_constant_pool_address_p (operands[1], QImode, false)) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
        return 805; /* *tocrefsi */
      break;

    case 1:
      if ((
#line 11337 "../../gcc/config/rs6000/rs6000.md"
(TARGET_TOC
    && legitimate_constant_pool_address_p (operands[1], QImode, false)) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
        return 806; /* *tocrefdi */
      break;

    default:
      break;
    }
  switch (GET_CODE (x2))
    {
    case UNSPEC:
      operands[0] = x3;
      switch (XVECLEN (x2, 0))
        {
        case 3:
          switch (XINT (x2, 1))
            {
            case 88:
              x4 = XVECEXP (x2, 0, 0);
              operands[1] = x4;
              x5 = XVECEXP (x2, 0, 1);
              operands[2] = x5;
              x6 = XVECEXP (x2, 0, 2);
              operands[3] = x6;
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  if (GET_MODE (x2) != E_SImode
                      || !gpc_reg_operand (operands[1], E_SImode)
                      || !symbol_ref_operand (operands[2], E_SImode))
                    return -1;
                  if (memory_operand (operands[0], E_SImode)
                      && (
#line 11367 "../../gcc/config/rs6000/rs6000.md"
(TARGET_PLTSEQ
   && DEFAULT_ABI == ABI_ELFv2) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                    return 809; /* *pltseq_tocsave_si */
                  if (!register_operand (operands[0], E_SImode)
                      || !(
#line 11402 "../../gcc/config/rs6000/rs6000.md"
(TARGET_PLTSEQ) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                    return -1;
                  return 815; /* *pltseq_mtctr_si */

                case E_DImode:
                  if (GET_MODE (x2) != E_DImode
                      || !gpc_reg_operand (operands[1], E_DImode)
                      || !symbol_ref_operand (operands[2], E_DImode))
                    return -1;
                  if (memory_operand (operands[0], E_DImode)
                      && (
#line 11367 "../../gcc/config/rs6000/rs6000.md"
(TARGET_PLTSEQ
   && DEFAULT_ABI == ABI_ELFv2) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                    return 810; /* *pltseq_tocsave_di */
                  if (!register_operand (operands[0], E_DImode)
                      || !(
#line 11402 "../../gcc/config/rs6000/rs6000.md"
(TARGET_PLTSEQ) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                    return -1;
                  return 816; /* *pltseq_mtctr_di */

                default:
                  return -1;
                }

            case 89:
              x4 = XVECEXP (x2, 0, 0);
              operands[1] = x4;
              x5 = XVECEXP (x2, 0, 1);
              operands[2] = x5;
              x6 = XVECEXP (x2, 0, 2);
              operands[3] = x6;
              switch (pattern337 (x2))
                {
                case 0:
                  if (!(
#line 11379 "../../gcc/config/rs6000/rs6000.md"
(TARGET_PLTSEQ) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                    return -1;
                  return 811; /* *pltseq_plt16_ha_si */

                case 1:
                  if (!(
#line 11379 "../../gcc/config/rs6000/rs6000.md"
(TARGET_PLTSEQ) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                    return -1;
                  return 812; /* *pltseq_plt16_ha_di */

                default:
                  return -1;
                }

            case 17:
              if (pattern222 (x2, 
E_CCmode, 
102) != 0)
                return -1;
              x5 = XVECEXP (x2, 0, 1);
              if (GET_CODE (x5) != REG
                  || REGNO (x5) != 103
                  || GET_MODE (x5) != E_CCmode)
                return -1;
              x6 = XVECEXP (x2, 0, 2);
              if (GET_CODE (x6) != REG
                  || REGNO (x6) != 104
                  || GET_MODE (x6) != E_CCmode
                  || !gpc_reg_operand (operands[0], E_SImode))
                return -1;
              return 1002; /* prologue_movesi_from_cr */

            case 445:
              if (pnum_clobbers == NULL)
                return -1;
              x4 = XVECEXP (x2, 0, 0);
              operands[1] = x4;
              x5 = XVECEXP (x2, 0, 1);
              operands[2] = x5;
              if (!int_reg_operand (operands[2], E_DImode))
                return -1;
              x6 = XVECEXP (x2, 0, 2);
              operands[3] = x6;
              if (!const_int_operand (operands[3], E_VOIDmode))
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  if (!int_reg_operand (operands[0], E_SImode)
                      || GET_MODE (x2) != E_SImode
                      || !d_form_memory (operands[1], E_SImode)
                      || !
#line 152 "../../gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT
   && (GET_CODE (operands[4]) == SCRATCH
       || reg_mentioned_p (operands[4], operands[1]))))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3346; /* *pcrel_opt_ldsi_gpr */

                case E_DImode:
                  if (!int_reg_operand (operands[0], E_DImode)
                      || GET_MODE (x2) != E_DImode
                      || !d_form_memory (operands[1], E_DImode)
                      || !
#line 152 "../../gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT
   && (GET_CODE (operands[4]) == SCRATCH
       || reg_mentioned_p (operands[4], operands[1]))))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3347; /* *pcrel_opt_lddi_gpr */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 1:
          return recog_109 (x1, insn, pnum_clobbers);

        case 2:
          x4 = XVECEXP (x2, 0, 0);
          operands[1] = x4;
          x5 = XVECEXP (x2, 0, 1);
          operands[2] = x5;
          switch (XINT (x2, 1))
            {
            case 49:
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  if (pattern381 (x2, 
E_SImode) != 0
                      || !(
#line 14443 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POPCNTD) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                    return -1;
                  return 1051; /* bpermd_si */

                case E_DImode:
                  if (pattern381 (x2, 
E_DImode) != 0
                      || !(
#line 14443 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POPCNTD) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                    return -1;
                  return 1052; /* bpermd_di */

                default:
                  return -1;
                }

            case 65:
              if (GET_MODE (x2) != E_SImode
                  || !register_operand (operands[0], E_SImode)
                  || !register_operand (operands[1], E_SImode)
                  || !register_operand (operands[2], E_SImode)
                  || !
#line 14821 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POPCNTD))
                return -1;
              return 1072; /* addg6s */

            case 68:
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  if (pattern141 (x2, 
E_SImode) != 0
                      || !
#line 14852 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POPCNTD))
                    return -1;
                  return 1075; /* dive_si */

                case E_DImode:
                  if (pattern141 (x2, 
E_DImode) != 0
                      || !(
#line 14852 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POPCNTD) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                    return -1;
                  return 1077; /* dive_di */

                default:
                  return -1;
                }

            case 69:
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  if (pattern141 (x2, 
E_SImode) != 0
                      || !
#line 14852 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POPCNTD))
                    return -1;
                  return 1076; /* diveu_si */

                case E_DImode:
                  if (pattern141 (x2, 
E_DImode) != 0
                      || !(
#line 14852 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POPCNTD) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                    return -1;
                  return 1078; /* diveu_di */

                default:
                  return -1;
                }

            case 70:
              if (GET_MODE (x2) != E_DImode
                  || !const_0_to_1_operand (operands[2], E_QImode))
                return -1;
              if (nonimmediate_operand (operands[0], E_DImode)
                  && register_operand (operands[1], E_TDmode))
                {
                  if ((
#line 14881 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT && FLOAT128_2REG_P (TDmode)) && 
#line 545 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT)))
                    return 1081; /* unpacktd_dm */
                  if ((
#line 14904 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_DIRECT_MOVE_64BIT && FLOAT128_2REG_P (TDmode)) && 
#line 545 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT)))
                    return 1084; /* unpacktd_nodm */
                }
              if (!register_operand (operands[0], E_DImode))
                return -1;
              switch (GET_MODE (operands[1]))
                {
                case E_V1TImode:
                  if (!register_operand (operands[1], E_V1TImode)
                      || !
#line 14991 "../../gcc/config/rs6000/rs6000.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (V1TImode)))
                    return -1;
                  return 1089; /* unpackv1ti */

                case E_KFmode:
                  if (!register_operand (operands[1], E_KFmode)
                      || !
#line 14991 "../../gcc/config/rs6000/rs6000.md"
(VECTOR_MEM_ALTIVEC_OR_VSX_P (KFmode)))
                    return -1;
                  return 1090; /* unpackkf */

                default:
                  return -1;
                }

            case 144:
              if (GET_MODE (x2) != E_DImode
                  || !gpc_reg_operand (operands[0], E_DImode)
                  || !gpc_reg_operand (operands[1], E_V2DImode)
                  || !gpc_reg_operand (operands[2], E_V2DImode)
                  || !
#line 3646 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V2DImode) && TARGET_DIRECT_MOVE_64BIT))
                return -1;
              return 1502; /* vsx_vslo_v2di */

            case 145:
              if (pnum_clobbers == NULL
                  || !gpc_reg_operand (operands[2], E_DImode))
                return -1;
              switch (pattern216 (x2))
                {
                case 0:
                  if (gpc_reg_operand (operands[1], E_V2DImode)
                      && 
#line 3658 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V2DImode) && TARGET_DIRECT_MOVE_64BIT))
                    {
                      *pnum_clobbers = 2;
                      return 1504; /* vsx_extract_v2di_var */
                    }
                  if (!memory_operand (operands[1], E_V2DImode)
                      || !
#line 3675 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V2DImode) && TARGET_DIRECT_MOVE_64BIT))
                    return -1;
                  *pnum_clobbers = 1;
                  return 1506; /* *vsx_extract_v2di_var_load */

                case 1:
                  if (gpc_reg_operand (operands[1], E_V4SImode)
                      && 
#line 4185 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT))
                    {
                      *pnum_clobbers = 2;
                      return 1533; /* vsx_extract_v4si_var */
                    }
                  if (!memory_operand (operands[1], E_V4SImode)
                      || !
#line 4204 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT))
                    return -1;
                  *pnum_clobbers = 1;
                  return 1536; /* *vsx_extract_v4si_var_load */

                default:
                  return -1;
                }

            case 170:
              if (pattern341 (x2, 
E_V16QImode) != 0
                  || !
#line 5974 "../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
                return -1;
              return 1724; /* vextublx */

            case 173:
              if (pattern341 (x2, 
E_V16QImode) != 0
                  || !
#line 5985 "../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
                return -1;
              return 1725; /* vextubrx */

            case 171:
              if (pattern341 (x2, 
E_V8HImode) != 0
                  || !
#line 5996 "../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
                return -1;
              return 1726; /* vextuhlx */

            case 174:
              if (pattern341 (x2, 
E_V8HImode) != 0
                  || !
#line 6007 "../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
                return -1;
              return 1727; /* vextuhrx */

            case 172:
              if (pattern341 (x2, 
E_V4SImode) != 0
                  || !
#line 6018 "../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
                return -1;
              return 1728; /* vextuwlx */

            case 175:
              if (pattern341 (x2, 
E_V4SImode) != 0
                  || !
#line 6029 "../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
                return -1;
              return 1729; /* vextuwrx */

            case 191:
              if (GET_MODE (x2) != E_DImode
                  || !gpc_reg_operand (operands[0], E_DImode)
                  || !const_0_to_1_operand (operands[2], E_QImode))
                return -1;
              switch (GET_MODE (operands[1]))
                {
                case E_V16QImode:
                  if (!altivec_register_operand (operands[1], E_V16QImode)
                      || !
#line 6472 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
                    return -1;
                  return 1744; /* vec_cntmb_v16qi */

                case E_V8HImode:
                  if (!altivec_register_operand (operands[1], E_V8HImode)
                      || !
#line 6472 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
                    return -1;
                  return 1745; /* vec_cntmb_v8hi */

                case E_V4SImode:
                  if (!altivec_register_operand (operands[1], E_V4SImode)
                      || !
#line 6472 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
                    return -1;
                  return 1746; /* vec_cntmb_v4si */

                case E_V2DImode:
                  if (!altivec_register_operand (operands[1], E_V2DImode)
                      || !
#line 6472 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
                    return -1;
                  return 1747; /* vec_cntmb_v2di */

                default:
                  return -1;
                }

            case 351:
              if (GET_MODE (x2) != E_DImode
                  || !register_operand (operands[0], E_DImode)
                  || !altivec_register_operand (operands[1], E_V2DImode)
                  || !u3bit_cint_operand (operands[2], E_QImode)
                  || !
#line 4681 "../../gcc/config/rs6000/altivec.md"
(TARGET_POWER10))
                return -1;
              return 2350; /* vgnb */

            case 444:
              if (GET_MODE (x2) != E_DImode
                  || !base_reg_operand (operands[0], E_DImode)
                  || !pcrel_external_address (operands[1], E_DImode)
                  || !const_int_operand (operands[2], E_VOIDmode)
                  || !
#line 125 "../../gcc/config/rs6000/pcrel-opt.md"
(TARGET_PCREL_OPT))
                return -1;
              return 3343; /* pcrel_opt_ld_addr_same_reg */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case PLUS:
      if (pnum_clobbers == NULL)
        return -1;
      x7 = XEXP (x2, 0);
      switch (GET_CODE (x7))
        {
        case EQ:
          switch (pattern175 (x1))
            {
            case 0:
              if (!
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT))
                return -1;
              *pnum_clobbers = 3;
              return 936; /* *plus_eq_si */

            case 1:
              if (!
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT))
                return -1;
              *pnum_clobbers = 3;
              return 937; /* *plus_eq_di */

            default:
              return -1;
            }

        case NE:
          switch (pattern175 (x1))
            {
            case 0:
              if (!
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT))
                return -1;
              *pnum_clobbers = 3;
              return 938; /* *plus_ne_si */

            case 1:
              if (!
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT))
                return -1;
              *pnum_clobbers = 3;
              return 939; /* *plus_ne_di */

            default:
              return -1;
            }

        case AND:
          switch (pattern45 (x1))
            {
            case 0:
              if (!
#line 1663 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2675; /* *fuse_and_add */

            case 1:
              if (!(
#line 1663 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              *pnum_clobbers = 1;
              return 2676; /* *fuse_and_add */

            case 2:
              if (!
#line 1699 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2679; /* *fuse_nor_add */

            case 3:
              if (!(
#line 1699 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              *pnum_clobbers = 1;
              return 2680; /* *fuse_nor_add */

            default:
              return -1;
            }

        case IOR:
          switch (pattern46 (x1))
            {
            case 0:
              if (!
#line 1681 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2677; /* *fuse_nand_add */

            case 1:
              if (!(
#line 1681 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              *pnum_clobbers = 1;
              return 2678; /* *fuse_nand_add */

            case 2:
              if (!
#line 1717 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2681; /* *fuse_or_add */

            case 3:
              if (!(
#line 1717 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              *pnum_clobbers = 1;
              return 2682; /* *fuse_or_add */

            default:
              return -1;
            }

        case PLUS:
          switch (pattern122 (x1))
            {
            case 0:
              if (!
#line 3031 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 3339; /* *fuse_add_add */

            case 1:
              if (!(
#line 3031 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              *pnum_clobbers = 1;
              return 3340; /* *fuse_add_add */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_136 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case ASHIFTRT:
      x5 = XEXP (x4, 1);
      if (GET_CODE (x5) != CONST_INT)
        return -1;
      switch (XWINT (x5, 0))
        {
        case 16L:
          if (!gpc_reg_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode
              || GET_MODE (x4) != E_SImode)
            return -1;
          x6 = XEXP (x4, 0);
          if (!gpc_reg_operand (x6, E_SImode))
            return -1;
          x7 = XEXP (x3, 1);
          if (GET_MODE (x7) != E_SImode)
            return -1;
          switch (GET_CODE (x7))
            {
            case SIGN_EXTEND:
              operands[2] = x6;
              x8 = XEXP (x7, 0);
              operands[1] = x8;
              if (!gpc_reg_operand (operands[1], E_HImode)
                  || !
#line 1571 "../../gcc/config/rs6000/rs6000.md"
(TARGET_MULHW))
                return -1;
              return 56; /* *mulchw */

            case ASHIFTRT:
              x9 = XEXP (x7, 1);
              if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 16])
                return -1;
              operands[1] = x6;
              x8 = XEXP (x7, 0);
              operands[2] = x8;
              if (!gpc_reg_operand (operands[2], E_SImode)
                  || !
#line 1632 "../../gcc/config/rs6000/rs6000.md"
(TARGET_MULHW))
                return -1;
              return 60; /* *mulhhw */

            default:
              return -1;
            }

        case 32L:
          x7 = XEXP (x3, 1);
          if (GET_CODE (x7) != ASHIFTRT)
            return -1;
          x9 = XEXP (x7, 1);
          if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 32])
            return -1;
          switch (pattern294 (x3))
            {
            case 0:
              if (!
#line 6556 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
                return -1;
              return 1770; /* smulv2di3_highpart */

            case 1:
              if (!
#line 6556 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
                return -1;
              return 1771; /* smulv4si3_highpart */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case LSHIFTRT:
      if (GET_MODE (x4) != E_SImode)
        return -1;
      x5 = XEXP (x4, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 16]
          || !gpc_reg_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode)
        return -1;
      x6 = XEXP (x4, 0);
      if (!gpc_reg_operand (x6, E_SImode))
        return -1;
      x7 = XEXP (x3, 1);
      if (GET_MODE (x7) != E_SImode)
        return -1;
      switch (GET_CODE (x7))
        {
        case ZERO_EXTEND:
          operands[2] = x6;
          x8 = XEXP (x7, 0);
          operands[1] = x8;
          if (!gpc_reg_operand (operands[1], E_HImode)
              || !
#line 1600 "../../gcc/config/rs6000/rs6000.md"
(TARGET_MULHW))
            return -1;
          return 58; /* *mulchwu */

        case LSHIFTRT:
          x9 = XEXP (x7, 1);
          if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 16])
            return -1;
          operands[1] = x6;
          x8 = XEXP (x7, 0);
          operands[2] = x8;
          if (!gpc_reg_operand (operands[2], E_SImode)
              || !
#line 1664 "../../gcc/config/rs6000/rs6000.md"
(TARGET_MULHW))
            return -1;
          return 62; /* *mulhhwu */

        default:
          return -1;
        }

    case SIGN_EXTEND:
      if (pattern47 (x3, 
SIGN_EXTEND) != 0
          || !
#line 1690 "../../gcc/config/rs6000/rs6000.md"
(TARGET_MULHW))
        return -1;
      return 64; /* *mullhw */

    case ZERO_EXTEND:
      if (pattern47 (x3, 
ZERO_EXTEND) != 0
          || !
#line 1716 "../../gcc/config/rs6000/rs6000.md"
(TARGET_MULHW))
        return -1;
      return 66; /* *mullhwu */

    case REG:
    case SUBREG:
      operands[1] = x4;
      x7 = XEXP (x3, 1);
      operands[2] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern266 (x3, 
E_SImode) != 0)
            return -1;
          return 165; /* mulsi3 */

        case E_DImode:
          if (pattern266 (x3, 
E_DImode) != 0
              || !
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
            return -1;
          return 166; /* muldi3 */

        case E_SFmode:
          if (pattern19 (x3, 
E_SFmode) != 0
              || !
#line 5097 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 316; /* *mulsf3_fpr */

        case E_DFmode:
          if (pattern19 (x3, 
E_DFmode) != 0
              || !
#line 5097 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 317; /* *muldf3_fpr */

        case E_KFmode:
          if (pattern1 (x3, 
E_KFmode) != 0
              || !(
#line 15040 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
            return -1;
          return 1097; /* mulkf3 */

        case E_TFmode:
          if (pattern1 (x3, 
E_TFmode) != 0
              || !(
#line 15040 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
            return -1;
          return 1098; /* multf3 */

        case E_V4SFmode:
          if (pattern2 (x3, 
E_V4SFmode) != 0
              || !
#line 1718 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V4SFmode)))
            return -1;
          return 1338; /* *vsx_mulv4sf3 */

        case E_V2DFmode:
          if (pattern2 (x3, 
E_V2DFmode) != 0
              || !
#line 1718 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode)))
            return -1;
          return 1339; /* *vsx_mulv2df3 */

        case E_V2DImode:
          if (pattern2 (x3, 
E_V2DImode) != 0
              || !
#line 6577 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1774; /* mulv2di3 */

        case E_V4SImode:
          if (pattern3 (x3, 
E_V4SImode) != 0
              || !
#line 803 "../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
            return -1;
          return 1909; /* mulv4si3_p8 */

        case E_DDmode:
          if (pattern19 (x3, 
E_DDmode) != 0
              || !
#line 193 "../../gcc/config/rs6000/dfp.md"
(TARGET_DFP))
            return -1;
          return 2440; /* muldd3 */

        case E_TDmode:
          if (pattern19 (x3, 
E_TDmode) != 0
              || !
#line 193 "../../gcc/config/rs6000/dfp.md"
(TARGET_DFP))
            return -1;
          return 2441; /* multd3 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_143 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      if (!gpc_reg_operand (operands[0], E_SFmode)
          || GET_MODE (x3) != E_SFmode
          || !gpc_reg_operand (operands[1], E_SFmode)
          || !
#line 5018 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT))
        return -1;
      return 306; /* *abssf2_fpr */

    case E_DFmode:
      if (!gpc_reg_operand (operands[0], E_DFmode)
          || GET_MODE (x3) != E_DFmode
          || !gpc_reg_operand (operands[1], E_DFmode)
          || !
#line 5018 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT))
        return -1;
      return 307; /* *absdf2_fpr */

    case E_KFmode:
      if (pnum_clobbers != NULL
          && register_operand (operands[0], E_KFmode)
          && GET_MODE (x3) == E_KFmode
          && register_operand (operands[1], E_KFmode)
          && (
#line 9327 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_TYPE && !TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
        {
          *pnum_clobbers = 1;
          return 629; /* ieee_128bit_vsx_abskf2 */
        }
      if (!altivec_register_operand (operands[0], E_KFmode)
          || GET_MODE (x3) != E_KFmode
          || !altivec_register_operand (operands[1], E_KFmode)
          || !(
#line 15132 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
        return -1;
      return 1109; /* abskf2_hw */

    case E_TFmode:
      if (pnum_clobbers != NULL
          && register_operand (operands[0], E_TFmode)
          && GET_MODE (x3) == E_TFmode
          && register_operand (operands[1], E_TFmode)
          && (
#line 9327 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_TYPE && !TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
        {
          *pnum_clobbers = 1;
          return 630; /* ieee_128bit_vsx_abstf2 */
        }
      if (!altivec_register_operand (operands[0], E_TFmode)
          || GET_MODE (x3) != E_TFmode
          || !altivec_register_operand (operands[1], E_TFmode)
          || !(
#line 15132 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
        return -1;
      return 1110; /* abstf2_hw */

    case E_V4SFmode:
      if (!vsx_register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x3) != E_V4SFmode
          || !vsx_register_operand (operands[1], E_V4SFmode)
          || !
#line 1991 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V4SFmode)))
        return -1;
      return 1358; /* *vsx_absv4sf2 */

    case E_V2DFmode:
      if (!vsx_register_operand (operands[0], E_V2DFmode)
          || GET_MODE (x3) != E_V2DFmode
          || !vsx_register_operand (operands[1], E_V2DFmode)
          || !
#line 1991 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode)))
        return -1;
      return 1359; /* *vsx_absv2df2 */

    case E_DDmode:
      if (!gpc_reg_operand (operands[0], E_DDmode)
          || GET_MODE (x3) != E_DDmode
          || !gpc_reg_operand (operands[1], E_DDmode)
          || !
#line 94 "../../gcc/config/rs6000/dfp.md"
(TARGET_HARD_FLOAT))
        return -1;
      return 2428; /* absdd2 */

    case E_TDmode:
      if (!gpc_reg_operand (operands[0], E_TDmode)
          || GET_MODE (x3) != E_TDmode
          || !gpc_reg_operand (operands[1], E_TDmode)
          || !
#line 118 "../../gcc/config/rs6000/dfp.md"
(TARGET_HARD_FLOAT))
        return -1;
      return 2431; /* abstd2 */

    default:
      return -1;
    }
}

 int
recog_150 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_CODE (operands[2]))
    {
    case REG:
    case SUBREG:
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern19 (x3, 
E_SImode) != 0)
            return -1;
          return 190; /* *divsi3 */

        case E_DImode:
          if (pattern19 (x3, 
E_DImode) != 0
              || !
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
            return -1;
          return 191; /* *divdi3 */

        case E_TImode:
          if (pattern1 (x3, 
E_TImode) != 0
              || !
#line 3441 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWER10 && TARGET_POWERPC64))
            return -1;
          return 198; /* divti3 */

        case E_SFmode:
          if (pattern19 (x3, 
E_SFmode) != 0
              || !
#line 5123 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 318; /* *divsf3_fpr */

        case E_DFmode:
          if (pattern19 (x3, 
E_DFmode) != 0
              || !
#line 5123 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 319; /* *divdf3_fpr */

        case E_KFmode:
          if (pattern1 (x3, 
E_KFmode) != 0
              || !(
#line 15050 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
            return -1;
          return 1099; /* divkf3 */

        case E_TFmode:
          if (pattern1 (x3, 
E_TFmode) != 0
              || !(
#line 15050 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
            return -1;
          return 1100; /* divtf3 */

        case E_V4SFmode:
          if (pattern2 (x3, 
E_V4SFmode) != 0
              || !
#line 1773 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V4SFmode)))
            return -1;
          return 1341; /* *vsx_divv4sf3 */

        case E_V2DFmode:
          if (pattern2 (x3, 
E_V2DFmode) != 0
              || !
#line 1773 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode)))
            return -1;
          return 1342; /* *vsx_divv2df3 */

        case E_V2DImode:
          if (pattern2 (x3, 
E_V2DImode) != 0
              || !
#line 6516 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1762; /* divv2di3 */

        case E_V4SImode:
          if (pattern2 (x3, 
E_V4SImode) != 0
              || !
#line 6516 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
            return -1;
          return 1763; /* divv4si3 */

        case E_DDmode:
          if (pattern19 (x3, 
E_DDmode) != 0
              || !
#line 201 "../../gcc/config/rs6000/dfp.md"
(TARGET_DFP))
            return -1;
          return 2442; /* divdd3 */

        case E_TDmode:
          if (pattern19 (x3, 
E_TDmode) != 0
              || !
#line 201 "../../gcc/config/rs6000/dfp.md"
(TARGET_DFP))
            return -1;
          return 2443; /* divtd3 */

        default:
          return -1;
        }

    case CONST_INT:
      if (pnum_clobbers == NULL)
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern328 (x3, 
E_SImode) != 0)
            return -1;
          *pnum_clobbers = 1;
          return 192; /* divsi3_sra */

        case E_DImode:
          if (pattern328 (x3, 
E_DImode) != 0
              || !
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
            return -1;
          *pnum_clobbers = 1;
          return 193; /* divdi3_sra */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_159 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) == SET)
    {
      res = recog_158 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  x5 = XEXP (x2, 1);
  x6 = XEXP (x5, 1);
  switch (GET_CODE (x6))
    {
    case CONST_INT:
      if (XWINT (x6, 0) != -1L
          || GET_CODE (x4) != SET)
        return -1;
      switch (pattern353 (x1, 
NE))
        {
        case 0:
          if (!
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT))
            return -1;
          return 84; /* *addsi3_imm_carry_m1 */

        case 1:
          if (!
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT))
            return -1;
          return 85; /* *adddi3_imm_carry_m1 */

        default:
          return -1;
        }

    case REG:
      if (REGNO (x6) != 98
          || GET_CODE (x4) != CLOBBER)
        return -1;
      x7 = XEXP (x4, 0);
      if (GET_CODE (x7) != REG
          || REGNO (x7) != 98)
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern516 (x1, 
E_SImode) != 0)
            return -1;
          return 92; /* addsi3_carry_in_0 */

        case E_DImode:
          if (pattern516 (x1, 
E_DImode) != 0
              || !
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
            return -1;
          return 93; /* adddi3_carry_in_0 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_166 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case PC:
      x4 = XEXP (x2, 1);
      operands[0] = x4;
      x5 = XVECEXP (x1, 0, 1);
      switch (GET_CODE (x5))
        {
        case CLOBBER:
          x6 = XEXP (x5, 0);
          operands[1] = x6;
          if (!cc_reg_operand (operands[1], E_CCmode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (!register_operand (operands[0], E_SImode)
                  || !(
#line 13540 "../../gcc/config/rs6000/rs6000.md"
(!rs6000_speculate_indirect_jumps) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                return -1;
              return 981; /* indirect_jumpsi_nospec */

            case E_DImode:
              if (!register_operand (operands[0], E_DImode)
                  || !(
#line 13540 "../../gcc/config/rs6000/rs6000.md"
(!rs6000_speculate_indirect_jumps) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                return -1;
              return 982; /* indirect_jumpdi_nospec */

            default:
              return -1;
            }

        case USE:
          x6 = XEXP (x5, 0);
          if (GET_CODE (x6) != LABEL_REF)
            return -1;
          x7 = XEXP (x6, 0);
          operands[1] = x7;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (!register_operand (operands[0], E_SImode)
                  || !(
#line 13647 "../../gcc/config/rs6000/rs6000.md"
(rs6000_speculate_indirect_jumps) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                return -1;
              return 983; /* tablejumpsi_insn_normal */

            case E_DImode:
              if (!register_operand (operands[0], E_DImode)
                  || !(
#line 13647 "../../gcc/config/rs6000/rs6000.md"
(rs6000_speculate_indirect_jumps) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                return -1;
              return 984; /* tablejumpdi_insn_normal */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case REG:
    case SUBREG:
    case MEM:
      x5 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x5) == SET)
        {
          res = recog_165 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      operands[0] = x3;
      if (GET_CODE (x5) != UNSPEC
          || XVECLEN (x5, 0) != 1)
        return -1;
      x8 = XVECEXP (x5, 0, 0);
      if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x4 = XEXP (x2, 1);
      operands[1] = x4;
      switch (XINT (x5, 1))
        {
        case 279:
          switch (pattern500 ())
            {
            case 0:
              if (!
#line 3182 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
                return -1;
              return 2231; /* altivec_stvx_v4si_internal */

            case 1:
              if (!
#line 3182 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
                return -1;
              return 2232; /* altivec_stvx_v8hi_internal */

            case 2:
              if (!
#line 3182 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
                return -1;
              return 2233; /* altivec_stvx_v16qi_internal */

            case 3:
              if (!
#line 3182 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
                return -1;
              return 2234; /* altivec_stvx_v4sf_internal */

            case 4:
              if (!
#line 3182 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
                return -1;
              return 2235; /* altivec_stvx_v2df_internal */

            case 5:
              if (!
#line 3182 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
                return -1;
              return 2236; /* altivec_stvx_v2di_internal */

            case 6:
              if (!
#line 3182 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
                return -1;
              return 2237; /* altivec_stvx_v1ti_internal */

            case 7:
              if (!(
#line 3182 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 211 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
                return -1;
              return 2238; /* altivec_stvx_kf_internal */

            case 8:
              if (!(
#line 3182 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 212 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
                return -1;
              return 2239; /* altivec_stvx_tf_internal */

            default:
              return -1;
            }

        case 280:
          switch (pattern500 ())
            {
            case 0:
              if (!
#line 3235 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
                return -1;
              return 2276; /* altivec_stvxl_v4si */

            case 1:
              if (!
#line 3235 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
                return -1;
              return 2277; /* altivec_stvxl_v8hi */

            case 2:
              if (!
#line 3235 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
                return -1;
              return 2278; /* altivec_stvxl_v16qi */

            case 3:
              if (!
#line 3235 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
                return -1;
              return 2279; /* altivec_stvxl_v4sf */

            case 4:
              if (!
#line 3235 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
                return -1;
              return 2280; /* altivec_stvxl_v2df */

            case 5:
              if (!
#line 3235 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
                return -1;
              return 2281; /* altivec_stvxl_v2di */

            case 6:
              if (!
#line 3235 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
                return -1;
              return 2282; /* altivec_stvxl_v1ti */

            case 7:
              if (!(
#line 3235 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 211 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
                return -1;
              return 2283; /* altivec_stvxl_kf */

            case 8:
              if (!(
#line 3235 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 212 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
                return -1;
              return 2284; /* altivec_stvxl_tf */

            default:
              return -1;
            }

        case 305:
          if (!memory_operand (operands[0], E_V16QImode)
              || !register_operand (operands[1], E_V16QImode)
              || !
#line 4280 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC && rs6000_cpu == PROCESSOR_CELL))
            return -1;
          return 2297; /* altivec_stvlx */

        case 306:
          if (!memory_operand (operands[0], E_V16QImode)
              || !register_operand (operands[1], E_V16QImode)
              || !
#line 4289 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC && rs6000_cpu == PROCESSOR_CELL))
            return -1;
          return 2298; /* altivec_stvlxl */

        case 307:
          if (!memory_operand (operands[0], E_V16QImode)
              || !register_operand (operands[1], E_V16QImode)
              || !
#line 4298 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC && rs6000_cpu == PROCESSOR_CELL))
            return -1;
          return 2299; /* altivec_stvrx */

        case 308:
          if (!memory_operand (operands[0], E_V16QImode)
              || !register_operand (operands[1], E_V16QImode)
              || !
#line 4307 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC && rs6000_cpu == PROCESSOR_CELL))
            return -1;
          return 2300; /* altivec_stvrxl */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_172 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[1] = x4;
      x5 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x5) != SET)
        return -1;
      x6 = XEXP (x5, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x7 = XEXP (x5, 0);
      if (GET_CODE (x7) != REG
          || REGNO (x7) != 98)
        return -1;
      x8 = XEXP (x2, 0);
      operands[0] = x8;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern497 (x1, 
E_SImode) != 0
              || !
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT))
            return -1;
          return 116; /* *subfsi3_imm_carry_m1 */

        case E_DImode:
          if (pattern497 (x1, 
E_DImode) != 0
              || !
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT))
            return -1;
          return 117; /* *subfdi3_imm_carry_m1 */

        default:
          return -1;
        }

    case XOR:
      x5 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x5) != CLOBBER)
        return -1;
      x8 = XEXP (x2, 0);
      operands[3] = x8;
      x9 = XEXP (x4, 1);
      operands[2] = x9;
      x7 = XEXP (x5, 0);
      operands[4] = x7;
      x10 = XEXP (x4, 0);
      switch (GET_CODE (x10))
        {
        case AND:
          x11 = XEXP (x10, 0);
          switch (GET_CODE (x11))
            {
            case REG:
            case SUBREG:
              switch (pattern447 (x3))
                {
                case 0:
                  if (!
#line 691 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 2567; /* *fuse_and_eqv */

                case 1:
                  if (!(
#line 691 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                    return -1;
                  return 2568; /* *fuse_and_eqv */

                case 2:
                  if (!
#line 2167 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 2859; /* *fuse_vand_veqv */

                case 3:
                  if (!
#line 2167 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 2860; /* *fuse_vand_veqv */

                case 4:
                  if (!
#line 2167 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 2861; /* *fuse_vand_veqv */

                case 5:
                  if (!
#line 2167 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 2862; /* *fuse_vand_veqv */

                case 6:
                  if (!
#line 2167 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 2863; /* *fuse_vand_veqv */

                case 7:
                  if (!
#line 2167 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 2864; /* *fuse_vand_veqv */

                case 8:
                  if (!
#line 2167 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 2865; /* *fuse_vand_veqv */

                case 9:
                  if (!
#line 2167 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 2866; /* *fuse_vand_veqv */

                case 10:
                  if (!(
#line 2167 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
                    return -1;
                  return 2867; /* *fuse_vand_veqv */

                case 11:
                  if (!(
#line 2167 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
                    return -1;
                  return 2868; /* *fuse_vand_veqv */

                default:
                  return -1;
                }

            case NOT:
              x12 = XEXP (x11, 0);
              operands[0] = x12;
              x13 = XEXP (x10, 1);
              switch (GET_CODE (x13))
                {
                case REG:
                case SUBREG:
                  switch (pattern522 (x3))
                    {
                    case 0:
                      if (!
#line 709 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                        return -1;
                      return 2569; /* *fuse_andc_eqv */

                    case 1:
                      if (!(
#line 709 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                        return -1;
                      return 2570; /* *fuse_andc_eqv */

                    case 2:
                      if (!
#line 2185 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                        return -1;
                      return 2869; /* *fuse_vandc_veqv */

                    case 3:
                      if (!
#line 2185 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                        return -1;
                      return 2870; /* *fuse_vandc_veqv */

                    case 4:
                      if (!
#line 2185 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                        return -1;
                      return 2871; /* *fuse_vandc_veqv */

                    case 5:
                      if (!
#line 2185 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                        return -1;
                      return 2872; /* *fuse_vandc_veqv */

                    case 6:
                      if (!
#line 2185 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                        return -1;
                      return 2873; /* *fuse_vandc_veqv */

                    case 7:
                      if (!
#line 2185 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                        return -1;
                      return 2874; /* *fuse_vandc_veqv */

                    case 8:
                      if (!
#line 2185 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                        return -1;
                      return 2875; /* *fuse_vandc_veqv */

                    case 9:
                      if (!
#line 2185 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                        return -1;
                      return 2876; /* *fuse_vandc_veqv */

                    case 10:
                      if (!(
#line 2185 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
                        return -1;
                      return 2877; /* *fuse_vandc_veqv */

                    case 11:
                      if (!(
#line 2185 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
                        return -1;
                      return 2878; /* *fuse_vandc_veqv */

                    default:
                      return -1;
                    }

                case NOT:
                  switch (pattern525 (x3))
                    {
                    case 0:
                      if (!
#line 763 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                        return -1;
                      return 2575; /* *fuse_nor_eqv */

                    case 1:
                      if (!(
#line 763 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                        return -1;
                      return 2576; /* *fuse_nor_eqv */

                    case 2:
                      if (!
#line 2239 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                        return -1;
                      return 2899; /* *fuse_vnor_veqv */

                    case 3:
                      if (!
#line 2239 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                        return -1;
                      return 2900; /* *fuse_vnor_veqv */

                    case 4:
                      if (!
#line 2239 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                        return -1;
                      return 2901; /* *fuse_vnor_veqv */

                    case 5:
                      if (!
#line 2239 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                        return -1;
                      return 2902; /* *fuse_vnor_veqv */

                    case 6:
                      if (!
#line 2239 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                        return -1;
                      return 2903; /* *fuse_vnor_veqv */

                    case 7:
                      if (!
#line 2239 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                        return -1;
                      return 2904; /* *fuse_vnor_veqv */

                    case 8:
                      if (!
#line 2239 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                        return -1;
                      return 2905; /* *fuse_vnor_veqv */

                    case 9:
                      if (!
#line 2239 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                        return -1;
                      return 2906; /* *fuse_vnor_veqv */

                    case 10:
                      if (!(
#line 2239 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
                        return -1;
                      return 2907; /* *fuse_vnor_veqv */

                    case 11:
                      if (!(
#line 2239 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
                        return -1;
                      return 2908; /* *fuse_vnor_veqv */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case NOT:
          x11 = XEXP (x10, 0);
          if (GET_CODE (x11) != XOR)
            return -1;
          x12 = XEXP (x11, 0);
          operands[0] = x12;
          x14 = XEXP (x11, 1);
          operands[1] = x14;
          switch (GET_MODE (operands[3]))
            {
            case E_SImode:
              if (pattern543 (x3, 
E_SImode) != 0
                  || !
#line 727 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 2571; /* *fuse_eqv_eqv */

            case E_DImode:
              if (pattern543 (x3, 
E_DImode) != 0
                  || !(
#line 727 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 2572; /* *fuse_eqv_eqv */

            case E_V4SImode:
              if (pattern544 (x3, 
E_V4SImode) != 0
                  || !
#line 2203 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 2879; /* *fuse_veqv_veqv */

            case E_V8HImode:
              if (pattern544 (x3, 
E_V8HImode) != 0
                  || !
#line 2203 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 2880; /* *fuse_veqv_veqv */

            case E_V16QImode:
              if (pattern544 (x3, 
E_V16QImode) != 0
                  || !
#line 2203 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 2881; /* *fuse_veqv_veqv */

            case E_V4SFmode:
              if (pattern544 (x3, 
E_V4SFmode) != 0
                  || !
#line 2203 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 2882; /* *fuse_veqv_veqv */

            case E_V2DFmode:
              if (pattern544 (x3, 
E_V2DFmode) != 0
                  || !
#line 2203 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 2883; /* *fuse_veqv_veqv */

            case E_V2DImode:
              if (pattern544 (x3, 
E_V2DImode) != 0
                  || !
#line 2203 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 2884; /* *fuse_veqv_veqv */

            case E_V1TImode:
              if (pattern544 (x3, 
E_V1TImode) != 0
                  || !
#line 2203 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 2885; /* *fuse_veqv_veqv */

            case E_TImode:
              if (pattern544 (x3, 
E_TImode) != 0
                  || !
#line 2203 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 2886; /* *fuse_veqv_veqv */

            case E_KFmode:
              if (pattern544 (x3, 
E_KFmode) != 0
                  || !(
#line 2203 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
                return -1;
              return 2887; /* *fuse_veqv_veqv */

            case E_TFmode:
              if (pattern544 (x3, 
E_TFmode) != 0
                  || !(
#line 2203 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
                return -1;
              return 2888; /* *fuse_veqv_veqv */

            default:
              return -1;
            }

        case IOR:
          x11 = XEXP (x10, 0);
          switch (GET_CODE (x11))
            {
            case NOT:
              x12 = XEXP (x11, 0);
              operands[0] = x12;
              x13 = XEXP (x10, 1);
              switch (GET_CODE (x13))
                {
                case NOT:
                  switch (pattern525 (x3))
                    {
                    case 0:
                      if (!
#line 745 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                        return -1;
                      return 2573; /* *fuse_nand_eqv */

                    case 1:
                      if (!(
#line 745 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                        return -1;
                      return 2574; /* *fuse_nand_eqv */

                    case 2:
                      if (!
#line 2221 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                        return -1;
                      return 2889; /* *fuse_vnand_veqv */

                    case 3:
                      if (!
#line 2221 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                        return -1;
                      return 2890; /* *fuse_vnand_veqv */

                    case 4:
                      if (!
#line 2221 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                        return -1;
                      return 2891; /* *fuse_vnand_veqv */

                    case 5:
                      if (!
#line 2221 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                        return -1;
                      return 2892; /* *fuse_vnand_veqv */

                    case 6:
                      if (!
#line 2221 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                        return -1;
                      return 2893; /* *fuse_vnand_veqv */

                    case 7:
                      if (!
#line 2221 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                        return -1;
                      return 2894; /* *fuse_vnand_veqv */

                    case 8:
                      if (!
#line 2221 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                        return -1;
                      return 2895; /* *fuse_vnand_veqv */

                    case 9:
                      if (!
#line 2221 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                        return -1;
                      return 2896; /* *fuse_vnand_veqv */

                    case 10:
                      if (!(
#line 2221 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
                        return -1;
                      return 2897; /* *fuse_vnand_veqv */

                    case 11:
                      if (!(
#line 2221 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
                        return -1;
                      return 2898; /* *fuse_vnand_veqv */

                    default:
                      return -1;
                    }

                case REG:
                case SUBREG:
                  switch (pattern522 (x3))
                    {
                    case 0:
                      if (!
#line 799 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                        return -1;
                      return 2579; /* *fuse_orc_eqv */

                    case 1:
                      if (!(
#line 799 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                        return -1;
                      return 2580; /* *fuse_orc_eqv */

                    case 2:
                      if (!
#line 2275 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                        return -1;
                      return 2919; /* *fuse_vorc_veqv */

                    case 3:
                      if (!
#line 2275 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                        return -1;
                      return 2920; /* *fuse_vorc_veqv */

                    case 4:
                      if (!
#line 2275 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                        return -1;
                      return 2921; /* *fuse_vorc_veqv */

                    case 5:
                      if (!
#line 2275 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                        return -1;
                      return 2922; /* *fuse_vorc_veqv */

                    case 6:
                      if (!
#line 2275 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                        return -1;
                      return 2923; /* *fuse_vorc_veqv */

                    case 7:
                      if (!
#line 2275 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                        return -1;
                      return 2924; /* *fuse_vorc_veqv */

                    case 8:
                      if (!
#line 2275 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                        return -1;
                      return 2925; /* *fuse_vorc_veqv */

                    case 9:
                      if (!
#line 2275 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                        return -1;
                      return 2926; /* *fuse_vorc_veqv */

                    case 10:
                      if (!(
#line 2275 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
                        return -1;
                      return 2927; /* *fuse_vorc_veqv */

                    case 11:
                      if (!(
#line 2275 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
                        return -1;
                      return 2928; /* *fuse_vorc_veqv */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            case REG:
            case SUBREG:
              switch (pattern447 (x3))
                {
                case 0:
                  if (!
#line 781 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 2577; /* *fuse_or_eqv */

                case 1:
                  if (!(
#line 781 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                    return -1;
                  return 2578; /* *fuse_or_eqv */

                case 2:
                  if (!
#line 2257 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 2909; /* *fuse_vor_veqv */

                case 3:
                  if (!
#line 2257 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 2910; /* *fuse_vor_veqv */

                case 4:
                  if (!
#line 2257 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 2911; /* *fuse_vor_veqv */

                case 5:
                  if (!
#line 2257 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 2912; /* *fuse_vor_veqv */

                case 6:
                  if (!
#line 2257 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 2913; /* *fuse_vor_veqv */

                case 7:
                  if (!
#line 2257 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 2914; /* *fuse_vor_veqv */

                case 8:
                  if (!
#line 2257 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 2915; /* *fuse_vor_veqv */

                case 9:
                  if (!
#line 2257 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                    return -1;
                  return 2916; /* *fuse_vor_veqv */

                case 10:
                  if (!(
#line 2257 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
                    return -1;
                  return 2917; /* *fuse_vor_veqv */

                case 11:
                  if (!(
#line 2257 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
                    return -1;
                  return 2918; /* *fuse_vor_veqv */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case XOR:
          switch (pattern447 (x3))
            {
            case 0:
              if (!
#line 817 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 2581; /* *fuse_xor_eqv */

            case 1:
              if (!(
#line 817 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 2582; /* *fuse_xor_eqv */

            case 2:
              if (!
#line 2293 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 2929; /* *fuse_vxor_veqv */

            case 3:
              if (!
#line 2293 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 2930; /* *fuse_vxor_veqv */

            case 4:
              if (!
#line 2293 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 2931; /* *fuse_vxor_veqv */

            case 5:
              if (!
#line 2293 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 2932; /* *fuse_vxor_veqv */

            case 6:
              if (!
#line 2293 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 2933; /* *fuse_vxor_veqv */

            case 7:
              if (!
#line 2293 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 2934; /* *fuse_vxor_veqv */

            case 8:
              if (!
#line 2293 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 2935; /* *fuse_vxor_veqv */

            case 9:
              if (!
#line 2293 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              return 2936; /* *fuse_vxor_veqv */

            case 10:
              if (!(
#line 2293 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
                return -1;
              return 2937; /* *fuse_vxor_veqv */

            case 11:
              if (!(
#line 2293 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
                return -1;
              return 2938; /* *fuse_vxor_veqv */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_186 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  switch (GET_CODE (x2))
    {
    case SET:
      return recog_185 (x1, insn, pnum_clobbers);

    case CALL:
      x3 = XEXP (x2, 0);
      if (GET_CODE (x3) != MEM)
        return -1;
      if (pnum_clobbers != NULL)
        {
          switch (pattern117 (x1))
            {
            case 0:
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  if (current_file_function_operand (operands[0], E_SImode)
                      && (
#line 11491 "../../gcc/config/rs6000/rs6000.md"
((INTVAL (operands[2]) & CALL_LONG) == 0) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                    {
                      *pnum_clobbers = 1;
                      return 819; /* *call_localsi */
                    }
                  if (symbol_ref_operand (operands[0], E_SImode))
                    {
                      if ((
#line 11567 "../../gcc/config/rs6000/rs6000.md"
((DEFAULT_ABI == ABI_DARWIN
   || (DEFAULT_ABI == ABI_V4
       && (INTVAL (operands[2]) & CALL_LONG) == 0))) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                        {
                          *pnum_clobbers = 1;
                          return 825; /* *call_nonlocal_sysvsi */
                        }
                      if ((
#line 11688 "../../gcc/config/rs6000/rs6000.md"
((DEFAULT_ABI == ABI_AIX || DEFAULT_ABI == ABI_ELFv2)
   && (INTVAL (operands[2]) & CALL_LONG) == 0) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                        {
                          *pnum_clobbers = 1;
                          return 835; /* *call_nonlocal_aixsi */
                        }
                    }
                  break;

                case E_DImode:
                  if (current_file_function_operand (operands[0], E_DImode)
                      && (
#line 11491 "../../gcc/config/rs6000/rs6000.md"
((INTVAL (operands[2]) & CALL_LONG) == 0) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                    {
                      *pnum_clobbers = 1;
                      return 820; /* *call_localdi */
                    }
                  if (symbol_ref_operand (operands[0], E_DImode))
                    {
                      if ((
#line 11567 "../../gcc/config/rs6000/rs6000.md"
((DEFAULT_ABI == ABI_DARWIN
   || (DEFAULT_ABI == ABI_V4
       && (INTVAL (operands[2]) & CALL_LONG) == 0))) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                        {
                          *pnum_clobbers = 1;
                          return 826; /* *call_nonlocal_sysvdi */
                        }
                      if ((
#line 11688 "../../gcc/config/rs6000/rs6000.md"
((DEFAULT_ABI == ABI_AIX || DEFAULT_ABI == ABI_ELFv2)
   && (INTVAL (operands[2]) & CALL_LONG) == 0) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                        {
                          *pnum_clobbers = 1;
                          return 836; /* *call_nonlocal_aixdi */
                        }
                    }
                  break;

                default:
                  break;
                }
              break;

            case 1:
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  if (indirect_call_operand (operands[0], E_SImode))
                    {
                      if ((
#line 11539 "../../gcc/config/rs6000/rs6000.md"
(DEFAULT_ABI == ABI_V4
   || DEFAULT_ABI == ABI_DARWIN) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                        {
                          *pnum_clobbers = 1;
                          return 823; /* *call_indirect_nonlocal_sysvsi */
                        }
                      if ((
#line 11786 "../../gcc/config/rs6000/rs6000.md"
(rs6000_pcrel_p ()) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                        {
                          *pnum_clobbers = 1;
                          return 845; /* *call_indirect_pcrelsi */
                        }
                    }
                  break;

                case E_DImode:
                  if (indirect_call_operand (operands[0], E_DImode))
                    {
                      if ((
#line 11539 "../../gcc/config/rs6000/rs6000.md"
(DEFAULT_ABI == ABI_V4
   || DEFAULT_ABI == ABI_DARWIN) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                        {
                          *pnum_clobbers = 1;
                          return 824; /* *call_indirect_nonlocal_sysvdi */
                        }
                      if ((
#line 11786 "../../gcc/config/rs6000/rs6000.md"
(rs6000_pcrel_p ()) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                        {
                          *pnum_clobbers = 1;
                          return 846; /* *call_indirect_pcreldi */
                        }
                    }
                  break;

                default:
                  break;
                }
              break;

            default:
              break;
            }
        }
      if (GET_MODE (x3) != E_SImode)
        return -1;
      x4 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x4) != SIMPLE_RETURN)
        return -1;
      x5 = XEXP (x3, 0);
      operands[0] = x5;
      x6 = XEXP (x2, 1);
      operands[1] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!call_operand (operands[0], E_SImode)
              || !(
#line 12066 "../../gcc/config/rs6000/rs6000.md"
(DEFAULT_ABI == ABI_AIX || DEFAULT_ABI == ABI_ELFv2) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
            return -1;
          return 863; /* *sibcall_aixsi */

        case E_DImode:
          if (!call_operand (operands[0], E_DImode)
              || !(
#line 12066 "../../gcc/config/rs6000/rs6000.md"
(DEFAULT_ABI == ABI_AIX || DEFAULT_ABI == ABI_ELFv2) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
            return -1;
          return 864; /* *sibcall_aixdi */

        default:
          return -1;
        }

    case UNSPEC_VOLATILE:
      if (XVECLEN (x2, 0) != 1)
        return -1;
      x4 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x4) != CLOBBER)
        return -1;
      x7 = XVECEXP (x2, 0, 0);
      operands[0] = x7;
      x8 = XEXP (x4, 0);
      operands[1] = x8;
      switch (XINT (x2, 1))
        {
        case 4:
          switch (pattern356 ())
            {
            case 0:
              if (!
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT))
                return -1;
              return 1044; /* eh_set_lr_si */

            case 1:
              if (!
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT))
                return -1;
              return 1045; /* eh_set_lr_di */

            default:
              return -1;
            }

        case 5:
          if (GET_MODE (x2) != E_BLKmode
              || !scratch_operand (operands[1], E_CCmode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_QImode:
              if (!register_operand (operands[0], E_QImode))
                return -1;
              return 1217; /* loadsync_qi */

            case E_HImode:
              if (!register_operand (operands[0], E_HImode))
                return -1;
              return 1218; /* loadsync_hi */

            case E_SImode:
              if (!register_operand (operands[0], E_SImode))
                return -1;
              return 1219; /* loadsync_si */

            case E_DImode:
              if (!register_operand (operands[0], E_DImode)
                  || !
#line 111 "../../gcc/config/rs6000/sync.md"
(TARGET_POWERPC64))
                return -1;
              return 1220; /* loadsync_di */

            case E_TImode:
              if (!register_operand (operands[0], E_TImode)
                  || !
#line 112 "../../gcc/config/rs6000/sync.md"
(TARGET_SYNC_TI))
                return -1;
              return 1221; /* loadsync_ti */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 rtx_insn *
split_2 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case ZERO_EXTEND:
      switch (pattern178 (x1, 
ZERO_EXTEND))
        {
        case 0:
          if (!
#line 886 "../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[2], CCmode)))
            return NULL;
          return gen_split_1 (insn, operands);

        case 1:
          if (!
#line 940 "../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[2], CCmode)))
            return NULL;
          return gen_split_5 (insn, operands);

        case 2:
          if (!(
#line 490 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64) && 
#line 886 "../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[2], CCmode))))
            return NULL;
          return gen_split_2 (insn, operands);

        case 3:
          if (!(
#line 493 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64) && 
#line 940 "../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[2], CCmode))))
            return NULL;
          return gen_split_6 (insn, operands);

        case 4:
          if (!(
#line 496 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64) && 
#line 997 "../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[2], CCmode))))
            return NULL;
          return gen_split_9 (insn, operands);

        case 5:
          if (!
#line 907 "../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[2], CCmode)))
            return NULL;
          return gen_split_3 (insn, operands);

        case 6:
          if (!
#line 961 "../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[2], CCmode)))
            return NULL;
          return gen_split_7 (insn, operands);

        case 7:
          if (!(
#line 490 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64) && 
#line 907 "../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[2], CCmode))))
            return NULL;
          return gen_split_4 (insn, operands);

        case 8:
          if (!(
#line 493 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64) && 
#line 961 "../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[2], CCmode))))
            return NULL;
          return gen_split_8 (insn, operands);

        case 9:
          if (!(
#line 496 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64) && 
#line 1018 "../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[2], CCmode))))
            return NULL;
          return gen_split_10 (insn, operands);

        default:
          return NULL;
        }

    case SIGN_EXTEND:
      switch (pattern178 (x1, 
SIGN_EXTEND))
        {
        case 0:
          if (!
#line 1049 "../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[2], CCmode)))
            return NULL;
          return gen_split_11 (insn, operands);

        case 1:
          if (!
#line 1124 "../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[2], CCmode)))
            return NULL;
          return gen_split_17 (insn, operands);

        case 2:
          if (!(
#line 490 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64) && 
#line 1049 "../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[2], CCmode))))
            return NULL;
          return gen_split_12 (insn, operands);

        case 3:
          if (!(
#line 493 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64) && 
#line 1124 "../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[2], CCmode))))
            return NULL;
          return gen_split_18 (insn, operands);

        case 4:
          if (!(
#line 496 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64) && 
#line 1224 "../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[2], CCmode))))
            return NULL;
          return gen_split_23 (insn, operands);

        case 5:
          if (!
#line 1070 "../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[2], CCmode)))
            return NULL;
          return gen_split_13 (insn, operands);

        case 6:
          if (!
#line 1145 "../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[2], CCmode)))
            return NULL;
          return gen_split_19 (insn, operands);

        case 7:
          if (!(
#line 490 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64) && 
#line 1070 "../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[2], CCmode))))
            return NULL;
          return gen_split_14 (insn, operands);

        case 8:
          if (!(
#line 493 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64) && 
#line 1145 "../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[2], CCmode))))
            return NULL;
          return gen_split_20 (insn, operands);

        case 9:
          if (!(
#line 496 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64) && 
#line 1245 "../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[2], CCmode))))
            return NULL;
          return gen_split_24 (insn, operands);

        default:
          return NULL;
        }

    case PLUS:
      switch (pattern204 (x1, 
PLUS))
        {
        case 0:
          if (!(
#line 1872 "../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode) && 
#line 1876 "../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[3], CCmode))))
            return NULL;
          return gen_split_25 (insn, operands);

        case 1:
          if (!((
#line 1872 "../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 1876 "../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[3], CCmode))))
            return NULL;
          return gen_split_26 (insn, operands);

        case 2:
          if (!(
#line 1896 "../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode) && 
#line 1900 "../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[3], CCmode))))
            return NULL;
          return gen_split_27 (insn, operands);

        case 3:
          if (!((
#line 1896 "../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 1900 "../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[3], CCmode))))
            return NULL;
          return gen_split_28 (insn, operands);

        default:
          return NULL;
        }

    case NOT:
      switch (pattern181 (x1, 
NOT))
        {
        case 0:
          if (!(
#line 2132 "../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode) && 
#line 2136 "../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[2], CCmode))))
            return NULL;
          return gen_split_35 (insn, operands);

        case 1:
          if (!((
#line 2132 "../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 2136 "../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[2], CCmode))))
            return NULL;
          return gen_split_36 (insn, operands);

        case 2:
          if (!(
#line 2153 "../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode) && 
#line 2157 "../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[2], CCmode))))
            return NULL;
          return gen_split_37 (insn, operands);

        case 3:
          if (!((
#line 2153 "../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 2157 "../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[2], CCmode))))
            return NULL;
          return gen_split_38 (insn, operands);

        default:
          return NULL;
        }

    case MINUS:
      x5 = XEXP (x3, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return NULL;
      x6 = XEXP (x2, 0);
      operands[3] = x6;
      if (!cc_reg_operand (operands[3], E_CCmode)
          || GET_MODE (x3) != E_CCmode)
        return NULL;
      x7 = XEXP (x4, 0);
      operands[2] = x7;
      x8 = XEXP (x4, 1);
      operands[1] = x8;
      switch (pattern486 (x1))
        {
        case 0:
          if (!(
#line 2215 "../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode) && 
#line 2219 "../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[3], CCmode))))
            return NULL;
          return gen_split_39 (insn, operands);

        case 1:
          if (!((
#line 2215 "../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 2219 "../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[3], CCmode))))
            return NULL;
          return gen_split_40 (insn, operands);

        case 2:
          if (!(
#line 2239 "../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode) && 
#line 2243 "../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[3], CCmode))))
            return NULL;
          return gen_split_41 (insn, operands);

        case 3:
          if (!((
#line 2239 "../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 2243 "../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[3], CCmode))))
            return NULL;
          return gen_split_42 (insn, operands);

        default:
          return NULL;
        }

    case NEG:
      switch (pattern181 (x1, 
NEG))
        {
        case 0:
          if (!(
#line 2410 "../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode) && 
#line 2414 "../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[2], CCmode))))
            return NULL;
          return gen_split_46 (insn, operands);

        case 1:
          if (!((
#line 2410 "../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 2414 "../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[2], CCmode))))
            return NULL;
          return gen_split_47 (insn, operands);

        case 2:
          if (!(
#line 2431 "../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode) && 
#line 2435 "../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[2], CCmode))))
            return NULL;
          return gen_split_48 (insn, operands);

        case 3:
          if (!((
#line 2431 "../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 2435 "../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[2], CCmode))))
            return NULL;
          return gen_split_49 (insn, operands);

        default:
          return NULL;
        }

    case MULT:
      switch (pattern204 (x1, 
MULT))
        {
        case 0:
          if (!(
#line 3124 "../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode) && 
#line 3128 "../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[3], CCmode))))
            return NULL;
          return gen_split_58 (insn, operands);

        case 1:
          if (!((
#line 3124 "../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 3128 "../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[3], CCmode))))
            return NULL;
          return gen_split_59 (insn, operands);

        case 2:
          if (!(
#line 3149 "../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode) && 
#line 3153 "../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[3], CCmode))))
            return NULL;
          return gen_split_60 (insn, operands);

        case 3:
          if (!((
#line 3149 "../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 3153 "../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[3], CCmode))))
            return NULL;
          return gen_split_61 (insn, operands);

        default:
          return NULL;
        }

    case AND:
    case IOR:
    case XOR:
      x5 = XEXP (x3, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return NULL;
      x6 = XEXP (x2, 0);
      if (!cc_reg_operand (x6, E_CCmode)
          || GET_MODE (x3) != E_CCmode)
        return NULL;
      if (GET_CODE (x4) == AND)
        {
          res = split_1 (x1, insn);
          if (res != NULL_RTX)
            return res;
        }
      operands[4] = x6;
      switch (pattern391 (x1))
        {
        case 0:
          if (!(
#line 4016 "../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode) && 
#line 4020 "../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[4], CCmode))))
            return NULL;
          return gen_split_89 (insn, operands);

        case 1:
          if (!((
#line 4016 "../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 4020 "../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[4], CCmode))))
            return NULL;
          return gen_split_90 (insn, operands);

        case 2:
          if (!(
#line 4039 "../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode) && 
#line 4043 "../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[4], CCmode))))
            return NULL;
          return gen_split_91 (insn, operands);

        case 3:
          if (!((
#line 4039 "../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 4043 "../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[4], CCmode))))
            return NULL;
          return gen_split_92 (insn, operands);

        case 4:
          if (!(
#line 4071 "../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode) && 
#line 4075 "../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[4], CCmode))))
            return NULL;
          return gen_split_93 (insn, operands);

        case 5:
          if (!((
#line 4071 "../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 4075 "../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[4], CCmode))))
            return NULL;
          return gen_split_94 (insn, operands);

        case 6:
          if (!(
#line 4094 "../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode) && 
#line 4098 "../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[4], CCmode))))
            return NULL;
          return gen_split_95 (insn, operands);

        case 7:
          if (!((
#line 4094 "../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 4098 "../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[4], CCmode))))
            return NULL;
          return gen_split_96 (insn, operands);

        case 8:
          if (!(
#line 4126 "../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode) && 
#line 4130 "../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[4], CCmode))))
            return NULL;
          return gen_split_97 (insn, operands);

        case 9:
          if (!((
#line 4126 "../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 4130 "../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[4], CCmode))))
            return NULL;
          return gen_split_98 (insn, operands);

        case 10:
          if (!(
#line 4149 "../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode) && 
#line 4153 "../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[4], CCmode))))
            return NULL;
          return gen_split_99 (insn, operands);

        case 11:
          if (!((
#line 4149 "../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 4153 "../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[4], CCmode))))
            return NULL;
          return gen_split_100 (insn, operands);

        default:
          return NULL;
        }

    case ROTATE:
      switch (pattern184 (x1, 
ROTATE))
        {
        case 0:
          if (!(
#line 4590 "../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode) && 
#line 4594 "../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[3], CCmode))))
            return NULL;
          return gen_split_129 (insn, operands);

        case 1:
          if (!((
#line 4590 "../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 4594 "../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[3], CCmode))))
            return NULL;
          return gen_split_130 (insn, operands);

        case 2:
          if (!(
#line 4615 "../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode) && 
#line 4619 "../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[3], CCmode))))
            return NULL;
          return gen_split_131 (insn, operands);

        case 3:
          if (!((
#line 4615 "../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 4619 "../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[3], CCmode))))
            return NULL;
          return gen_split_132 (insn, operands);

        default:
          return NULL;
        }

    case ASHIFT:
      switch (pattern185 (x1))
        {
        case 0:
          if (!(
#line 4658 "../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode) && 
#line 4662 "../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[3], CCmode))))
            return NULL;
          return gen_split_133 (insn, operands);

        case 1:
          if (!((
#line 4658 "../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 4662 "../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[3], CCmode))))
            return NULL;
          return gen_split_134 (insn, operands);

        case 2:
          if (!(
#line 4683 "../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode) && 
#line 4687 "../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[3], CCmode))))
            return NULL;
          return gen_split_135 (insn, operands);

        case 3:
          if (!((
#line 4683 "../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 4687 "../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[3], CCmode))))
            return NULL;
          return gen_split_136 (insn, operands);

        case 4:
          if (!(
#line 4732 "../../gcc/config/rs6000/rs6000.md"
(TARGET_EXTSWSLI) && 
#line 4738 "../../gcc/config/rs6000/rs6000.md"
( reload_completed
   && (cc_reg_not_cr0_operand (operands[3], CCmode)
       || memory_operand (operands[1], SImode)))))
            return NULL;
          return gen_split_138 (insn, operands);

        case 5:
          if (!(
#line 4782 "../../gcc/config/rs6000/rs6000.md"
(TARGET_EXTSWSLI) && 
#line 4788 "../../gcc/config/rs6000/rs6000.md"
( reload_completed
   && (cc_reg_not_cr0_operand (operands[3], CCmode)
       || memory_operand (operands[1], SImode)))))
            return NULL;
          return gen_split_139 (insn, operands);

        default:
          return NULL;
        }

    case LSHIFTRT:
      switch (pattern184 (x1, 
LSHIFTRT))
        {
        case 0:
          if (!(
#line 4847 "../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode) && 
#line 4851 "../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[3], CCmode))))
            return NULL;
          return gen_split_140 (insn, operands);

        case 1:
          if (!((
#line 4847 "../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 4851 "../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[3], CCmode))))
            return NULL;
          return gen_split_141 (insn, operands);

        case 2:
          if (!(
#line 4872 "../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode) && 
#line 4876 "../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[3], CCmode))))
            return NULL;
          return gen_split_142 (insn, operands);

        case 3:
          if (!((
#line 4872 "../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 4876 "../../gcc/config/rs6000/rs6000.md"
( reload_completed && cc_reg_not_cr0_operand (operands[3], CCmode))))
            return NULL;
          return gen_split_143 (insn, operands);

        default:
          return NULL;
        }

    case REG:
    case SUBREG:
      operands[1] = x4;
      x5 = XEXP (x3, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return NULL;
      x9 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x9) != SET)
        return NULL;
      x6 = XEXP (x2, 0);
      operands[2] = x6;
      if (!cc_reg_not_cr0_operand (operands[2], E_CCmode))
        return NULL;
      switch (pattern442 (x1))
        {
        case 0:
          if (!(
#line 8088 "../../gcc/config/rs6000/rs6000.md"
(reload_completed) && 
#line 513 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWERPC64)))
            return NULL;
          return gen_split_297 (insn, operands);

        case 1:
          if (!(
#line 8088 "../../gcc/config/rs6000/rs6000.md"
(reload_completed) && 
#line 513 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return NULL;
          return gen_split_298 (insn, operands);

        default:
          return NULL;
        }

    case MEM:
      switch (pattern190 (x1))
        {
        case 0:
          if (!(
#line 28 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 30 "../../gcc/config/rs6000/fusion.md"
( reload_completed
   && (cc_reg_not_cr0_operand (operands[2], CCmode)
       || !address_is_non_pfx_d_or_x (XEXP (operands[1], 0),
                                      DImode, NON_PREFIXED_DS)))))
            return NULL;
          return gen_split_744 (insn, operands);

        case 1:
          if (!(
#line 112 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 114 "../../gcc/config/rs6000/fusion.md"
( reload_completed
   && (cc_reg_not_cr0_operand (operands[2], CCmode)
       || !address_is_non_pfx_d_or_x (XEXP (operands[1], 0),
                                      SImode, NON_PREFIXED_D)))))
            return NULL;
          return gen_split_748 (insn, operands);

        case 2:
          if (!(
#line 239 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 241 "../../gcc/config/rs6000/fusion.md"
( reload_completed
   && (cc_reg_not_cr0_operand (operands[2], CCmode)
       || !address_is_non_pfx_d_or_x (XEXP (operands[1], 0),
                                      HImode, NON_PREFIXED_D)))))
            return NULL;
          return gen_split_754 (insn, operands);

        case 3:
          if (!((
#line 239 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 241 "../../gcc/config/rs6000/fusion.md"
( reload_completed
   && (cc_reg_not_cr0_operand (operands[2], CCmode)
       || !address_is_non_pfx_d_or_x (XEXP (operands[1], 0),
                                      HImode, NON_PREFIXED_D)))))
            return NULL;
          return gen_split_755 (insn, operands);

        case 4:
          if (!(
#line 49 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 51 "../../gcc/config/rs6000/fusion.md"
( reload_completed
   && (cc_reg_not_cr0_operand (operands[2], CCmode)
       || !address_is_non_pfx_d_or_x (XEXP (operands[1], 0),
                                      DImode, NON_PREFIXED_DS)))))
            return NULL;
          return gen_split_745 (insn, operands);

        case 5:
          if (!(
#line 133 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 135 "../../gcc/config/rs6000/fusion.md"
( reload_completed
   && (cc_reg_not_cr0_operand (operands[2], CCmode)
       || !address_is_non_pfx_d_or_x (XEXP (operands[1], 0),
                                      SImode, NON_PREFIXED_D)))))
            return NULL;
          return gen_split_749 (insn, operands);

        case 6:
          if (!(
#line 260 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 262 "../../gcc/config/rs6000/fusion.md"
( reload_completed
   && (cc_reg_not_cr0_operand (operands[2], CCmode)
       || !address_is_non_pfx_d_or_x (XEXP (operands[1], 0),
                                      HImode, NON_PREFIXED_D)))))
            return NULL;
          return gen_split_756 (insn, operands);

        case 7:
          if (!((
#line 260 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 262 "../../gcc/config/rs6000/fusion.md"
( reload_completed
   && (cc_reg_not_cr0_operand (operands[2], CCmode)
       || !address_is_non_pfx_d_or_x (XEXP (operands[1], 0),
                                      HImode, NON_PREFIXED_D)))))
            return NULL;
          return gen_split_757 (insn, operands);

        case 8:
          if (!(
#line 323 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 325 "../../gcc/config/rs6000/fusion.md"
( reload_completed
   && (cc_reg_not_cr0_operand (operands[2], CCmode)
       || !address_is_non_pfx_d_or_x (XEXP (operands[1], 0),
                                      QImode, NON_PREFIXED_D)))))
            return NULL;
          return gen_split_762 (insn, operands);

        case 9:
          if (!((
#line 323 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 325 "../../gcc/config/rs6000/fusion.md"
( reload_completed
   && (cc_reg_not_cr0_operand (operands[2], CCmode)
       || !address_is_non_pfx_d_or_x (XEXP (operands[1], 0),
                                      QImode, NON_PREFIXED_D)))))
            return NULL;
          return gen_split_763 (insn, operands);

        case 10:
          if (!(
#line 70 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 72 "../../gcc/config/rs6000/fusion.md"
( reload_completed
   && (cc_reg_not_cr0_operand (operands[2], CCmode)
       || !address_is_non_pfx_d_or_x (XEXP (operands[1], 0),
                                      DImode, NON_PREFIXED_DS)))))
            return NULL;
          return gen_split_746 (insn, operands);

        case 11:
          if (!(
#line 154 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 156 "../../gcc/config/rs6000/fusion.md"
( reload_completed
   && (cc_reg_not_cr0_operand (operands[2], CCmode)
       || !address_is_non_pfx_d_or_x (XEXP (operands[1], 0),
                                      SImode, NON_PREFIXED_D)))))
            return NULL;
          return gen_split_750 (insn, operands);

        case 12:
          if (!(
#line 91 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 93 "../../gcc/config/rs6000/fusion.md"
( reload_completed
   && (cc_reg_not_cr0_operand (operands[2], CCmode)
       || !address_is_non_pfx_d_or_x (XEXP (operands[1], 0),
                                      DImode, NON_PREFIXED_DS)))))
            return NULL;
          return gen_split_747 (insn, operands);

        case 13:
          if (!(
#line 175 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 177 "../../gcc/config/rs6000/fusion.md"
( reload_completed
   && (cc_reg_not_cr0_operand (operands[2], CCmode)
       || !address_is_non_pfx_d_or_x (XEXP (operands[1], 0),
                                      SImode, NON_PREFIXED_D)))))
            return NULL;
          return gen_split_751 (insn, operands);

        case 14:
          if (!((
#line 196 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 496 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 198 "../../gcc/config/rs6000/fusion.md"
( reload_completed
   && (cc_reg_not_cr0_operand (operands[2], CCmode)
       || !address_is_non_pfx_d_or_x (XEXP (operands[1], 0),
                                      SImode, NON_PREFIXED_DS)))))
            return NULL;
          return gen_split_752 (insn, operands);

        case 15:
          if (!(
#line 281 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 283 "../../gcc/config/rs6000/fusion.md"
( reload_completed
   && (cc_reg_not_cr0_operand (operands[2], CCmode)
       || !address_is_non_pfx_d_or_x (XEXP (operands[1], 0),
                                      HImode, NON_PREFIXED_D)))))
            return NULL;
          return gen_split_758 (insn, operands);

        case 16:
          if (!((
#line 281 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 493 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 283 "../../gcc/config/rs6000/fusion.md"
( reload_completed
   && (cc_reg_not_cr0_operand (operands[2], CCmode)
       || !address_is_non_pfx_d_or_x (XEXP (operands[1], 0),
                                      HImode, NON_PREFIXED_D)))))
            return NULL;
          return gen_split_759 (insn, operands);

        case 17:
          if (!((
#line 218 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 496 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 220 "../../gcc/config/rs6000/fusion.md"
( reload_completed
   && (cc_reg_not_cr0_operand (operands[2], CCmode)
       || !address_is_non_pfx_d_or_x (XEXP (operands[1], 0),
                                      SImode, NON_PREFIXED_D)))))
            return NULL;
          return gen_split_753 (insn, operands);

        case 18:
          if (!(
#line 302 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 304 "../../gcc/config/rs6000/fusion.md"
( reload_completed
   && (cc_reg_not_cr0_operand (operands[2], CCmode)
       || !address_is_non_pfx_d_or_x (XEXP (operands[1], 0),
                                      HImode, NON_PREFIXED_D)))))
            return NULL;
          return gen_split_760 (insn, operands);

        case 19:
          if (!((
#line 302 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 493 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 304 "../../gcc/config/rs6000/fusion.md"
( reload_completed
   && (cc_reg_not_cr0_operand (operands[2], CCmode)
       || !address_is_non_pfx_d_or_x (XEXP (operands[1], 0),
                                      HImode, NON_PREFIXED_D)))))
            return NULL;
          return gen_split_761 (insn, operands);

        case 20:
          if (!(
#line 344 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 346 "../../gcc/config/rs6000/fusion.md"
( reload_completed
   && (cc_reg_not_cr0_operand (operands[2], CCmode)
       || !address_is_non_pfx_d_or_x (XEXP (operands[1], 0),
                                      QImode, NON_PREFIXED_D)))))
            return NULL;
          return gen_split_764 (insn, operands);

        case 21:
          if (!((
#line 344 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 346 "../../gcc/config/rs6000/fusion.md"
( reload_completed
   && (cc_reg_not_cr0_operand (operands[2], CCmode)
       || !address_is_non_pfx_d_or_x (XEXP (operands[1], 0),
                                      QImode, NON_PREFIXED_D)))))
            return NULL;
          return gen_split_765 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
peephole2_1 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19;
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (peep2_current_count < 4
      || !logical_const_operand (operands[1], E_SImode)
      || !register_operand (operands[0], E_SImode))
    return NULL;
  x2 = PATTERN (peep2_next_insn (1));
  x3 = XEXP (x2, 1);
  if (!boolean_or_operator (x3, E_SImode))
    return NULL;
  operands[3] = x3;
  x4 = XEXP (x3, 1);
  operands[2] = x4;
  if (!logical_const_operand (operands[2], E_SImode))
    return NULL;
  x5 = XEXP (x3, 0);
  if (!rtx_equal_p (x5, operands[0]))
    return NULL;
  x6 = XEXP (x2, 0);
  if (!rtx_equal_p (x6, operands[0]))
    return NULL;
  x7 = PATTERN (peep2_next_insn (2));
  if (GET_CODE (x7) != SET)
    return NULL;
  x8 = XEXP (x7, 1);
  if (GET_CODE (x8) != COMPARE
      || GET_MODE (x8) != E_CCmode)
    return NULL;
  x9 = XEXP (x7, 0);
  operands[4] = x9;
  if (!cc_reg_operand (operands[4], E_CCmode))
    return NULL;
  x10 = XEXP (x8, 0);
  operands[5] = x10;
  if (!gpc_reg_operand (operands[5], E_SImode))
    return NULL;
  x11 = XEXP (x8, 1);
  if (!rtx_equal_p (x11, operands[0]))
    return NULL;
  x12 = PATTERN (peep2_next_insn (3));
  if (GET_CODE (x12) != SET)
    return NULL;
  x13 = XEXP (x12, 1);
  if (GET_CODE (x13) != IF_THEN_ELSE)
    return NULL;
  x14 = XEXP (x13, 0);
  if (!equality_operator (x14, E_VOIDmode))
    return NULL;
  operands[6] = x14;
  x15 = XEXP (x14, 1);
  if (x15 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return NULL;
  x16 = XEXP (x12, 0);
  if (GET_CODE (x16) != PC)
    return NULL;
  x17 = XEXP (x13, 1);
  operands[7] = x17;
  x18 = XEXP (x13, 2);
  operands[8] = x18;
  x19 = XEXP (x14, 0);
  if (!rtx_equal_p (x19, operands[4])
      || !
#line 12677 "../../gcc/config/rs6000/rs6000.md"
(peep2_reg_dead_p (3, operands[0])
   && peep2_reg_dead_p (4, operands[4])
   && REGNO (operands[0]) != REGNO (operands[5])))
    return NULL;
  *pmatch_len_ = 3;
  return gen_peephole2_13 (insn, operands);
}
