/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern6 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!vsx_register_operand (operands[1], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  switch (XWINT (x2, 0))
    {
    case 0L:
      x3 = XVECEXP (x1, 0, 1);
      if (XWINT (x3, 0) != 2L)
        return -1;
      return 0;

    case 1L:
      x3 = XVECEXP (x1, 0, 1);
      if (XWINT (x3, 0) != 3L)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern15 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V4SImode:
      return pattern3 (x3, 
E_V4SImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern3 (x3, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V16QImode:
      if (pattern3 (x3, 
E_V16QImode) != 0)
        return -1;
      return 2;

    case E_V2DImode:
      if (pattern3 (x3, 
E_V2DImode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern26 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!reg_or_cint_operand (operands[2], E_SImode))
    return -1;
  switch (GET_MODE (x1))
    {
    case E_SImode:
      if (!gpc_reg_operand (operands[1], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!gpc_reg_operand (operands[1], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern31 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (x1))
    {
    case E_SImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_SImode
          || !register_operand (operands[1], E_SImode)
          || !register_operand (operands[2], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_DImode
          || !register_operand (operands[1], E_DImode)
          || !register_operand (operands[2], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern37 (rtx x1, machine_mode i1, int i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i3)
    return -1;
  x4 = XEXP (x2, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + i2]
      || !gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  return 0;
}

int
pattern43 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !gpc_reg_operand (operands[0], i1))
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != i1
      || !gpc_reg_operand (operands[1], i1)
      || !gpc_reg_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern54 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!altivec_register_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !altivec_register_operand (operands[0], i1)
      || !altivec_register_operand (operands[1], i1)
      || !altivec_register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern61 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!altivec_register_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !altivec_register_operand (operands[0], i1)
      || !altivec_register_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !altivec_register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern68 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != PARALLEL)
    return -1;
  x4 = XEXP (x2, 0);
  operands[1] = x4;
  switch (XVECLEN (x3, 0))
    {
    case 2:
      x5 = XVECEXP (x3, 0, 0);
      if (GET_CODE (x5) != CONST_INT)
        return -1;
      x6 = XVECEXP (x3, 0, 1);
      if (GET_CODE (x6) != CONST_INT
          || !vsx_register_operand (operands[0], E_V2DFmode)
          || GET_MODE (x1) != E_V2DFmode
          || GET_MODE (x2) != E_V2SImode)
        return -1;
      return pattern6 (x3, 
E_V4SImode); /* [-1, 1] */

    case 1:
      if (pnum_clobbers == NULL)
        return -1;
      x5 = XVECEXP (x3, 0, 0);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_DFmode:
          res = pattern67 (x1, 
E_DFmode);
          if (res >= 0)
            return res + 2; /* [2, 4] */
          return -1;

        case E_SFmode:
          res = pattern67 (x1, 
E_SFmode);
          if (res >= 0)
            return res + 5; /* [5, 7] */
          return -1;

        case E_IFmode:
          if (!gpc_reg_operand (operands[0], E_IFmode)
              || GET_MODE (x1) != E_IFmode
              || GET_MODE (x2) != E_SImode
              || !gpc_reg_operand (operands[1], E_V4SImode)
              || !const_0_to_3_operand (operands[2], E_QImode))
            return -1;
          return 8;

        case E_KFmode:
          res = pattern67 (x1, 
E_KFmode);
          if (res >= 0)
            return res + 9; /* [9, 11] */
          return -1;

        case E_TFmode:
          res = pattern67 (x1, 
E_TFmode);
          if (res >= 0)
            return res + 12; /* [12, 14] */
          return -1;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern86 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !vector_shift_constant (operands[2], i1)
      || !scratch_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern91 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[2], i1)
      || !gpc_reg_operand (operands[1], i1)
      || !gpc_reg_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XEXP (x4, 1);
  if (GET_MODE (x6) != i1)
    return -1;
  return 0;
}

int
pattern100 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != PARALLEL
      || XVECLEN (x5, 0) != 1)
    return -1;
  x6 = XEXP (x4, 0);
  operands[1] = x6;
  if (!gpc_reg_operand (operands[1], E_V4SImode))
    return -1;
  x7 = XVECEXP (x5, 0, 0);
  operands[2] = x7;
  if (!const_0_to_3_operand (operands[2], E_QImode))
    return -1;
  x8 = XVECEXP (x1, 0, 1);
  x9 = XEXP (x8, 0);
  operands[3] = x9;
  if (!scratch_operand (operands[3], E_V4SImode))
    return -1;
  x10 = XVECEXP (x1, 0, 2);
  x11 = XEXP (x10, 0);
  operands[4] = x11;
  if (!scratch_operand (operands[4], E_DFmode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      if (!gpc_reg_operand (operands[0], E_SFmode)
          || GET_MODE (x3) != E_SFmode)
        return -1;
      return 0;

    case E_IFmode:
      if (!gpc_reg_operand (operands[0], E_IFmode)
          || GET_MODE (x3) != E_IFmode)
        return -1;
      return 1;

    case E_KFmode:
      if (!gpc_reg_operand (operands[0], E_KFmode)
          || GET_MODE (x3) != E_KFmode)
        return -1;
      return 2;

    case E_TFmode:
      if (!gpc_reg_operand (operands[0], E_TFmode)
          || GET_MODE (x3) != E_TFmode)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern113 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !scratch_operand (operands[3], i1)
      || !scratch_operand (operands[4], i1))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_SImode:
      if (!gpc_reg_operand (operands[1], E_SImode)
          || !reg_or_u_short_operand (operands[2], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!gpc_reg_operand (operands[1], E_DImode)
          || !reg_or_u_short_operand (operands[2], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern122 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[3] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  x6 = XEXP (x4, 1);
  operands[1] = x6;
  x7 = XEXP (x3, 1);
  operands[2] = x7;
  switch (GET_MODE (operands[3]))
    {
    case E_SImode:
      return pattern41 (x3, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern41 (x3, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern132 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!vsx_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !vsx_register_operand (operands[1], i1)
      || !vsx_register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern136 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_CCmode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!cc_reg_operand (operands[0], E_CCmode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!gpc_reg_operand (operands[1], E_SImode))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!gpc_reg_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern144 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V4SFmode:
      return pattern141 (x3, 
E_V4SFmode); /* [-1, 0] */

    case E_V4SImode:
      if (pattern141 (x3, 
E_V4SImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern154 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      if (!gpc_reg_operand (operands[0], E_SFmode)
          || GET_MODE (x3) != E_SFmode
          || !gpc_reg_operand (operands[1], E_SFmode))
        return -1;
      return 0;

    case E_DFmode:
      if (!gpc_reg_operand (operands[0], E_DFmode)
          || GET_MODE (x3) != E_DFmode
          || !gpc_reg_operand (operands[1], E_DFmode))
        return -1;
      return 1;

    case E_V4SFmode:
      if (GET_MODE (x3) != E_V4SFmode)
        return -1;
      return 2;

    case E_V2DFmode:
      if (!vsx_register_operand (operands[0], E_V2DFmode)
          || GET_MODE (x3) != E_V2DFmode
          || !vsx_register_operand (operands[1], E_V2DFmode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern166 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_V16QImode)
    return -1;
  x3 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x3) != MEM
      || GET_MODE (x3) != E_V16QImode)
    return -1;
  x4 = XEXP (x1, 0);
  if (GET_CODE (x4) != MEM
      || GET_MODE (x4) != E_V16QImode)
    return -1;
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  if (!gpc_reg_operand (operands[1], E_DImode))
    return -1;
  x6 = XVECEXP (x2, 0, 0);
  operands[0] = x6;
  if (!vsx_register_operand (operands[0], E_V16QImode))
    return -1;
  x7 = XVECEXP (x2, 0, 2);
  operands[2] = x7;
  if (!register_operand (operands[2], E_DImode))
    return -1;
  x8 = XEXP (x3, 0);
  if (!rtx_equal_p (x8, operands[1]))
    return -1;
  return 0;
}

int
pattern174 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !gpc_reg_operand (operands[1], i1)
      || !scc_eq_operand (operands[2], i1)
      || !gpc_reg_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern179 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  x6 = XEXP (x5, 0);
  switch (GET_MODE (x6))
    {
    case E_SImode:
      if (!gpc_reg_operand (operands[1], E_SImode)
          || !scratch_operand (operands[0], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!gpc_reg_operand (operands[1], E_DImode)
          || !scratch_operand (operands[0], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern185 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x2, 0);
  operands[3] = x5;
  if (!cc_reg_operand (operands[3], E_CCmode)
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x6 = XEXP (x3, 0);
  x7 = XEXP (x6, 1);
  operands[2] = x7;
  x8 = XEXP (x6, 0);
  switch (GET_CODE (x8))
    {
    case REG:
    case SUBREG:
      operands[1] = x8;
      if (!reg_or_cint_operand (operands[2], E_SImode))
        return -1;
      x9 = XVECEXP (x1, 0, 1);
      switch (GET_CODE (x9))
        {
        case CLOBBER:
          return pattern179 (x1); /* [-1, 1] */

        case SET:
          x10 = XEXP (x9, 1);
          if (GET_CODE (x10) != ASHIFT)
            return -1;
          res = pattern183 (x1);
          if (res >= 0)
            return res + 2; /* [2, 3] */
          return -1;

        default:
          return -1;
        }

    case SIGN_EXTEND:
      if (GET_MODE (x8) != E_DImode
          || GET_MODE (x6) != E_DImode)
        return -1;
      x11 = XEXP (x8, 0);
      operands[1] = x11;
      if (!reg_or_mem_operand (operands[1], E_SImode)
          || !u6bit_cint_operand (operands[2], E_DImode))
        return -1;
      x9 = XVECEXP (x1, 0, 1);
      switch (GET_CODE (x9))
        {
        case CLOBBER:
          x12 = XEXP (x9, 0);
          operands[0] = x12;
          if (!scratch_operand (operands[0], E_DImode))
            return -1;
          return 4;

        case SET:
          x10 = XEXP (x9, 1);
          if (GET_CODE (x10) != ASHIFT
              || GET_MODE (x10) != E_DImode)
            return -1;
          x13 = XEXP (x10, 0);
          if (GET_CODE (x13) != SIGN_EXTEND
              || GET_MODE (x13) != E_DImode)
            return -1;
          x12 = XEXP (x9, 0);
          operands[0] = x12;
          if (!gpc_reg_operand (operands[0], E_DImode))
            return -1;
          x14 = XEXP (x13, 0);
          if (!rtx_equal_p (x14, operands[1]))
            return -1;
          x15 = XEXP (x10, 1);
          if (!rtx_equal_p (x15, operands[2]))
            return -1;
          return 5;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern214 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!vsx_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !vsx_register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern222 (rtx x1, machine_mode i1, unsigned int i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_SImode)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != i2
      || GET_MODE (x2) != i1)
    return -1;
  return 0;
}

int
pattern227 (rtx x1, machine_mode i1, int i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XEXP (x2, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 106
      || GET_MODE (x4) != E_CCmode)
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x5) != SET)
    return -1;
  x6 = XEXP (x5, 1);
  if (GET_CODE (x6) != UNSPEC
      || XVECLEN (x6, 0) != 2
      || XINT (x6, 1) != i2
      || GET_MODE (x6) != i1)
    return -1;
  return 0;
}

int
pattern234 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!altivec_register_operand (operands[1], i1)
      || GET_MODE (x1) != i1
      || !altivec_register_operand (operands[2], i1)
      || !scratch_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern239 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!altivec_register_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !altivec_register_operand (operands[0], i1)
      || !altivec_register_operand (operands[1], i1)
      || !altivec_register_operand (operands[2], i1)
      || !scratch_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern248 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[3] = x3;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 0);
  operands[4] = x5;
  x6 = XEXP (x2, 1);
  x7 = XEXP (x6, 0);
  x8 = XEXP (x7, 0);
  switch (GET_CODE (x8))
    {
    case NOT:
      x9 = XEXP (x8, 0);
      operands[0] = x9;
      x10 = XEXP (x7, 1);
      switch (GET_CODE (x10))
        {
        case NOT:
          return pattern246 (x6); /* [-1, 23] */

        case REG:
        case SUBREG:
          res = pattern242 (x6);
          if (res >= 0)
            return res + 24; /* [24, 47] */
          return -1;

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      res = pattern237 (x6);
      if (res >= 0)
        return res + 48; /* [48, 71] */
      return -1;

    default:
      return -1;
    }
}

int
pattern259 (rtx x1, machine_mode i1, machine_mode i2, unsigned int i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != i3
      || GET_MODE (x3) != i2)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  if (!register_operand (operands[0], i1))
    return -1;
  return 0;
}

int
pattern260 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !gpc_reg_operand (operands[1], i1)
      || !reg_or_cint_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern265 (rtx x1, machine_mode i1, machine_mode i2, unsigned int i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != i3
      || GET_MODE (x3) != i2)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  if (!register_operand (operands[0], i1))
    return -1;
  x6 = XEXP (x4, 1);
  if (GET_MODE (x6) != i1)
    return -1;
  return 0;
}

int
pattern272 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !gpc_reg_operand (operands[0], i1)
      || !gpc_reg_operand (operands[1], i1))
    return -1;
  x4 = XEXP (x1, 1);
  if (GET_MODE (x4) != i1
      || !gpc_reg_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern279 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!altivec_register_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !altivec_register_operand (operands[0], i1))
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_MODE (x5) != i1
      || !altivec_register_operand (operands[1], i1))
    return -1;
  x6 = XEXP (x1, 1);
  if (GET_MODE (x6) != i1
      || !altivec_register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern286 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != NOT)
    return -1;
  x3 = XEXP (x1, 0);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  x6 = XEXP (x4, 1);
  operands[1] = x6;
  x7 = XEXP (x2, 0);
  operands[2] = x7;
  switch (GET_MODE (operands[3]))
    {
    case E_SImode:
      return pattern272 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern272 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern294 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x1, 1);
  x5 = XEXP (x4, 0);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V2DImode:
      return pattern293 (x1, 
E_V2DImode); /* [-1, 0] */

    case E_V4SImode:
      if (pattern293 (x1, 
E_V4SImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern303 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  if (!register_operand (operands[2], E_V16QImode))
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  return pattern301 (x5); /* [-1, 1] */
}

int
pattern310 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  x6 = XEXP (x4, 1);
  operands[2] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern309 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern309 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern317 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!vlogical_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !vlogical_operand (operands[1], i1)
      || !vlogical_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern324 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !short_cint_operand (operands[2], i1)
      || !gpc_reg_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern330 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_DImode:
      if (!gpc_reg_operand (operands[1], E_DImode))
        return -1;
      return 0;

    case E_SImode:
      if (!gpc_reg_operand (operands[1], E_SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern339 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!vsx_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V16QImode:
      if (!vsx_register_operand (operands[1], E_V16QImode))
        return -1;
      return 0;

    case E_V8HImode:
      if (!vsx_register_operand (operands[1], E_V8HImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern350 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern355 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  operands[2] = x4;
  x5 = XVECEXP (x1, 0, 1);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern354 (x3, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern354 (x3, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern361 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!int_reg_operand (operands[0], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != COMPARE
      || GET_MODE (x2) != E_CCmode)
    return -1;
  x3 = XEXP (x2, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x4 = XEXP (x1, 0);
  operands[2] = x4;
  if (!cc_reg_operand (operands[2], E_CCmode))
    return -1;
  x5 = XEXP (x2, 0);
  if (!rtx_equal_p (x5, operands[1]))
    return -1;
  return 0;
}

int
pattern370 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || !boolean_or_operator (operands[3], i1)
      || !gpc_reg_operand (operands[1], i1)
      || !logical_const_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern378 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern385 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!boolean_operator (operands[3], i1)
      || !gpc_reg_operand (operands[1], i1)
      || !gpc_reg_operand (operands[2], i1)
      || !scratch_operand (operands[0], i1))
    return -1;
  return 0;
}

int
pattern392 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[1], i1)
      || GET_MODE (x1) != i1
      || !gpc_reg_operand (operands[2], i1)
      || !scratch_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern400 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !gpc_reg_operand (operands[0], i1))
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_MODE (x5) != i1
      || !gpc_reg_operand (operands[1], i1))
    return -1;
  x6 = XEXP (x1, 1);
  if (GET_MODE (x6) != i1
      || !gpc_reg_operand (operands[2], i1)
      || !scratch_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern407 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != NOT)
    return -1;
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  x4 = XEXP (x1, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  switch (GET_CODE (x6))
    {
    case NOT:
      x7 = XEXP (x6, 0);
      operands[0] = x7;
      x8 = XEXP (x5, 1);
      switch (GET_CODE (x8))
        {
        case NOT:
          return pattern402 (x1); /* [-1, 11] */

        case REG:
        case SUBREG:
          res = pattern399 (x1);
          if (res >= 0)
            return res + 12; /* [12, 23] */
          return -1;

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      res = pattern396 (x1);
      if (res >= 0)
        return res + 24; /* [24, 35] */
      return -1;

    default:
      return -1;
    }
}

int
pattern416 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !gpc_reg_operand (operands[1], i1)
      || !const_int_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern418 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (x1))
    {
    case E_SImode:
      if (!gpc_reg_operand (operands[1], E_SImode)
          || !gpc_reg_operand (operands[2], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!gpc_reg_operand (operands[1], E_DImode)
          || !gpc_reg_operand (operands[2], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern425 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  switch (GET_MODE (operands[3]))
    {
    case E_SImode:
      return pattern423 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern423 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern424 (x1, 
E_V4SImode) != 0)
        return -1;
      return 2;

    case E_V8HImode:
      if (pattern424 (x1, 
E_V8HImode) != 0)
        return -1;
      return 3;

    case E_V16QImode:
      if (pattern424 (x1, 
E_V16QImode) != 0)
        return -1;
      return 4;

    case E_V4SFmode:
      if (pattern424 (x1, 
E_V4SFmode) != 0)
        return -1;
      return 5;

    case E_V2DFmode:
      if (pattern424 (x1, 
E_V2DFmode) != 0)
        return -1;
      return 6;

    case E_V2DImode:
      if (pattern424 (x1, 
E_V2DImode) != 0)
        return -1;
      return 7;

    case E_V1TImode:
      if (pattern424 (x1, 
E_V1TImode) != 0)
        return -1;
      return 8;

    case E_TImode:
      if (pattern424 (x1, 
E_TImode) != 0)
        return -1;
      return 9;

    case E_KFmode:
      if (pattern424 (x1, 
E_KFmode) != 0)
        return -1;
      return 10;

    case E_TFmode:
      if (pattern424 (x1, 
E_TFmode) != 0)
        return -1;
      return 11;

    default:
      return -1;
    }
}

int
pattern447 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  operands[0] = x4;
  x5 = XEXP (x3, 1);
  operands[1] = x5;
  switch (GET_MODE (operands[3]))
    {
    case E_SImode:
      return pattern445 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern445 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern446 (x1, 
E_V4SImode) != 0)
        return -1;
      return 2;

    case E_V8HImode:
      if (pattern446 (x1, 
E_V8HImode) != 0)
        return -1;
      return 3;

    case E_V16QImode:
      if (pattern446 (x1, 
E_V16QImode) != 0)
        return -1;
      return 4;

    case E_V4SFmode:
      if (pattern446 (x1, 
E_V4SFmode) != 0)
        return -1;
      return 5;

    case E_V2DFmode:
      if (pattern446 (x1, 
E_V2DFmode) != 0)
        return -1;
      return 6;

    case E_V2DImode:
      if (pattern446 (x1, 
E_V2DImode) != 0)
        return -1;
      return 7;

    case E_V1TImode:
      if (pattern446 (x1, 
E_V1TImode) != 0)
        return -1;
      return 8;

    case E_TImode:
      if (pattern446 (x1, 
E_TImode) != 0)
        return -1;
      return 9;

    case E_KFmode:
      if (pattern446 (x1, 
E_KFmode) != 0)
        return -1;
      return 10;

    case E_TFmode:
      if (pattern446 (x1, 
E_TFmode) != 0)
        return -1;
      return 11;

    default:
      return -1;
    }
}

int
pattern470 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[1], E_V4SFmode))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 2);
  if (!const_0_to_3_operand (x4, E_QImode))
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  x6 = XEXP (x5, 0);
  if (!scratch_operand (x6, E_SImode))
    return -1;
  x7 = XVECEXP (x3, 0, 1);
  switch (GET_CODE (x7))
    {
    case REG:
    case SUBREG:
      operands[2] = x7;
      if (!gpc_reg_operand (operands[2], E_SFmode))
        return -1;
      operands[3] = x4;
      operands[4] = x6;
      return 0;

    case CONST_DOUBLE:
      operands[2] = x7;
      if (!zero_fp_constant (operands[2], E_SFmode))
        return -1;
      operands[3] = x4;
      operands[4] = x6;
      return 1;

    case VEC_SELECT:
      if (GET_MODE (x7) != E_SFmode)
        return -1;
      x8 = XEXP (x7, 1);
      if (GET_CODE (x8) != PARALLEL
          || XVECLEN (x8, 0) != 1)
        return -1;
      x9 = XEXP (x7, 0);
      operands[2] = x9;
      if (!gpc_reg_operand (operands[2], E_V4SFmode))
        return -1;
      x10 = XVECEXP (x8, 0, 0);
      operands[3] = x10;
      if (!const_0_to_3_operand (operands[3], E_QImode))
        return -1;
      operands[4] = x4;
      operands[5] = x6;
      return 2;

    default:
      return -1;
    }
}

int
pattern492 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !gpc_reg_operand (operands[1], i1))
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != i1
      || !gpc_reg_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern501 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != UNSPEC
      || XVECLEN (x2, 0) != 1
      || XINT (x2, 1) != 3)
    return -1;
  x3 = XEXP (x1, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 2)
    return -1;
  return 0;
}

int
pattern507 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !gpc_reg_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1
      || !gpc_reg_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern516 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1
      || !gpc_reg_operand (operands[1], i1))
    return -1;
  x4 = XEXP (x3, 1);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  x6 = XEXP (x5, 0);
  if (GET_MODE (x6) != i1)
    return -1;
  return 0;
}

int
pattern522 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  operands[1] = x4;
  switch (GET_MODE (operands[3]))
    {
    case E_SImode:
      return pattern520 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern520 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern521 (x1, 
E_V4SImode) != 0)
        return -1;
      return 2;

    case E_V8HImode:
      if (pattern521 (x1, 
E_V8HImode) != 0)
        return -1;
      return 3;

    case E_V16QImode:
      if (pattern521 (x1, 
E_V16QImode) != 0)
        return -1;
      return 4;

    case E_V4SFmode:
      if (pattern521 (x1, 
E_V4SFmode) != 0)
        return -1;
      return 5;

    case E_V2DFmode:
      if (pattern521 (x1, 
E_V2DFmode) != 0)
        return -1;
      return 6;

    case E_V2DImode:
      if (pattern521 (x1, 
E_V2DImode) != 0)
        return -1;
      return 7;

    case E_V1TImode:
      if (pattern521 (x1, 
E_V1TImode) != 0)
        return -1;
      return 8;

    case E_TImode:
      if (pattern521 (x1, 
E_TImode) != 0)
        return -1;
      return 9;

    case E_KFmode:
      if (pattern521 (x1, 
E_KFmode) != 0)
        return -1;
      return 10;

    case E_TFmode:
      if (pattern521 (x1, 
E_TFmode) != 0)
        return -1;
      return 11;

    default:
      return -1;
    }
}

int
pattern542 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1
      || !gpc_reg_operand (operands[1], i1))
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 0);
  if (GET_MODE (x7) != i1)
    return -1;
  return 0;
}

int
pattern553 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[1], i1)
      || !reg_or_short_operand (operands[2], i1)
      || !gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  return 0;
}

int
pattern561 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!vsx_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !gpc_reg_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i2
      || !gpc_reg_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern568 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 4);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
      operands[4] = x3;
      if (!altivec_register_operand (operands[4], E_V4SImode))
        return -1;
      x4 = XEXP (x2, 0);
      if (GET_CODE (x4) != MEM
          || GET_MODE (x4) != E_V4SImode)
        return -1;
      x5 = XEXP (x4, 0);
      if (GET_CODE (x5) != PLUS)
        return -1;
      x6 = XEXP (x5, 0);
      operands[2] = x6;
      x7 = XEXP (x5, 1);
      operands[3] = x7;
      x8 = XVECEXP (x1, 0, 0);
      x9 = XEXP (x8, 0);
      switch (GET_MODE (x9))
        {
        case E_SImode:
          return pattern566 (x1, 
E_SImode); /* [-1, 0] */

        case E_DImode:
          if (pattern566 (x1, 
E_DImode) != 0)
            return -1;
          return 1;

        default:
          return -1;
        }

    case MEM:
      if (GET_MODE (x3) != E_V4SImode)
        return -1;
      x10 = XEXP (x3, 0);
      if (GET_CODE (x10) != PLUS)
        return -1;
      x4 = XEXP (x2, 0);
      operands[2] = x4;
      if (!altivec_register_operand (operands[2], E_V4SImode))
        return -1;
      x11 = XEXP (x10, 0);
      operands[3] = x11;
      x12 = XEXP (x10, 1);
      operands[4] = x12;
      x8 = XVECEXP (x1, 0, 0);
      x9 = XEXP (x8, 0);
      switch (GET_MODE (x9))
        {
        case E_SImode:
          if (pattern567 (x1, 
E_SImode) != 0)
            return -1;
          return 2;

        case E_DImode:
          if (pattern567 (x1, 
E_DImode) != 0)
            return -1;
          return 3;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern602 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 1);
  if (GET_CODE (x6) != i1)
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  x8 = XEXP (x7, 1);
  x9 = XEXP (x8, 0);
  x10 = XEXP (x9, 0);
  if (GET_CODE (x10) != i1)
    return -1;
  x11 = XEXP (x9, 1);
  if (GET_CODE (x11) != i1)
    return -1;
  x12 = XEXP (x5, 0);
  x13 = XEXP (x12, 0);
  operands[1] = x13;
  if (!gpc_reg_operand (operands[1], E_HImode))
    return -1;
  x14 = XEXP (x6, 0);
  operands[2] = x14;
  if (!gpc_reg_operand (operands[2], E_HImode))
    return -1;
  x15 = XEXP (x10, 0);
  if (!rtx_equal_p (x15, operands[1]))
    return -1;
  x16 = XEXP (x11, 0);
  if (!rtx_equal_p (x16, operands[2]))
    return -1;
  return 0;
}

 int
recog_8 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case EQ:
      res = recog_7 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case LT:
      if (pattern48 (x1, 
E_CCmode, 
GT) == 0
          && 
#line 15710 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_MISC))
        return 1208; /* setb_signed */
      break;

    case LTU:
      if (pattern48 (x1, 
E_CCUNSmode, 
GTU) == 0
          && 
#line 15723 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_MISC))
        return 1209; /* setb_unsigned */
      break;

    default:
      break;
    }
  operands[1] = x3;
  if (!scc_comparison_operator (operands[1], E_VOIDmode))
    return -1;
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x1, 0);
  operands[0] = x5;
  x6 = XEXP (x3, 0);
  operands[4] = x6;
  x7 = XEXP (x2, 1);
  operands[2] = x7;
  x8 = XEXP (x2, 2);
  operands[3] = x8;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      switch (pattern456 (x2, 
E_SImode))
        {
        case 0:
          if (!
#line 5570 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ISEL))
            return -1;
          return 353; /* isel_cc_si */

        case 1:
          if (!
#line 5570 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ISEL))
            return -1;
          return 355; /* isel_ccuns_si */

        default:
          return -1;
        }

    case E_DImode:
      switch (pattern456 (x2, 
E_DImode))
        {
        case 0:
          if (!(
#line 5570 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ISEL) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 354; /* isel_cc_di */

        case 1:
          if (!(
#line 5570 "../../gcc/config/rs6000/rs6000.md"
(TARGET_ISEL) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 356; /* isel_ccuns_di */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_15 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 0);
  operands[3] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case XOR:
      x6 = XEXP (x5, 0);
      operands[0] = x6;
      x7 = XEXP (x5, 1);
      operands[1] = x7;
      x8 = XEXP (x3, 1);
      switch (GET_CODE (x8))
        {
        case REG:
        case SUBREG:
          switch (pattern429 (x3))
            {
            case 0:
              if (!
#line 403 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2535; /* *fuse_eqv_and */

            case 1:
              if (!(
#line 403 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              *pnum_clobbers = 1;
              return 2536; /* *fuse_eqv_and */

            case 2:
              if (!
#line 1915 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2719; /* *fuse_veqv_vand */

            case 3:
              if (!
#line 1915 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2720; /* *fuse_veqv_vand */

            case 4:
              if (!
#line 1915 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2721; /* *fuse_veqv_vand */

            case 5:
              if (!
#line 1915 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2722; /* *fuse_veqv_vand */

            case 6:
              if (!
#line 1915 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2723; /* *fuse_veqv_vand */

            case 7:
              if (!
#line 1915 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2724; /* *fuse_veqv_vand */

            case 8:
              if (!
#line 1915 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2725; /* *fuse_veqv_vand */

            case 9:
              if (!
#line 1915 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2726; /* *fuse_veqv_vand */

            case 10:
              if (!(
#line 1915 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 2727; /* *fuse_veqv_vand */

            case 11:
              if (!(
#line 1915 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 2728; /* *fuse_veqv_vand */

            default:
              return -1;
            }

        case NOT:
          x9 = XEXP (x8, 0);
          operands[2] = x9;
          switch (GET_MODE (operands[3]))
            {
            case E_SImode:
              if (pattern272 (x3, 
E_SImode) != 0
                  || !
#line 583 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2555; /* *fuse_eqv_andc */

            case E_DImode:
              if (pattern272 (x3, 
E_DImode) != 0
                  || !(
#line 583 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              *pnum_clobbers = 1;
              return 2556; /* *fuse_eqv_andc */

            case E_V4SImode:
              if (pattern273 (x3, 
E_V4SImode) != 0
                  || !
#line 2059 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2799; /* *fuse_veqv_vandc */

            case E_V8HImode:
              if (pattern273 (x3, 
E_V8HImode) != 0
                  || !
#line 2059 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2800; /* *fuse_veqv_vandc */

            case E_V16QImode:
              if (pattern273 (x3, 
E_V16QImode) != 0
                  || !
#line 2059 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2801; /* *fuse_veqv_vandc */

            case E_V4SFmode:
              if (pattern273 (x3, 
E_V4SFmode) != 0
                  || !
#line 2059 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2802; /* *fuse_veqv_vandc */

            case E_V2DFmode:
              if (pattern273 (x3, 
E_V2DFmode) != 0
                  || !
#line 2059 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2803; /* *fuse_veqv_vandc */

            case E_V2DImode:
              if (pattern273 (x3, 
E_V2DImode) != 0
                  || !
#line 2059 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2804; /* *fuse_veqv_vandc */

            case E_V1TImode:
              if (pattern273 (x3, 
E_V1TImode) != 0
                  || !
#line 2059 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2805; /* *fuse_veqv_vandc */

            case E_TImode:
              if (pattern273 (x3, 
E_TImode) != 0
                  || !
#line 2059 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2806; /* *fuse_veqv_vandc */

            case E_KFmode:
              if (pattern273 (x3, 
E_KFmode) != 0
                  || !(
#line 2059 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 2807; /* *fuse_veqv_vandc */

            case E_TFmode:
              if (pattern273 (x3, 
E_TFmode) != 0
                  || !(
#line 2059 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 2808; /* *fuse_veqv_vandc */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case AND:
      switch (pattern281 (x3))
        {
        case 0:
          if (!
#line 1015 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2603; /* *fuse_and_nor */

        case 1:
          if (!(
#line 1015 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 1;
          return 2604; /* *fuse_and_nor */

        case 2:
          if (!
#line 2455 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3019; /* *fuse_vand_vnor */

        case 3:
          if (!
#line 2455 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3020; /* *fuse_vand_vnor */

        case 4:
          if (!
#line 2455 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3021; /* *fuse_vand_vnor */

        case 5:
          if (!
#line 2455 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3022; /* *fuse_vand_vnor */

        case 6:
          if (!
#line 2455 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3023; /* *fuse_vand_vnor */

        case 7:
          if (!
#line 2455 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3024; /* *fuse_vand_vnor */

        case 8:
          if (!
#line 2455 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3025; /* *fuse_vand_vnor */

        case 9:
          if (!
#line 2455 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3026; /* *fuse_vand_vnor */

        case 10:
          if (!(
#line 2455 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 3027; /* *fuse_vand_vnor */

        case 11:
          if (!(
#line 2455 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 3028; /* *fuse_vand_vnor */

        case 12:
          if (!
#line 1033 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2605; /* *fuse_andc_nor */

        case 13:
          if (!(
#line 1033 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 1;
          return 2606; /* *fuse_andc_nor */

        case 14:
          if (!
#line 2473 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3029; /* *fuse_vandc_vnor */

        case 15:
          if (!
#line 2473 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3030; /* *fuse_vandc_vnor */

        case 16:
          if (!
#line 2473 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3031; /* *fuse_vandc_vnor */

        case 17:
          if (!
#line 2473 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3032; /* *fuse_vandc_vnor */

        case 18:
          if (!
#line 2473 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3033; /* *fuse_vandc_vnor */

        case 19:
          if (!
#line 2473 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3034; /* *fuse_vandc_vnor */

        case 20:
          if (!
#line 2473 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3035; /* *fuse_vandc_vnor */

        case 21:
          if (!
#line 2473 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3036; /* *fuse_vandc_vnor */

        case 22:
          if (!(
#line 2473 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 3037; /* *fuse_vandc_vnor */

        case 23:
          if (!(
#line 2473 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 3038; /* *fuse_vandc_vnor */

        case 24:
          if (!
#line 1087 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2611; /* *fuse_nor_nor */

        case 25:
          if (!(
#line 1087 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 1;
          return 2612; /* *fuse_nor_nor */

        case 26:
          if (!
#line 2527 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3059; /* *fuse_vnor_vnor */

        case 27:
          if (!
#line 2527 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3060; /* *fuse_vnor_vnor */

        case 28:
          if (!
#line 2527 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3061; /* *fuse_vnor_vnor */

        case 29:
          if (!
#line 2527 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3062; /* *fuse_vnor_vnor */

        case 30:
          if (!
#line 2527 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3063; /* *fuse_vnor_vnor */

        case 31:
          if (!
#line 2527 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3064; /* *fuse_vnor_vnor */

        case 32:
          if (!
#line 2527 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3065; /* *fuse_vnor_vnor */

        case 33:
          if (!
#line 2527 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3066; /* *fuse_vnor_vnor */

        case 34:
          if (!(
#line 2527 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 3067; /* *fuse_vnor_vnor */

        case 35:
          if (!(
#line 2527 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 3068; /* *fuse_vnor_vnor */

        default:
          return -1;
        }

    case NOT:
      switch (pattern284 (x3))
        {
        case 0:
          if (!
#line 1051 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2607; /* *fuse_eqv_nor */

        case 1:
          if (!(
#line 1051 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 1;
          return 2608; /* *fuse_eqv_nor */

        case 2:
          if (!
#line 2491 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3039; /* *fuse_veqv_vnor */

        case 3:
          if (!
#line 2491 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3040; /* *fuse_veqv_vnor */

        case 4:
          if (!
#line 2491 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3041; /* *fuse_veqv_vnor */

        case 5:
          if (!
#line 2491 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3042; /* *fuse_veqv_vnor */

        case 6:
          if (!
#line 2491 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3043; /* *fuse_veqv_vnor */

        case 7:
          if (!
#line 2491 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3044; /* *fuse_veqv_vnor */

        case 8:
          if (!
#line 2491 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3045; /* *fuse_veqv_vnor */

        case 9:
          if (!
#line 2491 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3046; /* *fuse_veqv_vnor */

        case 10:
          if (!(
#line 2491 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 3047; /* *fuse_veqv_vnor */

        case 11:
          if (!(
#line 2491 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 3048; /* *fuse_veqv_vnor */

        default:
          return -1;
        }

    case IOR:
      switch (pattern285 (x3))
        {
        case 0:
          if (!
#line 1069 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2609; /* *fuse_nand_nor */

        case 1:
          if (!(
#line 1069 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 1;
          return 2610; /* *fuse_nand_nor */

        case 2:
          if (!
#line 2509 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3049; /* *fuse_vnand_vnor */

        case 3:
          if (!
#line 2509 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3050; /* *fuse_vnand_vnor */

        case 4:
          if (!
#line 2509 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3051; /* *fuse_vnand_vnor */

        case 5:
          if (!
#line 2509 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3052; /* *fuse_vnand_vnor */

        case 6:
          if (!
#line 2509 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3053; /* *fuse_vnand_vnor */

        case 7:
          if (!
#line 2509 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3054; /* *fuse_vnand_vnor */

        case 8:
          if (!
#line 2509 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3055; /* *fuse_vnand_vnor */

        case 9:
          if (!
#line 2509 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3056; /* *fuse_vnand_vnor */

        case 10:
          if (!(
#line 2509 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 3057; /* *fuse_vnand_vnor */

        case 11:
          if (!(
#line 2509 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 3058; /* *fuse_vnand_vnor */

        case 12:
          if (!
#line 1123 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2615; /* *fuse_orc_nor */

        case 13:
          if (!(
#line 1123 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 1;
          return 2616; /* *fuse_orc_nor */

        case 14:
          if (!
#line 2563 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3079; /* *fuse_vorc_vnor */

        case 15:
          if (!
#line 2563 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3080; /* *fuse_vorc_vnor */

        case 16:
          if (!
#line 2563 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3081; /* *fuse_vorc_vnor */

        case 17:
          if (!
#line 2563 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3082; /* *fuse_vorc_vnor */

        case 18:
          if (!
#line 2563 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3083; /* *fuse_vorc_vnor */

        case 19:
          if (!
#line 2563 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3084; /* *fuse_vorc_vnor */

        case 20:
          if (!
#line 2563 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3085; /* *fuse_vorc_vnor */

        case 21:
          if (!
#line 2563 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3086; /* *fuse_vorc_vnor */

        case 22:
          if (!(
#line 2563 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 3087; /* *fuse_vorc_vnor */

        case 23:
          if (!(
#line 2563 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 3088; /* *fuse_vorc_vnor */

        case 24:
          if (!
#line 1105 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2613; /* *fuse_or_nor */

        case 25:
          if (!(
#line 1105 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 1;
          return 2614; /* *fuse_or_nor */

        case 26:
          if (!
#line 2545 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3069; /* *fuse_vor_vnor */

        case 27:
          if (!
#line 2545 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3070; /* *fuse_vor_vnor */

        case 28:
          if (!
#line 2545 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3071; /* *fuse_vor_vnor */

        case 29:
          if (!
#line 2545 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3072; /* *fuse_vor_vnor */

        case 30:
          if (!
#line 2545 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3073; /* *fuse_vor_vnor */

        case 31:
          if (!
#line 2545 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3074; /* *fuse_vor_vnor */

        case 32:
          if (!
#line 2545 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3075; /* *fuse_vor_vnor */

        case 33:
          if (!
#line 2545 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3076; /* *fuse_vor_vnor */

        case 34:
          if (!(
#line 2545 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 3077; /* *fuse_vor_vnor */

        case 35:
          if (!(
#line 2545 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 3078; /* *fuse_vor_vnor */

        default:
          return -1;
        }

    case PLUS:
      switch (pattern286 (x3))
        {
        case 0:
          if (!
#line 1159 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2619; /* *fuse_add_nor */

        case 1:
          if (!(
#line 1159 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 1;
          return 2620; /* *fuse_add_nor */

        default:
          return -1;
        }

    case MINUS:
      switch (pattern286 (x3))
        {
        case 0:
          if (!
#line 1177 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2621; /* *fuse_subf_nor */

        case 1:
          if (!(
#line 1177 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 1;
          return 2622; /* *fuse_subf_nor */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_33 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  if (!gpc_reg_operand (operands[2], E_DImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_DFmode:
      if (!gpc_reg_operand (operands[0], E_DFmode)
          || GET_MODE (x3) != E_DFmode)
        return -1;
      if (gpc_reg_operand (operands[1], E_V2DFmode)
          && 
#line 3658 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V2DFmode) && TARGET_DIRECT_MOVE_64BIT))
        {
          *pnum_clobbers = 2;
          return 1503; /* vsx_extract_v2df_var */
        }
      if (!memory_operand (operands[1], E_V2DFmode)
          || !
#line 3675 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V2DFmode) && TARGET_DIRECT_MOVE_64BIT))
        return -1;
      *pnum_clobbers = 1;
      return 1505; /* *vsx_extract_v2df_var_load */

    case E_SFmode:
      if (!gpc_reg_operand (operands[0], E_SFmode)
          || GET_MODE (x3) != E_SFmode)
        return -1;
      if (gpc_reg_operand (operands[1], E_V4SFmode)
          && 
#line 3745 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SFmode) && TARGET_DIRECT_MOVE_64BIT))
        {
          *pnum_clobbers = 2;
          return 1510; /* vsx_extract_v4sf_var */
        }
      if (!memory_operand (operands[1], E_V4SFmode)
          || !
#line 3762 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SFmode) && TARGET_DIRECT_MOVE_64BIT))
        return -1;
      *pnum_clobbers = 1;
      return 1511; /* *vsx_extract_v4sf_var_load */

    case E_QImode:
      if (!gpc_reg_operand (operands[0], E_QImode)
          || GET_MODE (x3) != E_QImode)
        return -1;
      if (gpc_reg_operand (operands[1], E_V16QImode)
          && 
#line 4185 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V16QImode) && TARGET_DIRECT_MOVE_64BIT))
        {
          *pnum_clobbers = 2;
          return 1531; /* vsx_extract_v16qi_var */
        }
      if (!memory_operand (operands[1], E_V16QImode)
          || !
#line 4204 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V16QImode) && TARGET_DIRECT_MOVE_64BIT))
        return -1;
      *pnum_clobbers = 1;
      return 1534; /* *vsx_extract_v16qi_var_load */

    case E_HImode:
      if (!gpc_reg_operand (operands[0], E_HImode)
          || GET_MODE (x3) != E_HImode)
        return -1;
      if (gpc_reg_operand (operands[1], E_V8HImode)
          && 
#line 4185 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V8HImode) && TARGET_DIRECT_MOVE_64BIT))
        {
          *pnum_clobbers = 2;
          return 1532; /* vsx_extract_v8hi_var */
        }
      if (!memory_operand (operands[1], E_V8HImode)
          || !
#line 4204 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V8HImode) && TARGET_DIRECT_MOVE_64BIT))
        return -1;
      *pnum_clobbers = 1;
      return 1535; /* *vsx_extract_v8hi_var_load */

    default:
      return -1;
    }
}

 int
recog_40 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_CCFPmode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!cc_reg_operand (operands[0], E_CCFPmode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[1]))
    {
    case E_DFmode:
      if (!vsx_register_operand (operands[1], E_DFmode)
          || !vsx_register_operand (operands[2], E_DFmode)
          || !
#line 1969 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (DFmode)))
        return -1;
      return 1351; /* *vsx_tdivdf3_internal */

    case E_V4SFmode:
      if (!vsx_register_operand (operands[1], E_V4SFmode)
          || !vsx_register_operand (operands[2], E_V4SFmode)
          || !
#line 1969 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V4SFmode)))
        return -1;
      return 1352; /* *vsx_tdivv4sf3_internal */

    case E_V2DFmode:
      if (!vsx_register_operand (operands[1], E_V2DFmode)
          || !vsx_register_operand (operands[2], E_V2DFmode)
          || !
#line 1969 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode)))
        return -1;
      return 1353; /* *vsx_tdivv2df3_internal */

    default:
      return -1;
    }
}

 int
recog_47 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], E_V16QImode))
    return -1;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  if (!register_operand (operands[2], E_V16QImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || GET_MODE (x3) != E_V2DImode
          || !
#line 4510 "../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
        return -1;
      return 2330; /* altivec_vbpermq */

    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode)
          || GET_MODE (x3) != E_V16QImode
          || !
#line 4520 "../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
        return -1;
      return 2331; /* altivec_vbpermq2 */

    default:
      return -1;
    }
}

 int
recog_53 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_V2DImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!vsx_register_operand (operands[0], E_V2DImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!vsx_register_operand (operands[1], E_V16QImode))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!const_0_to_12_operand (operands[2], E_QImode)
      || !
#line 6041 "../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
    return -1;
  return 1730; /* extract4b */
}

 int
recog_59 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!gpc_reg_operand (operands[0], E_SImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!got_no_const_operand (operands[1], E_SImode))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!gpc_reg_operand (operands[2], E_SImode)
      || !
#line 7696 "../../gcc/config/rs6000/rs6000.md"
(DEFAULT_ABI == ABI_V4 && flag_pic == 1))
    return -1;
  return 567; /* *movsi_got_internal */
}

 int
recog_66 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V4SFmode:
      if (!vsx_register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x3) != E_V4SFmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_DFmode:
          if (!vsx_register_operand (operands[1], E_DFmode)
              || !
#line 2362 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (DFmode)))
            return -1;
          return 1419; /* vsx_xscvdpsp */

        case E_V2DFmode:
          if (!vsx_register_operand (operands[1], E_V2DFmode)
              || !
#line 2400 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode)))
            return -1;
          return 1422; /* vsx_xvcvdpsp */

        case E_SFmode:
          if (!vsx_register_operand (operands[1], E_SFmode)
              || !
#line 2446 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V4SFmode)))
            return -1;
          return 1427; /* vsx_xscvdpsp_scalar */

        default:
          return -1;
        }

    case E_DFmode:
      if (!vsx_register_operand (operands[0], E_DFmode)
          || GET_MODE (x3) != E_DFmode
          || !vsx_register_operand (operands[1], E_V4SFmode)
          || !
#line 2409 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V4SFmode)))
        return -1;
      return 1423; /* vsx_xscvspdp */

    case E_SFmode:
      if (!vsx_register_operand (operands[0], E_SFmode)
          || GET_MODE (x3) != E_SFmode
          || !vsx_register_operand (operands[1], E_V4SFmode)
          || !
#line 2418 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V4SFmode)))
        return -1;
      return 1424; /* vsx_xscvspdp_scalar2 */

    default:
      return -1;
    }
}

 int
recog_70 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      if (!memory_operand (operands[0], E_HImode)
          || GET_MODE (x3) != E_HImode
          || !register_operand (operands[1], E_V8HImode)
          || !
#line 3242 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
        return -1;
      return 2286; /* altivec_stvehx */

    case E_QImode:
      if (!memory_operand (operands[0], E_QImode)
          || GET_MODE (x3) != E_QImode
          || !register_operand (operands[1], E_V16QImode)
          || !
#line 3242 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
        return -1;
      return 2287; /* altivec_stvebx */

    case E_SFmode:
      if (!memory_operand (operands[0], E_SFmode)
          || GET_MODE (x3) != E_SFmode
          || !register_operand (operands[1], E_V4SFmode)
          || !
#line 3249 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
        return -1;
      return 2288; /* *altivec_stvesfx */

    default:
      return -1;
    }
}

 int
recog_78 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x3) != E_V4SImode
          || !s32bit_cint_operand (operands[1], E_SImode)
          || !
#line 6587 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
        return -1;
      return 1775; /* xxspltiw_v4si */

    case E_V4SFmode:
      if (!register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x3) != E_V4SFmode
          || !c32bit_cint_operand (operands[1], E_SImode)
          || !
#line 6607 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
        return -1;
      return 1776; /* xxspltiw_v4sf_inst */

    default:
      return -1;
    }
}

 int
recog_88 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_DFmode:
      if (!register_operand (operands[0], E_DFmode)
          || GET_MODE (x3) != E_DFmode
          || !
#line 9564 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWERPC64 && TARGET_DIRECT_MOVE))
        return -1;
      return 646; /* p8_mtvsrwz */

    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode)
          || GET_MODE (x3) != E_V16QImode
          || !
#line 9572 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWERPC64 && TARGET_DIRECT_MOVE))
        return -1;
      return 647; /* p8_mtvsrwz_v16qisi2 */

    default:
      return -1;
    }
}

 int
recog_97 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  if (!register_operand (operands[3], E_V16QImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V4SImode:
      if (pattern141 (x3, 
E_V4SImode) != 0
          || !
#line 2494 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
        return -1;
      return 2074; /* altivec_vperm_v4si_direct */

    case E_V8HImode:
      if (pattern141 (x3, 
E_V8HImode) != 0
          || !
#line 2494 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
        return -1;
      return 2075; /* altivec_vperm_v8hi_direct */

    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode)
          || GET_MODE (x3) != E_V16QImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V16QImode:
          if (!register_operand (operands[1], E_V16QImode)
              || !register_operand (operands[2], E_V16QImode)
              || !
#line 2494 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
            return -1;
          return 2076; /* altivec_vperm_v16qi_direct */

        case E_V8HImode:
          if (!register_operand (operands[1], E_V8HImode)
              || !register_operand (operands[2], E_V8HImode)
              || !
#line 2507 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
            return -1;
          return 2084; /* altivec_vperm_v8hiv16qi */

        default:
          return -1;
        }

    case E_V4SFmode:
      if (pattern141 (x3, 
E_V4SFmode) != 0
          || !
#line 2494 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
        return -1;
      return 2077; /* altivec_vperm_v4sf_direct */

    case E_V2DFmode:
      if (pattern141 (x3, 
E_V2DFmode) != 0
          || !
#line 2494 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
        return -1;
      return 2078; /* altivec_vperm_v2df_direct */

    case E_V2DImode:
      if (pattern141 (x3, 
E_V2DImode) != 0
          || !
#line 2494 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
        return -1;
      return 2079; /* altivec_vperm_v2di_direct */

    case E_V1TImode:
      if (pattern141 (x3, 
E_V1TImode) != 0
          || !
#line 2494 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
        return -1;
      return 2080; /* altivec_vperm_v1ti_direct */

    case E_TImode:
      if (pattern141 (x3, 
E_TImode) != 0
          || !
#line 2494 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
        return -1;
      return 2081; /* altivec_vperm_ti_direct */

    case E_KFmode:
      if (pattern141 (x3, 
E_KFmode) != 0
          || !(
#line 2494 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 200 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
        return -1;
      return 2082; /* altivec_vperm_kf_direct */

    case E_TFmode:
      if (pattern141 (x3, 
E_TFmode) != 0
          || !(
#line 2494 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 201 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
        return -1;
      return 2083; /* altivec_vperm_tf_direct */

    default:
      return -1;
    }
}

 int
recog_112 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (maybe_ne (SUBREG_BYTE (x2), 0)
      || GET_MODE (x2) != E_V1TImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != VEC_SELECT
      || GET_MODE (x3) != E_V2DImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != SUBREG
      || maybe_ne (SUBREG_BYTE (x4), 0)
      || GET_MODE (x4) != E_V2DImode)
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_CODE (x5) != PARALLEL
      || XVECLEN (x5, 0) != 2)
    return -1;
  x6 = XVECEXP (x5, 0, 0);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x7 = XVECEXP (x5, 0, 1);
  if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
      || !vsx_register_operand (operands[0], E_V1TImode))
    return -1;
  x8 = XEXP (x4, 0);
  operands[1] = x8;
  if (!vsx_register_operand (operands[1], E_V1TImode)
      || !
#line 3348 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
    return -1;
  return 1472; /* xxswapd_v1ti */
}

 int
recog_114 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case REG:
    case SUBREG:
      if (GET_CODE (x2) == SUBREG)
        {
          res = recog_110 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      x3 = XEXP (x1, 0);
      switch (GET_CODE (x3))
        {
        case PC:
          operands[0] = x2;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (register_operand (operands[0], E_SImode)
                  && (
#line 13533 "../../gcc/config/rs6000/rs6000.md"
(rs6000_speculate_indirect_jumps) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                return 979; /* *indirect_jumpsi */
              break;

            case E_DImode:
              if (register_operand (operands[0], E_DImode)
                  && (
#line 13533 "../../gcc/config/rs6000/rs6000.md"
(rs6000_speculate_indirect_jumps) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                return 980; /* *indirect_jumpdi */
              break;

            default:
              break;
            }
          break;

        case MEM:
          operands[0] = x3;
          operands[1] = x2;
          switch (GET_MODE (operands[0]))
            {
            case E_V2DFmode:
              if (indexed_or_indirect_operand (operands[0], E_V2DFmode)
                  && vsx_register_operand (operands[1], E_V2DFmode)
                  && 
#line 663 "../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX && !TARGET_P9_VECTOR))
                return 1265; /* *vsx_le_perm_store_v2df */
              break;

            case E_V2DImode:
              if (indexed_or_indirect_operand (operands[0], E_V2DImode)
                  && vsx_register_operand (operands[1], E_V2DImode)
                  && 
#line 663 "../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX && !TARGET_P9_VECTOR))
                return 1266; /* *vsx_le_perm_store_v2di */
              break;

            case E_V4SFmode:
              if (indexed_or_indirect_operand (operands[0], E_V4SFmode)
                  && vsx_register_operand (operands[1], E_V4SFmode)
                  && 
#line 733 "../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX && !TARGET_P9_VECTOR))
                return 1267; /* *vsx_le_perm_store_v4sf */
              break;

            case E_V4SImode:
              if (indexed_or_indirect_operand (operands[0], E_V4SImode)
                  && vsx_register_operand (operands[1], E_V4SImode)
                  && 
#line 733 "../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX && !TARGET_P9_VECTOR))
                return 1268; /* *vsx_le_perm_store_v4si */
              break;

            case E_V8HImode:
              if (indexed_or_indirect_operand (operands[0], E_V8HImode)
                  && vsx_register_operand (operands[1], E_V8HImode)
                  && 
#line 808 "../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX && !TARGET_P9_VECTOR))
                return 1269; /* *vsx_le_perm_store_v8hi */
              break;

            case E_V16QImode:
              if (indexed_or_indirect_operand (operands[0], E_V16QImode)
                  && vsx_register_operand (operands[1], E_V16QImode)
                  && 
#line 893 "../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX && !TARGET_P9_VECTOR))
                return 1270; /* *vsx_le_perm_store_v16qi */
              break;

            default:
              break;
            }
          break;

        default:
          break;
        }
      break;

    case MEM:
      operands[1] = x2;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      switch (GET_MODE (operands[0]))
        {
        case E_V2DFmode:
          if (vsx_register_operand (operands[0], E_V2DFmode)
              && indexed_or_indirect_operand (operands[1], E_V2DFmode)
              && 
#line 449 "../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX && !TARGET_P9_VECTOR))
            return 1259; /* *vsx_le_perm_load_v2df */
          break;

        case E_V2DImode:
          if (vsx_register_operand (operands[0], E_V2DImode)
              && indexed_or_indirect_operand (operands[1], E_V2DImode)
              && 
#line 449 "../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX && !TARGET_P9_VECTOR))
            return 1260; /* *vsx_le_perm_load_v2di */
          break;

        case E_V4SFmode:
          if (vsx_register_operand (operands[0], E_V4SFmode)
              && indexed_or_indirect_operand (operands[1], E_V4SFmode)
              && 
#line 497 "../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX && !TARGET_P9_VECTOR))
            return 1261; /* *vsx_le_perm_load_v4sf */
          break;

        case E_V4SImode:
          if (vsx_register_operand (operands[0], E_V4SImode)
              && indexed_or_indirect_operand (operands[1], E_V4SImode)
              && 
#line 497 "../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX && !TARGET_P9_VECTOR))
            return 1262; /* *vsx_le_perm_load_v4si */
          break;

        case E_V8HImode:
          if (vsx_register_operand (operands[0], E_V8HImode)
              && indexed_or_indirect_operand (operands[1], E_V8HImode)
              && 
#line 547 "../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX && !TARGET_P9_VECTOR))
            return 1263; /* *vsx_le_perm_load_v8hi */
          break;

        case E_V16QImode:
          if (vsx_register_operand (operands[0], E_V16QImode)
              && indexed_or_indirect_operand (operands[1], E_V16QImode)
              && 
#line 601 "../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX && !TARGET_P9_VECTOR))
            return 1264; /* *vsx_le_perm_load_v16qi */
          break;

        default:
          break;
        }
      break;

    default:
      break;
    }
  operands[1] = x2;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_KFmode:
      if (vsx_register_operand (operands[0], E_KFmode)
          && memory_operand (operands[1], E_KFmode)
          && (
#line 1040 "../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX && !TARGET_P9_VECTOR
   && !altivec_indexed_or_indirect_operand (operands[1], KFmode)) && 
#line 35 "../../gcc/config/rs6000/vsx.md"
(FLOAT128_VECTOR_P (KFmode))))
        return 1275; /* *vsx_le_perm_load_kf */
      break;

    case E_V1TImode:
      if (vsx_register_operand (operands[0], E_V1TImode)
          && memory_operand (operands[1], E_V1TImode)
          && 
#line 1040 "../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX && !TARGET_P9_VECTOR
   && !altivec_indexed_or_indirect_operand (operands[1], V1TImode)))
        return 1278; /* *vsx_le_perm_load_v1ti */
      break;

    default:
      break;
    }
  switch (GET_MODE (operands[0]))
    {
    case E_KFmode:
      if (memory_operand (operands[0], E_KFmode)
          && vsx_register_operand (operands[1], E_KFmode)
          && (
#line 1063 "../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX && !TARGET_P9_VECTOR
   && !altivec_indexed_or_indirect_operand (operands[0], KFmode)) && 
#line 35 "../../gcc/config/rs6000/vsx.md"
(FLOAT128_VECTOR_P (KFmode))))
        return 1279; /* *vsx_le_perm_store_kf */
      break;

    case E_V1TImode:
      if (memory_operand (operands[0], E_V1TImode)
          && vsx_register_operand (operands[1], E_V1TImode)
          && 
#line 1063 "../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX && !TARGET_P9_VECTOR
   && !altivec_indexed_or_indirect_operand (operands[0], V1TImode)))
        return 1282; /* *vsx_le_perm_store_v1ti */
      break;

    default:
      break;
    }
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      if (nonimmediate_operand (operands[0], E_V16QImode)
          && input_operand (operands[1], E_V16QImode))
        {
          if (
#line 1258 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWERPC64 && VECTOR_MEM_VSX_P (V16QImode)
   && (register_operand (operands[0], V16QImode) 
       || register_operand (operands[1], V16QImode))))
            return 1291; /* vsx_movv16qi_64bit */
          if (
#line 1312 "../../gcc/config/rs6000/vsx.md"
(!TARGET_POWERPC64 && VECTOR_MEM_VSX_P (V16QImode)
   && (register_operand (operands[0], V16QImode) 
       || register_operand (operands[1], V16QImode))))
            return 1301; /* *vsx_movv16qi_32bit */
          if (
#line 245 "../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_P (V16QImode)
   && (register_operand (operands[0], V16QImode) 
       || register_operand (operands[1], V16QImode))))
            return 1791; /* *altivec_movv16qi */
        }
      break;

    case E_V4SFmode:
      if (nonimmediate_operand (operands[0], E_V4SFmode)
          && input_operand (operands[1], E_V4SFmode))
        {
          if (
#line 1258 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWERPC64 && VECTOR_MEM_VSX_P (V4SFmode)
   && (register_operand (operands[0], V4SFmode) 
       || register_operand (operands[1], V4SFmode))))
            return 1295; /* vsx_movv4sf_64bit */
          if (
#line 1312 "../../gcc/config/rs6000/vsx.md"
(!TARGET_POWERPC64 && VECTOR_MEM_VSX_P (V4SFmode)
   && (register_operand (operands[0], V4SFmode) 
       || register_operand (operands[1], V4SFmode))))
            return 1305; /* *vsx_movv4sf_32bit */
        }
      break;

    case E_V2DFmode:
      if (nonimmediate_operand (operands[0], E_V2DFmode)
          && input_operand (operands[1], E_V2DFmode))
        {
          if (
#line 1258 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWERPC64 && VECTOR_MEM_VSX_P (V2DFmode)
   && (register_operand (operands[0], V2DFmode) 
       || register_operand (operands[1], V2DFmode))))
            return 1296; /* vsx_movv2df_64bit */
          if (
#line 1312 "../../gcc/config/rs6000/vsx.md"
(!TARGET_POWERPC64 && VECTOR_MEM_VSX_P (V2DFmode)
   && (register_operand (operands[0], V2DFmode) 
       || register_operand (operands[1], V2DFmode))))
            return 1306; /* *vsx_movv2df_32bit */
          if (
#line 245 "../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_P (V2DFmode)
   && (register_operand (operands[0], V2DFmode) 
       || register_operand (operands[1], V2DFmode))))
            return 1793; /* *altivec_movv2df */
        }
      break;

    case E_V1TImode:
      if (nonimmediate_operand (operands[0], E_V1TImode)
          && input_operand (operands[1], E_V1TImode))
        {
          if (
#line 1258 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWERPC64 && VECTOR_MEM_VSX_P (V1TImode)
   && (register_operand (operands[0], V1TImode) 
       || register_operand (operands[1], V1TImode))))
            return 1297; /* vsx_movv1ti_64bit */
          if (
#line 1312 "../../gcc/config/rs6000/vsx.md"
(!TARGET_POWERPC64 && VECTOR_MEM_VSX_P (V1TImode)
   && (register_operand (operands[0], V1TImode) 
       || register_operand (operands[1], V1TImode))))
            return 1307; /* *vsx_movv1ti_32bit */
        }
      break;

    case E_KFmode:
      if (nonimmediate_operand (operands[0], E_KFmode)
          && input_operand (operands[1], E_KFmode))
        {
          if ((
#line 1258 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWERPC64 && VECTOR_MEM_VSX_P (KFmode)
   && (register_operand (operands[0], KFmode) 
       || register_operand (operands[1], KFmode))) && 
#line 69 "../../gcc/config/rs6000/vsx.md"
(FLOAT128_VECTOR_P (KFmode))))
            return 1298; /* vsx_movkf_64bit */
          if ((
#line 1312 "../../gcc/config/rs6000/vsx.md"
(!TARGET_POWERPC64 && VECTOR_MEM_VSX_P (KFmode)
   && (register_operand (operands[0], KFmode) 
       || register_operand (operands[1], KFmode))) && 
#line 69 "../../gcc/config/rs6000/vsx.md"
(FLOAT128_VECTOR_P (KFmode))))
            return 1308; /* *vsx_movkf_32bit */
          if ((
#line 245 "../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_P (KFmode)
   && (register_operand (operands[0], KFmode) 
       || register_operand (operands[1], KFmode))) && 
#line 211 "../../gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return 1796; /* *altivec_movkf */
        }
      break;

    case E_OOmode:
      if (nonimmediate_operand (operands[0], E_OOmode)
          && input_operand (operands[1], E_OOmode)
          && 
#line 298 "../../gcc/config/rs6000/mma.md"
(TARGET_MMA
   && (gpc_reg_operand (operands[0], OOmode)
       || gpc_reg_operand (operands[1], OOmode))))
        return 2356; /* *movoo */
      break;

    case E_XOmode:
      if (nonimmediate_operand (operands[0], E_XOmode)
          && input_operand (operands[1], E_XOmode)
          && 
#line 345 "../../gcc/config/rs6000/mma.md"
(TARGET_MMA
   && (gpc_reg_operand (operands[0], XOmode)
       || gpc_reg_operand (operands[1], XOmode))))
        return 2357; /* *movxo */
      break;

    default:
      break;
    }
  operands[0] = x2;
  res = recog_111 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[0] = x3;
  switch (GET_CODE (x2))
    {
    case SUBREG:
      res = recog_112 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case MEM:
      res = recog_113 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    default:
      break;
    }
  if (nonimmediate_operand (operands[0], E_V1TImode))
    {
      operands[1] = x2;
      if (input_operand (operands[1], E_V1TImode)
          && 
#line 245 "../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_P (V1TImode)
   && (register_operand (operands[0], V1TImode) 
       || register_operand (operands[1], V1TImode))))
        return 1795; /* *altivec_movv1ti */
    }
  operands[0] = x2;
  switch (pattern32 (x3, 
E_V1TImode))
    {
    case 0:
      if ((
#line 3218 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
        return 2252; /* altivec_stvx_v1ti_2op_si */
      break;

    case 1:
      if ((
#line 3218 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
        return 2253; /* altivec_stvx_v1ti_2op_di */
      break;

    case 2:
      if ((
#line 3226 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
        return 2270; /* altivec_stvx_v1ti_1op_si */
      break;

    case 3:
      if ((
#line 3226 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
        return 2271; /* altivec_stvx_v1ti_1op_di */
      break;

    default:
      break;
    }
  if (GET_CODE (x2) != MEM)
    return -1;
  switch (pattern35 (x1, 
E_V1TImode))
    {
    case 0:
      if (!(
#line 3162 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
        return -1;
      return 2207; /* altivec_lvx_v1ti_2op_si */

    case 1:
      if (!(
#line 3162 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
        return -1;
      return 2208; /* altivec_lvx_v1ti_2op_di */

    case 2:
      if (!(
#line 3170 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
        return -1;
      return 2225; /* altivec_lvx_v1ti_1op_si */

    case 3:
      if (!(
#line 3170 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
        return -1;
      return 2226; /* altivec_lvx_v1ti_1op_di */

    default:
      return -1;
    }
}

 int
recog_127 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (pattern8 (x1))
    {
    case 0:
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pnum_clobbers != NULL
              && nonimmediate_operand (operands[0], E_SImode))
            {
              x2 = XEXP (x1, 1);
              if (GET_MODE (x2) == E_SImode)
                {
                  switch (GET_MODE (operands[1]))
                    {
                    case E_SFmode:
                      if (gpc_reg_operand (operands[1], E_SFmode)
                          && 
#line 6326 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_STFIWX && can_create_pseudo_p ()
   && !TARGET_DIRECT_MOVE))
                        {
                          *pnum_clobbers = 1;
                          return 425; /* fix_truncsfsi2_stfiwx */
                        }
                      break;

                    case E_DFmode:
                      if (gpc_reg_operand (operands[1], E_DFmode)
                          && 
#line 6326 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_STFIWX && can_create_pseudo_p ()
   && !TARGET_DIRECT_MOVE))
                        {
                          *pnum_clobbers = 1;
                          return 426; /* fix_truncdfsi2_stfiwx */
                        }
                      break;

                    default:
                      break;
                    }
                }
            }
          x2 = XEXP (x1, 1);
          if (GET_MODE (x2) != E_SImode)
            return -1;
          if (gpc_reg_operand (operands[0], E_SImode))
            {
              switch (GET_MODE (operands[1]))
                {
                case E_SFmode:
                  if (gpc_reg_operand (operands[1], E_SFmode)
                      && 
#line 6425 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE))
                    return 439; /* *fix_truncsfsi2_p8 */
                  break;

                case E_DFmode:
                  if (gpc_reg_operand (operands[1], E_DFmode)
                      && 
#line 6425 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE))
                    return 441; /* *fix_truncdfsi2_p8 */
                  break;

                default:
                  break;
                }
            }
          if (pnum_clobbers != NULL
              && memory_operand (operands[0], E_SImode))
            {
              switch (GET_MODE (operands[1]))
                {
                case E_SFmode:
                  if (gpc_reg_operand (operands[1], E_SFmode)
                      && 
#line 6438 "../../gcc/config/rs6000/rs6000.md"
((SImode == SImode && TARGET_P8_VECTOR) || TARGET_P9_VECTOR))
                    {
                      *pnum_clobbers = 1;
                      return 447; /* *fix_truncsfsi2_mem */
                    }
                  break;

                case E_DFmode:
                  if (gpc_reg_operand (operands[1], E_DFmode)
                      && 
#line 6438 "../../gcc/config/rs6000/rs6000.md"
((SImode == SImode && TARGET_P8_VECTOR) || TARGET_P9_VECTOR))
                    {
                      *pnum_clobbers = 1;
                      return 453; /* *fix_truncdfsi2_mem */
                    }
                  break;

                default:
                  break;
                }
            }
          if (altivec_register_operand (operands[0], E_SImode))
            {
              switch (GET_MODE (operands[1]))
                {
                case E_KFmode:
                  if (altivec_register_operand (operands[1], E_KFmode)
                      && (
#line 15287 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
                    return 1131; /* fix_kfsi2_hw */
                  break;

                case E_TFmode:
                  if (altivec_register_operand (operands[1], E_TFmode)
                      && (
#line 15287 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
                    return 1133; /* fix_tfsi2_hw */
                  break;

                default:
                  break;
                }
            }
          if (pnum_clobbers == NULL)
            return -1;
          switch (pattern336 (
E_SImode))
            {
            case 0:
              if (!(
#line 15308 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 1151; /* *fix_trunckfsi2_mem */

            case 1:
              if (!(
#line 15308 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 1157; /* *fix_trunctfsi2_mem */

            default:
              return -1;
            }

        case E_DImode:
          x2 = XEXP (x1, 1);
          if (GET_MODE (x2) != E_DImode)
            return -1;
          if (gpc_reg_operand (operands[0], E_DImode))
            {
              switch (GET_MODE (operands[1]))
                {
                case E_SFmode:
                  if (gpc_reg_operand (operands[1], E_SFmode)
                      && 
#line 6389 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_FCFID))
                    return 429; /* *fix_truncsfdi2_fctidz */
                  break;

                case E_DFmode:
                  if (gpc_reg_operand (operands[1], E_DFmode)
                      && 
#line 6389 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_FCFID))
                    return 430; /* *fix_truncdfdi2_fctidz */
                  break;

                case E_DDmode:
                  if (gpc_reg_operand (operands[1], E_DDmode)
                      && 
#line 253 "../../gcc/config/rs6000/dfp.md"
(TARGET_DFP))
                    return 2451; /* fixdddi2 */
                  break;

                case E_TDmode:
                  if (gpc_reg_operand (operands[1], E_TDmode)
                      && 
#line 253 "../../gcc/config/rs6000/dfp.md"
(TARGET_DFP))
                    return 2452; /* fixtddi2 */
                  break;

                default:
                  break;
                }
            }
          if (!altivec_register_operand (operands[0], E_DImode))
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_KFmode:
              if (!altivec_register_operand (operands[1], E_KFmode)
                  || !(
#line 15287 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
                return -1;
              return 1135; /* fix_kfdi2_hw */

            case E_TFmode:
              if (!altivec_register_operand (operands[1], E_TFmode)
                  || !(
#line 15287 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
                return -1;
              return 1137; /* fix_tfdi2_hw */

            default:
              return -1;
            }

        case E_QImode:
          if (pnum_clobbers != NULL)
            {
              x2 = XEXP (x1, 1);
              if (GET_MODE (x2) == E_QImode)
                {
                  if (gpc_reg_operand (operands[0], E_QImode))
                    {
                      switch (GET_MODE (operands[1]))
                        {
                        case E_SFmode:
                          if (gpc_reg_operand (operands[1], E_SFmode)
                              && 
#line 6405 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE))
                            {
                              *pnum_clobbers = 1;
                              return 431; /* fix_truncsfqi2 */
                            }
                          break;

                        case E_DFmode:
                          if (gpc_reg_operand (operands[1], E_DFmode)
                              && 
#line 6405 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE))
                            {
                              *pnum_clobbers = 1;
                              return 435; /* fix_truncdfqi2 */
                            }
                          break;

                        default:
                          break;
                        }
                    }
                  if (memory_operand (operands[0], E_QImode))
                    {
                      switch (GET_MODE (operands[1]))
                        {
                        case E_SFmode:
                          if (gpc_reg_operand (operands[1], E_SFmode)
                              && 
#line 6438 "../../gcc/config/rs6000/rs6000.md"
((QImode == SImode && TARGET_P8_VECTOR) || TARGET_P9_VECTOR))
                            {
                              *pnum_clobbers = 1;
                              return 443; /* *fix_truncsfqi2_mem */
                            }
                          break;

                        case E_DFmode:
                          if (gpc_reg_operand (operands[1], E_DFmode)
                              && 
#line 6438 "../../gcc/config/rs6000/rs6000.md"
((QImode == SImode && TARGET_P8_VECTOR) || TARGET_P9_VECTOR))
                            {
                              *pnum_clobbers = 1;
                              return 449; /* *fix_truncdfqi2_mem */
                            }
                          break;

                        default:
                          break;
                        }
                    }
                }
            }
          x2 = XEXP (x1, 1);
          if (GET_MODE (x2) != E_QImode)
            return -1;
          if (altivec_register_operand (operands[0], E_QImode))
            {
              switch (GET_MODE (operands[1]))
                {
                case E_KFmode:
                  if (altivec_register_operand (operands[1], E_KFmode)
                      && (
#line 15296 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
                    return 1139; /* fix_trunckfqi2 */
                  break;

                case E_TFmode:
                  if (altivec_register_operand (operands[1], E_TFmode)
                      && (
#line 15296 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
                    return 1143; /* fix_trunctfqi2 */
                  break;

                default:
                  break;
                }
            }
          if (pnum_clobbers == NULL)
            return -1;
          switch (pattern336 (
E_QImode))
            {
            case 0:
              if (!(
#line 15308 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 1147; /* *fix_trunckfqi2_mem */

            case 1:
              if (!(
#line 15308 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 1153; /* *fix_trunctfqi2_mem */

            default:
              return -1;
            }

        case E_HImode:
          if (pnum_clobbers != NULL)
            {
              x2 = XEXP (x1, 1);
              if (GET_MODE (x2) == E_HImode)
                {
                  if (gpc_reg_operand (operands[0], E_HImode))
                    {
                      switch (GET_MODE (operands[1]))
                        {
                        case E_SFmode:
                          if (gpc_reg_operand (operands[1], E_SFmode)
                              && 
#line 6405 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE))
                            {
                              *pnum_clobbers = 1;
                              return 433; /* fix_truncsfhi2 */
                            }
                          break;

                        case E_DFmode:
                          if (gpc_reg_operand (operands[1], E_DFmode)
                              && 
#line 6405 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE))
                            {
                              *pnum_clobbers = 1;
                              return 437; /* fix_truncdfhi2 */
                            }
                          break;

                        default:
                          break;
                        }
                    }
                  if (memory_operand (operands[0], E_HImode))
                    {
                      switch (GET_MODE (operands[1]))
                        {
                        case E_SFmode:
                          if (gpc_reg_operand (operands[1], E_SFmode)
                              && 
#line 6438 "../../gcc/config/rs6000/rs6000.md"
((HImode == SImode && TARGET_P8_VECTOR) || TARGET_P9_VECTOR))
                            {
                              *pnum_clobbers = 1;
                              return 445; /* *fix_truncsfhi2_mem */
                            }
                          break;

                        case E_DFmode:
                          if (gpc_reg_operand (operands[1], E_DFmode)
                              && 
#line 6438 "../../gcc/config/rs6000/rs6000.md"
((HImode == SImode && TARGET_P8_VECTOR) || TARGET_P9_VECTOR))
                            {
                              *pnum_clobbers = 1;
                              return 451; /* *fix_truncdfhi2_mem */
                            }
                          break;

                        default:
                          break;
                        }
                    }
                }
            }
          x2 = XEXP (x1, 1);
          if (GET_MODE (x2) != E_HImode)
            return -1;
          if (altivec_register_operand (operands[0], E_HImode))
            {
              switch (GET_MODE (operands[1]))
                {
                case E_KFmode:
                  if (altivec_register_operand (operands[1], E_KFmode)
                      && (
#line 15296 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
                    return 1141; /* fix_trunckfhi2 */
                  break;

                case E_TFmode:
                  if (altivec_register_operand (operands[1], E_TFmode)
                      && (
#line 15296 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
                    return 1145; /* fix_trunctfhi2 */
                  break;

                default:
                  break;
                }
            }
          if (pnum_clobbers == NULL)
            return -1;
          switch (pattern336 (
E_HImode))
            {
            case 0:
              if (!(
#line 15308 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 1149; /* *fix_trunckfhi2_mem */

            case 1:
              if (!(
#line 15308 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 1155; /* *fix_trunctfhi2_mem */

            default:
              return -1;
            }

        case E_TImode:
          x2 = XEXP (x1, 1);
          if (GET_MODE (x2) != E_TImode)
            return -1;
          if (vsx_register_operand (operands[0], E_TImode))
            {
              switch (GET_MODE (operands[1]))
                {
                case E_KFmode:
                  if (vsx_register_operand (operands[1], E_KFmode)
                      && (
#line 6951 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWER10 && TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
                    return 495; /* fix_trunckfti2 */
                  break;

                case E_TFmode:
                  if (vsx_register_operand (operands[1], E_TFmode)
                      && (
#line 6951 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWER10 && TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
                    return 496; /* fix_trunctfti2 */
                  break;

                default:
                  break;
                }
            }
          if (!gpc_reg_operand (operands[0], E_TImode)
              || !gpc_reg_operand (operands[1], E_TDmode)
              || !
#line 261 "../../gcc/config/rs6000/dfp.md"
(TARGET_POWER10))
            return -1;
          return 2453; /* fixtdti2 */

        case E_V4SImode:
          x2 = XEXP (x1, 1);
          if (GET_MODE (x2) != E_V4SImode)
            return -1;
          if (gpc_reg_operand (operands[0], E_V4SImode)
              && gpc_reg_operand (operands[1], E_V4SFmode)
              && 
#line 2292 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V4SFmode)))
            return 1400; /* vsx_fix_truncv4sfv4si2 */
          if (!vsx_register_operand (operands[0], E_V4SImode)
              || !vsx_register_operand (operands[1], E_V4SFmode)
              || !
#line 2503 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V4SFmode)))
            return -1;
          return 1436; /* vsx_xvcvspsxws */

        case E_V2DImode:
          x2 = XEXP (x1, 1);
          if (GET_MODE (x2) != E_V2DImode)
            return -1;
          if (gpc_reg_operand (operands[0], E_V2DImode)
              && gpc_reg_operand (operands[1], E_V2DFmode)
              && 
#line 2292 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode)))
            return 1401; /* vsx_fix_truncv2dfv2di2 */
          if (!vsx_register_operand (operands[0], E_V2DImode)
              || !vsx_register_operand (operands[1], E_V2DFmode)
              || !
#line 2510 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode)))
            return -1;
          return 1438; /* vsx_xvcvdpsxds */

        case E_V4SFmode:
          x2 = XEXP (x1, 1);
          if (GET_MODE (x2) != E_V4SFmode)
            return -1;
          if (vsx_register_operand (operands[0], E_V4SFmode)
              && vsx_register_operand (operands[1], E_V4SFmode)
              && 
#line 2323 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V4SFmode)))
            return 1410; /* vsx_btruncv4sf2 */
          if (!register_operand (operands[0], E_V4SFmode)
              || !register_operand (operands[1], E_V4SFmode)
              || !
#line 2468 "../../gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V4SFmode)))
            return -1;
          return 2073; /* *altivec_vrfiz */

        case E_V2DFmode:
          if (!vsx_register_operand (operands[0], E_V2DFmode))
            return -1;
          x2 = XEXP (x1, 1);
          if (GET_MODE (x2) != E_V2DFmode
              || !vsx_register_operand (operands[1], E_V2DFmode)
              || !
#line 2323 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode)))
            return -1;
          return 1411; /* vsx_btruncv2df2 */

        case E_DDmode:
          if (!gpc_reg_operand (operands[0], E_DDmode))
            return -1;
          x2 = XEXP (x1, 1);
          if (GET_MODE (x2) != E_DDmode
              || !gpc_reg_operand (operands[1], E_DDmode)
              || !
#line 242 "../../gcc/config/rs6000/dfp.md"
(TARGET_DFP))
            return -1;
          return 2449; /* ftruncdd2 */

        case E_TDmode:
          if (!gpc_reg_operand (operands[0], E_TDmode))
            return -1;
          x2 = XEXP (x1, 1);
          if (GET_MODE (x2) != E_TDmode
              || !gpc_reg_operand (operands[1], E_TDmode)
              || !
#line 242 "../../gcc/config/rs6000/dfp.md"
(TARGET_DFP))
            return -1;
          return 2450; /* ftrunctd2 */

        default:
          return -1;
        }

    case 1:
      if (!
#line 2680 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode) && BYTES_BIG_ENDIAN))
        return -1;
      return 1450; /* vsx_xvcvspsxds_be */

    case 2:
      if (!
#line 2689 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode) && !BYTES_BIG_ENDIAN))
        return -1;
      return 1452; /* vsx_xvcvspsxds_le */

    default:
      return -1;
    }
}

 int
recog_137 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      res = recog_117 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case VEC_DUPLICATE:
      res = recog_118 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    default:
      break;
    }
  operands[1] = x2;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HImode:
      if (vsx_register_operand (operands[0], E_V8HImode)
          && xxspltib_constant_nosplit (operands[1], E_V8HImode)
          && 
#line 1156 "../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
        return 1284; /* xxspltib_v8hi_nosplit */
      if (altivec_register_operand (operands[0], E_V8HImode)
          && xxspltib_constant_split (operands[1], E_V8HImode)
          && 
#line 1174 "../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
        return 1287; /* *xxspltib_v8hi_split */
      if (nonimmediate_operand (operands[0], E_V8HImode)
          && input_operand (operands[1], E_V8HImode))
        {
          if (
#line 1258 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWERPC64 && VECTOR_MEM_VSX_P (V8HImode)
   && (register_operand (operands[0], V8HImode) 
       || register_operand (operands[1], V8HImode))))
            return 1292; /* vsx_movv8hi_64bit */
          if (
#line 1312 "../../gcc/config/rs6000/vsx.md"
(!TARGET_POWERPC64 && VECTOR_MEM_VSX_P (V8HImode)
   && (register_operand (operands[0], V8HImode) 
       || register_operand (operands[1], V8HImode))))
            return 1302; /* *vsx_movv8hi_32bit */
          if (
#line 245 "../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_P (V8HImode)
   && (register_operand (operands[0], V8HImode) 
       || register_operand (operands[1], V8HImode))))
            return 1790; /* *altivec_movv8hi */
        }
      break;

    case E_V4SImode:
      if (vsx_register_operand (operands[0], E_V4SImode)
          && xxspltib_constant_nosplit (operands[1], E_V4SImode)
          && 
#line 1156 "../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
        return 1285; /* xxspltib_v4si_nosplit */
      if (altivec_register_operand (operands[0], E_V4SImode)
          && xxspltib_constant_split (operands[1], E_V4SImode)
          && 
#line 1174 "../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
        return 1288; /* *xxspltib_v4si_split */
      if (nonimmediate_operand (operands[0], E_V4SImode)
          && input_operand (operands[1], E_V4SImode))
        {
          if (
#line 1258 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWERPC64 && VECTOR_MEM_VSX_P (V4SImode)
   && (register_operand (operands[0], V4SImode) 
       || register_operand (operands[1], V4SImode))))
            return 1293; /* vsx_movv4si_64bit */
          if (
#line 1312 "../../gcc/config/rs6000/vsx.md"
(!TARGET_POWERPC64 && VECTOR_MEM_VSX_P (V4SImode)
   && (register_operand (operands[0], V4SImode) 
       || register_operand (operands[1], V4SImode))))
            return 1303; /* *vsx_movv4si_32bit */
        }
      break;

    case E_V2DImode:
      if (vsx_register_operand (operands[0], E_V2DImode)
          && xxspltib_constant_nosplit (operands[1], E_V2DImode)
          && 
#line 1156 "../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
        return 1286; /* xxspltib_v2di_nosplit */
      if (altivec_register_operand (operands[0], E_V2DImode))
        {
          if (xxspltib_constant_split (operands[1], E_V2DImode)
              && 
#line 1174 "../../gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
            return 1289; /* *xxspltib_v2di_split */
          if (vspltisw_vupkhsw_constant_split (operands[1], E_V2DImode)
              && 
#line 1213 "../../gcc/config/rs6000/vsx.md"
(TARGET_P8_VECTOR && vspltisw_vupkhsw_constant_split (operands[1], V2DImode)))
            return 1290; /* *vspltisw_v2di_split */
        }
      if (nonimmediate_operand (operands[0], E_V2DImode)
          && input_operand (operands[1], E_V2DImode))
        {
          if (
#line 1258 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWERPC64 && VECTOR_MEM_VSX_P (V2DImode)
   && (register_operand (operands[0], V2DImode) 
       || register_operand (operands[1], V2DImode))))
            return 1294; /* vsx_movv2di_64bit */
          if (
#line 1312 "../../gcc/config/rs6000/vsx.md"
(!TARGET_POWERPC64 && VECTOR_MEM_VSX_P (V2DImode)
   && (register_operand (operands[0], V2DImode) 
       || register_operand (operands[1], V2DImode))))
            return 1304; /* *vsx_movv2di_32bit */
          if (
#line 245 "../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_P (V2DImode)
   && (register_operand (operands[0], V2DImode) 
       || register_operand (operands[1], V2DImode))))
            return 1794; /* *altivec_movv2di */
        }
      break;

    default:
      break;
    }
  operands[0] = x2;
  res = recog_119 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[0] = x3;
  switch (GET_CODE (x2))
    {
    case VEC_DUPLICATE:
      res = recog_120 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case MEM:
      res = recog_121 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    default:
      break;
    }
  if (pnum_clobbers != NULL
      && memory_operand (operands[0], E_V4SImode))
    {
      operands[1] = x2;
      if (immediate_operand (operands[1], E_V4SImode)
          && 
#line 3458 "../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN
   && VECTOR_MEM_VSX_P (V4SImode)
   && !TARGET_P9_VECTOR
   && !altivec_indexed_or_indirect_operand (operands[0], V4SImode)
   && const_vec_duplicate_p (operands[1])))
        {
          *pnum_clobbers = 1;
          return 1488; /* vsx_stxvd2x4_le_const_v4si */
        }
    }
  if (nonimmediate_operand (operands[0], E_V4SImode))
    {
      operands[1] = x2;
      if (input_operand (operands[1], E_V4SImode)
          && 
#line 245 "../../gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_P (V4SImode)
   && (register_operand (operands[0], V4SImode) 
       || register_operand (operands[1], V4SImode))))
        return 1789; /* *altivec_movv4si */
    }
  operands[0] = x2;
  switch (pattern32 (x3, 
E_V4SImode))
    {
    case 0:
      if ((
#line 3218 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
        return 2240; /* altivec_stvx_v4si_2op_si */
      break;

    case 1:
      if ((
#line 3218 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
        return 2241; /* altivec_stvx_v4si_2op_di */
      break;

    case 2:
      if ((
#line 3226 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
        return 2258; /* altivec_stvx_v4si_1op_si */
      break;

    case 3:
      if ((
#line 3226 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
        return 2259; /* altivec_stvx_v4si_1op_di */
      break;

    default:
      break;
    }
  if (GET_CODE (x2) != MEM)
    return -1;
  switch (pattern35 (x1, 
E_V4SImode))
    {
    case 0:
      if (!(
#line 3162 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
        return -1;
      return 2195; /* altivec_lvx_v4si_2op_si */

    case 1:
      if (!(
#line 3162 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
        return -1;
      return 2196; /* altivec_lvx_v4si_2op_di */

    case 2:
      if (!(
#line 3170 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
        return -1;
      return 2213; /* altivec_lvx_v4si_1op_si */

    case 3:
      if (!(
#line 3170 "../../gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
        return -1;
      return 2214; /* altivec_lvx_v4si_1op_di */

    default:
      return -1;
    }
}

 int
recog_146 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      if (GET_MODE (x3) != E_SFmode)
        return -1;
      if (gpc_reg_operand (operands[0], E_SFmode)
          && gpc_reg_operand (operands[1], E_DFmode)
          && 
#line 5278 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT))
        return 330; /* *truncdfsf2_fpr */
      if (pnum_clobbers == NULL
          || !vsx_register_operand (operands[0], E_SFmode))
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_KFmode:
          if (!altivec_register_operand (operands[1], E_KFmode)
              || !(
#line 15257 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 1129; /* trunckfsf2_hw */

        case E_TFmode:
          if (!altivec_register_operand (operands[1], E_TFmode)
              || !(
#line 15257 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 1130; /* trunctfsf2_hw */

        default:
          return -1;
        }

    case E_DFmode:
      if (GET_MODE (x3) != E_DFmode)
        return -1;
      if (gpc_reg_operand (operands[0], E_DFmode))
        {
          switch (GET_MODE (operands[1]))
            {
            case E_IFmode:
              if (gpc_reg_operand (operands[1], E_IFmode))
                {
                  if ((
#line 8978 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_XL_COMPAT
   && TARGET_HARD_FLOAT && TARGET_LONG_DOUBLE_128) && 
#line 630 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IBM_P (IFmode))))
                    return 615; /* truncifdf2_internal1 */
                  if ((
#line 8994 "../../gcc/config/rs6000/rs6000.md"
(TARGET_XL_COMPAT && TARGET_HARD_FLOAT
   && TARGET_LONG_DOUBLE_128) && 
#line 630 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IBM_P (IFmode))))
                    return 617; /* truncifdf2_internal2 */
                }
              break;

            case E_TFmode:
              if (gpc_reg_operand (operands[1], E_TFmode))
                {
                  if ((
#line 8978 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_XL_COMPAT
   && TARGET_HARD_FLOAT && TARGET_LONG_DOUBLE_128) && 
#line 631 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IBM_P (TFmode))))
                    return 616; /* trunctfdf2_internal1 */
                  if ((
#line 8994 "../../gcc/config/rs6000/rs6000.md"
(TARGET_XL_COMPAT && TARGET_HARD_FLOAT
   && TARGET_LONG_DOUBLE_128) && 
#line 631 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IBM_P (TFmode))))
                    return 618; /* trunctfdf2_internal2 */
                }
              break;

            default:
              break;
            }
        }
      if (!altivec_register_operand (operands[0], E_DFmode))
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_KFmode:
          if (!altivec_register_operand (operands[1], E_KFmode)
              || !(
#line 15244 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
            return -1;
          return 1127; /* trunckfdf2_hw */

        case E_TFmode:
          if (!altivec_register_operand (operands[1], E_TFmode)
              || !(
#line 15244 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
            return -1;
          return 1128; /* trunctfdf2_hw */

        default:
          return -1;
        }

    case E_SDmode:
      if (!gpc_reg_operand (operands[0], E_SDmode)
          || GET_MODE (x3) != E_SDmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_DDmode:
          if (!gpc_reg_operand (operands[1], E_DDmode)
              || !
#line 80 "../../gcc/config/rs6000/dfp.md"
(TARGET_DFP))
            return -1;
          return 2426; /* truncddsd2 */

        case E_TDmode:
          if (pnum_clobbers == NULL
              || !gpc_reg_operand (operands[1], E_TDmode)
              || !
#line 165 "../../gcc/config/rs6000/dfp.md"
(TARGET_DFP))
            return -1;
          *pnum_clobbers = 2;
          return 2435; /* trunctdsd2 */

        default:
          return -1;
        }

    case E_DDmode:
      if (pnum_clobbers == NULL
          || !gpc_reg_operand (operands[0], E_DDmode)
          || GET_MODE (x3) != E_DDmode
          || !gpc_reg_operand (operands[1], E_TDmode)
          || !
#line 154 "../../gcc/config/rs6000/dfp.md"
(TARGET_DFP))
        return -1;
      *pnum_clobbers = 1;
      return 2434; /* trunctddd2 */

    default:
      return -1;
    }
}

 int
recog_155 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x2, 0);
  operands[3] = x5;
  if (!cc_reg_operand (operands[3], E_CCmode)
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x6 = XEXP (x3, 0);
  x7 = XEXP (x6, 0);
  switch (GET_CODE (x7))
    {
    case MULT:
      if (GET_MODE (x7) != E_SImode)
        return -1;
      x8 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x8) != SET)
        return -1;
      x9 = XEXP (x8, 1);
      if (GET_CODE (x9) != PLUS
          || GET_MODE (x9) != E_SImode)
        return -1;
      x10 = XEXP (x9, 0);
      if (GET_CODE (x10) != MULT
          || GET_MODE (x10) != E_SImode
          || GET_MODE (x6) != E_SImode)
        return -1;
      x11 = XEXP (x7, 0);
      if (GET_MODE (x11) != E_SImode)
        return -1;
      x12 = XEXP (x7, 1);
      if (GET_MODE (x12) != E_SImode)
        return -1;
      x13 = XEXP (x6, 1);
      operands[4] = x13;
      if (!gpc_reg_operand (operands[4], E_SImode))
        return -1;
      x14 = XEXP (x8, 0);
      operands[0] = x14;
      if (!gpc_reg_operand (operands[0], E_SImode))
        return -1;
      x15 = XEXP (x10, 0);
      if (GET_MODE (x15) != E_SImode)
        return -1;
      x16 = XEXP (x10, 1);
      if (GET_MODE (x16) != E_SImode)
        return -1;
      x17 = XEXP (x9, 1);
      if (!rtx_equal_p (x17, operands[4]))
        return -1;
      switch (GET_CODE (x11))
        {
        case ASHIFTRT:
          if (pattern601 (x1, 
ASHIFTRT) != 0)
            return -1;
          switch (GET_CODE (x12))
            {
            case SIGN_EXTEND:
              if (pattern606 (x1, 
SIGN_EXTEND) != 0
                  || !
#line 1274 "../../gcc/config/rs6000/rs6000.md"
(TARGET_MULHW))
                return -1;
              return 37; /* *macchwc */

            case ASHIFTRT:
              if (pattern607 (x1, 
ASHIFTRT) != 0
                  || !
#line 1340 "../../gcc/config/rs6000/rs6000.md"
(TARGET_MULHW))
                return -1;
              return 41; /* *machhwc */

            default:
              return -1;
            }

        case LSHIFTRT:
          if (pattern601 (x1, 
LSHIFTRT) != 0)
            return -1;
          switch (GET_CODE (x12))
            {
            case ZERO_EXTEND:
              if (pattern606 (x1, 
ZERO_EXTEND) != 0
                  || !
#line 1306 "../../gcc/config/rs6000/rs6000.md"
(TARGET_MULHW))
                return -1;
              return 39; /* *macchwuc */

            case LSHIFTRT:
              if (pattern607 (x1, 
LSHIFTRT) != 0
                  || !
#line 1375 "../../gcc/config/rs6000/rs6000.md"
(TARGET_MULHW))
                return -1;
              return 43; /* *machhwuc */

            default:
              return -1;
            }

        case SIGN_EXTEND:
          if (pattern602 (x1, 
SIGN_EXTEND) != 0
              || !
#line 1406 "../../gcc/config/rs6000/rs6000.md"
(TARGET_MULHW))
            return -1;
          return 45; /* *maclhwc */

        case ZERO_EXTEND:
          if (pattern602 (x1, 
ZERO_EXTEND) != 0
              || !
#line 1435 "../../gcc/config/rs6000/rs6000.md"
(TARGET_MULHW))
            return -1;
          return 47; /* *maclhwuc */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      operands[1] = x7;
      x13 = XEXP (x6, 1);
      operands[2] = x13;
      switch (GET_CODE (operands[2]))
        {
        case REG:
        case SUBREG:
          switch (pattern202 (x1, 
PLUS))
            {
            case 0:
              if (!
#line 1872 "../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode))
                return -1;
              return 70; /* *addsi3_dot */

            case 1:
              if (!(
#line 1872 "../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 71; /* *adddi3_dot */

            case 2:
              if (!
#line 1896 "../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode))
                return -1;
              return 72; /* *addsi3_dot2 */

            case 3:
              if (!(
#line 1896 "../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 73; /* *adddi3_dot2 */

            default:
              return -1;
            }

        case CONST_INT:
          if (pnum_clobbers == NULL)
            return -1;
          x8 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x8) != SET)
            return -1;
          x9 = XEXP (x8, 1);
          if (GET_CODE (x9) != PLUS)
            return -1;
          x14 = XEXP (x8, 0);
          operands[0] = x14;
          x10 = XEXP (x9, 0);
          if (!rtx_equal_p (x10, operands[1]))
            return -1;
          x17 = XEXP (x9, 1);
          if (!rtx_equal_p (x17, operands[2]))
            return -1;
          switch (GET_MODE (x6))
            {
            case E_SImode:
              if (pattern582 (x9, 
E_SImode) != 0
                  || !
#line 1944 "../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode))
                return -1;
              *pnum_clobbers = 1;
              return 76; /* *addsi3_imm_dot2 */

            case E_DImode:
              if (pattern582 (x9, 
E_DImode) != 0
                  || !(
#line 1944 "../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              *pnum_clobbers = 1;
              return 77; /* *adddi3_imm_dot2 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_168 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case ZERO_EXTEND:
      switch (pattern178 (x1, 
ZERO_EXTEND))
        {
        case 0:
          return 9; /* *zero_extendqisi2_dot */

        case 1:
          return 15; /* *zero_extendhisi2_dot */

        case 2:
          if (!
#line 490 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
            return -1;
          return 10; /* *zero_extendqidi2_dot */

        case 3:
          if (!
#line 493 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
            return -1;
          return 16; /* *zero_extendhidi2_dot */

        case 4:
          if (!
#line 496 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
            return -1;
          return 20; /* *zero_extendsidi2_dot */

        case 5:
          return 11; /* *zero_extendqisi2_dot2 */

        case 6:
          return 17; /* *zero_extendhisi2_dot2 */

        case 7:
          if (!
#line 490 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
            return -1;
          return 12; /* *zero_extendqidi2_dot2 */

        case 8:
          if (!
#line 493 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
            return -1;
          return 18; /* *zero_extendhidi2_dot2 */

        case 9:
          if (!
#line 496 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
            return -1;
          return 21; /* *zero_extendsidi2_dot2 */

        default:
          return -1;
        }

    case SIGN_EXTEND:
      switch (pattern178 (x1, 
SIGN_EXTEND))
        {
        case 0:
          return 24; /* *extendqisi2_dot */

        case 1:
          return 30; /* *extendhisi2_dot */

        case 2:
          if (!
#line 490 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
            return -1;
          return 25; /* *extendqidi2_dot */

        case 3:
          if (!
#line 493 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
            return -1;
          return 31; /* *extendhidi2_dot */

        case 4:
          if (!
#line 496 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
            return -1;
          return 35; /* *extendsidi2_dot */

        case 5:
          return 26; /* *extendqisi2_dot2 */

        case 6:
          return 32; /* *extendhisi2_dot2 */

        case 7:
          if (!
#line 490 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
            return -1;
          return 27; /* *extendqidi2_dot2 */

        case 8:
          if (!
#line 493 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
            return -1;
          return 33; /* *extendhidi2_dot2 */

        case 9:
          if (!
#line 496 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
            return -1;
          return 36; /* *extendsidi2_dot2 */

        default:
          return -1;
        }

    case PLUS:
      return recog_155 (x1, insn, pnum_clobbers);

    case MINUS:
      x5 = XEXP (x3, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x6 = XEXP (x2, 0);
      operands[3] = x6;
      if (!cc_reg_operand (operands[3], E_CCmode)
          || GET_MODE (x3) != E_CCmode)
        return -1;
      x7 = XEXP (x4, 1);
      switch (GET_CODE (x7))
        {
        case MULT:
          if (GET_MODE (x7) != E_SImode)
            return -1;
          x8 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x8) != SET)
            return -1;
          x9 = XEXP (x8, 1);
          if (GET_CODE (x9) != MINUS
              || GET_MODE (x9) != E_SImode)
            return -1;
          x10 = XEXP (x9, 1);
          if (GET_CODE (x10) != MULT
              || GET_MODE (x10) != E_SImode
              || GET_MODE (x4) != E_SImode)
            return -1;
          x11 = XEXP (x4, 0);
          operands[4] = x11;
          if (!gpc_reg_operand (operands[4], E_SImode))
            return -1;
          x12 = XEXP (x7, 0);
          if (GET_MODE (x12) != E_SImode)
            return -1;
          x13 = XEXP (x7, 1);
          if (GET_MODE (x13) != E_SImode)
            return -1;
          x14 = XEXP (x8, 0);
          operands[0] = x14;
          if (!gpc_reg_operand (operands[0], E_SImode))
            return -1;
          x15 = XEXP (x10, 0);
          if (GET_MODE (x15) != E_SImode)
            return -1;
          x16 = XEXP (x10, 1);
          if (GET_MODE (x16) != E_SImode)
            return -1;
          x17 = XEXP (x9, 0);
          if (!rtx_equal_p (x17, operands[4]))
            return -1;
          switch (GET_CODE (x12))
            {
            case ASHIFTRT:
              x18 = XEXP (x12, 1);
              if (x18 != const_int_rtx[MAX_SAVED_CONST_INT + 16]
                  || GET_CODE (x15) != ASHIFTRT)
                return -1;
              x19 = XEXP (x15, 1);
              if (x19 != const_int_rtx[MAX_SAVED_CONST_INT + 16])
                return -1;
              x20 = XEXP (x12, 0);
              if (!gpc_reg_operand (x20, E_SImode))
                return -1;
              switch (GET_CODE (x13))
                {
                case SIGN_EXTEND:
                  if (GET_CODE (x16) != SIGN_EXTEND)
                    return -1;
                  operands[2] = x20;
                  x21 = XEXP (x13, 0);
                  operands[1] = x21;
                  if (!gpc_reg_operand (operands[1], E_HImode))
                    return -1;
                  x22 = XEXP (x15, 0);
                  if (!rtx_equal_p (x22, operands[2]))
                    return -1;
                  x23 = XEXP (x16, 0);
                  if (!rtx_equal_p (x23, operands[1])
                      || !
#line 1466 "../../gcc/config/rs6000/rs6000.md"
(TARGET_MULHW))
                    return -1;
                  return 49; /* *nmacchwc */

                case ASHIFTRT:
                  x24 = XEXP (x13, 1);
                  if (x24 != const_int_rtx[MAX_SAVED_CONST_INT + 16]
                      || GET_CODE (x16) != ASHIFTRT)
                    return -1;
                  x25 = XEXP (x16, 1);
                  if (x25 != const_int_rtx[MAX_SAVED_CONST_INT + 16])
                    return -1;
                  operands[1] = x20;
                  x21 = XEXP (x13, 0);
                  operands[2] = x21;
                  if (!gpc_reg_operand (operands[2], E_SImode))
                    return -1;
                  x22 = XEXP (x15, 0);
                  if (!rtx_equal_p (x22, operands[1]))
                    return -1;
                  x23 = XEXP (x16, 0);
                  if (!rtx_equal_p (x23, operands[2])
                      || !
#line 1500 "../../gcc/config/rs6000/rs6000.md"
(TARGET_MULHW))
                    return -1;
                  return 51; /* *nmachhwc */

                default:
                  return -1;
                }

            case SIGN_EXTEND:
              if (GET_CODE (x13) != SIGN_EXTEND
                  || GET_CODE (x15) != SIGN_EXTEND
                  || GET_CODE (x16) != SIGN_EXTEND)
                return -1;
              x20 = XEXP (x12, 0);
              operands[1] = x20;
              if (!gpc_reg_operand (operands[1], E_HImode))
                return -1;
              x21 = XEXP (x13, 0);
              operands[2] = x21;
              if (!gpc_reg_operand (operands[2], E_HImode))
                return -1;
              x22 = XEXP (x15, 0);
              if (!rtx_equal_p (x22, operands[1]))
                return -1;
              x23 = XEXP (x16, 0);
              if (!rtx_equal_p (x23, operands[2])
                  || !
#line 1531 "../../gcc/config/rs6000/rs6000.md"
(TARGET_MULHW))
                return -1;
              return 53; /* *nmaclhwc */

            default:
              return -1;
            }

        case REG:
        case SUBREG:
          operands[1] = x7;
          x11 = XEXP (x4, 0);
          operands[2] = x11;
          switch (pattern486 (x1))
            {
            case 0:
              if (!
#line 2215 "../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode))
                return -1;
              return 104; /* *subfsi3_dot */

            case 1:
              if (!(
#line 2215 "../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 105; /* *subfdi3_dot */

            case 2:
              if (!
#line 2239 "../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode))
                return -1;
              return 106; /* *subfsi3_dot2 */

            case 3:
              if (!(
#line 2239 "../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 107; /* *subfdi3_dot2 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case MULT:
      x5 = XEXP (x3, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x6 = XEXP (x2, 0);
      operands[3] = x6;
      if (!cc_reg_operand (operands[3], E_CCmode)
          || GET_MODE (x3) != E_CCmode)
        return -1;
      x11 = XEXP (x4, 0);
      switch (GET_CODE (x11))
        {
        case ASHIFTRT:
          if (pattern440 (x1, 
ASHIFTRT) != 0)
            return -1;
          x7 = XEXP (x4, 1);
          switch (GET_CODE (x7))
            {
            case SIGN_EXTEND:
              if (pattern598 (x1, 
SIGN_EXTEND) != 0
                  || !
#line 1560 "../../gcc/config/rs6000/rs6000.md"
(TARGET_MULHW))
                return -1;
              return 55; /* *mulchwc */

            case ASHIFTRT:
              if (pattern599 (x1, 
ASHIFTRT) != 0
                  || !
#line 1620 "../../gcc/config/rs6000/rs6000.md"
(TARGET_MULHW))
                return -1;
              return 59; /* *mulhhwc */

            default:
              return -1;
            }

        case LSHIFTRT:
          if (pattern440 (x1, 
LSHIFTRT) != 0)
            return -1;
          x7 = XEXP (x4, 1);
          switch (GET_CODE (x7))
            {
            case ZERO_EXTEND:
              if (pattern598 (x1, 
ZERO_EXTEND) != 0
                  || !
#line 1589 "../../gcc/config/rs6000/rs6000.md"
(TARGET_MULHW))
                return -1;
              return 57; /* *mulchwuc */

            case LSHIFTRT:
              if (pattern599 (x1, 
LSHIFTRT) != 0
                  || !
#line 1652 "../../gcc/config/rs6000/rs6000.md"
(TARGET_MULHW))
                return -1;
              return 61; /* *mulhhwuc */

            default:
              return -1;
            }

        case SIGN_EXTEND:
          if (pattern441 (x1, 
SIGN_EXTEND) != 0
              || !
#line 1680 "../../gcc/config/rs6000/rs6000.md"
(TARGET_MULHW))
            return -1;
          return 63; /* *mullhwc */

        case ZERO_EXTEND:
          if (pattern441 (x1, 
ZERO_EXTEND) != 0
              || !
#line 1706 "../../gcc/config/rs6000/rs6000.md"
(TARGET_MULHW))
            return -1;
          return 65; /* *mullhwuc */

        case REG:
        case SUBREG:
          switch (pattern203 (x1, 
MULT))
            {
            case 0:
              if (!
#line 3124 "../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode))
                return -1;
              return 167; /* *mulsi3_dot */

            case 1:
              if (!(
#line 3124 "../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 168; /* *muldi3_dot */

            case 2:
              if (!
#line 3149 "../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode))
                return -1;
              return 169; /* *mulsi3_dot2 */

            case 3:
              if (!(
#line 3149 "../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              return 170; /* *muldi3_dot2 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case NOT:
      switch (pattern181 (x1, 
NOT))
        {
        case 0:
          if (!
#line 2132 "../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode))
            return -1;
          return 98; /* *one_cmplsi2_dot */

        case 1:
          if (!(
#line 2132 "../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 99; /* *one_cmpldi2_dot */

        case 2:
          if (!
#line 2153 "../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode))
            return -1;
          return 100; /* *one_cmplsi2_dot2 */

        case 3:
          if (!(
#line 2153 "../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 101; /* *one_cmpldi2_dot2 */

        default:
          return -1;
        }

    case NEG:
      switch (pattern181 (x1, 
NEG))
        {
        case 0:
          if (!
#line 2410 "../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode))
            return -1;
          return 129; /* *negsi2_dot */

        case 1:
          if (!(
#line 2410 "../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 130; /* *negdi2_dot */

        case 2:
          if (!
#line 2431 "../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode))
            return -1;
          return 131; /* *negsi2_dot2 */

        case 3:
          if (!(
#line 2431 "../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 132; /* *negdi2_dot2 */

        default:
          return -1;
        }

    case DIV:
      if (pattern182 (x1, pnum_clobbers, 
DIV) != 0
          || GET_MODE (x3) != E_CCmode)
        return -1;
      x11 = XEXP (x4, 0);
      operands[1] = x11;
      x7 = XEXP (x4, 1);
      operands[2] = x7;
      x8 = XVECEXP (x1, 0, 1);
      x14 = XEXP (x8, 0);
      operands[0] = x14;
      x9 = XEXP (x8, 1);
      x17 = XEXP (x9, 0);
      if (!rtx_equal_p (x17, operands[1]))
        return -1;
      x10 = XEXP (x9, 1);
      if (!rtx_equal_p (x10, operands[2]))
        return -1;
      switch (GET_MODE (x4))
        {
        case E_SImode:
          if (pattern575 (x9, 
E_SImode) != 0
              || !
#line 3420 "../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode))
            return -1;
          *pnum_clobbers = 1;
          return 196; /* *divsi3_sra_dot2 */

        case E_DImode:
          if (pattern575 (x9, 
E_DImode) != 0
              || !(
#line 3420 "../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 1;
          return 197; /* *divdi3_sra_dot2 */

        default:
          return -1;
        }

    case AND:
    case IOR:
    case XOR:
      x5 = XEXP (x3, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x6 = XEXP (x2, 0);
      if (!cc_reg_operand (x6, E_CCmode)
          || GET_MODE (x3) != E_CCmode)
        return -1;
      if (GET_CODE (x4) == AND)
        {
          res = recog_154 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      operands[4] = x6;
      switch (pattern391 (x1))
        {
        case 0:
          if (!
#line 4016 "../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode))
            return -1;
          return 228; /* *boolsi3_dot */

        case 1:
          if (!(
#line 4016 "../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 229; /* *booldi3_dot */

        case 2:
          if (!
#line 4039 "../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode))
            return -1;
          return 230; /* *boolsi3_dot2 */

        case 3:
          if (!(
#line 4039 "../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 231; /* *booldi3_dot2 */

        case 4:
          if (!
#line 4071 "../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode))
            return -1;
          return 234; /* *boolcsi3_dot */

        case 5:
          if (!(
#line 4071 "../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 235; /* *boolcdi3_dot */

        case 6:
          if (!
#line 4094 "../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode))
            return -1;
          return 236; /* *boolcsi3_dot2 */

        case 7:
          if (!(
#line 4094 "../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 237; /* *boolcdi3_dot2 */

        case 8:
          if (!
#line 4126 "../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode))
            return -1;
          return 240; /* *boolccsi3_dot */

        case 9:
          if (!(
#line 4126 "../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 241; /* *boolccdi3_dot */

        case 10:
          if (!
#line 4149 "../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode))
            return -1;
          return 242; /* *boolccsi3_dot2 */

        case 11:
          if (!(
#line 4149 "../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 243; /* *boolccdi3_dot2 */

        default:
          return -1;
        }

    case ROTATE:
      switch (pattern184 (x1, 
ROTATE))
        {
        case 0:
          if (!
#line 4590 "../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode))
            return -1;
          return 278; /* *rotlsi3_dot */

        case 1:
          if (!(
#line 4590 "../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 279; /* *rotldi3_dot */

        case 2:
          if (!
#line 4615 "../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode))
            return -1;
          return 280; /* *rotlsi3_dot2 */

        case 3:
          if (!(
#line 4615 "../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 281; /* *rotldi3_dot2 */

        default:
          return -1;
        }

    case ASHIFT:
      switch (pattern185 (x1))
        {
        case 0:
          if (!
#line 4658 "../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode))
            return -1;
          return 285; /* *ashlsi3_dot */

        case 1:
          if (!(
#line 4658 "../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 286; /* *ashldi3_dot */

        case 2:
          if (!
#line 4683 "../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode))
            return -1;
          return 287; /* *ashlsi3_dot2 */

        case 3:
          if (!(
#line 4683 "../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 288; /* *ashldi3_dot2 */

        case 4:
          if (!
#line 4732 "../../gcc/config/rs6000/rs6000.md"
(TARGET_EXTSWSLI))
            return -1;
          return 290; /* ashdi3_extswsli_dot */

        case 5:
          if (!
#line 4782 "../../gcc/config/rs6000/rs6000.md"
(TARGET_EXTSWSLI))
            return -1;
          return 291; /* ashdi3_extswsli_dot2 */

        default:
          return -1;
        }

    case LSHIFTRT:
      switch (pattern184 (x1, 
LSHIFTRT))
        {
        case 0:
          if (!
#line 4847 "../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode))
            return -1;
          return 295; /* *lshrsi3_dot */

        case 1:
          if (!(
#line 4847 "../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 296; /* *lshrdi3_dot */

        case 2:
          if (!
#line 4872 "../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode))
            return -1;
          return 297; /* *lshrsi3_dot2 */

        case 3:
          if (!(
#line 4872 "../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 298; /* *lshrdi3_dot2 */

        default:
          return -1;
        }

    case ASHIFTRT:
      if (pattern182 (x1, pnum_clobbers, 
ASHIFTRT) != 0
          || GET_MODE (x3) != E_CCmode)
        return -1;
      x11 = XEXP (x4, 0);
      operands[1] = x11;
      x7 = XEXP (x4, 1);
      operands[2] = x7;
      if (!reg_or_cint_operand (operands[2], E_SImode))
        return -1;
      switch (pattern183 (x1))
        {
        case 0:
          if (!
#line 4945 "../../gcc/config/rs6000/rs6000.md"
(SImode == Pmode))
            return -1;
          *pnum_clobbers = 1;
          return 304; /* *ashrsi3_dot2 */

        case 1:
          if (!(
#line 4945 "../../gcc/config/rs6000/rs6000.md"
(DImode == Pmode) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 1;
          return 305; /* *ashrdi3_dot2 */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      operands[1] = x4;
      x5 = XEXP (x3, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x8 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x8) != SET)
        return -1;
      x6 = XEXP (x2, 0);
      operands[2] = x6;
      if (!cc_reg_operand (operands[2], E_CCmode))
        return -1;
      switch (pattern442 (x1))
        {
        case 0:
          if (!
#line 513 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWERPC64))
            return -1;
          return 574; /* *movsi_internal2 */

        case 1:
          if (!
#line 513 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
            return -1;
          return 575; /* *movdi_internal2 */

        default:
          return -1;
        }

    case UNSPEC:
      if (pattern186 (x1, 
CLOBBER, 
E_CCFPmode) != 0
          || GET_MODE (x3) != E_CCFPmode
          || GET_MODE (x4) != E_V2DFmode)
        return -1;
      x5 = XEXP (x3, 1);
      if (!zero_constant (x5, E_V2DFmode))
        return -1;
      x8 = XVECEXP (x1, 0, 1);
      x14 = XEXP (x8, 0);
      operands[0] = x14;
      switch (XVECLEN (x4, 0))
        {
        case 3:
          x26 = XVECEXP (x4, 0, 0);
          operands[1] = x26;
          x27 = XVECEXP (x4, 0, 1);
          operands[2] = x27;
          x28 = XVECEXP (x4, 0, 2);
          operands[3] = x28;
          if (!const_0_to_1_operand (operands[3], E_QImode))
            return -1;
          operands[4] = x5;
          switch (XINT (x4, 1))
            {
            case 342:
              switch (pattern583 ())
                {
                case 0:
                  if (!
#line 4610 "../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
                    return -1;
                  return 2337; /* *bcdadd_test_v1ti */

                case 1:
                  if (!
#line 4610 "../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
                    return -1;
                  return 2339; /* *bcdadd_test_v16qi */

                default:
                  return -1;
                }

            case 343:
              switch (pattern583 ())
                {
                case 0:
                  if (!
#line 4610 "../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
                    return -1;
                  return 2338; /* *bcdsub_test_v1ti */

                case 1:
                  if (!
#line 4610 "../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
                    return -1;
                  return 2340; /* *bcdsub_test_v16qi */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 1:
          if (XINT (x4, 1) != 343)
            return -1;
          x26 = XVECEXP (x4, 0, 0);
          operands[1] = x26;
          operands[2] = x5;
          switch (GET_MODE (operands[1]))
            {
            case E_V1TImode:
              if (!register_operand (operands[1], E_V1TImode)
                  || !scratch_operand (operands[0], E_V1TImode)
                  || !
#line 4737 "../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
                return -1;
              return 2353; /* *bcdinvalid_v1ti */

            case E_V16QImode:
              if (!register_operand (operands[1], E_V16QImode)
                  || !scratch_operand (operands[0], E_V16QImode)
                  || !
#line 4737 "../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
                return -1;
              return 2354; /* *bcdinvalid_v16qi */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case MEM:
      switch (pattern190 (x1))
        {
        case 0:
          if (!
#line 28 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2509; /* *ld_cmpdi_cr0_DI_clobber_CC_none */

        case 1:
          if (!
#line 112 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2513; /* *lwz_cmpwi_cr0_SI_clobber_CC_none */

        case 2:
          if (!
#line 239 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2519; /* *lha_cmpdi_cr0_HI_clobber_CC_sign */

        case 3:
          if (!(
#line 239 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2520; /* *lha_cmpdi_cr0_HI_clobber_CC_sign */

        case 4:
          if (!
#line 49 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2510; /* *ld_cmpldi_cr0_DI_clobber_CCUNS_none */

        case 5:
          if (!
#line 133 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2514; /* *lwz_cmpldi_cr0_SI_clobber_CCUNS_none */

        case 6:
          if (!
#line 260 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2521; /* *lhz_cmpldi_cr0_HI_clobber_CCUNS_zero */

        case 7:
          if (!(
#line 260 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2522; /* *lhz_cmpldi_cr0_HI_clobber_CCUNS_zero */

        case 8:
          if (!
#line 323 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2527; /* *lbz_cmpldi_cr0_QI_clobber_CCUNS_zero */

        case 9:
          if (!(
#line 323 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2528; /* *lbz_cmpldi_cr0_QI_clobber_CCUNS_zero */

        case 10:
          if (!
#line 70 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2511; /* *ld_cmpdi_cr0_DI_DI_CC_none */

        case 11:
          if (!
#line 154 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2515; /* *lwz_cmpwi_cr0_SI_SI_CC_none */

        case 12:
          if (!
#line 91 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2512; /* *ld_cmpldi_cr0_DI_DI_CCUNS_none */

        case 13:
          if (!
#line 175 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2516; /* *lwz_cmpldi_cr0_SI_SI_CCUNS_none */

        case 14:
          if (!(
#line 196 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 496 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2517; /* *lwa_cmpdi_cr0_SI_EXTSI_CC_sign */

        case 15:
          if (!
#line 281 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2523; /* *lha_cmpdi_cr0_HI_EXTHI_CC_sign */

        case 16:
          if (!(
#line 281 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 493 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2524; /* *lha_cmpdi_cr0_HI_EXTHI_CC_sign */

        case 17:
          if (!(
#line 218 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 496 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2518; /* *lwz_cmpldi_cr0_SI_EXTSI_CCUNS_zero */

        case 18:
          if (!
#line 302 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2525; /* *lhz_cmpldi_cr0_HI_EXTHI_CCUNS_zero */

        case 19:
          if (!(
#line 302 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 493 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2526; /* *lhz_cmpldi_cr0_HI_EXTHI_CCUNS_zero */

        case 20:
          if (!
#line 344 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2529; /* *lbz_cmpldi_cr0_QI_GPR_CCUNS_zero */

        case 21:
          if (!(
#line 344 "../../gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2530; /* *lbz_cmpldi_cr0_QI_GPR_CCUNS_zero */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_184 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern80 (x1))
    {
    case 0:
      if (nonimmediate_operand (operands[0], E_SImode))
        {
          switch (pattern477 (
E_DImode))
            {
            case 0:
              if (
#line 6326 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_STFIWX && can_create_pseudo_p ()
   && !TARGET_DIRECT_MOVE))
                return 425; /* fix_truncsfsi2_stfiwx */
              break;

            case 1:
              if (
#line 6326 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_STFIWX && can_create_pseudo_p ()
   && !TARGET_DIRECT_MOVE))
                return 426; /* fix_truncdfsi2_stfiwx */
              break;

            default:
              break;
            }
        }
      if (!memory_operand (operands[0], E_SImode))
        return -1;
      switch (pattern478 ())
        {
        case 0:
          if (!
#line 6438 "../../gcc/config/rs6000/rs6000.md"
((SImode == SImode && TARGET_P8_VECTOR) || TARGET_P9_VECTOR))
            return -1;
          return 447; /* *fix_truncsfsi2_mem */

        case 1:
          if (!
#line 6438 "../../gcc/config/rs6000/rs6000.md"
((SImode == SImode && TARGET_P8_VECTOR) || TARGET_P9_VECTOR))
            return -1;
          return 453; /* *fix_truncdfsi2_mem */

        case 2:
          if (!(
#line 15308 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
            return -1;
          return 1151; /* *fix_trunckfsi2_mem */

        case 3:
          if (!(
#line 15308 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
            return -1;
          return 1157; /* *fix_trunctfsi2_mem */

        default:
          return -1;
        }

    case 1:
      if (gpc_reg_operand (operands[0], E_QImode))
        {
          switch (pattern477 (
E_SImode))
            {
            case 0:
              if (
#line 6405 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE))
                return 431; /* fix_truncsfqi2 */
              break;

            case 1:
              if (
#line 6405 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE))
                return 435; /* fix_truncdfqi2 */
              break;

            default:
              break;
            }
        }
      if (!memory_operand (operands[0], E_QImode))
        return -1;
      switch (pattern479 (
E_QImode))
        {
        case 0:
          if (!
#line 6438 "../../gcc/config/rs6000/rs6000.md"
((QImode == SImode && TARGET_P8_VECTOR) || TARGET_P9_VECTOR))
            return -1;
          return 443; /* *fix_truncsfqi2_mem */

        case 1:
          if (!
#line 6438 "../../gcc/config/rs6000/rs6000.md"
((QImode == SImode && TARGET_P8_VECTOR) || TARGET_P9_VECTOR))
            return -1;
          return 449; /* *fix_truncdfqi2_mem */

        case 2:
          if (!(
#line 15308 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
            return -1;
          return 1147; /* *fix_trunckfqi2_mem */

        case 3:
          if (!(
#line 15308 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
            return -1;
          return 1153; /* *fix_trunctfqi2_mem */

        default:
          return -1;
        }

    case 2:
      if (gpc_reg_operand (operands[0], E_HImode))
        {
          switch (pattern477 (
E_SImode))
            {
            case 0:
              if (
#line 6405 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE))
                return 433; /* fix_truncsfhi2 */
              break;

            case 1:
              if (
#line 6405 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE))
                return 437; /* fix_truncdfhi2 */
              break;

            default:
              break;
            }
        }
      if (!memory_operand (operands[0], E_HImode))
        return -1;
      switch (pattern479 (
E_HImode))
        {
        case 0:
          if (!
#line 6438 "../../gcc/config/rs6000/rs6000.md"
((HImode == SImode && TARGET_P8_VECTOR) || TARGET_P9_VECTOR))
            return -1;
          return 445; /* *fix_truncsfhi2_mem */

        case 1:
          if (!
#line 6438 "../../gcc/config/rs6000/rs6000.md"
((HImode == SImode && TARGET_P8_VECTOR) || TARGET_P9_VECTOR))
            return -1;
          return 451; /* *fix_truncdfhi2_mem */

        case 2:
          if (!(
#line 15308 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
            return -1;
          return 1149; /* *fix_trunckfhi2_mem */

        case 3:
          if (!(
#line 15308 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
            return -1;
          return 1155; /* *fix_trunctfhi2_mem */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_192 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != USE)
    return -1;
  x3 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x3) != USE)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG)
    return -1;
  x5 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x5) != SET)
    return -1;
  x6 = XEXP (x2, 0);
  operands[1] = x6;
  x7 = XEXP (x5, 0);
  operands[2] = x7;
  x8 = XEXP (x5, 1);
  operands[3] = x8;
  x9 = XVECEXP (x1, 0, 0);
  switch (GET_CODE (x9))
    {
    case CLOBBER:
      x10 = XEXP (x9, 0);
      if (GET_CODE (x10) != REG
          || REGNO (x10) != 96)
        return -1;
      switch (REGNO (x4))
        {
        case 11:
          switch (pattern555 (x1))
            {
            case 0:
              if (memory_operand (operands[2], E_SImode)
                  && gpc_reg_operand (operands[3], E_SImode)
                  && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT))
                return 1005; /* *save_gpregs_si_r11 */
              if (!gpc_reg_operand (operands[2], E_SImode)
                  || !memory_operand (operands[3], E_SImode)
                  || !
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT))
                return -1;
              return 1022; /* *restore_gpregs_si_r11 */

            case 1:
              if (!
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT))
                return -1;
              return 1011; /* *save_fpregs_si_r11 */

            case 2:
              if (memory_operand (operands[2], E_DImode)
                  && gpc_reg_operand (operands[3], E_DImode)
                  && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT))
                return 1006; /* *save_gpregs_di_r11 */
              if (!gpc_reg_operand (operands[2], E_DImode)
                  || !memory_operand (operands[3], E_DImode)
                  || !
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT))
                return -1;
              return 1023; /* *restore_gpregs_di_r11 */

            case 3:
              if (!
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT))
                return -1;
              return 1012; /* *save_fpregs_di_r11 */

            default:
              return -1;
            }

        case 12:
          switch (pattern555 (x1))
            {
            case 0:
              if (memory_operand (operands[2], E_SImode)
                  && gpc_reg_operand (operands[3], E_SImode)
                  && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT))
                return 1007; /* *save_gpregs_si_r12 */
              if (!gpc_reg_operand (operands[2], E_SImode)
                  || !memory_operand (operands[3], E_SImode)
                  || !
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT))
                return -1;
              return 1024; /* *restore_gpregs_si_r12 */

            case 1:
              if (!
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT))
                return -1;
              return 1013; /* *save_fpregs_si_r12 */

            case 2:
              if (memory_operand (operands[2], E_DImode)
                  && gpc_reg_operand (operands[3], E_DImode)
                  && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT))
                return 1008; /* *save_gpregs_di_r12 */
              if (!gpc_reg_operand (operands[2], E_DImode)
                  || !memory_operand (operands[3], E_DImode)
                  || !
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT))
                return -1;
              return 1025; /* *restore_gpregs_di_r12 */

            case 3:
              if (!
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT))
                return -1;
              return 1014; /* *save_fpregs_di_r12 */

            default:
              return -1;
            }

        case 1:
          switch (pattern555 (x1))
            {
            case 0:
              if (memory_operand (operands[2], E_SImode)
                  && gpc_reg_operand (operands[3], E_SImode)
                  && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT))
                return 1009; /* *save_gpregs_si_r1 */
              if (!gpc_reg_operand (operands[2], E_SImode)
                  || !memory_operand (operands[3], E_SImode)
                  || !
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT))
                return -1;
              return 1026; /* *restore_gpregs_si_r1 */

            case 1:
              if (!
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT))
                return -1;
              return 1015; /* *save_fpregs_si_r1 */

            case 2:
              if (memory_operand (operands[2], E_DImode)
                  && gpc_reg_operand (operands[3], E_DImode)
                  && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT))
                return 1010; /* *save_gpregs_di_r1 */
              if (!gpc_reg_operand (operands[2], E_DImode)
                  || !memory_operand (operands[3], E_DImode)
                  || !
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT))
                return -1;
              return 1027; /* *restore_gpregs_di_r1 */

            case 3:
              if (!
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT))
                return -1;
              return 1016; /* *save_fpregs_di_r1 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case RETURN:
      if (!gpc_reg_operand (operands[2], E_DFmode)
          || !memory_operand (operands[3], E_DFmode))
        return -1;
      switch (REGNO (x4))
        {
        case 11:
          switch (pattern556 (x4))
            {
            case 0:
              if (!
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT))
                return -1;
              return 1040; /* *return_and_restore_fpregs_aix_si_r11 */

            case 1:
              if (!
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT))
                return -1;
              return 1041; /* *return_and_restore_fpregs_aix_di_r11 */

            default:
              return -1;
            }

        case 1:
          switch (pattern556 (x4))
            {
            case 0:
              if (!
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT))
                return -1;
              return 1042; /* *return_and_restore_fpregs_aix_si_r1 */

            case 1:
              if (!
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT))
                return -1;
              return 1043; /* *return_and_restore_fpregs_aix_di_r1 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 rtx_insn *
split_4 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != PARALLEL
      || XVECLEN (x4, 0) != 1)
    return NULL;
  x5 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x5) != CLOBBER)
    return NULL;
  x6 = XEXP (x2, 0);
  operands[0] = x6;
  x7 = XEXP (x3, 0);
  switch (GET_CODE (x7))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x7;
      x8 = XVECEXP (x4, 0, 0);
      operands[2] = x8;
      x9 = XEXP (x5, 0);
      operands[3] = x9;
      switch (GET_MODE (operands[0]))
        {
        case E_DFmode:
          switch (pattern533 (x3, 
E_V2DFmode, 
E_DFmode))
            {
            case 0:
              if (!((
#line 3613 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWERPC64 && VECTOR_MEM_VSX_P (V2DFmode)) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)) && 
#line 3615 "../../gcc/config/rs6000/vsx.md"
( reload_completed)))
                return NULL;
              return gen_split_605 (insn, operands);

            case 1:
              if (!((
#line 3613 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWERPC64 && VECTOR_MEM_VSX_P (V2DFmode)) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)) && 
#line 3615 "../../gcc/config/rs6000/vsx.md"
( reload_completed)))
                return NULL;
              return gen_split_606 (insn, operands);

            default:
              return NULL;
            }

        case E_DImode:
          switch (pattern533 (x3, 
E_V2DImode, 
E_DImode))
            {
            case 0:
              if (!((
#line 3613 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWERPC64 && VECTOR_MEM_VSX_P (V2DImode)) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)) && 
#line 3615 "../../gcc/config/rs6000/vsx.md"
( reload_completed)))
                return NULL;
              return gen_split_607 (insn, operands);

            case 1:
              if (!((
#line 3613 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWERPC64 && VECTOR_MEM_VSX_P (V2DImode)) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)) && 
#line 3615 "../../gcc/config/rs6000/vsx.md"
( reload_completed)))
                return NULL;
              return gen_split_608 (insn, operands);

            default:
              return NULL;
            }

        case E_SFmode:
          if (GET_MODE (x3) != E_SFmode)
            return NULL;
          if (vsx_register_operand (operands[0], E_SFmode)
              && vsx_register_operand (operands[1], E_V4SFmode)
              && u5bit_cint_operand (operands[2], E_QImode)
              && scratch_operand (operands[3], E_V4SFmode)
              && (
#line 3692 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V4SFmode)) && 
#line 3694 "../../gcc/config/rs6000/vsx.md"
( 1)))
            return gen_split_613 (insn, operands);
          if (!register_operand (operands[0], E_SFmode))
            return NULL;
          switch (pattern557 ())
            {
            case 0:
              if (!((
#line 3725 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SFmode)) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)) && 
#line 3727 "../../gcc/config/rs6000/vsx.md"
( reload_completed)))
                return NULL;
              return gen_split_614 (insn, operands);

            case 1:
              if (!((
#line 3725 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SFmode)) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)) && 
#line 3727 "../../gcc/config/rs6000/vsx.md"
( reload_completed)))
                return NULL;
              return gen_split_615 (insn, operands);

            default:
              return NULL;
            }

        case E_QImode:
          if (GET_MODE (x3) != E_QImode)
            return NULL;
          if (int_reg_operand (operands[0], E_QImode)
              && altivec_register_operand (operands[1], E_V16QImode)
              && const_int_operand (operands[2], E_QImode)
              && int_reg_operand (operands[3], E_SImode)
              && 
#line 4000 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V16QImode) && TARGET_VEXTRACTUB && reload_completed))
            return gen_split_618 (insn, operands);
          if (!const_0_to_15_operand (operands[2], E_QImode))
            return NULL;
          if (nonimmediate_operand (operands[0], E_QImode)
              && gpc_reg_operand (operands[1], E_V16QImode)
              && scratch_operand (operands[3], E_V16QImode)
              && (
#line 4117 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V16QImode) && TARGET_DIRECT_MOVE_64BIT
   && !TARGET_P9_VECTOR) && 
#line 4120 "../../gcc/config/rs6000/vsx.md"
( reload_completed)))
            return gen_split_628 (insn, operands);
          if (!register_operand (operands[0], E_QImode)
              || !memory_operand (operands[1], E_V16QImode)
              || !scratch_operand (operands[3], E_DImode)
              || !(
#line 4165 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V16QImode) && TARGET_DIRECT_MOVE_64BIT) && 
#line 4167 "../../gcc/config/rs6000/vsx.md"
( reload_completed)))
            return NULL;
          return gen_split_630 (insn, operands);

        case E_HImode:
          if (GET_MODE (x3) != E_HImode)
            return NULL;
          if (int_reg_operand (operands[0], E_HImode)
              && altivec_register_operand (operands[1], E_V8HImode)
              && const_int_operand (operands[2], E_QImode)
              && int_reg_operand (operands[3], E_SImode)
              && 
#line 4000 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V8HImode) && TARGET_VEXTRACTUB && reload_completed))
            return gen_split_619 (insn, operands);
          if (!const_0_to_7_operand (operands[2], E_QImode))
            return NULL;
          if (nonimmediate_operand (operands[0], E_HImode)
              && gpc_reg_operand (operands[1], E_V8HImode)
              && scratch_operand (operands[3], E_V8HImode)
              && (
#line 4117 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V8HImode) && TARGET_DIRECT_MOVE_64BIT
   && !TARGET_P9_VECTOR) && 
#line 4120 "../../gcc/config/rs6000/vsx.md"
( reload_completed)))
            return gen_split_629 (insn, operands);
          if (!register_operand (operands[0], E_HImode)
              || !memory_operand (operands[1], E_V8HImode)
              || !scratch_operand (operands[3], E_DImode)
              || !(
#line 4165 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V8HImode) && TARGET_DIRECT_MOVE_64BIT) && 
#line 4167 "../../gcc/config/rs6000/vsx.md"
( reload_completed)))
            return NULL;
          return gen_split_631 (insn, operands);

        case E_SImode:
          if (GET_MODE (x3) != E_SImode)
            return NULL;
          if (int_reg_operand (operands[0], E_SImode)
              && altivec_register_operand (operands[1], E_V4SImode)
              && const_int_operand (operands[2], E_QImode)
              && int_reg_operand (operands[3], E_SImode)
              && 
#line 4000 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_VEXTRACTUB && reload_completed))
            return gen_split_620 (insn, operands);
          if (!const_0_to_3_operand (operands[2], E_QImode))
            return NULL;
          if (nonimmediate_operand (operands[0], E_SImode)
              && gpc_reg_operand (operands[1], E_V4SImode)
              && scratch_operand (operands[3], E_V4SImode)
              && (
#line 4081 "../../gcc/config/rs6000/vsx.md"
(TARGET_DIRECT_MOVE_64BIT) && 
#line 4083 "../../gcc/config/rs6000/vsx.md"
( INTVAL (operands[2]) != (BYTES_BIG_ENDIAN ? 1 : 2))))
            return gen_split_627 (insn, operands);
          if (!register_operand (operands[0], E_SImode)
              || !memory_operand (operands[1], E_V4SImode)
              || !scratch_operand (operands[3], E_DImode)
              || !(
#line 4165 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT) && 
#line 4167 "../../gcc/config/rs6000/vsx.md"
( reload_completed)))
            return NULL;
          return gen_split_632 (insn, operands);

        default:
          return NULL;
        }

    case PLUS:
      if (pattern414 (x1) != 0
          || !(
#line 4997 "../../gcc/config/rs6000/vsx.md"
(BYTES_BIG_ENDIAN && VECTOR_UNIT_VSX_P (V2DFmode)) && 
#line 4999 "../../gcc/config/rs6000/vsx.md"
( 1)))
        return NULL;
      return gen_split_683 (insn, operands);

    case SMIN:
      if (pattern414 (x1) != 0
          || !(
#line 4997 "../../gcc/config/rs6000/vsx.md"
(BYTES_BIG_ENDIAN && VECTOR_UNIT_VSX_P (V2DFmode)) && 
#line 4999 "../../gcc/config/rs6000/vsx.md"
( 1)))
        return NULL;
      return gen_split_684 (insn, operands);

    case SMAX:
      if (pattern414 (x1) != 0
          || !(
#line 4997 "../../gcc/config/rs6000/vsx.md"
(BYTES_BIG_ENDIAN && VECTOR_UNIT_VSX_P (V2DFmode)) && 
#line 4999 "../../gcc/config/rs6000/vsx.md"
( 1)))
        return NULL;
      return gen_split_685 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_7 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  switch (GET_CODE (x2))
    {
    case SET:
      x3 = XEXP (x2, 1);
      switch (GET_CODE (x3))
        {
        case COMPARE:
          return split_2 (x1, insn);

        case BSWAP:
          x4 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x4) != CLOBBER)
            return NULL;
          x5 = XEXP (x2, 0);
          operands[0] = x5;
          x6 = XEXP (x3, 0);
          operands[1] = x6;
          x7 = XEXP (x4, 0);
          operands[2] = x7;
          switch (GET_CODE (operands[1]))
            {
            case REG:
            case SUBREG:
              switch (GET_CODE (operands[0]))
                {
                case REG:
                case SUBREG:
                  switch (GET_MODE (operands[0]))
                    {
                    case E_HImode:
                      if (!gpc_reg_operand (operands[0], E_HImode)
                          || GET_MODE (x3) != E_HImode
                          || !gpc_reg_operand (operands[1], E_HImode)
                          || !scratch_operand (operands[2], E_SImode)
                          || !
#line 2677 "../../gcc/config/rs6000/rs6000.md"
(reload_completed && !TARGET_POWER10 && int_reg_operand (operands[0], HImode)))
                        return NULL;
                      return gen_split_50 (insn, operands);

                    case E_DImode:
                      if (!gpc_reg_operand (operands[0], E_DImode)
                          || GET_MODE (x3) != E_DImode
                          || !gpc_reg_operand (operands[1], E_DImode)
                          || !
#line 3086 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWERPC64 && reload_completed))
                        return NULL;
                      return gen_split_57 (insn, operands);

                    default:
                      return NULL;
                    }

                case MEM:
                  if (!indexed_or_indirect_operand (operands[0], E_DImode)
                      || GET_MODE (x3) != E_DImode
                      || !gpc_reg_operand (operands[1], E_DImode)
                      || !gpc_reg_operand (operands[2], E_SImode)
                      || !
#line 3038 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWERPC64 && reload_completed))
                    return NULL;
                  return gen_split_56 (insn, operands);

                default:
                  return NULL;
                }

            case MEM:
              if (!indexed_or_indirect_operand (operands[1], E_DImode)
                  || !gpc_reg_operand (operands[0], E_DImode)
                  || GET_MODE (x3) != E_DImode
                  || !gpc_reg_operand (operands[2], E_SImode)
                  || !
#line 2986 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_POWERPC64 && reload_completed))
                return NULL;
              return gen_split_55 (insn, operands);

            default:
              return NULL;
            }

        case IOR:
          x4 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x4) != CLOBBER)
            return NULL;
          x5 = XEXP (x2, 0);
          operands[0] = x5;
          x6 = XEXP (x3, 0);
          switch (GET_CODE (x6))
            {
            case REG:
            case SUBREG:
              operands[1] = x6;
              switch (pattern355 (x1))
                {
                case 0:
                  if (!(
#line 4472 "../../gcc/config/rs6000/rs6000.md"
(!logical_const_operand (operands[2], SImode)
   && rs6000_is_valid_mask (operands[2], NULL, NULL, SImode)) && 
#line 4475 "../../gcc/config/rs6000/rs6000.md"
( 1)))
                    return NULL;
                  return gen_split_119 (insn, operands);

                case 1:
                  if (!((
#line 4472 "../../gcc/config/rs6000/rs6000.md"
(!logical_const_operand (operands[2], DImode)
   && rs6000_is_valid_mask (operands[2], NULL, NULL, DImode)) && 
#line 475 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 4475 "../../gcc/config/rs6000/rs6000.md"
( 1)))
                    return NULL;
                  return gen_split_120 (insn, operands);

                default:
                  return NULL;
                }

            case ASHIFT:
              if (pattern252 (x3) != 0)
                return NULL;
              switch (pattern526 (x1))
                {
                case 0:
                  if (!(
#line 4528 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64 && INTVAL (operands[2]) == 8) && 
#line 4530 "../../gcc/config/rs6000/rs6000.md"
( 1)))
                    return NULL;
                  return gen_split_124 (insn, operands);

                case 1:
                  if (!(
#line 4528 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64 && INTVAL (operands[2]) == 16) && 
#line 4530 "../../gcc/config/rs6000/rs6000.md"
( 1)))
                    return NULL;
                  return gen_split_125 (insn, operands);

                case 2:
                  if (!(
#line 4528 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64 && INTVAL (operands[2]) == 32) && 
#line 4530 "../../gcc/config/rs6000/rs6000.md"
( 1)))
                    return NULL;
                  return gen_split_126 (insn, operands);

                default:
                  return NULL;
                }

            default:
              return NULL;
            }

        case IF_THEN_ELSE:
          x4 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x4) != CLOBBER)
            return NULL;
          x5 = XEXP (x2, 0);
          operands[0] = x5;
          x6 = XEXP (x3, 0);
          operands[1] = x6;
          x8 = XEXP (x3, 1);
          operands[4] = x8;
          x9 = XEXP (x3, 2);
          operands[5] = x9;
          x7 = XEXP (x4, 0);
          operands[6] = x7;
          if (!scratch_operand (operands[6], E_V2DImode))
            return NULL;
          switch (GET_CODE (operands[1]))
            {
            case EQ:
            case GE:
            case GT:
              if (!fpmask_comparison_operator (operands[1], E_CCFPmode))
                return NULL;
              switch (pattern532 (x3))
                {
                case 0:
                  if (!(
#line 5665 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_MINMAX) && 
#line 5667 "../../gcc/config/rs6000/rs6000.md"
( 1)))
                    return NULL;
                  return gen_split_161 (insn, operands);

                case 1:
                  if (!(
#line 5665 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_MINMAX) && 
#line 5667 "../../gcc/config/rs6000/rs6000.md"
( 1)))
                    return NULL;
                  return gen_split_163 (insn, operands);

                case 2:
                  if (!(
#line 5665 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_MINMAX) && 
#line 5667 "../../gcc/config/rs6000/rs6000.md"
( 1)))
                    return NULL;
                  return gen_split_162 (insn, operands);

                case 3:
                  if (!(
#line 5665 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_MINMAX) && 
#line 5667 "../../gcc/config/rs6000/rs6000.md"
( 1)))
                    return NULL;
                  return gen_split_164 (insn, operands);

                case 4:
                  if (!((
#line 5770 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWER10 && TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))) && 
#line 5772 "../../gcc/config/rs6000/rs6000.md"
( 1)))
                    return NULL;
                  return gen_split_169 (insn, operands);

                case 5:
                  if (!((
#line 5770 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWER10 && TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))) && 
#line 5772 "../../gcc/config/rs6000/rs6000.md"
( 1)))
                    return NULL;
                  return gen_split_170 (insn, operands);

                default:
                  return NULL;
                }

            case NE:
            case UNLE:
            case UNLT:
              if (!invert_fpmask_comparison_operator (operands[1], E_CCFPmode))
                return NULL;
              switch (pattern532 (x3))
                {
                case 0:
                  if (!(
#line 5697 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_MINMAX) && 
#line 5699 "../../gcc/config/rs6000/rs6000.md"
( 1)))
                    return NULL;
                  return gen_split_165 (insn, operands);

                case 1:
                  if (!(
#line 5697 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_MINMAX) && 
#line 5699 "../../gcc/config/rs6000/rs6000.md"
( 1)))
                    return NULL;
                  return gen_split_167 (insn, operands);

                case 2:
                  if (!(
#line 5697 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_MINMAX) && 
#line 5699 "../../gcc/config/rs6000/rs6000.md"
( 1)))
                    return NULL;
                  return gen_split_166 (insn, operands);

                case 3:
                  if (!(
#line 5697 "../../gcc/config/rs6000/rs6000.md"
(TARGET_P9_MINMAX) && 
#line 5699 "../../gcc/config/rs6000/rs6000.md"
( 1)))
                    return NULL;
                  return gen_split_168 (insn, operands);

                case 4:
                  if (!((
#line 5802 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWER10 && TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))) && 
#line 5804 "../../gcc/config/rs6000/rs6000.md"
( 1)))
                    return NULL;
                  return gen_split_171 (insn, operands);

                case 5:
                  if (!((
#line 5802 "../../gcc/config/rs6000/rs6000.md"
(TARGET_POWER10 && TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))) && 
#line 5804 "../../gcc/config/rs6000/rs6000.md"
( 1)))
                    return NULL;
                  return gen_split_172 (insn, operands);

                default:
                  return NULL;
                }

            default:
              return NULL;
            }

        case FLOAT:
          return split_5 (x1, insn);

        case UNSIGNED_FLOAT:
          switch (pattern79 (x1))
            {
            case 0:
              if (!(
#line 5976 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_LFIWZX && TARGET_FCFIDS) && 
#line 5978 "../../gcc/config/rs6000/rs6000.md"
( 1)))
                return NULL;
              return gen_split_181 (insn, operands);

            case 1:
              if (!(
#line 7129 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_FCFIDUS) && 
#line 7131 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                return NULL;
              return gen_split_229 (insn, operands);

            case 2:
              if (!(
#line 5976 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_LFIWZX && TARGET_FCFID) && 
#line 5978 "../../gcc/config/rs6000/rs6000.md"
( 1)))
                return NULL;
              return gen_split_182 (insn, operands);

            case 3:
              if (!(
#line 7004 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && (TARGET_FCFIDU || VECTOR_UNIT_VSX_P (DFmode))) && 
#line 7006 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                return NULL;
              return gen_split_226 (insn, operands);

            case 4:
              if (!((
#line 15394 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))) && 
#line 15396 "../../gcc/config/rs6000/rs6000.md"
( 1)))
                return NULL;
              return gen_split_525 (insn, operands);

            case 5:
              if (!((
#line 15414 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))) && 
#line 15416 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                return NULL;
              return gen_split_527 (insn, operands);

            case 6:
              if (!((
#line 15414 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))) && 
#line 15416 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                return NULL;
              return gen_split_528 (insn, operands);

            case 7:
              if (!((
#line 15394 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))) && 
#line 15396 "../../gcc/config/rs6000/rs6000.md"
( 1)))
                return NULL;
              return gen_split_526 (insn, operands);

            case 8:
              if (!((
#line 15414 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))) && 
#line 15416 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                return NULL;
              return gen_split_529 (insn, operands);

            case 9:
              if (!((
#line 15414 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))) && 
#line 15416 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                return NULL;
              return gen_split_530 (insn, operands);

            case 10:
              if (!(
#line 6016 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_LFIWZX && TARGET_FCFIDS) && 
#line 6018 "../../gcc/config/rs6000/rs6000.md"
( 1)))
                return NULL;
              return gen_split_183 (insn, operands);

            case 11:
              if (!(
#line 6016 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_LFIWZX && TARGET_FCFID) && 
#line 6018 "../../gcc/config/rs6000/rs6000.md"
( 1)))
                return NULL;
              return gen_split_184 (insn, operands);

            case 12:
              if (const_0_to_3_operand (operands[2], E_QImode)
                  && scratch_operand (operands[3], E_V4SImode)
                  && (
#line 4437 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT) && 
#line 4439 "../../gcc/config/rs6000/vsx.md"
( 1)))
                return gen_split_640 (insn, operands);
              if (!const_int_operand (operands[2], E_QImode)
                  || !scratch_operand (operands[3], E_SImode)
                  || !(
#line 4568 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR) && 
#line 4571 "../../gcc/config/rs6000/vsx.md"
( reload_completed)))
                return NULL;
              return gen_split_670 (insn, operands);

            case 13:
              if (!(
#line 4568 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V16QImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR) && 
#line 4571 "../../gcc/config/rs6000/vsx.md"
( reload_completed)))
                return NULL;
              return gen_split_662 (insn, operands);

            case 14:
              if (!(
#line 4568 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V8HImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR) && 
#line 4571 "../../gcc/config/rs6000/vsx.md"
( reload_completed)))
                return NULL;
              return gen_split_666 (insn, operands);

            case 15:
              if (!(
#line 4568 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V16QImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR) && 
#line 4571 "../../gcc/config/rs6000/vsx.md"
( reload_completed)))
                return NULL;
              return gen_split_661 (insn, operands);

            case 16:
              if (!(
#line 4568 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V8HImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR) && 
#line 4571 "../../gcc/config/rs6000/vsx.md"
( reload_completed)))
                return NULL;
              return gen_split_665 (insn, operands);

            case 17:
              if (!(
#line 4568 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR) && 
#line 4571 "../../gcc/config/rs6000/vsx.md"
( reload_completed)))
                return NULL;
              return gen_split_669 (insn, operands);

            case 18:
              if (!((
#line 4568 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V16QImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR) && 
#line 240 "../../gcc/config/rs6000/vsx.md"
(TARGET_FLOAT128_HW)) && 
#line 4571 "../../gcc/config/rs6000/vsx.md"
( reload_completed)))
                return NULL;
              return gen_split_663 (insn, operands);

            case 19:
              if (!((
#line 4568 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V8HImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR) && 
#line 240 "../../gcc/config/rs6000/vsx.md"
(TARGET_FLOAT128_HW)) && 
#line 4571 "../../gcc/config/rs6000/vsx.md"
( reload_completed)))
                return NULL;
              return gen_split_667 (insn, operands);

            case 20:
              if (!((
#line 4568 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR) && 
#line 240 "../../gcc/config/rs6000/vsx.md"
(TARGET_FLOAT128_HW)) && 
#line 4571 "../../gcc/config/rs6000/vsx.md"
( reload_completed)))
                return NULL;
              return gen_split_671 (insn, operands);

            case 21:
              if (!((
#line 4568 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V16QImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR) && 
#line 241 "../../gcc/config/rs6000/vsx.md"
(TARGET_FLOAT128_HW
				    && FLOAT128_IEEE_P (TFmode))) && 
#line 4571 "../../gcc/config/rs6000/vsx.md"
( reload_completed)))
                return NULL;
              return gen_split_664 (insn, operands);

            case 22:
              if (!((
#line 4568 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V8HImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR) && 
#line 241 "../../gcc/config/rs6000/vsx.md"
(TARGET_FLOAT128_HW
				    && FLOAT128_IEEE_P (TFmode))) && 
#line 4571 "../../gcc/config/rs6000/vsx.md"
( reload_completed)))
                return NULL;
              return gen_split_668 (insn, operands);

            case 23:
              if (!((
#line 4568 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_DIRECT_MOVE_64BIT
   && TARGET_P9_VECTOR) && 
#line 241 "../../gcc/config/rs6000/vsx.md"
(TARGET_FLOAT128_HW
				    && FLOAT128_IEEE_P (TFmode))) && 
#line 4571 "../../gcc/config/rs6000/vsx.md"
( reload_completed)))
                return NULL;
              return gen_split_672 (insn, operands);

            default:
              return NULL;
            }

        case FIX:
          switch (pattern80 (x1))
            {
            case 0:
              if (nonimmediate_operand (operands[0], E_SImode))
                {
                  switch (pattern477 (
E_DImode))
                    {
                    case 0:
                      if ((
#line 6326 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_STFIWX && can_create_pseudo_p ()
   && !TARGET_DIRECT_MOVE) && 
#line 6329 "../../gcc/config/rs6000/rs6000.md"
( 1)))
                        return gen_split_195 (insn, operands);
                      break;

                    case 1:
                      if ((
#line 6326 "../../gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_STFIWX && can_create_pseudo_p ()
   && !TARGET_DIRECT_MOVE) && 
#line 6329 "../../gcc/config/rs6000/rs6000.md"
( 1)))
                        return gen_split_196 (insn, operands);
                      break;

                    default:
                      break;
                    }
                }
              if (!memory_operand (operands[0], E_SImode))
                return NULL;
              switch (pattern478 ())
                {
                case 0:
                  if (!(
#line 6438 "../../gcc/config/rs6000/rs6000.md"
((SImode == SImode && TARGET_P8_VECTOR) || TARGET_P9_VECTOR) && 
#line 6440 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                    return NULL;
                  return gen_split_211 (insn, operands);

                case 1:
                  if (!(
#line 6438 "../../gcc/config/rs6000/rs6000.md"
((SImode == SImode && TARGET_P8_VECTOR) || TARGET_P9_VECTOR) && 
#line 6440 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                    return NULL;
                  return gen_split_217 (insn, operands);

                case 2:
                  if (!((
#line 15308 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))) && 
#line 15310 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                    return NULL;
                  return gen_split_511 (insn, operands);

                case 3:
                  if (!((
#line 15308 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))) && 
#line 15310 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                    return NULL;
                  return gen_split_517 (insn, operands);

                default:
                  return NULL;
                }

            case 1:
              if (gpc_reg_operand (operands[0], E_QImode))
                {
                  switch (pattern477 (
E_SImode))
                    {
                    case 0:
                      if ((
#line 6405 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE) && 
#line 6410 "../../gcc/config/rs6000/rs6000.md"
( reload_completed && int_reg_operand (operands[0], QImode))))
                        return gen_split_199 (insn, operands);
                      break;

                    case 1:
                      if ((
#line 6405 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE) && 
#line 6410 "../../gcc/config/rs6000/rs6000.md"
( reload_completed && int_reg_operand (operands[0], QImode))))
                        return gen_split_203 (insn, operands);
                      break;

                    default:
                      break;
                    }
                }
              if (!memory_operand (operands[0], E_QImode))
                return NULL;
              switch (pattern479 (
E_QImode))
                {
                case 0:
                  if (!(
#line 6438 "../../gcc/config/rs6000/rs6000.md"
((QImode == SImode && TARGET_P8_VECTOR) || TARGET_P9_VECTOR) && 
#line 6440 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                    return NULL;
                  return gen_split_207 (insn, operands);

                case 1:
                  if (!(
#line 6438 "../../gcc/config/rs6000/rs6000.md"
((QImode == SImode && TARGET_P8_VECTOR) || TARGET_P9_VECTOR) && 
#line 6440 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                    return NULL;
                  return gen_split_213 (insn, operands);

                case 2:
                  if (!((
#line 15308 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))) && 
#line 15310 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                    return NULL;
                  return gen_split_507 (insn, operands);

                case 3:
                  if (!((
#line 15308 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))) && 
#line 15310 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                    return NULL;
                  return gen_split_513 (insn, operands);

                default:
                  return NULL;
                }

            case 2:
              if (gpc_reg_operand (operands[0], E_HImode))
                {
                  switch (pattern477 (
E_SImode))
                    {
                    case 0:
                      if ((
#line 6405 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE) && 
#line 6410 "../../gcc/config/rs6000/rs6000.md"
( reload_completed && int_reg_operand (operands[0], HImode))))
                        return gen_split_201 (insn, operands);
                      break;

                    case 1:
                      if ((
#line 6405 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE) && 
#line 6410 "../../gcc/config/rs6000/rs6000.md"
( reload_completed && int_reg_operand (operands[0], HImode))))
                        return gen_split_205 (insn, operands);
                      break;

                    default:
                      break;
                    }
                }
              if (!memory_operand (operands[0], E_HImode))
                return NULL;
              switch (pattern479 (
E_HImode))
                {
                case 0:
                  if (!(
#line 6438 "../../gcc/config/rs6000/rs6000.md"
((HImode == SImode && TARGET_P8_VECTOR) || TARGET_P9_VECTOR) && 
#line 6440 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                    return NULL;
                  return gen_split_209 (insn, operands);

                case 1:
                  if (!(
#line 6438 "../../gcc/config/rs6000/rs6000.md"
((HImode == SImode && TARGET_P8_VECTOR) || TARGET_P9_VECTOR) && 
#line 6440 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                    return NULL;
                  return gen_split_215 (insn, operands);

                case 2:
                  if (!((
#line 15308 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))) && 
#line 15310 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                    return NULL;
                  return gen_split_509 (insn, operands);

                case 3:
                  if (!((
#line 15308 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))) && 
#line 15310 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                    return NULL;
                  return gen_split_515 (insn, operands);

                default:
                  return NULL;
                }

            default:
              return NULL;
            }

        case UNSIGNED_FIX:
          return split_6 (x1, insn);

        case UNSPEC:
          return split_3 (x1, insn);

        case ZERO_EXTEND:
          if (GET_MODE (x3) != E_DImode)
            return NULL;
          x4 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x4) != CLOBBER)
            return NULL;
          x5 = XEXP (x2, 0);
          operands[0] = x5;
          if (!gpc_reg_operand (operands[0], E_DImode))
            return NULL;
          x6 = XEXP (x3, 0);
          switch (GET_CODE (x6))
            {
            case UNSPEC:
              if (XVECLEN (x6, 0) != 1
                  || XINT (x6, 1) != 87
                  || GET_MODE (x6) != E_SImode)
                return NULL;
              x10 = XVECEXP (x6, 0, 0);
              operands[1] = x10;
              if (!input_operand (operands[1], E_SFmode))
                return NULL;
              x7 = XEXP (x4, 0);
              operands[2] = x7;
              if (!scratch_operand (operands[2], E_V4SFmode)
                  || !(
#line 7892 "../../gcc/config/rs6000/rs6000.md"
(TARGET_DIRECT_MOVE_64BIT
   && (register_operand (operands[0], DImode)
       || register_operand (operands[1], SImode))) && 
#line 7903 "../../gcc/config/rs6000/rs6000.md"
( reload_completed
   && register_operand (operands[0], DImode)
   && vsx_reg_sfsubreg_ok (operands[1], SFmode))))
                return NULL;
              return gen_split_292 (insn, operands);

            case VEC_SELECT:
              x11 = XEXP (x6, 1);
              if (GET_CODE (x11) != PARALLEL
                  || XVECLEN (x11, 0) != 1)
                return NULL;
              x12 = XEXP (x6, 0);
              operands[1] = x12;
              switch (pattern499 (x1))
                {
                case 0:
                  if (!(
#line 4025 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V16QImode) && TARGET_VEXTRACTUB) && 
#line 4027 "../../gcc/config/rs6000/vsx.md"
( reload_completed)))
                    return NULL;
                  return gen_split_621 (insn, operands);

                case 1:
                  if (!(
#line 4025 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V8HImode) && TARGET_VEXTRACTUB) && 
#line 4027 "../../gcc/config/rs6000/vsx.md"
( reload_completed)))
                    return NULL;
                  return gen_split_622 (insn, operands);

                case 2:
                  if (!(
#line 4025 "../../gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V4SImode) && TARGET_VEXTRACTUB) && 
#line 4027 "../../gcc/config/rs6000/vsx.md"
( reload_completed)))
                    return NULL;
                  return gen_split_623 (insn, operands);

                default:
                  return NULL;
                }

            default:
              return NULL;
            }

        case FLOAT_EXTEND:
          x4 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x4) != USE)
            return NULL;
          x5 = XEXP (x2, 0);
          operands[0] = x5;
          x6 = XEXP (x3, 0);
          operands[1] = x6;
          if (!nonimmediate_operand (operands[1], E_DFmode))
            return NULL;
          switch (pattern357 (x1))
            {
            case 0:
              if (!((
#line 8912 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_VSX && TARGET_HARD_FLOAT
   && TARGET_LONG_DOUBLE_128) && 
#line 630 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IBM_P (IFmode))) && 
#line 8915 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                return NULL;
              return gen_split_322 (insn, operands);

            case 1:
              if (!((
#line 8912 "../../gcc/config/rs6000/rs6000.md"
(!TARGET_VSX && TARGET_HARD_FLOAT
   && TARGET_LONG_DOUBLE_128) && 
#line 631 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IBM_P (TFmode))) && 
#line 8915 "../../gcc/config/rs6000/rs6000.md"
( reload_completed)))
                return NULL;
              return gen_split_323 (insn, operands);

            default:
              return NULL;
            }

        case NEG:
          x4 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x4) != CLOBBER)
            return NULL;
          x5 = XEXP (x2, 0);
          operands[0] = x5;
          x7 = XEXP (x4, 0);
          operands[2] = x7;
          if (!scratch_operand (operands[2], E_V16QImode))
            return NULL;
          x6 = XEXP (x3, 0);
          switch (GET_CODE (x6))
            {
            case REG:
            case SUBREG:
              operands[1] = x6;
              switch (pattern301 (x3))
                {
                case 0:
                  if (!((
#line 9299 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_TYPE && !TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))) && 
#line 9301 "../../gcc/config/rs6000/rs6000.md"
( 1)))
                    return NULL;
                  return gen_split_330 (insn, operands);

                case 1:
                  if (!((
#line 9299 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_TYPE && !TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))) && 
#line 9301 "../../gcc/config/rs6000/rs6000.md"
( 1)))
                    return NULL;
                  return gen_split_331 (insn, operands);

                default:
                  return NULL;
                }

            case ABS:
              x12 = XEXP (x6, 0);
              operands[1] = x12;
              switch (GET_MODE (operands[0]))
                {
                case E_KFmode:
                  if (pattern475 (x3, 
E_KFmode) != 0
                      || !((
#line 9357 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_TYPE && !TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))) && 
#line 9359 "../../gcc/config/rs6000/rs6000.md"
( 1)))
                    return NULL;
                  return gen_split_334 (insn, operands);

                case E_TFmode:
                  if (pattern475 (x3, 
E_TFmode) != 0
                      || !((
#line 9357 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_TYPE && !TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))) && 
#line 9359 "../../gcc/config/rs6000/rs6000.md"
( 1)))
                    return NULL;
                  return gen_split_335 (insn, operands);

                default:
                  return NULL;
                }

            default:
              return NULL;
            }

        case ABS:
          x4 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x4) != CLOBBER)
            return NULL;
          x5 = XEXP (x2, 0);
          operands[0] = x5;
          x6 = XEXP (x3, 0);
          operands[1] = x6;
          switch (pattern302 (x1))
            {
            case 0:
              if (!((
#line 9327 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_TYPE && !TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))) && 
#line 9329 "../../gcc/config/rs6000/rs6000.md"
( 1)))
                return NULL;
              return gen_split_332 (insn, operands);

            case 1:
              if (!((
#line 9327 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_TYPE && !TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))) && 
#line 9329 "../../gcc/config/rs6000/rs6000.md"
( 1)))
                return NULL;
              return gen_split_333 (insn, operands);

            default:
              return NULL;
            }

        case FLOAT_TRUNCATE:
          if (GET_MODE (x3) != E_SFmode)
            return NULL;
          x4 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x4) != CLOBBER)
            return NULL;
          x5 = XEXP (x2, 0);
          operands[0] = x5;
          if (!vsx_register_operand (operands[0], E_SFmode))
            return NULL;
          x6 = XEXP (x3, 0);
          operands[1] = x6;
          x7 = XEXP (x4, 0);
          operands[2] = x7;
          switch (pattern451 ())
            {
            case 0:
              if (!((
#line 15257 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))) && 
#line 15259 "../../gcc/config/rs6000/rs6000.md"
( 1)))
                return NULL;
              return gen_split_505 (insn, operands);

            case 1:
              if (!((
#line 15257 "../../gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))) && 
#line 15259 "../../gcc/config/rs6000/rs6000.md"
( 1)))
                return NULL;
              return gen_split_506 (insn, operands);

            default:
              return NULL;
            }

        case CONST_INT:
        case CONST_WIDE_INT:
        case CONST_POLY_INT:
        case CONST_FIXED:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case CONST:
        case LABEL_REF:
        case SYMBOL_REF:
        case HIGH:
          operands[1] = x3;
          x4 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x4) != CLOBBER)
            return NULL;
          x5 = XEXP (x2, 0);
          operands[0] = x5;
          x7 = XEXP (x4, 0);
          switch (pattern315 (x7))
            {
            case 0:
              if (!(
#line 3458 "../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN
   && VECTOR_MEM_VSX_P (V4SFmode)
   && !TARGET_P9_VECTOR
   && !altivec_indexed_or_indirect_operand (operands[0], V4SFmode)
   && const_vec_duplicate_p (operands[1])) && 
#line 3464 "../../gcc/config/rs6000/vsx.md"
( 1)))
                return NULL;
              return gen_split_603 (insn, operands);

            case 1:
              if (!(
#line 3458 "../../gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN
   && VECTOR_MEM_VSX_P (V4SImode)
   && !TARGET_P9_VECTOR
   && !altivec_indexed_or_indirect_operand (operands[0], V4SImode)
   && const_vec_duplicate_p (operands[1])) && 
#line 3464 "../../gcc/config/rs6000/vsx.md"
( 1)))
                return NULL;
              return gen_split_604 (insn, operands);

            default:
              return NULL;
            }

        case VEC_SELECT:
          return split_4 (x1, insn);

        case PLUS:
          if (pattern83 (x1) != 0
              || !(
#line 4927 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode)) && 
#line 4929 "../../gcc/config/rs6000/vsx.md"
( 1)))
            return NULL;
          return gen_split_677 (insn, operands);

        case SMIN:
          if (pattern83 (x1) != 0
              || !(
#line 4927 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode)) && 
#line 4929 "../../gcc/config/rs6000/vsx.md"
( 1)))
            return NULL;
          return gen_split_678 (insn, operands);

        case SMAX:
          if (pattern83 (x1) != 0
              || !(
#line 4927 "../../gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode)) && 
#line 4929 "../../gcc/config/rs6000/vsx.md"
( 1)))
            return NULL;
          return gen_split_679 (insn, operands);

        case SIGN_EXTEND:
          if (GET_MODE (x3) != E_TImode)
            return NULL;
          x4 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x4) != CLOBBER
              || pattern259 (x1, 
E_TImode, 
E_DImode, 
98) != 0)
            return NULL;
          x6 = XEXP (x3, 0);
          operands[1] = x6;
          if (!input_operand (operands[1], E_DImode)
              || !(
#line 5133 "../../gcc/config/rs6000/vsx.md"
(TARGET_POWERPC64 && TARGET_POWER10) && 
#line 5135 "../../gcc/config/rs6000/vsx.md"
( reload_completed)))
            return NULL;
          return gen_split_689 (insn, operands);

        case ASHIFT:
          switch (pattern88 (x1))
            {
            case 0:
              if (!((
#line 2197 "../../gcc/config/rs6000/altivec.md"
(((V4SImode == V2DImode && TARGET_P8_VECTOR)
    || (V4SImode == V4SImode && TARGET_P9_VECTOR))) && 
#line 2183 "../../gcc/config/rs6000/altivec.md"
(TARGET_P9_VECTOR)) && 
#line 2200 "../../gcc/config/rs6000/altivec.md"
( 1)))
                return NULL;
              return gen_split_732 (insn, operands);

            case 1:
              if (!((
#line 2197 "../../gcc/config/rs6000/altivec.md"
(((V2DImode == V2DImode && TARGET_P8_VECTOR)
    || (V2DImode == V4SImode && TARGET_P9_VECTOR))) && 
#line 2184 "../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR)) && 
#line 2200 "../../gcc/config/rs6000/altivec.md"
( 1)))
                return NULL;
              return gen_split_735 (insn, operands);

            default:
              return NULL;
            }

        case ASHIFTRT:
          switch (pattern88 (x1))
            {
            case 0:
              if (!((
#line 2197 "../../gcc/config/rs6000/altivec.md"
(((V4SImode == V2DImode && TARGET_P8_VECTOR)
    || (V4SImode == V4SImode && TARGET_P9_VECTOR))) && 
#line 2183 "../../gcc/config/rs6000/altivec.md"
(TARGET_P9_VECTOR)) && 
#line 2200 "../../gcc/config/rs6000/altivec.md"
( 1)))
                return NULL;
              return gen_split_733 (insn, operands);

            case 1:
              if (!((
#line 2197 "../../gcc/config/rs6000/altivec.md"
(((V2DImode == V2DImode && TARGET_P8_VECTOR)
    || (V2DImode == V4SImode && TARGET_P9_VECTOR))) && 
#line 2184 "../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR)) && 
#line 2200 "../../gcc/config/rs6000/altivec.md"
( 1)))
                return NULL;
              return gen_split_736 (insn, operands);

            default:
              return NULL;
            }

        case LSHIFTRT:
          switch (pattern88 (x1))
            {
            case 0:
              if (!((
#line 2197 "../../gcc/config/rs6000/altivec.md"
(((V4SImode == V2DImode && TARGET_P8_VECTOR)
    || (V4SImode == V4SImode && TARGET_P9_VECTOR))) && 
#line 2183 "../../gcc/config/rs6000/altivec.md"
(TARGET_P9_VECTOR)) && 
#line 2200 "../../gcc/config/rs6000/altivec.md"
( 1)))
                return NULL;
              return gen_split_734 (insn, operands);

            case 1:
              if (!((
#line 2197 "../../gcc/config/rs6000/altivec.md"
(((V2DImode == V2DImode && TARGET_P8_VECTOR)
    || (V2DImode == V4SImode && TARGET_P9_VECTOR))) && 
#line 2184 "../../gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR)) && 
#line 2200 "../../gcc/config/rs6000/altivec.md"
( 1)))
                return NULL;
              return gen_split_737 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case UNSPEC_VOLATILE:
      if (XVECLEN (x2, 0) != 1
          || XINT (x2, 1) != 4)
        return NULL;
      x4 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x4) != CLOBBER)
        return NULL;
      x13 = XVECEXP (x2, 0, 0);
      operands[0] = x13;
      x7 = XEXP (x4, 0);
      operands[1] = x7;
      switch (pattern356 ())
        {
        case 0:
          if (!(
#line 14320 "../../gcc/config/rs6000/rs6000.md"
(reload_completed) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
            return NULL;
          return gen_split_490 (insn, operands);

        case 1:
          if (!(
#line 14320 "../../gcc/config/rs6000/rs6000.md"
(reload_completed) && 
#line 512 "../../gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
            return NULL;
          return gen_split_491 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}
